/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Y=function(x){for(var t=[],m=0,A=x.length;m<A;m++)t[m]=X[x[m]];return t};define(X[57],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(A,D){if(!A)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}t.ok=m}),define(X[44],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function m(F){return(C,u,d)=>{let S=null,y=null;if(typeof d.value=="function"?(S="value",y=d.value):typeof d.get=="function"&&(S="get",y=d.get),!y)throw new Error("not supported");d[S]=F(y,u)}}t.createDecorator=m;function A(F,C,u){let d=null,S=null;if(typeof u.value=="function"?(d="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(d="get",S=u.get),!S)throw new Error("not supported");const y=`$memoize$${C}`;u[d]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,w)}),this[y]}}t.memoize=A;function D(F,C,u){return m((d,S)=>{const y=`$debounce$${S}`,w=`$debounce$result$${S}`;return function(...T){this[w]||(this[w]=u?u():void 0),clearTimeout(this[y]),C&&(this[w]=C(this[w],...T),T=[this[w]]),this[y]=setTimeout(()=>{d.apply(this,T),this[w]=u?u():void 0},F)}})}t.debounce=D;function R(F,C,u){return m((d,S)=>{const y=`$throttle$timer$${S}`,w=`$throttle$result$${S}`,T=`$throttle$lastRun$${S}`,c=`$throttle$pending$${S}`;return function(...h){if(this[w]||(this[w]=u?u():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),C&&(this[w]=C(this[w],...h)),this[c])return;const b=this[T]+F;b<=Date.now()?(this[T]=Date.now(),d.apply(this,[this[w]]),this[w]=u?u():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[T]=Date.now(),d.apply(this,[this[w]]),this[w]=u?u():void 0},b-Date.now()))}})}t.throttle=R}),define(X[22],Y([0,1,12]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function A(p,f=0){return p[p.length-(1+f)]}t.tail=A;function D(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}t.tail2=D;function R(p,f,l=(g,I)=>g===I){if(p===f)return!0;if(!p||!f||p.length!==f.length)return!1;for(let g=0,I=p.length;g<I;g++)if(!l(p[g],f[g]))return!1;return!0}t.equals=R;function F(p,f,l){let g=0,I=p.length-1;for(;g<=I;){const N=(g+I)/2|0,M=l(p[N],f);if(M<0)g=N+1;else if(M>0)I=N-1;else return N}return-(g+1)}t.binarySearch=F;function C(p,f){let l=0,g=p.length;if(g===0)return 0;for(;l<g;){const I=Math.floor((l+g)/2);f(p[I])?g=I:l=I+1}return l}t.findFirstInSorted=C;function u(p,f,l){if(p=p|0,p>=f.length)throw new TypeError("invalid index");let g=f[Math.floor(f.length*Math.random())],I=[],N=[],M=[];for(let V of f){const W=l(V,g);W<0?I.push(V):W>0?N.push(V):M.push(V)}return p<I.length?u(p,I,l):p<I.length+M.length?M[0]:u(p-(I.length+M.length),N,l)}t.quickSelect=u;function d(p,f){const l=[];let g;for(const I of p.slice(0).sort(f))!g||f(g[0],I)!==0?(g=[I],l.push(g)):g.push(I);return l}t.groupBy=d;function S(p,f,l){const g=[];function I(V,W,_){if(W===0&&_.length===0)return;const G=g[g.length-1];G&&G.start+G.deleteCount===V?(G.deleteCount+=W,G.toInsert.push(..._)):g.push({start:V,deleteCount:W,toInsert:_})}let N=0,M=0;for(;;){if(N===p.length){I(N,0,f.slice(M));break}if(M===f.length){I(N,p.length-N,[]);break}const V=p[N],W=f[M],_=l(V,W);_===0?(N+=1,M+=1):_<0?(I(N,1,[]),N+=1):_>0&&(I(N,0,[W]),M+=1)}return g}t.sortedDiff=S;function y(p,f,l){const g=S(p,f,l),I=[],N=[];for(const M of g)I.push(...p.slice(M.start,M.start+M.deleteCount)),N.push(...M.toInsert);return{removed:I,added:N}}t.delta=y;function w(p,f,l){if(l===0)return[];const g=p.slice(0,l).sort(f);return c(p,f,g,l,p.length),g}t.top=w;function T(p,f,l,g,I){return l===0?Promise.resolve([]):new Promise((N,M)=>{(async()=>{const V=p.length,W=p.slice(0,l).sort(f);for(let _=l,G=Math.min(l+g,V);_<V;_=G,G=Math.min(G+g,V)){if(_>l&&await new Promise(J=>setTimeout(J)),I&&I.isCancellationRequested)throw m.canceled();c(p,f,W,_,G)}return W})().then(N,M)})}t.topAsync=T;function c(p,f,l,g,I){for(const N=l.length;g<I;g++){const M=p[g];if(f(M,l[N-1])<0){l.pop();const V=C(l,W=>f(M,W)<0);l.splice(V,0,M)}}}function h(p){return p.filter(f=>!!f)}t.coalesce=h;function b(p){let f=0;for(let l=0;l<p.length;l++)p[l]&&(p[f]=p[l],f+=1);p.length=f}t.coalesceInPlace=b;function O(p,f,l){p.splice(l,0,p.splice(f,1)[0])}t.move=O;function L(p){return!Array.isArray(p)||p.length===0}t.isFalsyOrEmpty=L;function v(p){return Array.isArray(p)&&p.length>0}t.isNonEmptyArray=v;function o(p,f){if(!f)return p.filter((g,I)=>p.indexOf(g)===I);const l=Object.create(null);return p.filter(g=>{const I=f(g);return l[I]?!1:(l[I]=!0,!0)})}t.distinct=o;function r(p){const f=new Set;return p.filter(l=>f.has(l)?!1:(f.add(l),!0))}t.distinctES6=r;function e(p){const f=Object.create(null);return l=>{const g=p(l);return f[g]?!1:(f[g]=!0,!0)}}t.uniqueFilter=e;function i(p,f){for(let l=p.length-1;l>=0;l--){const g=p[l];if(f(g))return l}return-1}t.lastIndex=i;function n(p,f){return p.length>0?p[0]:f}t.firstOrDefault=n;function s(p,f,l=(g,I)=>g===I){let g=0;for(let I=0,N=Math.min(p.length,f.length);I<N&&l(p[I],f[I]);I++)g++;return g}t.commonPrefixLength=s;function a(p){return[].concat(...p)}t.flatten=a;function E(p,f){let l=typeof f=="number"?p:0;typeof f=="number"?l=p:(l=0,f=p);const g=[];if(l<=f)for(let I=l;I<f;I++)g.push(I);else for(let I=l;I>f;I--)g.push(I);return g}t.range=E;function P(p,f,l){return p.reduce((g,I)=>(g[f(I)]=l?l(I):I,g),Object.create(null))}t.index=P;function U(p,f){return p.push(f),()=>k(p,f)}t.insert=U;function k(p,f){const l=p.indexOf(f);if(l>-1)return p.splice(l,1),f}t.remove=k;function j(p,f,l){const g=p.slice(0,f),I=p.slice(f);return g.concat(l,I)}t.arrayInsert=j;function B(p,f){let l;if(typeof f=="number"){let g=f;l=()=>{const I=Math.sin(g++)*179426549;return I-Math.floor(I)}}else l=Math.random;for(let g=p.length-1;g>0;g-=1){const I=Math.floor(l()*(g+1)),N=p[g];p[g]=p[I],p[I]=N}}t.shuffle=B;function $(p,f){const l=p.indexOf(f);l>-1&&(p.splice(l,1),p.unshift(f))}t.pushToStart=$;function K(p,f){const l=p.indexOf(f);l>-1&&(p.splice(l,1),p.push(f))}t.pushToEnd=K;function ee(p,f){return Array.isArray(p)?p.map(f):f(p)}t.mapArrayOrNot=ee;function te(p){return Array.isArray(p)?p:[p]}t.asArray=te;function Q(p){return p[Math.floor(Math.random()*p.length)]}t.getRandomElement=Q;function oe(p,f){for(const l of p){const g=f(l);if(g!==void 0)return g}}t.mapFind=oe;function se(p,f){let l=Number.MAX_SAFE_INTEGER,g=0;return p.forEach((I,N)=>{const M=f(I);M<l&&(l=M,g=N)}),g}t.minIndex=se;function re(p,f){let l=Number.MIN_SAFE_INTEGER,g=0;return p.forEach((I,N)=>{const M=f(I);M>l&&(l=M,g=N)}),g}t.maxIndex=re}),define(X[58],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var A;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(A=t.SyntaxKind||(t.SyntaxKind={}));var D;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(D=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,s=e.length,a="",E=0,P=16,U=0;function k(Q){let oe=0,se=0;for(;oe<Q;){const re=e.charCodeAt(n);if(re>=48&&re<=57)se=se*16+re-48;else if(re>=65&&re<=70)se=se*16+re-65+10;else if(re>=97&&re<=102)se=se*16+re-97+10;else break;n++,oe++}return oe<Q&&(se=-1),se}function j(Q){n=Q,a="",E=0,P=16,U=0}function B(){const Q=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return U=3,e.substring(Q,n);let oe=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;oe=n}else U=3;return e.substring(Q,oe)}function $(){let Q="",oe=n;for(;;){if(n>=s){Q+=e.substring(oe,n),U=2;break}const se=e.charCodeAt(n);if(se===34){Q+=e.substring(oe,n),n++;break}if(se===92){if(Q+=e.substring(oe,n),n++,n>=s){U=2;break}switch(e.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const p=k(4);p>=0?Q+=String.fromCharCode(p):U=4;break;default:U=5}oe=n;continue}if(se>=0&&se<=31)if(u(se)){Q+=e.substring(oe,n),U=2;break}else U=6;n++}return Q}function K(){if(a="",U=0,E=n,n>=s)return E=s,P=17;let Q=e.charCodeAt(n);if(C(Q)){do n++,a+=String.fromCharCode(Q),Q=e.charCodeAt(n);while(C(Q));return P=15}if(u(Q))return n++,a+=String.fromCharCode(Q),Q===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),P=14;switch(Q){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,a=$(),P=10;case 47:const oe=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!u(e.charCodeAt(n));)n++;return a=e.substring(oe,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const se=s-1;let re=!1;for(;n<se;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,re=!0;break}n++}return re||(n++,U=1),a=e.substring(oe,n),P=13}return a+=String.fromCharCode(Q),n++,P=16;case 45:if(a+=String.fromCharCode(Q),n++,n===s||!d(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=B(),P=11;default:for(;n<s&&ee(Q);)n++,Q=e.charCodeAt(n);if(E!==n){switch(a=e.substring(E,n),a){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return a+=String.fromCharCode(Q),n++,P=16}}function ee(Q){if(C(Q)||u(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let Q;do Q=K();while(Q>=12&&Q<=15);return Q}return{setPosition:j,getPosition:()=>n,scan:i?te:K,getToken:()=>P,getTokenValue:()=>a,getTokenOffset:()=>E,getTokenLength:()=>n-E,getTokenError:()=>U}}t.createScanner=F;function C(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var S;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(S||(S={}));function y(e,i){const n=[],s=new Object;let a;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function U(k,j,B,$){E.value=k,E.offset=j,E.length=B,E.type=$,E.colonOffset=void 0,a=E}try{v(e,{onObjectBegin:(k,j)=>{if(i<=k)throw s;a=void 0,P=i>k,n.push("")},onObjectProperty:(k,j,B)=>{if(i<j||(U(k,j,B,"property"),n[n.length-1]=k,i<=j+B))throw s},onObjectEnd:(k,j)=>{if(i<=k)throw s;a=void 0,n.pop()},onArrayBegin:(k,j)=>{if(i<=k)throw s;a=void 0,n.push(0)},onArrayEnd:(k,j)=>{if(i<=k)throw s;a=void 0,n.pop()},onLiteralValue:(k,j,B)=>{if(i<j||(U(k,j,B,r(k)),i<=j+B))throw s},onSeparator:(k,j,B)=>{if(i<=j)throw s;if(k===":"&&a&&a.type==="property")a.colonOffset=j,P=!1,a=void 0;else if(k===","){const $=n[n.length-1];typeof $=="number"?n[n.length-1]=$+1:(P=!0,n[n.length-1]=""),a=void 0}}})}catch(k){if(k!==s)throw k}return{path:n,previousNode:a,isAtPropertyKey:P,matches:k=>{let j=0;for(let B=0;j<k.length&&B<n.length;B++)if(k[j]===n[B]||k[j]==="*")j++;else if(k[j]!=="**")return!1;return j===k.length}}}t.getLocation=y;function w(e,i=[],n=R.DEFAULT){let s=null,a=[];const E=[];function P(k){Array.isArray(a)?a.push(k):s!==null&&(a[s]=k)}return v(e,{onObjectBegin:()=>{const k={};P(k),E.push(a),a=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{a=E.pop()},onArrayBegin:()=>{const k=[];P(k),E.push(a),a=k,s=null},onArrayEnd:()=>{a=E.pop()},onLiteralValue:P,onError:(k,j,B)=>{i.push({error:k,offset:j,length:B})}},n),a[0]}t.parse=w;function T(e,i=[],n=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function E(k){return s.children.push(k),k}v(e,{onObjectBegin:k=>{s=E({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,j,B)=>{s=E({type:"property",offset:j,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:j,length:B,parent:s})},onObjectEnd:(k,j)=>{s.length=k+j-s.offset,s=s.parent,a(k+j)},onArrayBegin:(k,j)=>{s=E({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,j)=>{s.length=k+j-s.offset,s=s.parent,a(k+j)},onLiteralValue:(k,j,B)=>{E({type:r(k),offset:j,length:B,parent:s,value:k}),a(j+B)},onSeparator:(k,j,B)=>{s.type==="property"&&(k===":"?s.colonOffset=j:k===","&&a(j))},onError:(k,j,B)=>{i.push({error:k,offset:j,length:B})}},n);const U=s.children[0];return U&&delete U.parent,U}t.parseTree=T;function c(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const E of n.children)if(Array.isArray(E.children)&&E.children[0].value===s){n=E.children[1],a=!0;break}if(!a)return}else{const a=s;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=c;function h(e){if(!e.parent||!e.parent.children)return[];const i=h(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=h;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=b(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function O(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=O;function L(e,i,n=!1){if(O(e,i,n)){const s=e.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=i;a++){const E=L(s[a],i,n);if(E)return E}return e}}t.findNodeAtOffset=L;function v(e,i,n=R.DEFAULT){const s=F(e,!1);function a(M){return M?()=>M(s.getTokenOffset(),s.getTokenLength()):()=>!0}function E(M){return M?V=>M(V,s.getTokenOffset(),s.getTokenLength()):()=>!0}const P=a(i.onObjectBegin),U=E(i.onObjectProperty),k=a(i.onObjectEnd),j=a(i.onArrayBegin),B=a(i.onArrayEnd),$=E(i.onLiteralValue),K=E(i.onSeparator),ee=a(i.onComment),te=E(i.onError),Q=n&&n.disallowComments,oe=n&&n.allowTrailingComma;function se(){for(;;){const M=s.scan();switch(s.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Q||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(M){case 12:case 13:Q?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return M}}}function re(M,V=[],W=[]){if(te(M),V.length+W.length>0){let _=s.getToken();for(;_!==17;){if(V.indexOf(_)!==-1){se();break}else if(W.indexOf(_)!==-1)break;_=se()}}}function p(M){const V=s.getTokenValue();return M?$(V):U(V),se(),!0}function f(){switch(s.getToken()){case 11:let M=0;try{M=JSON.parse(s.getTokenValue()),typeof M!="number"&&(re(2),M=0)}catch(V){re(2)}$(M);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return se(),!0}function l(){return s.getToken()!==10?(re(3,[],[2,5]),!1):(p(!1),s.getToken()===6?(K(":"),se(),N()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function g(){P(),se();let M=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(M||re(4,[],[]),K(","),se(),s.getToken()===2&&oe)break}else M&&re(6,[],[]);l()||re(4,[],[2,5]),M=!0}return k(),s.getToken()!==2?re(7,[2],[]):se(),!0}function I(){j(),se();let M=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(M||re(4,[],[]),K(","),se(),s.getToken()===4&&oe)break}else M&&re(6,[],[]);N()||re(4,[],[4,5]),M=!0}return B(),s.getToken()!==4?re(8,[4],[]):se(),!0}function N(){switch(s.getToken()){case 3:return I();case 1:return g();case 10:return p(!0);default:return f()}}return se(),s.getToken()===17?n.allowEmptyContent?!0:(re(4,[],[]),!1):N()?(s.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}t.visit=v;function o(e,i){let n=F(e),s=[],a,E=0,P;do switch(P=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:E!==P&&s.push(e.substring(E,P)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),E=n.getPosition();break}while(a!==17);return s.join("")}t.stripComments=o;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r}),function(){function x(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function F(u){R.push(u,Date.now())}function C(){const u=[];for(let d=0;d<R.length;d+=2)u.push({name:R[d],startTime:R[d+1]});return u}return{mark:F,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const F of performance.getEntriesByType("mark"))R.push({name:F.name,startTime:Math.round(D+F.startTime)});return R}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=t()),D.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=m(A))}(),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var A in m)(typeof exports=="object"?exports:x)[A]=m[A]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function m(A){if(t[A])return t[A].exports;var D=t[A]={i:A,l:!1,exports:{}};return x[A].call(D.exports,D,D.exports,m),D.l=!0,D.exports}return m.m=x,m.c=t,m.d=function(A,D,R){m.o(A,D)||Object.defineProperty(A,D,{enumerable:!0,get:R})},m.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},m.t=function(A,D){if(1&D&&(A=m(A)),8&D||4&D&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(m.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&D&&typeof A!="string")for(var F in A)m.d(R,F,function(C){return A[C]}.bind(null,F));return R},m.n=function(A){var D=A&&A.__esModule?function(){return A.default}:function(){return A};return m.d(D,"a",D),D},m.o=function(A,D){return Object.prototype.hasOwnProperty.call(A,D)},m.p="",m(m.s=0)}([function(x,t,m){(function(A){var D;t=x.exports=W,D=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],u=t.src=[],d=0,S=d++;u[S]="0|[1-9]\\d*";var y=d++;u[y]="[0-9]+";var w=d++;u[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=d++;u[T]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var c=d++;u[c]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var h=d++;u[h]="(?:"+u[S]+"|"+u[w]+")";var b=d++;u[b]="(?:"+u[y]+"|"+u[w]+")";var O=d++;u[O]="(?:-("+u[h]+"(?:\\."+u[h]+")*))";var L=d++;u[L]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var v=d++;u[v]="[0-9A-Za-z-]+";var o=d++;u[o]="(?:\\+("+u[v]+"(?:\\."+u[v]+")*))";var r=d++,e="v?"+u[T]+u[O]+"?"+u[o]+"?";u[r]="^"+e+"$";var i="[v=\\s]*"+u[c]+u[L]+"?"+u[o]+"?",n=d++;u[n]="^"+i+"$";var s=d++;u[s]="((?:<|>)?=?)";var a=d++;u[a]=u[y]+"|x|X|\\*";var E=d++;u[E]=u[S]+"|x|X|\\*";var P=d++;u[P]="[v=\\s]*("+u[E]+")(?:\\.("+u[E]+")(?:\\.("+u[E]+")(?:"+u[O]+")?"+u[o]+"?)?)?";var U=d++;u[U]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[L]+")?"+u[o]+"?)?)?";var k=d++;u[k]="^"+u[s]+"\\s*"+u[P]+"$";var j=d++;u[j]="^"+u[s]+"\\s*"+u[U]+"$";var B=d++;u[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=d++;u[$]="(?:~>?)";var K=d++;u[K]="(\\s*)"+u[$]+"\\s+",C[K]=new RegExp(u[K],"g");var ee=d++;u[ee]="^"+u[$]+u[P]+"$";var te=d++;u[te]="^"+u[$]+u[U]+"$";var Q=d++;u[Q]="(?:\\^)";var oe=d++;u[oe]="(\\s*)"+u[Q]+"\\s+",C[oe]=new RegExp(u[oe],"g");var se=d++;u[se]="^"+u[Q]+u[P]+"$";var re=d++;u[re]="^"+u[Q]+u[U]+"$";var p=d++;u[p]="^"+u[s]+"\\s*("+i+")$|^$";var f=d++;u[f]="^"+u[s]+"\\s*("+e+")$|^$";var l=d++;u[l]="(\\s*)"+u[s]+"\\s*("+i+"|"+u[P]+")",C[l]=new RegExp(u[l],"g");var g=d++;u[g]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var I=d++;u[I]="^\\s*("+u[U]+")\\s+-\\s+("+u[U]+")\\s*$";var N=d++;u[N]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)D(M,u[M]),C[M]||(C[M]=new RegExp(u[M]));function V(z,q){if(z instanceof W)return z;if(typeof z!="string"||z.length>R||!(q?C[n]:C[r]).test(z))return null;try{return new W(z,q)}catch(H){return null}}function W(z,q){if(z instanceof W){if(z.loose===q)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof W))return new W(z,q);D("SemVer",z,q),this.loose=q;var H=z.trim().match(q?C[n]:C[r]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var ae=+ie;if(ae>=0&&ae<F)return ae}return ie}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=V,t.valid=function(z,q){var H=V(z,q);return H?H.version:null},t.clean=function(z,q){var H=V(z.trim().replace(/^[=v]+/,""),q);return H?H.version:null},t.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(z){return D("SemVer.compare",this.version,this.loose,z),z instanceof W||(z=new W(z,this.loose)),this.compareMain(z)||this.comparePre(z)},W.prototype.compareMain=function(z){return z instanceof W||(z=new W(z,this.loose)),G(this.major,z.major)||G(this.minor,z.minor)||G(this.patch,z.patch)},W.prototype.comparePre=function(z){if(z instanceof W||(z=new W(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var q=0;do{var H=this.prerelease[q],ie=z.prerelease[q];if(D("prerelease compare",q,H,ie),H===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(H===void 0)return-1;if(H!==ie)return G(H,ie)}while(++q)},W.prototype.inc=function(z,q){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,q,H,ie){typeof H=="string"&&(ie=H,H=void 0);try{return new W(z,H).inc(q,ie).version}catch(ae){return null}},t.diff=function(z,q){if(ce(z,q))return null;var H=V(z),ie=V(q);if(H.prerelease.length||ie.prerelease.length){for(var ae in H)if((ae==="major"||ae==="minor"||ae==="patch")&&H[ae]!==ie[ae])return"pre"+ae;return"prerelease"}for(var ae in H)if((ae==="major"||ae==="minor"||ae==="patch")&&H[ae]!==ie[ae])return ae},t.compareIdentifiers=G;var _=/^[0-9]+$/;function G(z,q){var H=_.test(z),ie=_.test(q);return H&&ie&&(z=+z,q=+q),H&&!ie?-1:ie&&!H?1:z<q?-1:z>q?1:0}function J(z,q,H){return new W(z,H).compare(new W(q,H))}function Z(z,q,H){return J(z,q,H)>0}function ne(z,q,H){return J(z,q,H)<0}function ce(z,q,H){return J(z,q,H)===0}function ye(z,q,H){return J(z,q,H)!==0}function be(z,q,H){return J(z,q,H)>=0}function Ae(z,q,H){return J(z,q,H)<=0}function Te(z,q,H,ie){var ae;switch(q){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ae=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ae=z!==H;break;case"":case"=":case"==":ae=ce(z,H,ie);break;case"!=":ae=ye(z,H,ie);break;case">":ae=Z(z,H,ie);break;case">=":ae=be(z,H,ie);break;case"<":ae=ne(z,H,ie);break;case"<=":ae=Ae(z,H,ie);break;default:throw new TypeError("Invalid operator: "+q)}return ae}function Se(z,q){if(z instanceof Se){if(z.loose===q)return z;z=z.value}if(!(this instanceof Se))return new Se(z,q);D("comparator",z,q),this.loose=q,this.parse(z),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}t.rcompareIdentifiers=function(z,q){return G(q,z)},t.major=function(z,q){return new W(z,q).major},t.minor=function(z,q){return new W(z,q).minor},t.patch=function(z,q){return new W(z,q).patch},t.compare=J,t.compareLoose=function(z,q){return J(z,q,!0)},t.rcompare=function(z,q,H){return J(q,z,H)},t.sort=function(z,q){return z.sort(function(H,ie){return t.compare(H,ie,q)})},t.rsort=function(z,q){return z.sort(function(H,ie){return t.rcompare(H,ie,q)})},t.gt=Z,t.lt=ne,t.eq=ce,t.neq=ye,t.gte=be,t.lte=Ae,t.cmp=Te,t.Comparator=Se;var ke={};function ve(z,q){if(z instanceof ve)return z.loose===q?z:new ve(z.raw,q);if(z instanceof Se)return new ve(z.value,q);if(!(this instanceof ve))return new ve(z,q);if(this.loose=q,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function _e(z,q,H,ie,ae,Pe,de,Ce,Ee,Le,Ne,we,Ie){return((q=Re(H)?"":Re(ie)?">="+H+".0.0":Re(ae)?">="+H+"."+ie+".0":">="+q)+" "+(Ce=Re(Ee)?"":Re(Le)?"<"+(+Ee+1)+".0.0":Re(Ne)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+Ne+"-"+we:"<="+Ce)).trim()}function $e(z,q){for(var H=0;H<z.length;H++)if(!z[H].test(q))return!1;if(q.prerelease.length){for(H=0;H<z.length;H++)if(D(z[H].semver),z[H].semver!==ke&&z[H].semver.prerelease.length>0){var ie=z[H].semver;if(ie.major===q.major&&ie.minor===q.minor&&ie.patch===q.patch)return!0}return!1}return!0}function ze(z,q,H){try{q=new ve(q,H)}catch(ie){return!1}return q.test(z)}function Ve(z,q,H,ie){var ae,Pe,de,Ce,Ee;switch(z=new W(z,ie),q=new ve(q,ie),H){case">":ae=Z,Pe=Ae,de=ne,Ce=">",Ee=">=";break;case"<":ae=ne,Pe=be,de=Z,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(z,q,ie))return!1;for(var Le=0;Le<q.set.length;++Le){var Ne=q.set[Le],we=null,Ie=null;if(Ne.forEach(function(Oe){Oe.semver===ke&&(Oe=new Se(">=0.0.0")),we=we||Oe,Ie=Ie||Oe,ae(Oe.semver,we.semver,ie)?we=Oe:de(Oe.semver,Ie.semver,ie)&&(Ie=Oe)}),we.operator===Ce||we.operator===Ee||(!Ie.operator||Ie.operator===Ce)&&Pe(z,Ie.semver)||Ie.operator===Ee&&de(z,Ie.semver))return!1}return!0}Se.prototype.parse=function(z){var q=this.loose?C[p]:C[f],H=z.match(q);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new W(H[2],this.loose):this.semver=ke},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(z){return D("Comparator.test",z,this.loose),this.semver===ke||(typeof z=="string"&&(z=new W(z,this.loose)),Te(z,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(z,q){if(!(z instanceof Se))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new ve(z.value,q),ze(this.value,H,q);if(z.operator==="")return H=new ve(this.value,q),ze(z.semver,H,q);var ie=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Pe=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Te(this.semver,"<",z.semver,q)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ee=Te(this.semver,">",z.semver,q)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ie||ae||Pe&&de||Ce||Ee},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(z){var q=this.loose;z=z.trim(),D("range",z,q);var H=q?C[I]:C[g];z=z.replace(H,_e),D("hyphen replace",z),z=z.replace(C[l],"$1$2$3"),D("comparator trim",z,C[l]),z=(z=(z=z.replace(C[K],"$1~")).replace(C[oe],"$1^")).split(/\s+/).join(" ");var ie=q?C[p]:C[f],ae=z.split(" ").map(function(Pe){return function(de,Ce){return D("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Ne){return function(we,Ie){D("caret",we,Ie);var Oe=Ie?C[re]:C[se];return we.replace(Oe,function(Fe,le,he,ge,me){var De;return D("caret",we,Fe,le,he,ge,me),Re(le)?De="":Re(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?De=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":me?(D("replaceCaret pr",me),me.charAt(0)!=="-"&&(me="-"+me),De=le==="0"?he==="0"?">="+le+"."+he+"."+ge+me+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+me+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+me+" <"+(+le+1)+".0.0"):(D("no pr"),De=le==="0"?he==="0"?">="+le+"."+he+"."+ge+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+" <"+(+le+1)+".0.0"),D("caret return",De),De})}(Ne,Le)}).join(" ")}(de,Ce),D("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(Ne){return function(we,Ie){var Oe=Ie?C[te]:C[ee];return we.replace(Oe,function(Fe,le,he,ge,me){var De;return D("tilde",we,Fe,le,he,ge,me),Re(le)?De="":Re(he)?De=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?De=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":me?(D("replaceTilde pr",me),me.charAt(0)!=="-"&&(me="-"+me),De=">="+le+"."+he+"."+ge+me+" <"+le+"."+(+he+1)+".0"):De=">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0",D("tilde return",De),De})}(Ne,Le)}).join(" ")}(de,Ce),D("tildes",de),de=function(Ee,Le){return D("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(Ne){return function(we,Ie){we=we.trim();var Oe=Ie?C[j]:C[k];return we.replace(Oe,function(Fe,le,he,ge,me,De){D("xRange",we,Fe,le,he,ge,me,De);var xe=Re(he),je=xe||Re(ge),Ue=je||Re(me);return le==="="&&Ue&&(le=""),xe?Fe=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(je&&(ge=0),Ue&&(me=0),le===">"?(le=">=",je?(he=+he+1,ge=0,me=0):Ue&&(ge=+ge+1,me=0)):le==="<="&&(le="<",je?he=+he+1:ge=+ge+1),Fe=le+he+"."+ge+"."+me):je?Fe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Fe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),D("xRange return",Fe),Fe})}(Ne,Le)}).join(" ")}(de,Ce),D("xrange",de),de=function(Ee,Le){return D("replaceStars",Ee,Le),Ee.trim().replace(C[N],"")}(de,Ce),D("stars",de),de}(Pe,q)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Pe){return!!Pe.match(ie)})),ae=ae.map(function(Pe){return new Se(Pe,q)})},ve.prototype.intersects=function(z,q){if(!(z instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ie){return z.set.some(function(ae){return ae.every(function(Pe){return ie.intersects(Pe,q)})})})})},t.toComparators=function(z,q){return new ve(z,q).set.map(function(H){return H.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new W(z,this.loose));for(var q=0;q<this.set.length;q++)if($e(this.set[q],z))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(z,q,H){var ie=null,ae=null;try{var Pe=new ve(q,H)}catch(de){return null}return z.forEach(function(de){Pe.test(de)&&(ie&&ae.compare(de)!==-1||(ae=new W(ie=de,H)))}),ie},t.minSatisfying=function(z,q,H){var ie=null,ae=null;try{var Pe=new ve(q,H)}catch(de){return null}return z.forEach(function(de){Pe.test(de)&&(ie&&ae.compare(de)!==1||(ae=new W(ie=de,H)))}),ie},t.validRange=function(z,q){try{return new ve(z,q).range||"*"}catch(H){return null}},t.ltr=function(z,q,H){return Ve(z,q,"<",H)},t.gtr=function(z,q,H){return Ve(z,q,">",H)},t.outside=Ve,t.prerelease=function(z,q){var H=V(z,q);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(z,q,H){return z=new ve(z,H),q=new ve(q,H),z.intersects(q)},t.coerce=function(z){if(z instanceof W)return z;if(typeof z!="string")return null;var q=z.match(C[B]);return q==null?null:V((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,m(1))},function(x,t){var m,A,D=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function C(b){if(m===setTimeout)return setTimeout(b,0);if((m===R||!m)&&setTimeout)return m=setTimeout,setTimeout(b,0);try{return m(b,0)}catch(O){try{return m.call(null,b,0)}catch(L){return m.call(this,b,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:R}catch(b){m=R}try{A=typeof clearTimeout=="function"?clearTimeout:F}catch(b){A=F}})();var u,d=[],S=!1,y=-1;function w(){S&&u&&(S=!1,u.length?d=u.concat(d):y=-1,d.length&&T())}function T(){if(!S){var b=C(w);S=!0;for(var O=d.length;O;){for(u=d,d=[];++y<O;)u&&u[y].run();y=-1,O=d.length}u=null,S=!1,function(L){if(A===clearTimeout)return clearTimeout(L);if((A===F||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(L);try{A(L)}catch(v){try{return A.call(null,L)}catch(o){return A.call(this,L)}}}(b)}}function c(b,O){this.fun=b,this.array=O}function h(){}D.nextTick=function(b){var O=new Array(arguments.length-1);if(arguments.length>1)for(var L=1;L<arguments.length;L++)O[L-1]=arguments[L];d.push(new c(b,O)),d.length!==1||S||C(T)},c.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=h,D.addListener=h,D.once=h,D.off=h,D.removeListener=h,D.removeAllListeners=h,D.emit=h,D.prependListener=h,D.prependOnceListener=h,D.listeners=function(b){return[]},D.binding=function(b){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(b){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(X[34],Y([0,1,12,2]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function D(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=D;function R(v){const o=v;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=R;function F(v,o){return new C(v,o)}t.newWriteableStream=F;class C{constructor(o,r){this.reducer=o,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(r=>r(o))}emitError(o){this.listeners.error.length===0?m.onUnexpectedError(o):this.listeners.error.slice(0).forEach(r=>r(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,r){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(o,r){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(v,o){const r=[];let e;for(;(e=v.read())!==null;)r.push(e);return o(r)}t.consumeReadable=u;function d(v,o,r){const e=[];let i;for(;(i=v.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return v.read()}}}t.peekReadable=d;function S(v,o){return new Promise((r,e)=>{const i=[];y(v,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):r(void 0)},onEnd:()=>{r(o?o(i):void 0)}})})}t.consumeStream=S;function y(v,o){v.on("error",r=>o.onError(r)),v.on("end",()=>o.onEnd()),v.on("data",r=>o.onData(r))}t.listenStream=y;function w(v,o){return new Promise((r,e)=>{const i=new A.DisposableStore,n=[],s=P=>{if(n.push(P),n.length>o)return i.dispose(),v.pause(),r({stream:v,buffer:n,ended:!1})},a=P=>e(P),E=()=>r({stream:v,buffer:n,ended:!0});i.add(A.toDisposable(()=>v.removeListener("error",a))),v.on("error",a),i.add(A.toDisposable(()=>v.removeListener("end",E))),v.on("end",E),i.add(A.toDisposable(()=>v.removeListener("data",s))),v.on("data",s)})}t.peekStream=w;function T(v,o){const r=F(o);return r.end(v),r}t.toStream=T;function c(){const v=F(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=c;function h(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}t.toReadable=h;function b(v,o,r){const e=F(r);return y(v,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function O(v,o,r){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?r([v,i]):v)}}}t.prefixedReadable=O;function L(v,o,r){let e=!1;const i=F(r);return y(o,{onData:n=>e?i.write(n):(e=!0,i.write(r([v,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(v)),i.end()}}),i}t.prefixedStream=L}),define(X[16],Y([0,1,19,34]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let C,u;class d{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return D?new d(Buffer.allocUnsafe(P)):new d(new Uint8Array(P))}static wrap(P){return D&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new d(P)}static fromString(P,U){return!((U==null?void 0:U.dontUseNodeBuffer)||!1)&&D?new d(Buffer.from(P)):R?(C||(C=new TextEncoder),new d(C.encode(P))):new d(m.encodeUTF8(P))}static concat(P,U){if(typeof U=="undefined"){U=0;for(let B=0,$=P.length;B<$;B++)U+=P[B].byteLength}const k=d.alloc(U);let j=0;for(let B=0,$=P.length;B<$;B++){const K=P[B];k.set(K,j),j+=K.byteLength}return k}toString(){return D?this.buffer.toString():F?(u||(u=new TextDecoder),u.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(P,U){return new d(this.buffer.subarray(P,U))}set(P,U){P instanceof d?this.buffer.set(P.buffer,U):this.buffer.set(P,U)}readUInt32BE(P){return w(this.buffer,P)}writeUInt32BE(P,U){T(this.buffer,P,U)}readUInt32LE(P){return c(this.buffer,P)}writeUInt32LE(P,U){h(this.buffer,P,U)}readUInt8(P){return b(this.buffer,P)}writeUInt8(P,U){O(this.buffer,P,U)}}t.VSBuffer=d;function S(E,P){return E[P+0]<<0>>>0|E[P+1]<<8>>>0}t.readUInt16LE=S;function y(E,P,U){E[U+0]=P&255,P=P>>>8,E[U+1]=P&255}t.writeUInt16LE=y;function w(E,P){return E[P]*2**24+E[P+1]*2**16+E[P+2]*2**8+E[P+3]}t.readUInt32BE=w;function T(E,P,U){E[U+3]=P,P=P>>>8,E[U+2]=P,P=P>>>8,E[U+1]=P,P=P>>>8,E[U]=P}t.writeUInt32BE=T;function c(E,P){return E[P+0]<<0>>>0|E[P+1]<<8>>>0|E[P+2]<<16>>>0|E[P+3]<<24>>>0}t.readUInt32LE=c;function h(E,P,U){E[U+0]=P&255,P=P>>>8,E[U+1]=P&255,P=P>>>8,E[U+2]=P&255,P=P>>>8,E[U+3]=P&255}t.writeUInt32LE=h;function b(E,P){return E[P]}t.readUInt8=b;function O(E,P,U){E[U]=P}t.writeUInt8=O;function L(E){return A.consumeReadable(E,P=>d.concat(P))}t.readableToBuffer=L;function v(E){return A.toReadable(E)}t.bufferToReadable=v;function o(E){return A.consumeStream(E,P=>d.concat(P))}t.streamToBuffer=o;async function r(E){return E.ended?d.concat(E.buffer):d.concat([...E.buffer,await o(E.stream)])}t.bufferedStreamToBuffer=r;function e(E){return A.toStream(E,P=>d.concat(P))}t.bufferToStream=e;function i(E){return A.transform(E,{data:P=>typeof P=="string"?d.fromString(P):d.wrap(P)},P=>d.concat(P))}t.streamToBufferReadableStream=i;function n(E){return A.newWriteableStream(P=>d.concat(P),E)}t.newWriteableBufferStream=n;function s(E,P){return A.prefixedReadable(E,P,U=>d.concat(U))}t.prefixedBufferReadable=s;function a(E,P){return A.prefixedStream(E,P,U=>d.concat(U))}t.prefixedBufferStream=a}),define(X[20],Y([0,1,13]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const b=Array.isArray(h)?[]:{};return Object.keys(h).forEach(O=>{h[O]&&typeof h[O]=="object"?b[O]=A(h[O]):b[O]=h[O]}),b}t.deepClone=A;function D(h){if(!h||typeof h!="object")return h;const b=[h];for(;b.length>0;){const O=b.shift();Object.freeze(O);for(const L in O)if(R.call(O,L)){const v=O[L];typeof v=="object"&&!Object.isFrozen(v)&&b.push(v)}}return h}t.deepFreeze=D;const R=Object.prototype.hasOwnProperty;function F(h,b){return C(h,b,new Set)}t.cloneAndChange=F;function C(h,b,O){if(m.isUndefinedOrNull(h))return h;const L=b(h);if(typeof L!="undefined")return L;if(m.isArray(h)){const v=[];for(const o of h)v.push(C(o,b,O));return v}if(m.isObject(h)){if(O.has(h))throw new Error("Cannot clone recursive data-structure");O.add(h);const v={};for(let o in h)R.call(h,o)&&(v[o]=C(h[o],b,O));return O.delete(h),v}return h}function u(h,b,O=!0){return m.isObject(h)?(m.isObject(b)&&Object.keys(b).forEach(L=>{L in h?O&&(m.isObject(h[L])&&m.isObject(b[L])?u(h[L],b[L],O):h[L]=b[L]):h[L]=b[L]}),h):b}t.mixin=u;function d(h,b){if(h===b)return!0;if(h==null||b===null||b===void 0||typeof h!=typeof b||typeof h!="object"||Array.isArray(h)!==Array.isArray(b))return!1;let O,L;if(Array.isArray(h)){if(h.length!==b.length)return!1;for(O=0;O<h.length;O++)if(!d(h[O],b[O]))return!1}else{const v=[];for(L in h)v.push(L);v.sort();const o=[];for(L in b)o.push(L);if(o.sort(),!d(v,o))return!1;for(O=0;O<v.length;O++)if(!d(h[v[O]],b[v[O]]))return!1}return!0}t.equals=d;function S(h){const b=new Set;return JSON.stringify(h,(O,L)=>{if(m.isObject(L)||Array.isArray(L)){if(b.has(L))return"[Circular]";b.add(L)}return L})}t.safeStringify=S;function y(h,b,O){const L=b(h);return typeof L=="undefined"?O:L}t.getOrDefault=y;function w(h,b){const O=Object.create(null);return!h||!b||Object.keys(b).forEach(v=>{const o=h[v],r=b[v];d(o,r)||(O[v]=r)}),O}t.distinct=w;function T(h,b){const O=b.toLowerCase(),L=Object.keys(h).find(v=>v.toLowerCase()===O);return L?h[L]:h[b]}t.getCaseInsensitive=T;function c(h,b){const O=Object.create(null);for(const L of Object.keys(h))b(L,h[L])&&(O[L]=h[L]);return O}t.filter=c}),define(X[59],Y([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function A(d){const S=d;return S&&typeof S.type=="string"&&typeof S.severity=="string"}t.isRemoteConsoleLog=A;function D(d){const S=[];let y;try{const w=JSON.parse(d.arguments),T=w[w.length-1];T&&T.__$stack&&(w.pop(),y=T.__$stack),S.push(...w)}catch(w){S.push("Unable to log remote console arguments",d.arguments)}return{args:S,stack:y}}t.parse=D;function R(d){if(typeof d!="string")return R(D(d).stack);const S=d;if(S){const y=F(S),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:m.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=R;function F(d){if(!d)return d;const S=d.indexOf(`
`);return S===-1?d:d.substring(0,S)}function C(d,S){const{args:y,stack:w}=D(d),T=typeof y[0]=="string"&&y.length===1;let c=F(w);c&&(c=`(${c.trim()})`);let h=[];if(typeof y[0]=="string"?c&&T?h=[`%c[${S}] %c${y[0]} %c${c}`,u("blue"),u(""),u("grey")]:h=[`%c[${S}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:h=[`%c[${S}]%`,u("blue"),...y],c&&!T&&h.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,h)}t.log=C;function u(d){return`color: ${d}`}}),define(X[60],Y([0,1,16,19,7]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(S){return JSON.stringify(S,u)}t.stringify=R;function F(S){let y=JSON.parse(S);return y=d(y),y}t.parse=F;var C;(function(S){S[S.Uri=1]="Uri",S[S.Regexp=2]="Regexp",S[S.ScmResource=3]="ScmResource",S[S.ScmResourceGroup=4]="ScmResourceGroup",S[S.ScmProvider=5]="ScmProvider",S[S.CommentController=6]="CommentController",S[S.CommentThread=7]="CommentThread",S[S.CommentThreadReply=8]="CommentThreadReply",S[S.CommentNode=9]="CommentNode",S[S.CommentThreadNode=10]="CommentThreadNode",S[S.TimelineActionContext=11]="TimelineActionContext",S[S.NotebookCellActionContext=12]="NotebookCellActionContext",S[S.TestItemContext=13]="TestItemContext"})(C=t.MarshalledId||(t.MarshalledId={}));function u(S,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:A.regExpFlags(y)}:y}function d(S,y=0){if(!S||y>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof m.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=d(S[w],y+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=d(S[w],y+1))}return S}t.revive=d}),define(X[61],Y([0,1,19,35,3,45,4]),function(x,t,m,A,D,R,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function C(){return Object.create(null)}t.getEmptyExpression=C;const u="**",d="/",S="[/\\\\]",y="[^/\\\\]",w=/\//g;function T(l){switch(l){case 0:return"";case 1:return`${y}*?`;default:return`(?:${S}|${y}+${S}|${S}${y}+)*?`}}function c(l,g){if(!l)return[];const I=[];let N=!1,M=!1,V="";for(const W of l){switch(W){case g:if(!N&&!M){I.push(V),V="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":M=!0;break;case"]":M=!1;break}V+=W}return V&&I.push(V),I}t.splitGlobAware=c;function h(l){if(!l)return"";let g="";const I=c(l,d);if(I.every(N=>N===u))g=".*";else{let N=!1;I.forEach((M,V)=>{if(M===u){N||(g+=T(2),N=!0);return}let W=!1,_="",G=!1,J="";for(const Z of M){if(Z!=="}"&&W){_+=Z;continue}if(G&&(Z!=="]"||!J)){let ne;Z==="-"?ne=Z:(Z==="^"||Z==="!")&&!J?ne="^":Z===d?ne="":ne=m.escapeRegExpCharacters(Z),J+=ne;continue}switch(Z){case"{":W=!0;continue;case"[":G=!0;continue;case"}":g+=`(?:${c(_,",").map(ye=>h(ye)).join("|")})`,W=!1,_="";break;case"]":g+="["+J+"]",G=!1,J="";break;case"?":g+=y;continue;case"*":g+=T(1);continue;default:g+=m.escapeRegExpCharacters(Z)}}V<I.length-1&&(I[V+1]!==u||V+2<I.length)&&(g+=S),N=!1})}return g}const b=/^\*\*\/\*\.[\w\.-]+$/,O=/^\*\*\/([\w\.-]+)\/?$/,L=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new R.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(l,g){if(!l)return n;let I;typeof l!="string"?I=l.pattern:I=l,I=I.trim();const N=`${I}_${!!g.trimForExclusions}`;let M=e.get(N);if(M)return a(M,l);let V;if(b.test(I)){const W=I.substr(4);M=function(_,G){return typeof _=="string"&&_.endsWith(W)?I:null}}else(V=O.exec(E(I,g)))?M=P(V[1],I):(g.trimForExclusions?v:L).test(I)?M=U(I,g):(V=o.exec(E(I,g)))?M=k(V[1].substr(1),I,!0):(V=r.exec(E(I,g)))?M=k(V[1],I,!1):M=j(I);return e.set(N,M),a(M,l)}function a(l,g){return typeof g=="string"?l:function(I,N){return A.isEqualOrParent(I,g.base)?l(D.relative(g.base,I),N):null}}function E(l,g){return g.trimForExclusions&&l.endsWith("/**")?l.substr(0,l.length-2):l}function P(l,g){const I=`/${l}`,N=`\\${l}`,M=function(W,_){return typeof W!="string"?null:_?_===l?g:null:W===l||W.endsWith(I)||W.endsWith(N)?g:null},V=[l];return M.basenames=V,M.patterns=[g],M.allBasenames=V,M}function U(l,g){const I=f(l.slice(1,-1).split(",").map(_=>s(_,g)).filter(_=>_!==n),l),N=I.length;if(!N)return n;if(N===1)return I[0];const M=function(_,G){for(let J=0,Z=I.length;J<Z;J++)if(I[J](_,G))return l;return null},V=I.find(_=>!!_.allBasenames);V&&(M.allBasenames=V.allBasenames);const W=I.reduce((_,G)=>G.allPaths?_.concat(G.allPaths):_,[]);return W.length&&(M.allPaths=W),M}function k(l,g,I){const N=D.sep===D.posix.sep,M=N?l:l.replace(w,D.sep),V=D.sep+M,W=D.posix.sep+l,_=I?function(G,J){return typeof G=="string"&&(G===M||G.endsWith(V)||!N&&(G===l||G.endsWith(W)))?g:null}:function(G,J){return typeof G=="string"&&(G===M||!N&&G===l)?g:null};return _.allPaths=[(I?"*/":"./")+l],_}function j(l){try{const g=new RegExp(`^${h(l)}$`);return function(I){return g.lastIndex=0,typeof I=="string"&&g.test(I)?l:null}}catch(g){return n}}function B(l,g,I){return!l||typeof g!="string"?!1:$(l)(g,void 0,I)}t.match=B;function $(l,g={}){if(!l)return i;if(typeof l=="string"||Q(l)){const I=s(l,g);if(I===n)return i;const N=function(M,V){return!!I(M,V)};return I.allBasenames&&(N.allBasenames=I.allBasenames),I.allPaths&&(N.allPaths=I.allPaths),N}return re(l,g)}t.parse=$;function K(l){if(!l)return;let g;return I=>(g||(g=(l()||Promise.resolve([])).then(N=>N?te(N):{})),g.then(N=>!!N[I]))}t.hasSiblingPromiseFn=K;function ee(l){if(!l)return;let g;return I=>{if(!g){const N=l();g=N?te(N):{}}return!!g[I]}}t.hasSiblingFn=ee;function te(l){const g={};for(const I of l)g[I]=!0;return g}function Q(l){const g=l;return g&&typeof g.base=="string"&&typeof g.pattern=="string"}t.isRelativePattern=Q;function oe(l){return l.allBasenames||[]}t.getBasenameTerms=oe;function se(l){return l.allPaths||[]}t.getPathTerms=se;function re(l,g){const I=f(Object.getOwnPropertyNames(l).map(_=>p(_,l[_],g)).filter(_=>_!==n)),N=I.length;if(!N)return n;if(!I.some(_=>!!_.requiresSiblings)){if(N===1)return I[0];const _=function(Z,ne){for(let ce=0,ye=I.length;ce<ye;ce++){const be=I[ce](Z,ne);if(be)return be}return null},G=I.find(Z=>!!Z.allBasenames);G&&(_.allBasenames=G.allBasenames);const J=I.reduce((Z,ne)=>ne.allPaths?Z.concat(ne.allPaths):Z,[]);return J.length&&(_.allPaths=J),_}const M=function(_,G,J){let Z;for(let ne=0,ce=I.length;ne<ce;ne++){const ye=I[ne];ye.requiresSiblings&&J&&(G||(G=D.basename(_)),Z||(Z=G.substr(0,G.length-D.extname(_).length)));const be=ye(_,G,Z,J);if(be)return be}return null},V=I.find(_=>!!_.allBasenames);V&&(M.allBasenames=V.allBasenames);const W=I.reduce((_,G)=>G.allPaths?_.concat(G.allPaths):_,[]);return W.length&&(M.allPaths=W),M}function p(l,g,I){if(g===!1)return n;const N=s(l,I);if(N===n)return n;if(typeof g=="boolean")return N;if(g){const M=g.when;if(typeof M=="string"){const V=(W,_,G,J)=>{if(!J||!N(W,_))return null;const Z=M.replace("$(basename)",G),ne=J(Z);return F.isThenable(ne)?ne.then(ce=>ce?l:null):ne?l:null};return V.requiresSiblings=!0,V}}return N}function f(l,g){const I=l.filter(_=>!!_.basenames);if(I.length<2)return l;const N=I.reduce((_,G)=>{const J=G.basenames;return J?_.concat(J):_},[]);let M;if(g){M=[];for(let _=0,G=N.length;_<G;_++)M.push(g)}else M=I.reduce((_,G)=>{const J=G.patterns;return J?_.concat(J):_},[]);const V=function(_,G){if(typeof _!="string")return null;if(!G){let Z;for(Z=_.length;Z>0;Z--){const ne=_.charCodeAt(Z-1);if(ne===47||ne===92)break}G=_.substr(Z)}const J=N.indexOf(G);return J!==-1?M[J]:null};V.basenames=N,V.patterns=M,V.allBasenames=N;const W=l.filter(_=>!_.basenames);return W.push(V),W}}),define(X[62],Y([0,1,7,3,19,8,14,17,35]),function(x,t,m,A,D,R,F,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(s,a,E){if(typeof s=="string"&&(s=m.URI.file(s)),E){const U=E.getWorkspaceFolder(s);if(U){const k=E.getWorkspace().folders.length>1;let j;if(C.isEqual(U.uri,s)?j="":j=C.relativePath(U.uri,s),k){const B=U.name?U.name:C.basename(U.uri);j=j?B+" \u2022 "+j:B}return j}}if(s.scheme!==R.Schemas.file&&s.scheme!==R.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(u.hasDriveLetter(s.fsPath))return A.normalize(y(s.fsPath));let P=A.normalize(s.fsPath);return!F.isWindows&&(a==null?void 0:a.userHome)&&(P=T(P,a.userHome.fsPath)),P}t.getPathLabel=d;function S(s){if(!s)return;typeof s=="string"&&(s=m.URI.file(s));const a=C.basename(s)||(s.scheme===R.Schemas.file?s.fsPath:s.path);return F.isWindows&&u.isRootOrDriveLetter(a)?y(a):a}t.getBaseLabel=S;function y(s){return u.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=y;let w=Object.create(null);function T(s,a){if(F.isWindows||!s||!a)return s;let E=w.original===a?w.normalized:void 0;return E||(E=`${D.rtrim(a,A.posix.sep)}${A.posix.sep}`,w={original:a,normalized:E}),(F.isLinux?s.startsWith(E):D.startsWithIgnoreCase(s,E))&&(s=`~/${s.substr(E.length)}`),s}t.tildify=T;function c(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=c;const h="\u2026",b="\\\\",O="~";function L(s,a=A.sep){const E=new Array(s.length);let P=!1;for(let U=0;U<s.length;U++){let k=s[U];if(k===""){E[U]=`.${a}`;continue}if(!k){E[U]=k;continue}P=!0;let j="";k.indexOf(b)===0?(j=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(a)===0?(j=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(O)===0&&(j=k.substr(0,k.indexOf(O)+O.length),k=k.substr(k.indexOf(O)+O.length));const B=k.split(a);for(let $=1;P&&$<=B.length;$++)for(let K=B.length-$;P&&K>=0;K--){P=!1;let ee=B.slice(K,K+$).join(a);for(let te=0;!P&&te<s.length;te++)if(te!==U&&s[te]&&s[te].indexOf(ee)>-1){const Q=K+$===B.length,oe=K>0&&s[te].indexOf(a)>-1?a+ee:ee,se=s[te].endsWith(oe);P=!Q||se}if(!P){let te="";(B[0].endsWith(":")||j!=="")&&(K===1&&(K=0,$++,ee=B[0]+a+ee),K>0&&(te=B[0]+a),te=j+te),K>0&&(te=te+h+a),te=te+ee,K+$<B.length&&(te=te+a+h),E[U]=te}}P&&(E[U]=k)}return E}t.shorten=L;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function o(s,a=Object.create(null)){const E=[];let P=!1,U="";for(const k of s)if(k==="$"||P&&k==="{")U&&E.push({value:U,type:v.TEXT}),U="",P=!0;else if(k==="}"&&P){const j=a[U];if(typeof j=="string")j.length&&E.push({value:j,type:v.VARIABLE});else if(j){const B=E[E.length-1];(!B||B.type!==v.SEPARATOR)&&E.push({value:j.label,type:v.SEPARATOR})}U="",P=!1}else U+=k;return U&&!P&&E.push({value:U,type:v.TEXT}),E.filter((k,j)=>{if(k.type===v.SEPARATOR){const B=E[j-1],$=E[j+1];return[B,$].every(K=>K&&(K.type===v.VARIABLE||K.type===v.TEXT)&&K.value.length>0)}return!0}).map(k=>k.value).join("")}t.template=o;function r(s,a){return F.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):s.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,a){return F.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):F.isWindows?s.replace(/&&|&/g,E=>E==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const a=s.indexOf("/")!==-1?A.posix:A.win32,E=a.basename(s),P=a.dirname(s);return E.length?{name:E,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(X[46],Y([0,1,124]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class A{constructor(R="utf8"){this.stringDecoder=new m.StringDecoder(R),this.remaining=null}write(R){const F=[],C=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(C.length<1)return F;let u=0,d,S=u;for(;S<C.length;)if(d=C.charCodeAt(S),d===13||d===10){if(F.push(C.substring(u,S)),S++,S<C.length){const y=d;d=C.charCodeAt(S),(y===13&&d===10||y===10&&d===13)&&S++}u=S}else S++;return this.remaining=u<C.length?C.substr(u):null,F}end(){return this.remaining}}t.LineDecoder=A}),define(X[63],Y([0,1,36,19,3,9]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function F(S){const y=D.dirname(S);if(S===y)return S;const w=(D.basename(S)||S).toLowerCase();try{const c=R.readdirSync(y).filter(h=>h.toLowerCase()===w);if(c.length===1){const h=F(y);if(h)return D.join(h,c[0])}else if(c.length>1){const h=c.indexOf(w);if(h>=0){const b=F(y);if(b)return D.join(b,c[h])}}}catch(T){}return null}t.realcaseSync=F;async function C(S){try{return await R.Promises.realpath(S)}catch(y){const w=d(S);return await R.Promises.access(w,m.constants.R_OK),w}}t.realpath=C;function u(S){try{return m.realpathSync(S)}catch(y){const w=d(S);return m.accessSync(w,m.constants.R_OK),w}}t.realpathSync=u;function d(S){return A.rtrim(D.normalize(S),D.sep)}});var pe=this&&this.__await||function(x){return this instanceof pe?(this.v=x,this):new pe(x)},Be=this&&this.__asyncGenerator||function(x,t,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=m.apply(x,t||[]),D,R=[];return D={},F("next"),F("throw"),F("return"),D[Symbol.asyncIterator]=function(){return this},D;function F(w){A[w]&&(D[w]=function(T){return new Promise(function(c,h){R.push([w,T,c,h])>1||C(w,T)})})}function C(w,T){try{u(A[w](T))}catch(c){y(R[0][3],c)}}function u(w){w.value instanceof pe?Promise.resolve(w.value.v).then(d,S):y(R[0][2],w)}function d(w){C("next",w)}function S(w){C("throw",w)}function y(w,T){w(T),R.shift(),R.length&&C(R[0][0],R[0][1])}},We=this&&this.__asyncValues||function(x){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=x[Symbol.asyncIterator],m;return t?t.call(x):(x=typeof __values=="function"?__values(x):x[Symbol.iterator](),m={},A("next"),A("throw"),A("return"),m[Symbol.asyncIterator]=function(){return this},m);function A(R){m[R]=x[R]&&function(F){return new Promise(function(C,u){F=x[R](F),D(C,u,F.done,F.value)})}}function D(R,F,C,u){Promise.resolve(u).then(function(d){R({value:d,done:C})},F)}};define(X[64],Y([0,1,9,31,3]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,F=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var u;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(u||(u={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class y{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function T({useAlternateBitness:o=!1,findPreview:r=!1}={}){const e=w({useAlternateBitness:o});if(!e)return null;const i=D.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const P of await m.Promises.readdir(i)){let U=-1;if(r){const j=P.indexOf("-");if(j<0)continue;const B=P.substring(0,j);if(!R.test(B)||P.substring(j+1)!=="preview")continue;U=parseInt(B,10)}else{if(!R.test(P))continue;U=parseInt(P,10)}if(U<=n)continue;const k=D.join(i,P,"pwsh.exe");!await m.SymlinkSupport.existsFile(k)||(s=k,n=U)}if(!s)return null;const a=e.includes("x86")?" (x86)":"",E=r?" Preview":"";return new y(s,`PowerShell${E}${a}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const r=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await m.Promises.readdir(r))if(e.test(n)){const s=D.join(r,n,"pwsh.exe");return new y(s,i)}return null}function h(){const o=D.join(A.homedir(),".dotnet","tools","pwsh.exe");return new y(o,".NET Core PowerShell Global Tool")}function b(){const o=D.join(process.env.windir,d===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(o,"Windows PowerShell",!0)}function O(){return Be(this,arguments,function*(){let r=yield pe(T());r&&(yield yield pe(r)),r=yield pe(T({useAlternateBitness:!0})),r&&(yield yield pe(r)),r=yield pe(c()),r&&(yield yield pe(r)),r=h(),r&&(yield yield pe(r)),r=yield pe(T({findPreview:!0})),r&&(yield yield pe(r)),r=yield pe(c({findPreview:!0})),r&&(yield yield pe(r)),r=yield pe(T({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield pe(r)),r=b(),r&&(yield yield pe(r))})}function L(){return Be(this,arguments,function*(){var r,e;try{for(var i=We(O()),n;n=yield pe(i.next()),!n.done;){const s=n.value;(yield pe(s.exists()))&&(yield yield pe(s))}}catch(s){r={error:s}}finally{try{n&&!n.done&&(e=i.return)&&(yield pe(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=L;async function v(){var o,r;try{for(var e=We(L()),i;i=await e.next(),!i.done;)return i.value}catch(n){o={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(o)throw o.error}}return null}t.getFirstAvailablePowerShellInstallation=v}),define(X[65],Y([0,1,3,36,14,125,2,9]),function(x,t,m,A,D,R,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function u(y,w,T){return S({path:y,isDirectory:!1},w,T)}t.watchFile=u;function d(y,w,T){return S({path:y,isDirectory:!0},w,T)}t.watchFolder=d,t.CHANGE_BUFFER_DELAY=100;function S(y,w,T){const c=m.basename(y.path),h=new Map;let b=!1,O=[F.toDisposable(()=>{h.forEach(L=>F.dispose(L)),h.clear()})];try{const L=A.watch(y.path);O.push(F.toDisposable(()=>{L.removeAllListeners(),L.close()}));const v=new Set;y.isDirectory&&C.Promises.readdir(y.path).then(o=>o.forEach(r=>v.add(r))),L.on("error",(o,r)=>{b||T(`Failed to watch ${y.path} for changes using fs.watch() (${o}, ${r})`)}),L.on("change",(o,r)=>{if(b)return;let e="";if(r&&(e=r.toString(),D.isMacintosh&&(e=R.normalizeNFC(e))),!e||o!=="change"&&o!=="rename")return;const i=y.isDirectory?m.join(y.path,e):y.path;if(y.isDirectory)if(o==="rename"){const n=h.get(i);n&&F.dispose(n);const s=setTimeout(async()=>{h.delete(i);const a=await C.Promises.exists(i);if(b)return;let E;a?v.has(e)?E="changed":(E="added",v.add(e)):(v.delete(e),E="deleted"),w(E,i)},t.CHANGE_BUFFER_DELAY);h.set(i,F.toDisposable(()=>clearTimeout(s)))}else{let n;v.has(e)?n="changed":(n="added",v.add(e)),w(n,i)}else if(o==="rename"||e!==c){const n=setTimeout(async()=>{const s=await C.Promises.exists(i);b||(s?(w("changed",i),O=[S(y,w,T)]):w("deleted",i))},t.CHANGE_BUFFER_DELAY);F.dispose(O),O=[F.toDisposable(()=>clearTimeout(n))]}else w("changed",i)})}catch(L){C.Promises.exists(y.path).then(v=>{v&&!b&&T(`Failed to watch ${y.path} for changes using fs.watch() (${L.toString()})`)})}return F.toDisposable(()=>{b=!0,O=F.dispose(O)})}});var ue=this&&this.__decorate||function(x,t,m,A){var D=arguments.length,R=D<3?t:A===null?A=Object.getOwnPropertyDescriptor(t,m):A,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,t,m,A);else for(var C=x.length-1;C>=0;C--)(F=x[C])&&(R=(D<3?F(R):D>3?F(t,m,R):F(t,m))||R);return D>3&&R&&Object.defineProperty(t,m,R),R};define(X[37],Y([0,1,10,2,4,26,12,16,22,13,60,19,44]),function(x,t,m,A,D,R,F,C,u,d,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var T;(function(f){f[f.Promise=100]="Promise",f[f.PromiseCancel=101]="PromiseCancel",f[f.EventListen=102]="EventListen",f[f.EventDispose=103]="EventDispose"})(T=t.RequestType||(t.RequestType={}));function c(f){switch(f){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(f){f[f.Initialize=200]="Initialize",f[f.PromiseSuccess=201]="PromiseSuccess",f[f.PromiseError=202]="PromiseError",f[f.PromiseErrorObj=203]="PromiseErrorObj",f[f.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function b(f){switch(f){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var O;(function(f){f[f.Uninitialized=0]="Uninitialized",f[f.Idle=1]="Idle"})(O||(O={}));class L{constructor(l){this.buffer=l,this.pos=0}read(l){const g=this.buffer.slice(this.pos,this.pos+l);return this.pos+=g.byteLength,g}}class v{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(l){this.buffers.push(l)}}var o;(function(f){f[f.Undefined=0]="Undefined",f[f.String=1]="String",f[f.Buffer=2]="Buffer",f[f.VSBuffer=3]="VSBuffer",f[f.Array=4]="Array",f[f.Object=5]="Object"})(o||(o={}));function r(f){const l=C.VSBuffer.alloc(4);return l.writeUInt32BE(f,0),l}function e(f){return f.read(4).readUInt32BE(0)}function i(f){const l=C.VSBuffer.alloc(1);return l.writeUInt8(f,0),l}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},s=typeof Buffer!="undefined";function a(f,l){if(typeof l=="undefined")f.write(n.Undefined);else if(typeof l=="string"){const g=C.VSBuffer.fromString(l);f.write(n.String),f.write(r(g.byteLength)),f.write(g)}else if(s&&Buffer.isBuffer(l)){const g=C.VSBuffer.wrap(l);f.write(n.Buffer),f.write(r(g.byteLength)),f.write(g)}else if(l instanceof C.VSBuffer)f.write(n.VSBuffer),f.write(r(l.byteLength)),f.write(l);else if(Array.isArray(l)){f.write(n.Array),f.write(r(l.length));for(const g of l)a(f,g)}else{const g=C.VSBuffer.fromString(JSON.stringify(l));f.write(n.Object),f.write(r(g.byteLength)),f.write(g)}}function E(f){switch(f.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return f.read(e(f)).toString();case o.Buffer:return f.read(e(f)).buffer;case o.VSBuffer:return f.read(e(f));case o.Array:{const g=e(f),I=[];for(let N=0;N<g;N++)I.push(E(f));return I}case o.Object:return JSON.parse(f.read(e(f)).toString())}}class P{constructor(l,g,I=null,N=1e3){this.protocol=l,this.ctx=g,this.logger=I,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(M=>this.onRawMessage(M)),this.sendResponse({type:200})}registerChannel(l,g){this.channels.set(l,g),setTimeout(()=>this.flushPendingRequests(l),0)}sendResponse(l){switch(l.type){case 200:{const g=this.send([l.type]);this.logger&&this.logger.logOutgoing(g,0,1,b(l.type));return}case 201:case 202:case 204:case 203:{const g=this.send([l.type,l.id],l.data);this.logger&&this.logger.logOutgoing(g,l.id,1,b(l.type),l.data);return}}}send(l,g=void 0){const I=new v;return a(I,l),a(I,g),this.sendBuffer(I.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(g){return 0}}onRawMessage(l){const g=new L(l),I=E(g),N=E(g),M=I[0];switch(M){case 100:return this.logger&&this.logger.logIncoming(l.byteLength,I[1],1,`${c(M)}: ${I[2]}.${I[3]}`,N),this.onPromise({type:M,id:I[1],channelName:I[2],name:I[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(l.byteLength,I[1],1,`${c(M)}: ${I[2]}.${I[3]}`,N),this.onEventListen({type:M,id:I[1],channelName:I[2],name:I[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(l.byteLength,I[1],1,`${c(M)}`),this.disposeActiveRequest({type:M,id:I[1]});case 103:return this.logger&&this.logger.logIncoming(l.byteLength,I[1],1,`${c(M)}`),this.disposeActiveRequest({type:M,id:I[1]})}}onPromise(l){const g=this.channels.get(l.channelName);if(!g){this.collectPendingRequest(l);return}const I=new R.CancellationTokenSource;let N;try{N=g.call(this.ctx,l.name,l.arg,I.token)}catch(W){N=Promise.reject(W)}const M=l.id;N.then(W=>{this.sendResponse({id:M,data:W,type:201}),this.activeRequests.delete(l.id)},W=>{W instanceof Error?this.sendResponse({id:M,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:M,data:W,type:203}),this.activeRequests.delete(l.id)});const V=A.toDisposable(()=>I.cancel());this.activeRequests.set(l.id,V)}onEventListen(l){const g=this.channels.get(l.channelName);if(!g){this.collectPendingRequest(l);return}const I=l.id,M=g.listen(this.ctx,l.name,l.arg)(V=>this.sendResponse({id:I,data:V,type:204}));this.activeRequests.set(l.id,M)}disposeActiveRequest(l){const g=this.activeRequests.get(l.id);g&&(g.dispose(),this.activeRequests.delete(l.id))}collectPendingRequest(l){let g=this.pendingRequests.get(l.channelName);g||(g=[],this.pendingRequests.set(l.channelName,g));const I=setTimeout(()=>{console.error(`Unknown channel: ${l.channelName}`),l.type===100&&this.sendResponse({id:l.id,data:{name:"Unknown channel",message:`Channel name '${l.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);g.push({request:l,timeoutTimer:I})}flushPendingRequests(l){const g=this.pendingRequests.get(l);if(g){for(const I of g)switch(clearTimeout(I.timeoutTimer),I.request.type){case 100:this.onPromise(I.request);break;case 102:this.onEventListen(I.request);break}this.pendingRequests.delete(l)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var U;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(U=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(l,g=null){this.protocol=l,this.isDisposed=!1,this.state=O.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(I=>this.onBuffer(I)),this.logger=g}getChannel(l){const g=this;return{call(I,N,M){return g.isDisposed?Promise.reject(F.canceled()):g.requestPromise(l,I,N,M)},listen(I,N){return g.isDisposed?Promise.reject(F.canceled()):g.requestEvent(l,I,N)}}}requestPromise(l,g,I,N=R.CancellationToken.None){const M=this.lastRequestId++,W={id:M,type:100,channelName:l,name:g,arg:I};if(N.isCancellationRequested)return Promise.reject(F.canceled());let _;return new Promise((J,Z)=>{if(N.isCancellationRequested)return Z(F.canceled());const ne=()=>{const Ae=Te=>{switch(Te.type){case 201:this.handlers.delete(M),J(Te.data);break;case 202:this.handlers.delete(M);const Se=new Error(Te.data.message);Se.stack=Te.data.stack,Se.name=Te.data.name,Z(Se);break;case 203:this.handlers.delete(M),Z(Te.data);break}};this.handlers.set(M,Ae),this.sendRequest(W)};let ce=null;this.state===O.Idle?ne():(ce=D.createCancelablePromise(Ae=>this.whenInitialized()),ce.then(()=>{ce=null,ne()}));const ye=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:M,type:101}),Z(F.canceled())},be=N.onCancellationRequested(ye);_=A.combinedDisposable(A.toDisposable(ye),be),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(l,g,I){const N=this.lastRequestId++,V={id:N,type:102,channelName:l,name:g,arg:I};let W=null;const _=new m.Emitter({onFirstListenerAdd:()=>{W=D.createCancelablePromise(J=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(_),this.sendRequest(V)})},onLastListenerRemove:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(_),this.sendRequest({id:N,type:103}))}}),G=J=>_.fire(J.data);return this.handlers.set(N,G),_.event}sendRequest(l){switch(l.type){case 100:case 102:{const g=this.send([l.type,l.id,l.channelName,l.name],l.arg);this.logger&&this.logger.logOutgoing(g,l.id,0,`${c(l.type)}: ${l.channelName}.${l.name}`,l.arg);return}case 101:case 103:{const g=this.send([l.type,l.id]);this.logger&&this.logger.logOutgoing(g,l.id,0,c(l.type));return}}}send(l,g=void 0){const I=new v;return a(I,l),a(I,g),this.sendBuffer(I.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(g){return 0}}onBuffer(l){const g=new L(l),I=E(g),N=E(g),M=I[0];switch(M){case 200:return this.logger&&this.logger.logIncoming(l.byteLength,0,0,b(M)),this.onResponse({type:I[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(l.byteLength,I[1],0,b(M),N),this.onResponse({type:I[0],id:I[1],data:N})}}onResponse(l){if(l.type===200){this.state=O.Idle,this._onDidInitialize.fire();return}const g=this.handlers.get(l.id);g&&g(l)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===O.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}ue([w.memoize],k.prototype,"onDidInitializePromise",null),t.ChannelClient=k;class j{constructor(l){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,l(({protocol:g,onDidClientDisconnect:I})=>{m.Event.once(g.onMessage)(M=>{const V=new L(M),W=E(V),_=new P(g,W),G=new k(g);this.channels.forEach((Z,ne)=>_.registerChannel(ne,Z));const J={channelServer:_,channelClient:G,ctx:W};this._connections.add(J),this._onDidAddConnection.fire(J),I(()=>{_.dispose(),G.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const l=[];return this._connections.forEach(g=>l.push(g)),l}getChannel(l,g){const I=this;return{call(N,M,V){let W;if(d.isFunction(g)){let G=u.getRandomElement(I.connections.filter(g));W=G?Promise.resolve(G):m.Event.toPromise(m.Event.filter(I.onDidAddConnection,g))}else W=g.routeCall(I,N,M);const _=W.then(G=>G.channelClient.getChannel(l));return $(_).call(N,M,V)},listen(N,M){if(d.isFunction(g))return I.getMulticastEvent(l,g,N,M);const V=g.routeEvent(I,N,M).then(W=>W.channelClient.getChannel(l));return $(V).listen(N,M)}}}getMulticastEvent(l,g,I,N){const M=this;let V=new A.DisposableStore;const W=new m.Emitter({onFirstListenerAdd:()=>{V=new A.DisposableStore;const _=new m.EventMultiplexer,G=new Map,J=ne=>{const ye=ne.channelClient.getChannel(l).listen(I,N),be=_.add(ye);G.set(ne,be)},Z=ne=>{const ce=G.get(ne);!ce||(ce.dispose(),G.delete(ne))};M.connections.filter(g).forEach(J),m.Event.filter(M.onDidAddConnection,g)(J,void 0,V),M.onDidRemoveConnection(Z,void 0,V),_.event(W.fire,W,V),V.add(_)},onLastListenerRemove:()=>{V.dispose()}});return W.event}registerChannel(l,g){this.channels.set(l,g),this._connections.forEach(I=>{I.channelServer.registerChannel(l,g)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=j;class B{constructor(l,g,I=null){const N=new v;a(N,g),l.send(N.buffer),this.channelClient=new k(l,I),this.channelServer=new P(l,g,I)}getChannel(l){return this.channelClient.getChannel(l)}registerChannel(l,g){this.channelServer.registerChannel(l,g)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=B;function $(f){return{call(l,g,I){return f.then(N=>N.call(l,g,I))},listen(l,g){const I=new m.Relay;return f.then(N=>I.input=N.listen(l,g)),I.event}}}t.getDelayedChannel=$;function K(f){let l=!1;return{call(g,I,N){return l?f.call(g,I,N):D.timeout(0).then(()=>l=!0).then(()=>f.call(g,I,N))},listen(g,I){if(l)return f.listen(g,I);const N=new m.Relay;return D.timeout(0).then(()=>l=!0).then(()=>N.input=f.listen(g,I)),N.event}}}t.getNextTickChannel=K;class ee{constructor(l){this.fn=l}routeCall(l){return this.route(l)}routeEvent(l){return this.route(l)}async route(l){for(const g of l.connections)if(await Promise.resolve(this.fn(g.ctx)))return Promise.resolve(g);return await m.Event.toPromise(l.onDidAddConnection),await this.route(l)}}t.StaticRouter=ee;var te;(function(f){function l(N,M){const V=N,W=M&&M.disableMarshalling,_=new Map;for(const G in V)I(G)&&_.set(G,m.Event.buffer(V[G],!0));return new class{listen(G,J){const Z=_.get(J);if(Z)return Z;throw new Error(`Event not found: ${J}`)}call(G,J,Z){const ne=V[J];if(typeof ne=="function"){if(!W&&Array.isArray(Z))for(let ce=0;ce<Z.length;ce++)Z[ce]=S.revive(Z[ce]);return ne.apply(V,Z)}throw new Error(`Method not found: ${J}`)}}}f.fromService=l;function g(N,M){const V=M&&M.disableMarshalling;return new Proxy({},{get(W,_){var G;if(typeof _=="string")return((G=M==null?void 0:M.properties)===null||G===void 0?void 0:G.has(_))?M.properties.get(_):I(_)?N.listen(_):async function(...J){let Z;M&&!d.isUndefinedOrNull(M.context)?Z=[M.context,...J]:Z=J;const ne=await N.call(_,Z);return V?ne:S.revive(ne)};throw new Error(`Property not found: ${String(_)}`)}})}f.toService=g;function I(N){return N[0]==="o"&&N[1]==="n"&&y.isUpperAsciiLetter(N.charCodeAt(2))}})(te=t.ProxyChannel||(t.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(f){if(Array.isArray(f))return f;if(f&&typeof f=="object"&&typeof f.toString=="function"){let l=f.toString();if(l!=="[object Object]")return l}return f}function se(f){return Array.isArray(f)?f.map(oe):oe(f)}function re(f,l,g,I,N,M,V){V=se(V);const W=Q[N],_=W[I%W.length];let G=[`%c[${f}]%c[${String(l).padStart(7," ")}]%c[len: ${String(g).padStart(5," ")}]%c${String(I).padStart(5," ")} - ${M}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(M)?(G=G.concat(V),G.push(")")):G.push(V),console.log.apply(console,G)}t.logWithColors=re;class p{constructor(l,g){this._outgoingPrefix=l,this._incomingPrefix=g,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(l,g,I,N,M){this._totalOutgoing+=l,re(this._outgoingPrefix,this._totalOutgoing,l,g,I,N,M)}logIncoming(l,g,I,N,M){this._totalIncoming+=l,re(this._incomingPrefix,this._totalIncoming,l,g,I,N,M)}}t.IPCLogger=p}),define(X[66],Y([0,1,2,10,4,13]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var C;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(C||(C={}));class u extends m.Disposable{constructor(y,w=Object.create(null)){super();this.database=y,this.options=w,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){var w,T;(w=y.changed)===null||w===void 0||w.forEach((c,h)=>this.accept(h,c)),(T=y.deleted)===null||T===void 0||T.forEach(c=>this.accept(c,void 0))}accept(y,w){if(this.state===C.Closed)return;let T=!1;R.isUndefinedOrNull(w)?T=this.cache.delete(y):this.cache.get(y)!==w&&(this.cache.set(y,w),T=!0),T&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,w){const T=this.cache.get(y);return R.isUndefinedOrNull(T)?w:T}getBoolean(y,w){const T=this.get(y);return R.isUndefinedOrNull(T)?w:T==="true"}getNumber(y,w){const T=this.get(y);return R.isUndefinedOrNull(T)?w:parseInt(T,10)}async set(y,w){if(this.state===C.Closed)return;if(R.isUndefinedOrNull(w))return this.delete(y);const T=String(w);if(this.cache.get(y)!==T)return this.cache.set(y,T),this.pendingInserts.set(y,T),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===C.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{var w;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(w=this.whenFlushedCallbacks.pop())===null||w===void 0||w()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class d{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((w,T)=>this.items.set(T,w)),y.delete&&y.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=d}),define(X[67],Y([5,6]),function(x,t){return x.create("vs/base/common/date",t)}),define(X[68],Y([0,1,67]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const A=60,D=A*60,R=D*24,F=R*7,C=R*30,u=R*365;function d(y,w){typeof y!="number"&&(y=y.getTime());const T=Math.round((new Date().getTime()-y)/1e3);if(T<-30)return m.localize(0,null,d(new Date().getTime()+T*1e3,!1));if(T<30)return m.localize(1,null);let c;return T<A?(c=T,w?c===1?m.localize(2,null,c):m.localize(3,null,c):c===1?m.localize(4,null,c):m.localize(5,null,c)):T<D?(c=Math.floor(T/A),w?c===1?m.localize(6,null,c):m.localize(7,null,c):c===1?m.localize(8,null,c):m.localize(9,null,c)):T<R?(c=Math.floor(T/D),w?c===1?m.localize(10,null,c):m.localize(11,null,c):c===1?m.localize(12,null,c):m.localize(13,null,c)):T<F?(c=Math.floor(T/R),w?c===1?m.localize(14,null,c):m.localize(15,null,c):c===1?m.localize(16,null,c):m.localize(17,null,c)):T<C?(c=Math.floor(T/F),w?c===1?m.localize(18,null,c):m.localize(19,null,c):c===1?m.localize(20,null,c):m.localize(21,null,c)):T<u?(c=Math.floor(T/C),w?c===1?m.localize(22,null,c):m.localize(23,null,c):c===1?m.localize(24,null,c):m.localize(25,null,c)):(c=Math.floor(T/u),w?c===1?m.localize(26,null,c):m.localize(27,null,c):c===1?m.localize(28,null,c):m.localize(29,null,c))}t.fromNow=d;function S(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=S}),define(X[69],Y([5,6]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(X[28],Y([0,1,69,13,22]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(d,S){return S&&(d.stack||d.stacktrace)?m.localize(0,null,C(d),F(d.stack)||F(d.stacktrace)):C(d)}function F(d){return Array.isArray(d)?d.join(`
`):d}function C(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?m.localize(1,null,d.message):d.message||m.localize(2,null)}function u(d=null,S=!1){if(!d)return m.localize(3,null);if(Array.isArray(d)){const y=D.coalesce(d),w=u(y[0],S);return y.length>1?m.localize(4,null,w,y.length):w}if(A.isString(d))return d;if(d.detail){const y=d.detail;if(y.error)return R(y.error,S);if(y.exception)return R(y.exception,S)}return d.stack?R(d,S):d.message?d.message:m.localize(5,null)}t.toErrorMessage=u}),define(X[70],Y([5,6]),function(x,t){return x.create("vs/base/node/processes",t)}),define(X[47],Y([0,1,3,9,32,70,33,13,20,35,14,46,8]),function(x,t,m,A,D,R,F,C,u,d,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function T(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,r){if(S.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,a)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?T(e.status):1})}else if(S.isLinux||S.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(i=>{D.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function h(o=F.env){return o.comspec||"cmd.exe"}t.getWindowsShell=h;class b{constructor(r,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=n;else{const s=r;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(F.env).forEach(a=>{s[a]=F.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(m.sep);return e!==-1&&(r=r.substring(e+1)),b.WellKnowCommands[r]?r:"other"}start(r){return S.isWindows&&(this.options&&this.options.cwd&&d.isUNC(this.options.cwd)||!this.options&&d.isUNC(F.cwd()))?Promise.reject(new Error(R.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((a,E)=>{i=a,n=E});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=D.exec(a,this.options,(E,P,U)=>{this.childProcess=null;const k=E;k&&k.killed?n({killed:this.terminateRequested,stdout:P.toString(),stderr:U.toString()}):this.handleExec(i,r,E,P,U)})}else{let a=null;const E=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,i,r,n);const U={terminated:this.terminateRequested};C.isNumber(P)&&(U.cmdCode=P),i(U)};if(this.shell&&S.isWindows){const P=u.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let U=!1,k=!1;const j=[];let B=this.ensureQuotes(this.cmd);j.push(B.value),U=B.quoted,this.args&&this.args.forEach(K=>{B=this.ensureQuotes(K),j.push(B.value),k=k&&B.quoted});const $=["/s","/c"];U?k?$.push('"'+j.join(" ")+'"'):j.length>1?$.push('"'+j[0]+'" '+j.slice(1).join(" ")):$.push('"'+j[0]+'"'):$.push(j.join(" ")),a=D.spawn(h(),$,P)}else this.cmd&&(a=D.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",P=>{this.childProcess=null,n({terminated:this.terminateRequested,error:P})}),a.pid&&(this.childProcess.on("close",E),this.handleSpawn(a,i,r,n,!0)))}return s})}handleClose(r,e,i,n){}ensureQuotes(r){return b.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,c(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!S.isWindows)return r(!1);const e=D.spawn(h(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class O extends b{constructor(r,e,i,n){super(r,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,n,s){[n,s].forEach((a,E)=>{const P=new y.LineDecoder;P.write(a).forEach(j=>{e({line:j,source:E===0?0:1})});const k=P.end();k&&e({line:k,source:E===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,n,s){const a=new y.LineDecoder,E=new y.LineDecoder;r.stdout.on("data",P=>{a.write(P).forEach(k=>i({line:k,source:0}))}),r.stderr.on("data",P=>{E.write(P).forEach(k=>i({line:k,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=E}handleClose(r,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=O;function L(o){let r=[],e=!1;const i=function(n){if(e){r.push(n);return}(!o.send(n,a=>{if(a&&console.error(a),e=!1,r.length>0){const E=r.slice(0);r=[],E.forEach(P=>i(P))}})||S.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=L;var v;(function(o){async function r(e,i,n){if(m.isAbsolute(e))return e;if(i===void 0&&(i=F.cwd()),m.dirname(e)!=="."||(n===void 0&&C.isString(F.env.PATH)&&(n=F.env.PATH.split(m.delimiter)),n===void 0||n.length===0))return m.join(i,e);async function a(E){return await A.Promises.exists(E)?!(await A.Promises.stat(E)).isDirectory():!1}for(let E of n){let P;if(m.isAbsolute(E)?P=m.join(E,e):P=m.join(i,E,e),await a(P))return P;let U=P+".com";if(await a(U)||(U=P+".exe",await a(U)))return U}return m.join(i,e)}o.findExecutable=r})(v=t.win32||(t.win32={}))}),define(X[71],Y([0,1,31,14,64,47]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(T,c){return T===1?A.isWindows?y():R.getWindowsShell(c):d(T,c)}t.getSystemShell=F;function C(T,c){return T===1?A.isWindows?w(c):R.getWindowsShell(c):d(T,c)}t.getSystemShellSync=C;let u=null;function d(T,c){if(A.isLinux&&T===2||A.isMacintosh&&T===3)return"/bin/bash";if(!u){let h;if(A.isWindows)h="/bin/bash";else{if(h=c.SHELL,!h)try{h=m.userInfo().shell}catch(b){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}u=h}return u}let S=null;async function y(){return S||(S=(await D.getFirstAvailablePowerShellInstallation()).exePath),S}function w(T){if(S)return S;const c=A.isWindows&&parseFloat(m.release())>=10,h=T.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${T.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?b:R.getWindowsShell(T)}}),define(X[48],Y([0,1,32,2,4,20,10,47,37,59,26,12,16,14]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends u.ChannelServer{constructor(O){super({send:L=>{try{process.send&&process.send(L.buffer.toString("base64"))}catch(v){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",L=>w.VSBuffer.wrap(Buffer.from(L,"base64")))},O);process.once("disconnect",()=>this.dispose())}}t.Server=c;class h{constructor(O,L){this.modulePath=O,this.options=L,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=L&&L.timeout?L.timeout:6e4;this.disposeDelayer=new D.Delayer(v),this.child=null,this._client=null}getChannel(O){const L=this;return{call(v,o,r){return L.requestPromise(O,v,o,r)},listen(v,o){return L.requestEvent(O,v,o)}}}requestPromise(O,L,v,o=S.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(O),e=D.createCancelablePromise(s=>r.call(L,v,s)),i=o.onCancellationRequested(()=>e.cancel()),n=A.toDisposable(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(O,L,v){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let o;const r=new F.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(O).listen(L,v)(r.fire,r),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const O=this.options&&this.options.args?this.options.args:[],L=Object.create(null);L.env=Object.assign(Object.assign({},R.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(L.env=Object.assign(Object.assign({},L.env),this.options.env)),this.options&&this.options.freshExecArgv&&(L.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(L.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(L.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),L.execArgv===void 0&&(L.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),T.isMacintosh&&L.env&&delete L.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,O,L);const v=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if(d.isRemoteConsoleLog(a)){d.log(a,`IPC Library: ${this.options.serverName}`);return}v.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const r=this.options.useQueue?C.createQueuedSender(this.child):this.child,e=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),i=v.event,n={send:e,onMessage:i};this._client=new u.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,E)=>{process.removeListener("exit",s),this.activeRequests.forEach(P=>A.dispose(P)),this.activeRequests.clear(),a!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:E})})}return this._client}getCachedChannel(O){let L=this.channels.get(O);return L||(L=this.client.getChannel(O),this.channels.set(O,L)),L}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=h}),define(X[72],Y([5,6]),function(x,t){return x.create("vs/base/node/zip",t)}),define(X[73],Y([5,6]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(X[74],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(X[75],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(X[76],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(X[77],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(X[78],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(X[79],Y([5,6]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(X[80],Y([5,6]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(X[81],Y([5,6]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(X[82],Y([5,6]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(X[83],Y([5,6]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(X[84],Y([5,6]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(X[85],Y([0,1,3,17,44,68,8,7,33]),function(x,t,m,A,D,R,F,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(c,h,b){this._args=c,this.paths=h,this.productService=b}get appRoot(){return m.dirname(F.FileAccess.asFileUri("",x).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return A.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return A.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=R.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return A.joinPath(C.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return A.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return A.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=u.env.VSCODE_PORTABLE;return c?C.URI.file(m.join(c,"argv.json")):A.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return A.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?m.resolve(c):m.normalize(m.join(F.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?m.resolve(c):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return m.resolve(c);const h=u.env.VSCODE_EXTENSIONS;if(h)return h;const b=u.env.VSCODE_PORTABLE;return b?m.join(b,"extensions"):A.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(h=>/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file(m.normalize(h)))}get extensionDevelopmentKind(){var c;return(c=this.args.extensionDevelopmentKind)===null||c===void 0?void 0:c.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file(m.normalize(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!u.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return A.joinPath(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([D.memoize],d.prototype,"appRoot",null),ue([D.memoize],d.prototype,"userHome",null),ue([D.memoize],d.prototype,"userDataPath",null),ue([D.memoize],d.prototype,"appSettingsHome",null),ue([D.memoize],d.prototype,"tmpDir",null),ue([D.memoize],d.prototype,"userRoamingDataHome",null),ue([D.memoize],d.prototype,"settingsResource",null),ue([D.memoize],d.prototype,"userDataSyncHome",null),ue([D.memoize],d.prototype,"userDataSyncLogResource",null),ue([D.memoize],d.prototype,"sync",null),ue([D.memoize],d.prototype,"machineSettingsResource",null),ue([D.memoize],d.prototype,"globalStorageHome",null),ue([D.memoize],d.prototype,"workspaceStorageHome",null),ue([D.memoize],d.prototype,"keybindingsResource",null),ue([D.memoize],d.prototype,"keyboardLayoutResource",null),ue([D.memoize],d.prototype,"argvResource",null),ue([D.memoize],d.prototype,"snippetsHome",null),ue([D.memoize],d.prototype,"isExtensionDevelopment",null),ue([D.memoize],d.prototype,"untitledWorkspacesHome",null),ue([D.memoize],d.prototype,"installSourcePath",null),ue([D.memoize],d.prototype,"builtinExtensionsPath",null),ue([D.memoize],d.prototype,"extensionsPath",null),ue([D.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ue([D.memoize],d.prototype,"extensionDevelopmentKind",null),ue([D.memoize],d.prototype,"extensionTestsLocationURI",null),ue([D.memoize],d.prototype,"debugExtensionHost",null),ue([D.memoize],d.prototype,"serviceMachineIdResource",null),ue([D.memoize],d.prototype,"telemetryLogResource",null),ue([D.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function S(T,c){return w(T["inspect-extensions"],T["inspect-brk-extensions"],5870,c,T.debugId)}t.parseExtensionHostPort=S;function y(T,c){return w(T["inspect-search"],T["inspect-brk-search"],5876,c)}t.parseSearchPort=y;function w(T,c,h,b,O){const v=Number(c||T)||(b?null:h),o=v?Boolean(!!c):!1;return{port:v,break:o,debugId:O}}}),function(){"use strict";function x(t,m,A,D){function R(C){const u=F(C),d=[u];return t.isAbsolute(u)||d.unshift(D),t.resolve(...d)}function F(C){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");const d=C["user-data-dir"];if(d)return d;let S=process.env.VSCODE_APPDATA;if(!S)switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=t.join(y,"AppData","Roaming")}break;case"darwin":S=t.join(m.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(S,A)}return{getUserDataPath:R}}if(typeof define=="function")define(X[86],Y([0,87,31,8,17,33]),function(t,m,A,D,R,F){const C=R.dirname(D.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return x(m,A,u.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),A=require("os");module.exports=x(m,A,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[88],Y([0,1,31,86,85]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(C,u){super(C,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:A.getUserDataPath(C)},u)}}t.NativeEnvironmentService=R}),define(X[89],Y([0,1,20]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function D(R,F){const C=u=>{var d;if(typeof u!="string")return;const S=A.exec(u);if(!S)return;const y=(d=F[S[1]])!==null&&d!==void 0?d:u;return typeof y=="string"?y:typeof y.message=="string"?y.message:u};return m.cloneAndChange(R,C)}t.localizeManifest=D}),define(X[49],Y([0,1,79]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function R(w){return w=w.trim(),w==="*"||A.test(w)}t.isValidVersionStr=R;function F(w){if(!R(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let T=w.match(A);return T?{hasCaret:T[1]==="^",hasGreaterEquals:T[1]===">=",majorBase:T[2]==="x"?0:parseInt(T[2],10),majorMustEqual:T[2]!=="x",minorBase:T[4]==="x"?0:parseInt(T[4],10),minorMustEqual:T[4]!=="x",patchBase:T[6]==="x"?0:parseInt(T[6],10),patchMustEqual:T[6]!=="x",preRelease:T[8]||null}:null}t.parseVersion=F;function C(w){if(!w)return null;let T=w.majorBase,c=w.majorMustEqual,h=w.minorBase,b=w.minorMustEqual,O=w.patchBase,L=w.patchMustEqual;w.hasCaret&&(T===0||(b=!1),L=!1);let v=0;if(w.preRelease){const o=D.exec(w.preRelease);if(o){const[,r,e,i]=o;v=Date.UTC(Number(r),Number(e)-1,Number(i))}}return{majorBase:T,majorMustEqual:c,minorBase:h,minorMustEqual:b,patchBase:O,patchMustEqual:L,isMinimum:w.hasGreaterEquals,notBefore:v}}t.normalizeVersion=C;function u(w,T,c){let h;typeof w=="string"?h=C(F(w)):h=w;let b;T instanceof Date?b=T.getTime():typeof T=="string"&&(b=new Date(T).getTime());let O;if(typeof c=="string"?O=C(F(c)):O=c,!h||!O)return!1;let L=h.majorBase,v=h.minorBase,o=h.patchBase,r=O.majorBase,e=O.minorBase,i=O.patchBase,n=O.notBefore,s=O.majorMustEqual,a=O.minorMustEqual,E=O.patchMustEqual;return O.isMinimum?L>r?!0:L<r?!1:v>e?!0:v<e||b&&b<n?!1:o>=i:(L===1&&r===0&&(!s||!a||!E)&&(r=1,e=0,i=0,s=!0,a=!1,E=!1),L<r?!1:L>r?!s:v<e?!1:v>e?!a:o<i?!1:o>i?!E:!(b&&b<n))}t.isValidVersion=u;function d(w,T,c,h){return c.isBuiltin||typeof c.main=="undefined"?!0:y(w,T,c.engines.vscode,h)}t.isValidExtensionVersion=d;function S(w,T,c){return w==="*"||y(T,c,w)}t.isEngineValid=S;function y(w,T,c,h=[]){let b=C(F(c));if(!b)return h.push(m.localize(0,null,c)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return h.push(m.localize(1,null,c)),!1}else if(!b.majorMustEqual)return h.push(m.localize(2,null,c)),!1;return u(w,T,b)?!0:(h.push(m.localize(3,null,w,c)),!1)}}),define(X[90],Y([0,1,37,48,2,8]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends D.Disposable{constructor(u,d,S,y){super();this.folders=u,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(R.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(X[91],Y([0,1,37,48,2,8]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends D.Disposable{constructor(u,d,S,y,w={}){super();this.folders=u,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=y,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(R.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(u.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(X[92],Y([0,1,32,46,61,8]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(u,d,S,y,w){this.watchedFolder=u,this.eventCallback=S,this.logCallback=y,this.verboseLogging=w,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(T=>D.parse(T)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=m.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,u);const d=new A.LineDecoder;this.handle.stdout.on("data",S=>{const y=[];for(const w of d.write(S)){const T=w.split("|");if(T.length===2){const c=Number(T[0]),h=T[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(b=>b(h))){this.verboseLogging&&this.log(h);continue}y.push({type:F.changeTypeMap[c],path:h})}else this.log(T[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",S=>this.onError(S)),this.handle.stderr.on("data",S=>this.onError(S)),this.handle.on("exit",(S,y)=>this.onExit(S,y))}onError(u){this.error("process error: "+u.toString())}onExit(u,d){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${d})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(X[93],Y([0,1,92,3,19]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R{constructor(C,u,d,S){this.onDidFilesChange=u,this.onLogMessage=d,this.verboseLogging=S,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=D.rtrim(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=R}),define(X[50],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class m{constructor(R,F=[],C=!1){this.ctor=R,this.staticArguments=F,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=m;const A=(D,...R)=>new m(D,R);t.createSyncDescriptor=A}),define(X[94],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=m;class A{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let F of this._nodes.values())F.outgoing.size===0&&R.push(F);return R}insertEdge(R,F){const C=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(F);C.outgoing.set(this._hashFn(F),u),u.incoming.set(this._hashFn(R),C)}removeNode(R){const F=this._hashFn(R);this._nodes.delete(F);for(let C of this._nodes.values())C.outgoing.delete(F),C.incoming.delete(F)}lookupOrInsertNode(R){const F=this._hashFn(R);let C=this._nodes.get(F);return C||(C=new m(R),this._nodes.set(F,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[F,C]of this._nodes)R.push(`${F}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,F]of this._nodes){const C=new Set([R]),u=this._findCycle(F,C);if(u)return u}}_findCycle(R,F){for(let[C,u]of R.outgoing){if(F.has(C))return[...F,C].join(" -> ");F.add(C);const d=this._findCycle(u,F);if(d)return d;F.delete(C)}}}t.Graph=A}),define(X[95],Y([0,1,11]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=m.createDecorator("downloadService")}),define(X[21],Y([0,1,11]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=m.createDecorator("environmentService"),t.INativeEnvironmentService=m.refineServiceDecorator(t.IEnvironmentService)}),define(X[23],Y([0,1,74,11,8]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function R(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=R;var F;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var C;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(C=t.SortOrder||(t.SortOrder={}));var u;(function(y){y.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var d;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(d=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=A.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(w,T){super(w);this.code=T}}t.ExtensionManagementError=S,t.IExtensionManagementService=A.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=A.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=A.createDecorator("IExtensionTipsService"),t.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=m.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=m.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=A.createDecorator("IExtensionManagementCLIService")}),define(X[38],Y([0,1,19,11]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkpaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}t.getWorkpaceSupportTypeMessage=D;function R(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(F=t.ExtensionType||(t.ExtensionType={}));class C{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y=="undefined"||y===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){let T=typeof y=="string"?y:y.value,c=typeof w=="string"?w:w.value;return m.equalsIgnoreCase(T,c)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}t.ExtensionIdentifier=C;function u(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function d(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=A.createDecorator("IBuiltinExtensionsScannerService")}),define(X[24],Y([0,1,19,38]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function D(T,c){return T.uuid&&c.uuid?T.uuid===c.uuid:T.id===c.id?!0:m.compareIgnoreCase(T.id,c.id)===0}t.areSameExtensions=D;class R{constructor(c,h){this.version=h,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof R?D(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=R;function F(T,c){return`${T}.${c}`}t.getExtensionId=F;function C(T){return T.toLocaleLowerCase()}t.adoptToGalleryExtensionId=C;function u(T,c){return C(F(T,c))}t.getGalleryExtensionId=u;function d(T,c){const h=[],b=O=>{for(const L of h)if(L.some(v=>D(c(v),c(O))))return L;return null};for(const O of T){const L=b(O);L?L.push(O):h.push([O])}return h}t.groupByExtension=d;function S(T){return{id:T.identifier.id,name:T.manifest.name,galleryId:null,publisherId:T.publisherId,publisherName:T.manifest.publisher,publisherDisplayName:T.publisherDisplayName,dependencies:T.manifest.extensionDependencies&&T.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=S;function y(T){return Object.assign({id:T.identifier.id,name:T.name,galleryId:T.identifier.uuid,publisherId:T.publisherId,publisherName:T.publisher,publisherDisplayName:T.publisherDisplayName,dependencies:!!(T.properties.dependencies&&T.properties.dependencies.length>0)},T.telemetryData)}t.getGalleryExtensionTelemetryData=y,t.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function w(T){const c=new Set;for(const h of T)h.malicious&&c.add(h.id.id);return c}t.getMaliciousExtensionsSet=w});var fe=this&&this.__param||function(x,t){return function(m,A){t(m,A,x)}};define(X[96],Y([0,1,75,12,7,39,23,24,38,62,26,8]),function(x,t,m,A,D,R,F,C,u,d,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=L=>m.localize(0,null,L),T=m.localize(1,null,"ms-dotnettools.csharp");function c(L,v){return v?`${L.publisher}.${L.name}@${L.version}`:`${L.publisher}.${L.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(L){const v=h.exec(L);return v&&v[1]?[C.adoptToGalleryExtensionId(v[1]),v[2]]:[C.adoptToGalleryExtensionId(L),void 0]}t.getIdAndVersion=b;let O=class{constructor(v,o){this.extensionManagementService=v,this.extensionGalleryService=o}get location(){}async listExtensions(v,o,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=u.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){r.log("Possible Categories: "),i.forEach(s=>{r.log(s)});return}this.location&&r.log(m.localize(2,null,this.location)),e=e.sort((s,a)=>s.identifier.id.localeCompare(a.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,r.log(c(s.manifest,v)))}async installExtensions(v,o,r,e,i=console){const n=[],s=[];v.length&&i.log(this.location?m.localize(3,null,this.location):m.localize(4,null));const a=await this.extensionManagementService.getInstalled(1),E=(k,j)=>{const B=a.find($=>C.areSameExtensions($.identifier,{id:k}));if(B){if(!j&&!e)return i.log(m.localize(5,null,k,B.manifest.version,k)),!1;if(j&&B.manifest.version===j)return i.log(m.localize(6,null,`${k}@${j}`)),!1}return!0},P=[],U=[];for(const k of v)if(k instanceof D.URI)P.push(k);else{const[j,B]=b(k);E(j,B)&&U.push({id:j,version:B,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const k of o){const[j,B]=b(k);E(j,B)&&U.push({id:j,version:B,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async k=>{try{const j=await this.installVSIX(k,{isBuiltin:!1,isMachineScoped:r},e,i);j&&s.push(j)}catch(j){i.error(j.message||j.stack||j),n.push(k.toString())}})),U.length){const k=await this.getGalleryExtensions(U);await Promise.all(U.map(async j=>{const B=k.get(j.id.toLowerCase());if(B)try{const $=await this.installFromGallery(j,B,a,e,i);$&&s.push($)}catch($){i.error($.message||$.stack||$),n.push(j.id)}else i.error(`${w(j.version?`${j.id}@${j.version}`:j.id)}
${T}`),n.push(j.id)}))}if(n.length)throw new Error(m.localize(7,null,n.join(", ")))}async installVSIX(v,o,r,e){const i=await this.extensionManagementService.getManifest(v);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(v,o),e.log(m.localize(8,null,d.getBaseLabel(v))),i}catch(s){if(A.isPromiseCanceledError(s))return e.log(m.localize(9,null,d.getBaseLabel(v))),null;throw s}return null}async getGalleryExtensions(v){const o=v.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=v.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(o,S.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:v,version:o,installOptions:r},e,i,n,s){const a=await this.extensionGalleryService.getManifest(e,S.CancellationToken.None);if(a&&!this.validateExtensionKind(a,s))return null;const E=i.find(P=>C.areSameExtensions(P.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return s.log(m.localize(10,null,o?`${v}@${o}`:v)),null;s.log(m.localize(11,null,v,e.version))}try{return r.isBuiltin?s.log(o?m.localize(12,null,v,o):m.localize(13,null,v)):s.log(o?m.localize(14,null,v,o):m.localize(15,null,v)),await this.extensionManagementService.installFromGallery(e,r),s.log(m.localize(16,null,v,e.version)),a}catch(P){if(A.isPromiseCanceledError(P))return s.log(m.localize(17,null,v)),null;throw P}}validateExtensionKind(v,o){return!0}async validateVSIX(v,o,r){const e={id:C.getGalleryExtensionId(v.publisher,v.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>C.areSameExtensions(e,s.identifier)&&R.gt(s.manifest.version,v.version));return n&&!o?(r.log(m.localize(18,null,n.identifier.id,n.manifest.version,v.version)),!1):this.validateExtensionKind(v,r)}async uninstallExtensions(v,o,r=console){const e=async n=>{if(n instanceof D.URI){const s=await this.extensionManagementService.getManifest(n);return c(s)}return n},i=[];for(const n of v){const s=await e(n),E=(await this.extensionManagementService.getInstalled()).filter(P=>C.areSameExtensions(P.identifier,{id:s}));if(!E.length)throw new Error(`${this.notInstalled(s)}
${T}`);if(E.some(P=>P.type===0)){r.log(m.localize(19,null,s));return}if(!o&&E.some(P=>P.isBuiltin)){r.log(m.localize(20,null,s));return}r.log(m.localize(21,null,s));for(const P of E)await this.extensionManagementService.uninstall(P),i.push(P);this.location?r.log(m.localize(22,null,s,this.location)):r.log(m.localize(23,null,s))}}async locateExtension(v,o=console){const r=await this.extensionManagementService.getInstalled();v.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===y.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(v){return this.location?m.localize(24,null,v,this.location):m.localize(25,null,v)}};O=ue([fe(0,F.IExtensionManagementService),fe(1,F.IExtensionGalleryService)],O),t.ExtensionManagementCLIService=O}),define(X[97],Y([0,1,2,3,38,9]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends m.Disposable{constructor(u,d){super();this.environmentService=u,this.extensionsManifestCache=A.join(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtension(S=>this.onDidInstallExtension(S))),this._register(d.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtension(u){u.error||this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(X[98],Y([0,1,87,32,29,14,126,28,71,26,12]),function(x,t,m,A,D,R,F,C,u,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function y(c,h,b){return h["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):F.isLaunchedFromCli(b)&&!h["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(F.isLaunchedFromCli(b)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=new Promise(async O=>{const L=new d.CancellationTokenSource,v=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),L.dispose(!0),O({})},1e4);try{const o=await T(c,L.token);O(o)}catch(o){S.isPromiseCanceledError(o)||c.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),O({})}finally{clearTimeout(v),L.dispose()}})),w)}t.resolveShellEnv=y;let w;async function T(c,h){const b=new Promise(async(O,L)=>{const v=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",v);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",o);const r=D.generateUuid().replace(/-/g,"").substr(0,12),e=new RegExp(r+"(.*)"+r),i=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});c.trace("getUnixShellEnvironment#env",i);const n=await u.getSystemShell(R.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),h.isCancellationRequested)return L(S.canceled);const s=m.basename(n);let a,E;/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' -p '''${r}'' + JSON.stringify(process.env) + ''${r}'''`,E=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,E=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),a);const P=A.spawn(n,[...E,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});h.onCancellationRequested(()=>(P.kill(),L(S.canceled))),P.on("error",j=>{c.error("getUnixShellEnvironment#errorChildProcess",C.toErrorMessage(j)),O({})});const U=[];P.stdout.on("data",j=>U.push(j));const k=[];P.stderr.on("data",j=>k.push(j)),P.on("close",(j,B)=>{const $=Buffer.concat(U).toString("utf8");c.trace("getUnixShellEnvironment#raw",$);const K=Buffer.concat(k).toString("utf8");if(K.trim()&&c.trace("getUnixShellEnvironment#stderr",K),j||B)return L(new Error(`Failed to get environment (code ${j}, signal ${B})`));const ee=e.exec($),te=ee?ee[1]:"{}";try{const Q=JSON.parse(te);v?Q.ELECTRON_RUN_AS_NODE=v:delete Q.ELECTRON_RUN_AS_NODE,o?Q.ELECTRON_NO_ATTACH_CONSOLE=o:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Q),O(Q)}catch(Q){c.error("getUnixShellEnvironment#errorCaught",C.toErrorMessage(Q)),L(Q)}})});try{return await b}catch(O){return c.error("getUnixShellEnvironment#error",C.toErrorMessage(O)),{}}}}),define(X[51],Y([0,1,7,18,14]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function R(u){return u.map(d=>({type:d.type,resource:m.URI.file(d.path)}))}t.toFileChanges=R;function F(u){const d=new C;for(const S of u)d.processEvent(S);return d.normalize()}t.normalizeFileChanges=F;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const S=this.mapPathToChange.get(d.path);if(S){const y=S.type,w=d.type;y===1&&w===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(S),1)):y===2&&w===1?S.type=0:y===1&&w===0||(S.type=w)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],S=[];return this.normalized.filter(y=>y.type!==2?(d.push(y),!1):!0).sort((y,w)=>y.path.length-w.path.length).filter(y=>S.some(w=>A.isParent(y.path,w,!D.isLinux))?!1:(S.push(y.path),!0)).concat(d)}}}),define(X[99],Y([0,1,51,2,9,63,65,4,3]),function(x,t,m,A,D,R,F,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends A.Disposable{constructor(y,w,T,c){super();this.path=y,this.onDidFilesChange=w,this.onLogMessage=T,this.verboseLogging=c,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:w}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let T=this.path;if(w)try{T=await R.realpath(T)}catch(c){if(this.onError(c),w.dangling)return}y.isDirectory()?this._register(F.watchFolder(T,(c,h)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:u.join(this.path,u.basename(h))})},c=>this.onError(c))):this._register(F.watchFile(T,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const T=m.normalizeFileChanges(w);if(this.verboseLogging)for(const c of T)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);T.length>0&&this.onDidFilesChange(T)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(X[52],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[R,F]of D)this.set(R,F)}set(D,R){const F=this._entries.get(D);return this._entries.set(D,R),F}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}t.ServiceCollection=m}),define(X[100],Y([0,1,12,94,50,11,52,4]),function(x,t,m,A,D,R,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class d extends Error{constructor(c){var h;super("cyclic dependency between services");this.message=(h=c.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class S{constructor(c=new F.ServiceCollection,h=!1,b){this._activeInstantiations=new Set,this._services=c,this._strict=h,this._parent=b,this._services.set(R.IInstantiationService,this)}createChild(c){return new S(c,this._strict,this)}invokeFunction(c,...h){let b=w.traceInvocation(c),O=!1;try{return c({get:(v,o)=>{if(O)throw m.illegalState("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(v,b);if(!r&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...h)}finally{O=!0,b.stop()}}createInstance(c,...h){let b,O;return c instanceof D.SyncDescriptor?(b=w.traceCreation(c.ctor),O=this._createInstance(c.ctor,c.staticArguments.concat(h),b)):(b=w.traceCreation(c),O=this._createInstance(c,h,b)),b.stop(),O}_createInstance(c,h=[],b){let O=R._util.getServiceDependencies(c).sort((o,r)=>o.index-r.index),L=[];for(const o of O){let r=this._getOrCreateServiceInstance(o.id,b);if(!r&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);L.push(r)}let v=O.length>0?O[0].index:h.length;if(h.length!==v){console.warn(`[createInstance] First service dependency of ${c.name} at position ${v+1} conflicts with ${h.length} static arguments`);let o=v-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,v)}return new c(...[...h,...L])}_setServiceInstance(c,h){if(this._services.get(c)instanceof D.SyncDescriptor)this._services.set(c,h);else if(this._parent)this._parent._setServiceInstance(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let h=this._services.get(c);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):h}_getOrCreateServiceInstance(c,h){let b=this._getServiceInstanceOrDescriptor(c);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,b,h.branch(c,!0)):(h.branch(c,!1),b)}_safeCreateAndCacheServiceInstance(c,h,b){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,h,b)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,h,b){const O=new A.Graph(o=>o.id.toString());let L=0;const v=[{id:c,desc:h,_trace:b}];for(;v.length;){const o=v.pop();if(O.lookupOrInsertNode(o),L++>1e3)throw new d(O);for(let r of R._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`),e instanceof D.SyncDescriptor){const i={id:r.id,desc:e,_trace:o._trace.branch(r.id,!0)};O.insertEdge(o,i),v.push(i)}}}for(;;){const o=O.roots();if(o.length===0){if(!O.isEmpty())throw new d(O);break}for(const{data:r}of o){if(this._getServiceInstanceOrDescriptor(r.id)instanceof D.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}O.removeNode(r)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,h,b=[],O,L){if(this._services.get(c)instanceof D.SyncDescriptor)return this._createServiceInstance(h,b,O,L);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,h,b,O,L);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(c,h=[],b,O){if(b){const L=new C.IdleValue(()=>this._createInstance(c,h,O));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let r=L.value,e=r[o];return typeof e!="function"||(e=e.bind(r),v[o]=e),e},set(v,o,r){return L.value[o]=r,!0}})}else return this._createInstance(c,h,O)}}t.InstantiationService=S;var y;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(y||(y={}));class w{constructor(c,h){this.type=c,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return u?new w(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(c){return u?new w(0,c.name):w._None}branch(c,h){let b=new w(2,c.toString());return this._dep.push([c,h,b]),b}stop(){let c=Date.now()-this._start;w._totals+=c;let h=!1;function b(L,v){let o=[],r=new Array(L+1).join("	");for(const[e,i,n]of v._dep)if(i&&n){h=!0,o.push(`${r}CREATES -> ${e}`);let s=b(L+1,n);s&&o.push(s)}else o.push(`${r}uses -> ${e}`);return o.join(`
`)}let O=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(c>2||h)&&console.log(O.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(X[53],Y([0,1,11]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=m.createDecorator("localizationsService");function A(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const R of D.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}t.isValidLocalization=A}),define(X[15],Y([0,1,11,2,14,10,28]),function(x,t,m,A,D,R,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=m.createDecorator("logService"),t.ILoggerService=m.createDecorator("loggerService");function C(){return new Date().toISOString()}var u;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class d extends A.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class S extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=S;class y extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,e,...i):console.warn(`[main ${C()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class w extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=w;class T extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:F.toErrorMessage(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=T;class c extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class h extends A.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=h;class b extends A.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class O{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=O;function L(r){if(r.verbose)return u.Trace;if(typeof r.logLevel=="string"){const e=v(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=L;function v(r){switch(r){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=v;function o(r){switch(r){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=o}),define(X[101],Y([0,1,9,2,18,23,21,7,17,24,15,29,39,14,4,12]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let O=class extends A.Disposable{constructor(v,o,r,e){super();this.fileService=o,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=C.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,o){await this.cleanUpPromise;const r=this.getName(v),e=u.joinPath(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=u.joinPath(this.extensionsDownloadDir,`.${y.generateUuid()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(v,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${h.getErrorMessage(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(v){}async rename(v,o,r){try{await m.Promises.rename(v.fsPath,o.fsPath)}catch(e){if(T.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${v} to ${o} with 'EPERM' error. Trying again...`),this.rename(v,o,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const o=[],r=[];for(const n of v.children){const s=this.parse(n.name);s&&r.push([s,n])}const e=d.groupByExtension(r,([n])=>n),i=[];for(const n of e)n.sort((s,a)=>w.rcompare(s[0].version,a[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new d.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():y.generateUuid()}parse(v){const o=b.exec(v);return o&&o[1]&&o[2]?new d.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};O=ue([fe(0,F.INativeEnvironmentService),fe(1,D.IFileService),fe(2,R.IExtensionGalleryService),fe(3,S.ILogService)],O),t.ExtensionsDownloader=O}),define(X[102],Y([0,1,2,15,32,28,3,4,10,8,9,21]),function(x,t,m,A,D,R,F,C,u,d,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends m.Disposable{constructor(c,h){super();this.environmentService=c,this.logService=h,this.processesLimiter=new C.Limiter(5)}async postUninstall(c){const h=this.parseScript(c,"uninstall");return h&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${b}`)))),S.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(c,h){const b=`vscode:${h}`;if(c.location.scheme===d.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const O=c.manifest.scripts[b].split(" ");return O.length<2||O[0]!=="node"||!O[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:F.join(c.location.fsPath,O[1]),args:O.slice(2)||[]}}return null}runLifecycleHook(c,h,b,O,L){return new Promise((v,o)=>{const r=this.start(c,h,b,L);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):v(void 0)};r.on("error",n=>{i(R.toErrorMessage(n)||"Unknown")}),r.on("exit",(n,s)=>{i(n?`post-${h} process exited with code ${n}`:void 0)}),O&&(e=setTimeout(()=>{e=null,r.kill(),o("timed out")},5e3))})}start(c,h,b,O){const L={silent:!0,execArgv:void 0},v=D.fork(c,[`--type=extension-post-${h}`,...b],L);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=u.Event.fromNodeEventEmitter(v.stdout,"data"),r=u.Event.fromNodeEventEmitter(v.stderr,"data");o(n=>this.logService.info(O.identifier.id,O.manifest.version,`post-${h}`,n)),r(n=>this.logService.error(O.identifier.id,O.manifest.version,`post-${h}`,n));const e=u.Event.any(u.Event.map(o,n=>({data:`%c${n}`,format:[""]})),u.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return u.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(O.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(c){return F.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};w=ue([fe(0,y.IEnvironmentService),fe(1,A.ILogService)],w),t.ExtensionsLifecycle=w}),define(X[103],Y([0,1,2,21,10,18,7,24,17,15]),function(x,t,m,A,D,R,F,C,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let S=class extends m.Disposable{constructor(w,T,c,h){super();this.extensionsManagementService=w,this.logService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(L=>{this.installedExtensions=L.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(L=>this.onInstallExtension(L))),this._register(w.onDidInstallExtension(L=>this.onDidInstallExtension(L))),this._register(w.onDidUninstallExtension(L=>this.onDidUninstallExtension(L)));const b=F.URI.file(c.extensionsPath),O=new u.ExtUri(L=>!T.hasCapability(L,1024));this._register(T.watch(b)),this._register(D.Event.filter(T.onDidChangeFilesRaw,L=>L.changes.some(v=>this.doesChangeAffects(v,b,O)))(()=>this.onDidChange()))}doesChangeAffects(w,T,c){return c.isEqual(c.dirname(w.resource),T)?c.isEqual(w.resource,c.joinPath(T,".obsolete"))?!0:!(w.type!==1&&w.type!==2||c.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtension(w){this.removeInstallingExtension(w.identifier),w.error||this.addInstalledExtension(w.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(T=>!C.areSameExtensions(T,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(T=>!C.areSameExtensions(T,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),T=w.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(b=>C.areSameExtensions(b,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),c=this.installedExtensions.filter(h=>this.installingExtensions.some(b=>C.areSameExtensions(b,h))?!1:w.every(b=>!C.areSameExtensions(b.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=w.map(h=>h.identifier),(T.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:T,removed:c})}}};S=ue([fe(1,R.IFileService),fe(2,A.INativeEnvironmentService),fe(3,d.ILogService)],S),t.ExtensionsWatcher=S}),define(X[104],Y([0,1,9,127,23,2,21,4,24,15,53,22,10,8,3]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let h=class extends R.Disposable{constructor(L,v,o){super();this.extensionManagementService=L,this.logService=o,this._onDidLanguagesChange=this._register(new w.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new b(v,o)),this._register(L.onDidInstallExtension(({local:r})=>this.onDidInstallExtension(r))),this._register(L.onDidUninstallExtension(({identifier:r})=>this.onDidUninstallExtension(r)))}getLanguageIds(){return this.cache.getLanguagePacks().then(L=>{const v=["en",...Object.keys(L)];return y.distinct(v)})}onDidInstallExtension(L){L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",L.identifier.id),this.update().then(v=>{v&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(L){this.cache.getLanguagePacks().then(v=>{Object.keys(v).some(o=>v[o]&&v[o].extensions.some(r=>u.areSameExtensions(r.extensionIdentifier,L)))&&(this.logService.debug("Removing language packs from the extension",L.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))})}async update(){const[L,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(v);return!y.equals(Object.keys(L),Object.keys(o))}};h=ue([fe(0,D.IExtensionManagementService),fe(1,F.INativeEnvironmentService),fe(2,d.ILogService)],h),t.LocalizationsService=h;let b=class extends R.Disposable{constructor(L,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=c.join(L.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(L){return this.withLanguagePacks(v=>{Object.keys(v).forEach(o=>delete v[o]),this.createLanguagePacksFromExtensions(v,...L)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(L,...v){for(const o of v)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(L,o);Object.keys(L).forEach(o=>this.updateHash(L[o]))}createLanguagePacksFromExtension(L,v){const o=v.identifier,r=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const e of r)if(v.location.scheme===T.Schemas.file&&S.isValidLocalization(e)){let i=L[e.languageId];i||(i={hash:"",extensions:[],translations:{}},L[e.languageId]=i);let n=i.extensions.filter(s=>u.areSameExtensions(s.extensionIdentifier,o))[0];n?n.version=v.manifest.version:i.extensions.push({extensionIdentifier:o,version:v.manifest.version});for(const s of e.translations)i.translations[s.id]=c.join(v.location.fsPath,s.path)}}updateHash(L){if(L){const v=A.createHash("md5");for(const o of L.extensions)v.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);L.hash=v.digest("hex")}}withLanguagePacks(L=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch(r){return{}}}).then(o=>(v=L(o),o)).then(o=>{for(const e of Object.keys(o))o[e]||delete o[e];this.languagePacks=o,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),m.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>v,o=>this.logService.error(o))})}};b=ue([fe(0,F.INativeEnvironmentService),fe(1,d.ILogService)],b)}),define(X[105],Y([0,1,15,18]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function D(u,d,S,y){try{const w=await new Promise((T,c)=>{x(["spdlog"],T,c)});return w.setFlushOn(m.LogLevel.Trace),w.createAsyncRotatingLogger(u,d,S,y)}catch(w){console.error(w)}return null}function R(u,d,S,y){const w=x.__$__nodeRequire("spdlog");return w.setFlushOn(m.LogLevel.Trace),w.createRotatingLogger(u,d,S,y)}t.createRotatingLogger=R;function F(u,d,S){switch(d){case m.LogLevel.Trace:u.trace(S);break;case m.LogLevel.Debug:u.debug(S);break;case m.LogLevel.Info:u.info(S);break;case m.LogLevel.Warning:u.warn(S);break;case m.LogLevel.Error:u.error(S);break;case m.LogLevel.Critical:u.critical(S);break;default:throw new Error("Invalid log level")}}class C extends m.AbstractMessageLogger{constructor(d,S,y,w){super();this.name=d,this.filepath=S,this.rotating=y,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(T=>{this._logger&&this._logger.setLevel(T)}))}_createSpdLogLogger(){const d=this.rotating?6:1,S=30/d*A.ByteSize.MB;return D(this.name,this.filepath,S,d).then(y=>{if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:w,message:T}of this.buffer)F(this._logger,w,T);this.buffer=[]}})}log(d,S){this._logger?F(this._logger,d,S):this.getLevel()<=d&&this.buffer.push({level:d,message:S})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=C}),define(X[54],Y([0,1,81,16,18,12,40]),function(x,t,m,A,D,R,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(y,w,T,c,h,b){let O;try{await u(y,w,T,c,h,b)}catch(L){O=L}finally{O&&h.errorTransformer&&(O=h.errorTransformer(O)),typeof O!="undefined"&&T.error(O),T.end()}}t.readFileIntoStream=C;async function u(y,w,T,c,h,b){d(b);const O=await y.open(w,{create:!1});try{d(b);let L=0,v=0,o=h&&typeof h.length=="number"?h.length:void 0,r=A.VSBuffer.alloc(Math.min(h.bufferSize,typeof o=="number"?o:h.bufferSize)),e=h&&typeof h.position=="number"?h.position:0,i=0;do v=await y.read(O,e,r.buffer,i,r.byteLength-i),e+=v,i+=v,L+=v,typeof o=="number"&&(o-=v),i===r.byteLength&&(await T.write(c(r)),r=A.VSBuffer.alloc(Math.min(h.bufferSize,typeof o=="number"?o:h.bufferSize)),i=0);while(v>0&&(typeof o!="number"||o>0)&&d(b)&&S(L,h));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),T.write(c(r.slice(0,n)))}}catch(L){throw D.ensureFileSystemProviderError(L)}finally{await y.close(O)}}function d(y){if(y.isCancellationRequested)throw R.canceled();return!0}function S(y,w){if(w==null?void 0:w.limits){if(typeof w.limits.memory=="number"&&y>w.limits.memory)throw D.createFileSystemProviderError(m.localize(0,null,F.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&y>w.limits.size)throw D.createFileSystemProviderError(m.localize(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[106],Y([0,1,80,128,2,18,10,17,45,22,15,16,34,4,26,8,54,129]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h,b,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let L=class Me extends D.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new F.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Me.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Me.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Me.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new R.FileChangesEvent(r,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Me.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Me.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Me.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new R.FileChangesEvent(r,!0)))),this.watchedResources=u.TernarySearchTree.forUris(r=>{const e=this.getProvider(r.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);A.mark(`code/registerFilesystem/${o}`),this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r});const e=new D.DisposableStore;return e.add(r.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(r)))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),D.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),D.dispose(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await T.Promises.settled(r)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return O.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!C.isAbsolutePath(o))throw new R.FileOperationError(m.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=m.localize(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if(R.hasOpenReadWriteCloseCapability(r)||R.hasReadWriteCapability(r)||R.hasFileReadStreamCapability(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if(R.hasOpenReadWriteCloseCapability(r)||R.hasReadWriteCapability(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw R.toFileSystemProviderErrorCode(e)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError(m.localize(2,null,this.resourceForError(o)),1):R.ensureFileSystemProviderError(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,s=r==null?void 0:r.resolveSingleChildDescendants,a=r==null?void 0:r.resolveMetadata,E=await e.stat(o);let P;return this.toFileStat(e,o,E,void 0,!!a,(U,k)=>(P||(P=u.TernarySearchTree.forUris(()=>!i),P.set(o,!0),d.isNonEmptyArray(n)&&n.forEach(j=>P.set(j,!0))),Boolean(P.findSuperstr(U.resource)||P.get(U.resource))?!0:U.isDirectory&&s?k===1:!1))}async toFileStat(o,r,e,i,n,s){var a;const{providerExtUri:E}=this.getExtUri(o),P={resource:r,name:E.basename(r),isFile:(e.type&R.FileType.File)!=0,isDirectory:(e.type&R.FileType.Directory)!=0,isSymbolicLink:(e.type&R.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean(((a=e.permissions)!==null&&a!==void 0?a:0)&R.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:R.etag({mtime:e.mtime,size:e.size})};if(P.isDirectory&&s(P,i)){try{const U=await o.readdir(r),k=await T.Promises.settled(U.map(async([j,B])=>{try{const $=E.joinPath(r,j),K=n?await o.stat($):{type:B};return await this.toFileStat(o,$,K,U.length,n,s)}catch($){return this.logService.trace($),null}}));P.children=d.coalesce(k)}catch(U){this.logService.trace(U),P.children=[]}return P}return P}async resolveAll(o){return T.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch(e){return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(o))throw new R.FileOperationError(m.localize(3,null,this.resourceForError(o)),3,r)}async createFile(o,r=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,r);return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,i)),i}async writeFile(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if(R.hasReadWriteCapability(i)&&!(r instanceof y.VSBuffer))if(w.isReadableStream(r)){const E=await w.peekStream(r,3);E.ended?a=y.VSBuffer.concat(E.buffer):a=E}else a=w.peekReadable(r,E=>y.VSBuffer.concat(E),3);else a=r;!R.hasOpenReadWriteCloseCapability(i)||R.hasReadWriteCapability(i)&&a instanceof y.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof y.VSBuffer?y.bufferToReadable(a):a)}catch(s){throw new R.FileOperationError(m.localize(4,null,this.resourceForError(o),R.ensureFileSystemProviderError(s).toString()),R.toFileOperationResult(s),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){if(!!(e==null?void 0:e.unlock)&&!(o.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(r)));let n;try{n=await o.stat(r)}catch(s){return}if((n.type&R.FileType.Directory)!=0)throw new R.FileOperationError(m.localize(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==R.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==R.etag({mtime:e.mtime,size:n.size}))throw new R.FileOperationError(m.localize(7,null),3,e);return n}async readFile(o,r){const e=await this.withReadProvider(o);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,o,r):this.doReadFile(e,o,r)}async doReadFileAtomic(o,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,r,e);i(s)}catch(s){n(s)}})})}async doReadFile(o,r,e){const i=await this.doReadFileStream(o,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await y.streamToBuffer(i.value)})}async readFileStream(o,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,r)}async doReadFileStream(o,r,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(r,e).then(a=>a,a=>{throw i.cancel(),a});let s;try{e&&typeof e.etag=="string"&&e.etag!==R.ETAG_DISABLED&&await n,!(R.hasOpenReadWriteCloseCapability(o)||R.hasFileReadStreamCapability(o))||R.hasReadWriteCapability(o)&&(e==null?void 0:e.preferUnbuffered)?s=this.readFileUnbuffered(o,r,e):R.hasFileReadStreamCapability(o)?s=this.readFileStreamed(o,r,i.token,e):s=this.readFileBuffered(o,r,i.token,e);const a=await n;return Object.assign(Object.assign({},a),{value:s})}catch(a){s&&await w.consumeStream(s);const E=m.localize(8,null,this.resourceForError(r),R.ensureFileSystemProviderError(a).toString());throw a instanceof R.NotModifiedSinceFileOperationError?new R.NotModifiedSinceFileOperationError(E,a.stat,e):new R.FileOperationError(E,R.toFileOperationResult(a),e)}}readFileStreamed(o,r,e,i=Object.create(null)){const n=o.readFileStream(r,i,e);return w.transform(n,{data:s=>s instanceof y.VSBuffer?s:y.VSBuffer.wrap(s),error:s=>new R.FileOperationError(m.localize(9,null,this.resourceForError(r),R.ensureFileSystemProviderError(s).toString()),R.toFileOperationResult(s),i)},s=>y.VSBuffer.concat(s))}readFileBuffered(o,r,e,i=Object.create(null)){const n=y.newWriteableBufferStream();return b.readFileIntoStream(o,r,n,s=>s,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new R.FileOperationError(m.localize(10,null,this.resourceForError(r),R.ensureFileSystemProviderError(s).toString()),R.toFileOperationResult(s),i)}),e),n}readFileUnbuffered(o,r,e){const i=w.newWriteableStream(n=>y.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(y.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new R.FileOperationError(m.localize(11,null,this.resourceForError(o)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==R.ETAG_DISABLED&&r.etag===e.etag)throw new R.NotModifiedSinceFileOperationError(m.localize(12,null),e,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new R.FileOperationError(m.localize(13,null,this.resourceForError(o)),i)}}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,i){if(o.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,o,s,r,e,i)}catch(n){return n}return!0}async move(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"move",!!e),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,s==="move"?2:3,a)),a}async copy(o,r,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"copy",!!e),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,s==="copy"?3:2,a)),a}async doMoveCopy(o,r,e,i,n,s){if(r.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,r,e,i,n,s);if(a&&!E&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&R.hasFileFolderCopyCapability(o))await o.copy(r,i,{overwrite:s});else{const P=await this.resolve(r);P.isDirectory?await this.doCopyFolder(o,P,e,i):await this.doCopyFile(o,r,e,i)}return n}else return o===e?(await o.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(o,r,e,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,i){if(R.hasOpenReadWriteCloseCapability(o)&&R.hasOpenReadWriteCloseCapability(e))return this.doPipeBuffered(o,r,e,i);if(R.hasOpenReadWriteCloseCapability(o)&&R.hasReadWriteCapability(e))return this.doPipeBufferedToUnbuffered(o,r,e,i);if(R.hasReadWriteCapability(o)&&R.hasOpenReadWriteCloseCapability(e))return this.doPipeUnbufferedToBuffered(o,r,e,i);if(R.hasReadWriteCapability(o)&&R.hasReadWriteCapability(e))return this.doPipeUnbuffered(o,r,e,i)}async doCopyFolder(o,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await T.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,s):this.doCopyFile(o,n.resource,e,s)}))}async doValidateMoveCopy(o,r,e,i,n,s){let a=!1;if(o===e){const{providerExtUri:P,isPathCaseSensitive:U}=this.getExtUri(o);if(U||(a=P.isEqual(r,i)),a&&n==="copy")throw new Error(m.localize(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,r))throw new Error(m.localize(15,null,this.resourceForError(r),this.resourceForError(i)))}const E=await this.exists(i);if(E&&!a){if(!s)throw new R.FileOperationError(m.localize(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(o===e){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(r,i))throw new Error(m.localize(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:E,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(r,i.dirname(r));)try{if(((await o.stat(r)).type&R.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(r)));break}catch(n){if(R.toFileSystemProviderErrorCode(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await o.mkdir(r)}catch(s){if(R.toFileSystemProviderErrorCode(s)!==R.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new R.FileOperationError(m.localize(20,null,this.resourceForError(o)),1);if(!!!(r==null?void 0:r.recursive)){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new R.FileOperationEvent(o,1))}onDidChangeFile(o,r){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new R.FileChangesEvent(e,!r))}if(i){const n=r?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Me.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,r={recursive:!1,excludes:[]}){var e;const i=new D.DisposableStore;{let n=!1,s=()=>{n=!0};i.add(D.toDisposable(()=>s())),this.doWatch(o,r).then(a=>{n?D.dispose(a):s=()=>D.dispose(a)},a=>this.logService.error(a))}return r.recursive||(this.watchedResources.set(o,((e=this.watchedResources.get(o))!==null&&e!==void 0?e:0)+1),i.add(D.toDisposable(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),i}async doWatch(o,r){const e=await this.withProvider(o),i=this.toWatchKey(e,o,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,D.toDisposable(()=>{n.count--,n.count===0&&(D.dispose(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,r,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>D.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{var n;const s=await o.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{w.isReadableStream(i)||w.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(o,s,i):await this.doWriteReadableBufferedQueued(o,s,i)}catch(a){throw R.ensureFileSystemProviderError(a)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,r,e){let i=0,n;if(w.isReadableBufferedStream(e)){if(e.buffer.length>0){const s=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,a)=>{w.listenStream(n,{onData:async E=>{n.pause();try{await this.doWriteBuffer(o,r,E,E.byteLength,i,0)}catch(P){return a(P)}i+=E.byteLength,setTimeout(()=>n.resume())},onError:E=>a(E),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,r,e,i,n,s){let a=0;for(;a<i;)a+=await o.write(r,n+a,e.buffer,s+a,i-a)}async doWriteUnbuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,r,e,i))}async doWriteUnbufferedQueued(o,r,e,i){var n;let s;i instanceof y.VSBuffer?s=i:w.isReadableStream(i)?s=await y.streamToBuffer(i):w.isReadableBufferedStream(i)?s=await y.bufferedStreamToBuffer(i):s=y.readableToBuffer(i),await o.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,r,e,i))}async doPipeBufferedQueued(o,r,e,i){let n,s;try{n=await o.open(r,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const a=y.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,P=0,U=0;do U=await o.read(n,E,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(e,s,a,U,E,P),E+=U,P+=U,P===a.byteLength&&(P=0);while(U>0)}catch(a){throw R.ensureFileSystemProviderError(a)}finally{await T.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,r,e,i))}async doPipeUnbufferedQueued(o,r,e,i){return e.writeFile(i,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,i))}async doPipeUnbufferedToBufferedQueued(o,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(r);await this.doWriteBuffer(e,n,y.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw R.ensureFileSystemProviderError(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,r,e,i){const n=await y.streamToBuffer(this.readFileBuffered(o,r,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&2048)throw new R.FileOperationError(m.localize(22,null,this.resourceForError(r)),6);return o}throwIfFileIsReadonly(o,r){var e;if(((e=r.permissions)!==null&&e!==void 0?e:0)&R.FilePermission.Readonly)throw new R.FileOperationError(m.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===h.Schemas.file?o.fsPath:o.toString(!0)}};L.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},L=ue([fe(0,S.ILogService)],L),t.FileService=L}),define(X[107],Y([0,1,2,18,10,14,9,3,17,35,4,15,82,51,91,93,90,99,34,54,22,16]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h,b,O,L,v,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends m.Disposable{constructor(n,s){var a;super();this.logService=n,this.options=s,this.BUFFER_SIZE=((a=this.options)===null||a===void 0?void 0:a.bufferSize)||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:a}=await F.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await F.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async E=>{try{let P;E.isSymbolicLink()?P=(await this.stat(u.joinPath(n,E.name))).type:P=this.toType(E),a.push([E.name,P])}catch(P){this.logService.trace(P)}})),a}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let a;return(s==null?void 0:s.dangling)?a=A.FileType.Unknown:n.isFile()?a=A.FileType.File:n.isDirectory()?a=A.FileType.Directory:a=A.FileType.Unknown,s&&(a|=A.FileType.SymbolicLink),a}async readFile(n){try{const s=this.toFilePath(n);return await F.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,a){const E=L.newWriteableStream(P=>r.VSBuffer.concat(P.map(U=>r.VSBuffer.wrap(U))).buffer);return v.readFileIntoStream(this,n,E,P=>P.buffer,Object.assign(Object.assign({},s),{bufferSize:this.BUFFER_SIZE}),a),E}async writeFile(n,s,a){let E;try{const P=this.toFilePath(n);if(!a.create||!a.overwrite){if(await F.Promises.exists(P)){if(!a.overwrite)throw A.createFileSystemProviderError(w.localize(0,null),A.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw A.createFileSystemProviderError(w.localize(1,null),A.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(E,0,s,0,s.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(n,P)}finally{typeof E=="number"&&await this.close(E)}}async open(n,s){try{const a=this.toFilePath(n);if(A.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:U}=await F.SymlinkSupport.stat(a);U.mode&128||await F.Promises.chmod(a,U.mode|128)}catch(U){this.logService.trace(U)}let E;if(A.isFileOpenForWriteOptions(s)){if(R.isWindows)try{await F.Promises.truncate(a,0),E="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}E||(E="w")}else E="r";const P=await F.Promises.open(a,E);return this.mapHandleToPos.set(P,0),A.isFileOpenForWriteOptions(s)&&this.writeHandles.set(P,n),P}catch(a){throw A.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(n,a):this.toFileSystemProviderError(a)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await F.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await F.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,a,E,P){const U=this.normalizePos(n,s);let k=null;try{const j=await F.Promises.read(n,a,E,P,U);return typeof j=="number"?k=j:k=j.bytesRead,k}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(n,U,k)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,a){const E=this.mapHandleToPos.get(n);typeof E=="number"&&(typeof s=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,E+a):this.mapHandleToPos.delete(n)))}async write(n,s,a,E,P){return S.retry(()=>this.doWrite(n,s,a,E,P),100,3)}async doWrite(n,s,a,E,P){const U=this.normalizePos(n,s);let k=null;try{const j=await F.Promises.write(n,a,E,P,U);return typeof j=="number"?k=j:k=j.bytesWritten,k}catch(j){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),j)}finally{this.updatePos(n,U,k)}}async mkdir(n){try{await F.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const a=this.toFilePath(n);await this.doDelete(a,s)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(n,s){s.recursive?await F.Promises.rm(n,F.RimRafMode.MOVE):await F.Promises.unlink(n)}async rename(n,s,a){const E=this.toFilePath(n),P=this.toFilePath(s);if(E!==P)try{await this.validateTargetDeleted(n,s,"move",a.overwrite),await F.Promises.move(E,P)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(w.localize(2,null,C.basename(E),C.basename(C.dirname(P)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(n,s,a){const E=this.toFilePath(n),P=this.toFilePath(s);if(E!==P)try{await this.validateTargetDeleted(n,s,"copy",a.overwrite),await F.Promises.copy(E,P,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error(w.localize(3,null,C.basename(E),C.basename(C.dirname(P)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(n,s,a,E){const P=this.toFilePath(n),U=this.toFilePath(s);let k=!1;if(!!(this.capabilities&1024)||(k=d.isEqual(P,U,!0)),k&&a==="copy")throw A.createFileSystemProviderError(w.localize(4,null),A.FileSystemProviderErrorCode.FileExists);if(!k&&await F.Promises.exists(U)){if(!E)throw A.createFileSystemProviderError(w.localize(5,null),A.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const a={path:this.toFilePath(n),excludes:s},E=o.insert(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,s,a;if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let E,P;((s=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||s===void 0?void 0:s.usePolling)?(E=c.FileWatcher,P=(a=this.options)===null||a===void 0?void 0:a.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?E=h.FileWatcher:E=c.FileWatcher:E=b.FileWatcher,this.recursiveWatcher=new E(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire(T.toFileChanges(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===y.LogLevel.Trace,P),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new O.FileWatcher(this.toFilePath(n),E=>this._onDidChangeFile.fire(T.toFileChanges(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===y.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return m.combinedDisposable(s,a)}toFilePath(n){return C.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof A.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=A.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=A.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=A.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=A.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=A.FileSystemProviderErrorCode.NoPermissions;break;default:s=A.FileSystemProviderErrorCode.Unknown}return A.createFileSystemProviderError(n,s)}async toFileSystemProviderWriteError(n,s){let a=this.toFileSystemProviderError(s);if(n&&a.code===A.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await F.SymlinkSupport.stat(this.toFilePath(n));E.mode&128||(a=A.createFileSystemProviderError(s,A.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return a}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(X[41],Y([0,1,11]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=m.createDecorator("productService")}),define(X[25],Y([0,1,13,57]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class D{constructor(){this.data=new Map}add(F,C){A.ok(m.isString(F)),A.ok(m.isObject(C)),A.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,C)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new D}),define(X[108],Y([0,1,25,10]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,d){this.schemasById[D(u)]=d,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new R;m.Registry.add(t.Extensions.JSONContribution,F)}),define(X[30],Y([0,1,73,10,25,13,108]),function(x,t,m,A,D,R,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var C;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const u=D.Registry.as(F.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(O,L=!0){this.registerConfigurations([O],L)}registerConfigurations(O,L=!0){const v=[];O.forEach(o=>{v.push(...this.validateAndRegisterProperties(o,L,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(O){const L=[],v=o=>{if(o.properties)for(const r in o.properties)L.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r]);o.allOf&&o.allOf.forEach(r=>v(r))};for(const o of O){v(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}u.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(L)}registerDefaultConfigurations(O){const L=[],v=[];for(const o of O)for(const r in o)if(L.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),o[r]);const e={type:"object",default:this.defaultValues[r],description:m.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};v.push(y(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=o[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(L)}deregisterDefaultConfigurations(O){const L=[];for(const v of O)for(const o in v)if(L.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const r=this.configurationProperties[o];r&&(this.updatePropertyDefaultValue(o,r),this.updateSchema(o,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(L)}notifyConfigurationSchemaUpdated(...O){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(O){for(const L of O)this.overrideIdentifiers.add(L);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(O,L=!0,v,o=3){var r;o=R.isUndefinedOrNull(O.scope)?o:O.scope;let e=[],i=O.properties;if(i)for(let s in i){if(L&&c(s)){delete i[s];continue}const a=i[s];if(this.updatePropertyDefaultValue(s,a),t.OVERRIDE_PROPERTY_PATTERN.test(s)?a.scope=void 0:(a.scope=R.isUndefinedOrNull(a.scope)?o:a.scope,a.restricted=R.isUndefinedOrNull(a.restricted)?!!((r=v==null?void 0:v.restrictedConfigurations)===null||r===void 0?void 0:r.includes(s)):a.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=O.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,L,v,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(O){const L=v=>{let o=v.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let r=v.allOf;r&&r.forEach(L)};L(O)}updateSchema(O,L){switch(t.allSettings.properties[O]=L,L.scope){case 1:t.applicationSettings.properties[O]=L;break;case 2:t.machineSettings.properties[O]=L;break;case 6:t.machineOverridableSettings.properties[O]=L;break;case 3:t.windowSettings.properties[O]=L;break;case 4:t.resourceSettings.properties[O]=L;break;case 5:t.resourceSettings.properties[O]=L,this.resourceLanguageSettingsSchema.properties[O]=L;break}}removeFromSchema(O,L){switch(delete t.allSettings.properties[O],L.scope){case 1:delete t.applicationSettings.properties[O];break;case 2:delete t.machineSettings.properties[O];break;case 6:delete t.machineOverridableSettings.properties[O];break;case 3:delete t.windowSettings.properties[O];break;case 4:case 5:delete t.resourceSettings.properties[O];break}}updateOverridePropertyPatternKey(){for(const O of this.overrideIdentifiers.values()){const L=`[${O}]`,v={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(L,v),t.allSettings.properties[L]=v,t.applicationSettings.properties[L]=v,t.machineSettings.properties[L]=v,t.machineOverridableSettings.properties[L]=v,t.windowSettings.properties[L]=v,t.resourceSettings.properties[L]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(O,L){let v=this.defaultValues[O];R.isUndefined(v)&&(v=L.default),R.isUndefined(v)&&(v=w(L.type)),L.default=v}}const S="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(S);function y(b){return b.substring(1,b.length-1)}t.overrideIdentifierFromKey=y;function w(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=w;const T=new d;D.Registry.add(t.Extensions.Configuration,T);function c(b){return b.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(b)?m.localize(5,null,b):T.getConfigurationProperties()[b]!==void 0?m.localize(6,null,b):null:m.localize(4,null)}t.validateProperty=c;function h(){const b=[],O=T.getConfigurationProperties();for(const L of Object.keys(O))b.push([L,O[L].scope]);return b.push(["launch",4]),b.push(["task",4]),b}t.getScopes=h}),define(X[27],Y([0,1,20,13,7,25,11,30]),function(x,t,m,A,D,R,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=F.createDecorator("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof D.URI)}t.isConfigurationOverrides=u;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function S(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=S;function y(i,n){const s=n?i?n.keys.filter(B=>i.keys.indexOf(B)===-1):[...n.keys]:[],a=i?n?i.keys.filter(B=>n.keys.indexOf(B)===-1):[...i.keys]:[],E=[];if(n&&i){for(const B of i.keys)if(n.keys.indexOf(B)!==-1){const $=O(i.contents,B),K=O(n.contents,B);m.equals($,K)||E.push(B)}}const P=[],U=B=>{const $={};for(const K of B)for(const ee of K.identifiers)$[r(ee)]=K;return $},k=n?U(n.overrides):{},j=i?U(i.overrides):{};if(Object.keys(k).length)for(const B of s){const $=k[B];$&&P.push([C.overrideIdentifierFromKey(B),$.keys])}if(Object.keys(j).length)for(const B of a){const $=j[B];$&&P.push([C.overrideIdentifierFromKey(B),$.keys])}if(Object.keys(k).length&&Object.keys(j).length)for(const B of E){const $=j[B],K=k[B];if($&&K){const ee=y({contents:$.contents,keys:$.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});P.push([C.overrideIdentifierFromKey(B),[...ee.added,...ee.removed,...ee.updated]])}}return{added:s,removed:a,updated:E,overrides:P}}t.compare=y;function w(i,n){const s=[];for(const a of Object.keys(i))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const E={};for(const P in i[a])E[P]=i[a][P];s.push({identifiers:[C.overrideIdentifierFromKey(a).trim()],keys:Object.keys(E),contents:T(E,n)})}return s}t.toOverrides=w;function T(i,n){const s=Object.create(null);for(let a in i)c(s,a,i[a],n);return s}t.toValuesTree=T;function c(i,n,s,a){const E=n.split("."),P=E.pop();let U=i;for(let k=0;k<E.length;k++){let j=E[k],B=U[j];switch(typeof B){case"undefined":B=U[j]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${E.slice(0,k+1).join(".")} is ${JSON.stringify(B)}`);return}U=B}if(typeof U=="object"&&U!==null)try{U[P]=s}catch(k){a(`Ignoring ${n} as ${E.join(".")} is ${JSON.stringify(U)}`)}else a(`Ignoring ${n} as ${E.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=c;function h(i,n){const s=n.split(".");b(i,s)}t.removeFromValueTree=h;function b(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const a=i[s];typeof a=="object"&&!Array.isArray(a)&&(b(a,n),Object.keys(a).length===0&&delete i[s])}}function O(i,n,s){function a(U,k){let j=U;for(const B of k){if(typeof j!="object"||j===null)return;j=j[B]}return j}const E=n.split("."),P=a(i,E);return typeof P=="undefined"?s:P}t.getConfigurationValue=O;function L(i,n,s){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?A.isObject(i[a])&&A.isObject(n[a])?L(i[a],n[a],s):s&&(i[a]=n[a]):i[a]=n[a])})}t.merge=L;function v(){const i=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=v;function o(){const i=Object.create(null),n=R.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let s in n){let a=n[s].default;c(i,s,a,E=>console.error(`Conflict in default settings: ${E}`))}return i}t.getDefaultValues=o;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,s){const a=i.inspect(n),E=i.inspect(s);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:a.defaultValue}t.getMigratedSettingValue=e}),define(X[109],Y([0,1,58,45,22,13,20,7,30,27,25,2,10]),function(x,t,m,A,D,R,F,C,u,d,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class T{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?d.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?d.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[s],E=i[s];E&&(typeof a=="object"&&typeof E=="object"?(a=F.deepClone(a),this.mergeContents(a,E)):a=E),n[s]=a}return new T(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),s=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const E of a.overrides){const[P]=n.filter(U=>D.equals(U.identifiers,E.identifiers));P?this.mergeContents(P.contents,E.contents):n.push(F.deepClone(E))}for(const E of a.keys)s.indexOf(E)===-1&&s.push(E)}return new T(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&R.isObject(e[n])&&R.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),d.addToValueTree(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&d.removeFromValueTree(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=T;class c extends T{constructor(){const e=d.getDefaultValues(),i=d.getConfigurationKeys(),n=[];for(const s of Object.keys(e))u.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[u.overrideIdentifierFromKey(s).trim()],keys:Object.keys(e[s]),contents:d.toValuesTree(e[s],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!R.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:a,restricted:E}=this.doParseRaw(e,i);this._configurationModel=new T(n,s,a),this._restrictedConfigurations=E||[]}doParseContent(e){let i={},n=null,s=[],a=[],E=[];function P(k){Array.isArray(s)?s.push(k):n&&(s[n]=k)}let U={onObjectBegin:()=>{let k={};P(k),a.push(s),s=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let k=[];P(k),a.push(s),s=k,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:P,onError:(k,j,B)=>{E.push({error:k,offset:j,length:B})}};if(e)try{m.visit(e,U),i=s[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(e,i){const n=S.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const a=d.toValuesTree(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`)),E=Object.keys(e),P=d.toOverrides(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`));return{contents:a,keys:E,overrides:P,restricted:s.restricted}}filter(e,i,n,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:e,restricted:[]};const a={},E=[];for(let P in e)if(u.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const U=this.filter(e[P],i,!1,s);a[P]=U.raw,E.push(...U.restricted)}else{const U=i[P],k=U?typeof U.scope!="undefined"?U.scope:3:void 0;(U==null?void 0:U.restricted)&&E.push(P),(k===void 0||s.scopes===void 0||s.scopes.includes(k))&&(s.skipRestricted&&(U==null?void 0:U.restricted)||(a[P]=e[P]))}return{raw:a,restricted:E}}}t.ConfigurationModelParser=h;class b extends y.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class O{constructor(e,i,n=new T,s=new T,a=new A.ResourceMap,E=new T,P=new A.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=E,this._memoryConfigurationByResource=P,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new T,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),B=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,K=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(e):E.getValue(e),ee=s.getValue(e),te=D.distinct(D.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(e,Q)!==void 0);return{defaultValue:P,userValue:U,userLocalValue:k,userRemoteValue:j,workspaceValue:B,workspaceFolderValue:$,memoryValue:K,value:ee,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:a==null?void 0:a.freeze().getValue(e),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:E.getValue(e),override:i.overrideIdentifier?E.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>u.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const a=u.overrideIdentifierFromKey(s),E=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=e.getKeysForOverrideIdentifier(a),U=[...P.filter(k=>E.indexOf(k)===-1),...E.filter(k=>P.indexOf(k)===-1),...E.filter(k=>!F.equals(this._defaultConfiguration.override(a).getValue(k),e.override(a).getValue(k)))];return[a,U]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=d.compare(this.localUserConfiguration,e),E=[...i,...n,...s];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=d.compare(this.remoteUserConfiguration,e);let E=[...i,...n,...s];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=d.compare(this.workspaceConfiguration,e);let E=[...i,...n,...s];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:a,removed:E,overrides:P}=d.compare(n,i);let U=[...s,...a,...E];return(U.length||!n)&&this.updateFolderConfiguration(e,i),{keys:U,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:a,overrides:E}=d.compare(i,void 0);return{keys:[...n,...s,...a],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((E,P)=>(E.set(C.URI.revive(P[0]),this.parseConfigurationModel(P[1])),E),new A.ResourceMap);return new O(i,n,new T,s,a,new T,new A.ResourceMap,!1)}static parseConfigurationModel(e){return new T(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=O;function L(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const s of r)s.keys.forEach(a=>e.add(a)),s.overrides.forEach(([a,E])=>{const P=A.getOrSet(i,a,new Set);E.forEach(U=>P.add(U))});const n=[];return i.forEach((s,a)=>n.push([a,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=L;class v{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(P=>a.add(P)),e.overrides.forEach(([,P])=>P.forEach(U=>a.add(U))),this.affectedKeys=[...a.values()];const E=new T;this.affectedKeys.forEach(P=>E.setValue(P,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=O.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,a=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=d.toValuesTree({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=v;class o extends v{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=o}),define(X[110],Y([0,1,25,30,2,27,109,10,4,17]),function(x,t,m,A,D,R,F,C,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class S extends D.Disposable{constructor(w,T){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,d.extUriBiasedIgnorePathCase,T)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,T){const c=typeof w=="string"?w:void 0,h=R.isConfigurationOverrides(w)?w:R.isConfigurationOverrides(T)?T:{};return this.configuration.getValue(c,h,void 0)}updateValue(w,T,c,h){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const T=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(c,T,1)}onDidDefaultConfigurationChange(w){const T=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,w);this.trigger(c,T,6)}trigger(w,T,c){const h=new F.ConfigurationChangeEvent(w,{data:T},this.configuration);h.source=c,h.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=S}),define(X[55],Y([0,1,83,11,30,25,16]),function(x,t,m,A,D,R,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=A.createDecorator("requestService");function C(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=C;function u(c){return c.res.statusCode===204}async function d(c){if(!C(c))throw new Error("Server returned "+c.res.statusCode);return u(c)?null:(await F.streamToBuffer(c.stream)).toString()}t.asText=d;async function S(c){if(!C(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const b=(await F.streamToBuffer(c.stream)).toString();try{return JSON.parse(b)}catch(O){throw O.message+=`:
`+b,O}}t.asJson=S;function y(c){T(c)}t.updateProxyConfigurationsScope=y;let w;function T(c){const h=R.Registry.as(D.Extensions.Configuration);w&&h.deregisterConfigurations([w]),w={id:"http",order:15,title:m.localize(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},h.registerConfiguration(w)}T(2)}),define(X[111],Y([0,1,112,13]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function D(F,C){return F.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:F.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function R(F,C,u={}){const d=m.parse(F),S=u.proxyUrl||D(d,C);if(!S)return null;const y=m.parse(S);if(!/^https?:$/.test(y.protocol||""))return null;const w={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:A.isBoolean(u.strictSSL)?u.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((T,c)=>{x(["http-proxy-agent"],T,c)}))(w):new(await new Promise((T,c)=>{x(["https-proxy-agent"],T,c)}))(w)}t.getProxyAgent=R}),define(X[113],Y([0,1,29,16]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function D(R,F,C){let u=C&&C.get("storage.serviceMachineId",0)||null;if(u)return u;try{const S=(await F.readFile(R.serviceMachineIdResource)).value.toString();u=m.isUUID(S)?S:null}catch(d){u=null}if(!u){u=m.generateUuid();try{await F.writeFile(R.serviceMachineIdResource,A.VSBuffer.fromString(u))}catch(d){}}return C&&C.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=D}),define(X[114],Y([0,1,11,10,2,13,66,4]),function(x,t,m,A,D,R,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=m.createDecorator("storageService");var d;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var S;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(S=t.StorageScope||(t.StorageScope={}));var y;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(y=t.StorageTarget||(t.StorageTarget={}));class w extends D.Disposable{constructor(b={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=C.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){D.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,O){O===u?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:O,target:this.getKeyTargets(b)[O]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,O,L){var v;return(v=this.getStorage(O))===null||v===void 0?void 0:v.get(b,L)}getBoolean(b,O,L){var v;return(v=this.getStorage(O))===null||v===void 0?void 0:v.getBoolean(b,L)}getNumber(b,O,L){var v;return(v=this.getStorage(O))===null||v===void 0?void 0:v.getNumber(b,L)}store(b,O,L,v){if(R.isUndefinedOrNull(O)){this.remove(b,L);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(b,L,v),(o=this.getStorage(L))===null||o===void 0||o.set(b,O)})}remove(b,O){this.withPausedEmitters(()=>{var L;this.updateKeyTarget(b,O,void 0),(L=this.getStorage(O))===null||L===void 0||L.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,O){const L=[],v=this.getKeyTargets(b);for(const o of Object.keys(v))v[o]===O&&L.push(o);return L}updateKeyTarget(b,O,L){var v,o;const r=this.getKeyTargets(O);typeof L=="number"?r[b]!==L&&(r[b]=L,(v=this.getStorage(O))===null||v===void 0||v.set(u,JSON.stringify(r))):typeof r[b]=="number"&&(delete r[b],(o=this.getStorage(O))===null||o===void 0||o.set(u,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const O=this.get(u,b);if(O)try{return JSON.parse(O)}catch(L){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(){var b,O,L,v;this._onWillSaveState.fire({reason:d.NONE}),await C.Promises.settled([(O=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&O!==void 0?O:Promise.resolve(),(v=(L=this.getStorage(1))===null||L===void 0?void 0:L.whenFlushed())!==null&&v!==void 0?v:Promise.resolve()])}async logStorage(){var b,O,L,v,o,r;const e=(O=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&O!==void 0?O:new Map,i=(v=(L=this.getStorage(1))===null||L===void 0?void 0:L.items)!==null&&v!==void 0?v:new Map;return c(e,i,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class T extends w{constructor(){super();this.globalStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=T;async function c(h,b,O,L){const v=a=>{try{return JSON.parse(a)}catch(E){return a}},o=new Map,r=new Map;h.forEach((a,E)=>{o.set(E,a),r.set(E,v(a))});const e=new Map,i=new Map;b.forEach((a,E)=>{e.set(E,a),i.set(E,v(a))}),console.group(`Storage: Global (path: ${O})`);let n=[];o.forEach((a,E)=>{n.push({key:E,value:a})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${L})`);let s=[];e.forEach((a,E)=>{s.push({key:E,value:a})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=c}),define(X[115],Y([0,1,14,33,29,7]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(d){if(m.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function C(d,S,y,w,T,c,h,b,O,L){const v=Object.create(null);v["common.machineId"]=h,v.sessionID=D.generateUuid()+Date.now(),v.commitHash=T,v.version=c,v["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=m.PlatformToString(m.platform),v["common.nodePlatform"]=A.platform,v["common.nodeArch"]=w,v["common.product"]=L||"desktop";const o=u(b||[]);o&&(v["common.msftInternal"]=o);let r=0;const e=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),m.isLinuxSnap&&(v["common.snap"]="true");const i=F(y);i&&(v["common.platformDetail"]=i);try{const n=await d.readFile(R.URI.file(O));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}t.resolveCommonProperties=C;function u(d){const S=A.env.USERDNSDOMAIN;if(!S)return!1;const y=S.toLowerCase();return d.some(w=>y===w)}t.verifyMicrosoftInternalDomain=u}),define(X[42],Y([0,1,11]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=m.createDecorator("telemetryService"),t.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(X[116],Y([0,1,12,23,24,20,42,55,49,21,26,15,18,7,41,114,113,11,17]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h,b,O,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var v;(function(p){p[p.None=0]="None",p[p.IncludeVersions=1]="IncludeVersions",p[p.IncludeFiles=2]="IncludeFiles",p[p.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",p[p.IncludeSharedAccounts=8]="IncludeSharedAccounts",p[p.IncludeVersionProperties=16]="IncludeVersionProperties",p[p.ExcludeNonValidated=32]="ExcludeNonValidated",p[p.IncludeInstallationTargets=64]="IncludeInstallationTargets",p[p.IncludeAssetUri=128]="IncludeAssetUri",p[p.IncludeStatistics=256]="IncludeStatistics",p[p.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",p[p.Unpublished=4096]="Unpublished"})(v||(v={}));function o(...p){return String(p.reduce((f,l)=>f|l,0))}var r;(function(p){p[p.Tag=1]="Tag",p[p.ExtensionId=4]="ExtensionId",p[p.Category=5]="Category",p[p.ExtensionName=7]="ExtensionName",p[p.Target=8]="Target",p[p.Featured=9]="Featured",p[p.SearchText=10]="SearchText",p[p.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class a{constructor(f=s){this.state=f}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(f,l=this.state.pageSize){return new a(Object.assign(Object.assign({},this.state),{pageNumber:f,pageSize:l}))}withFilter(f,...l){const g=[...this.state.criteria,...l.length?l.map(I=>({filterType:f,value:I})):[{filterType:f}]];return new a(Object.assign(Object.assign({},this.state),{criteria:g}))}withSortBy(f){return new a(Object.assign(Object.assign({},this.state),{sortBy:f}))}withSortOrder(f){return new a(Object.assign(Object.assign({},this.state),{sortOrder:f}))}withFlags(...f){return new a(Object.assign(Object.assign({},this.state),{flags:f.reduce((l,g)=>l|g,0)}))}withAssetTypes(...f){return new a(Object.assign(Object.assign({},this.state),{assetTypes:f}))}get raw(){const{criteria:f,pageNumber:l,pageSize:g,sortBy:I,sortOrder:N,flags:M,assetTypes:V}=this.state;return{filters:[{criteria:f,pageNumber:l,pageSize:g,sortBy:I,sortOrder:N}],assetTypes:V,flags:M}}get searchText(){const f=this.state.criteria.filter(l=>l.filterType===r.SearchText)[0];return f&&f.value?f.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(f=>String(f.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function E(p,f){const l=(p||[]).filter(g=>g.statisticName===f)[0];return l?l.value:0}function P(p){const f="Microsoft.VisualStudio.Code.Translation.";return p.files.filter(g=>g.assetType.indexOf(f)===0).reduce((g,I)=>{const N=B(p,I.assetType);return N&&g.push([I.assetType.substring(f.length),N]),g},[])}function U(p){if(p.properties){const f=p.properties.filter(I=>I.key===e.Repository),l=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),g=f.filter(I=>l.test(I.value))[0];return g?{uri:g.value,fallbackUri:g.value}:null}return B(p,e.Repository)}function k(p){return{uri:`${p.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${p.fallbackAssetUri}/${e.VSIX}`}}function j(p){const f=B(p,e.Icon);if(f)return f;const l=A.DefaultIconPath;return{uri:l,fallbackUri:l}}function B(p,f){return p.files.filter(g=>g.assetType===f)[0]?{uri:`${p.assetUri}/${f}`,fallbackUri:`${p.fallbackAssetUri}/${f}`}:null}function $(p,f){const l=p.properties?p.properties.filter(I=>I.key===f):[],g=l.length>0&&l[0].value;return g?g.split(",").map(I=>D.adoptToGalleryExtensionId(I)):[]}function K(p){const f=p.properties?p.properties.filter(l=>l.key===i.Engine):[];return f.length>0&&f[0].value||""}function ee(p){const f=p.properties?p.properties.filter(g=>g.key===i.LocalizedLanguages):[],l=f.length>0&&f[0].value||"";return l?l.split(","):[]}function te(p){return p.indexOf("preview")!==-1}function Q(p){return p.files.some(f=>f.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?L.joinPath(T.URI.parse(p.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function oe(p,f,l,g,I){var N;const M={manifest:B(f,e.Manifest),readme:B(f,e.Details),changelog:B(f,e.Changelog),license:B(f,e.License),repository:U(f),download:k(f),icon:j(f),coreTranslations:P(f)};return{identifier:{id:D.getGalleryExtensionId(p.publisher.publisherName,p.extensionName),uuid:p.extensionId},name:p.extensionName,version:f.version,date:f.lastUpdated,displayName:p.displayName,publisherId:p.publisher.publisherId,publisher:p.publisher.publisherName,publisherDisplayName:p.publisher.displayName,description:p.shortDescription||"",installCount:E(p.statistics,"install"),rating:E(p.statistics,"averagerating"),ratingCount:E(p.statistics,"ratingcount"),assetUri:T.URI.parse(f.assetUri),webExtension:!!((N=p.tags)===null||N===void 0?void 0:N.includes(A.WEB_EXTENSION_TAG)),webResource:Q(f),assetTypes:f.files.map(({assetType:V})=>V),assets:M,properties:{dependencies:$(f,i.Dependency),extensionPack:$(f,i.ExtensionPack),engine:K(f),localizedLanguages:ee(f)},telemetryData:{index:(g.pageNumber-1)*g.pageSize+l,querySource:I},preview:te(p.flags)}}let se=class{constructor(f,l,g,I,N,M,V){this.requestService=f,this.logService=l,this.environmentService=g,this.telemetryService=I,this.fileService=N,this.productService=M;const W=M.extensionsGallery;this.extensionsGalleryUrl=W&&W.serviceUrl,this.extensionsControlUrl=W&&W.controlUrl,this.commonHeadersPromise=re(M.version,this.environmentService,this.fileService,V)}api(f=""){return`${this.extensionsGalleryUrl}${f}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(f,l){const g=[];let{total:I,firstPage:N,getPage:M}=await this.query({names:f,pageSize:f.length},l);g.push(...N);for(let V=1;g.length<I&&(N=await M(V,l),N.length);V++)g.push(...N);return g}async getCompatibleExtension(f,l){return this.getCompatibleExtensionByEngine(f,l)}async getCompatibleExtensionByEngine(f,l){const g=A.isIExtensionIdentifier(f)?null:f;if(g&&g.properties.engine&&u.isEngineValid(g.properties.engine,this.productService.version,this.productService.date))return g;const{id:I,uuid:N}=g?g.identifier:f;let M=new a().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N?M=M.withFilter(r.ExtensionId,N):M=M.withFilter(r.ExtensionName,I);const{galleryExtensions:V}=await this.queryGallery(M,S.CancellationToken.None),[W]=V;if(!W||!W.versions.length)return null;if(l){const G=W.versions.filter(J=>J.version===l)[0];if(G){const J=oe(W,G,0,M);if(J.properties.engine&&u.isEngineValid(J.properties.engine,this.productService.version,this.productService.date))return J}return null}const _=await this.getLastValidExtensionVersion(W,W.versions);return _?oe(W,_,0,M):null}async query(f,l){const g=S.CancellationToken.isCancellationToken(f)?{}:f,I=S.CancellationToken.isCancellationToken(f)?f:l;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let N=g.text||"";const M=R.getOrDefault(g,Z=>Z.pageSize,50);let V=new a().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,M).withFilter(r.Target,"Microsoft.VisualStudio.Code");N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Z,ne,ce)=>(V=V.withFilter(r.Category,ce||ne),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Z,ne,ce)=>(V=V.withFilter(r.Tag,ce||ne),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(r.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),V=V.withFilter(r.SearchText,N)),V=V.withSortBy(0)):g.ids?V=V.withFilter(r.ExtensionId,...g.ids):g.names?V=V.withFilter(r.ExtensionName,...g.names):V=V.withSortBy(4),typeof g.sortBy=="number"&&(V=V.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(V=V.withSortOrder(g.sortOrder));const{galleryExtensions:W,total:_}=await this.queryGallery(V,I),G=W.map((Z,ne)=>oe(Z,Z.versions[0],ne,V,g.source)),J=async(Z,ne)=>{if(ne.isCancellationRequested)throw m.canceled();const ce=V.withPage(Z+1),{galleryExtensions:ye}=await this.queryGallery(ce,ne);return ye.map((be,Ae)=>oe(be,be.versions[0],Ae,ce,g.source))};return{firstPage:G,total:_,pageSize:V.pageSize,getPage:J}}async queryGallery(f,l){if(!this.isEnabled())throw new Error("No extension gallery service configured.");f=f.withFlags(f.flags,v.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,o(v.Unpublished));const g=await this.commonHeadersPromise,I=JSON.stringify(f.raw),N=Object.assign(Object.assign({},g),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(I.length)}),M=new Date().getTime();let V,W,_=0;try{if(V=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:I,headers:N},l),V.res.statusCode&&V.res.statusCode>=400&&V.res.statusCode<500)return{galleryExtensions:[],total:_};const G=await C.asJson(V);if(G){const J=G.results[0],Z=J.extensions,ne=J.resultMetadata&&J.resultMetadata.filter(ce=>ce.metadataType==="ResultCount")[0];return _=ne&&ne.metadataItems.filter(ce=>ce.name==="TotalCount")[0].count||0,{galleryExtensions:Z,total:_}}return{galleryExtensions:[],total:_}}catch(G){throw W=G,G}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},f.telemetryData),{requestBodySize:String(I.length),duration:new Date().getTime()-M,success:!!V&&C.isSuccess(V),responseBodySize:V==null?void 0:V.res.headers["Content-Length"],statusCode:V?String(V.res.statusCode):void 0,errorCode:W?m.isPromiseCanceledError(W)?"canceled":m.getErrorMessage(W).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(_)}))}}async reportStatistic(f,l,g,I){if(!this.isEnabled())return;const N=await this.commonHeadersPromise,M=Object.assign(Object.assign({},N),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${f}/extensions/${l}/${g}/stats?statType=${I}`),headers:M},S.CancellationToken.None)}catch(V){}}async download(f,l,g){this.logService.trace("ExtensionGalleryService#download",f.identifier.id);const I=D.getGalleryExtensionTelemetryData(f),N=new Date().getTime(),M=G=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},I),{duration:G})),V=g===1?"install":g===2?"update":"",W=V?{uri:`${f.assets.download.uri}&${V}=true`,fallbackUri:`${f.assets.download.fallbackUri}?${V}=true`}:f.assets.download,_=await this.getAsset(W);await this.fileService.writeFile(l,_.stream),M(new Date().getTime()-N)}async getReadme(f,l){if(f.assets.readme){const g=await this.getAsset(f.assets.readme,{},l);return await C.asText(g)||""}return""}async getManifest(f,l){if(f.assets.manifest){const g=await this.getAsset(f.assets.manifest,{},l),I=await C.asText(g);return I?JSON.parse(I):null}return null}async getCoreTranslation(f,l){const g=f.assets.coreTranslations.filter(I=>I[0]===l.toUpperCase())[0];if(g){const I=await this.getAsset(g[1]),N=await C.asText(I);return N?JSON.parse(N):null}return null}async getChangelog(f,l){if(f.assets.changelog){const g=await this.getAsset(f.assets.changelog,{},l);return await C.asText(g)||""}return""}async getAllVersions(f,l){let g=new a().withFlags(v.IncludeVersions,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");f.identifier.uuid?g=g.withFilter(r.ExtensionId,f.identifier.uuid):g=g.withFilter(r.ExtensionName,f.identifier.id);const I=[],{galleryExtensions:N}=await this.queryGallery(g,S.CancellationToken.None);return N.length&&(l?await Promise.all(N[0].versions.map(async M=>{let V;try{V=await this.getEngine(M)}catch(W){}V&&u.isEngineValid(V,this.productService.version,this.productService.date)&&I.push({version:M.version,date:M.lastUpdated})})):I.push(...N[0].versions.map(M=>({version:M.version,date:M.lastUpdated})))),I}async getAsset(f,l={},g=S.CancellationToken.None){const I=await this.commonHeadersPromise,N={type:"GET"},M=Object.assign(Object.assign({},I),l.headers||{});l=Object.assign(Object.assign(Object.assign({},l),N),{headers:M});const V=f.uri,W=f.fallbackUri,_=Object.assign(Object.assign({},l),{url:V});try{const G=await this.requestService.request(_,g);if(G.res.statusCode===200)return G;const J=await C.asText(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${J}`)}catch(G){if(m.isPromiseCanceledError(G))throw G;const J=m.getErrorMessage(G);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:V,message:J});const Z=Object.assign(Object.assign({},l),{url:W});return this.requestService.request(Z,g)}}async getLastValidExtensionVersion(f,l){const g=this.getLastValidExtensionVersionFromProperties(f,l);return g||this.getLastValidExtensionVersionRecursively(f,l)}getLastValidExtensionVersionFromProperties(f,l){for(const g of l){const I=K(g);if(!I)return null;if(u.isEngineValid(I,this.productService.version,this.productService.date))return g}return null}async getEngine(f){const l=K(f);if(l)return l;const g=B(f,e.Manifest);if(!g)throw new Error("Manifest was not found");const I={"Accept-Encoding":"gzip"},N=await this.getAsset(g,{headers:I}),M=await C.asJson(N);if(M)return M.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(f,l){if(!l.length)return null;const g=l[0],I=await this.getEngine(g);return u.isEngineValid(I,this.productService.version,this.productService.date)?Object.assign(Object.assign({},g),{properties:[...g.properties||[],{key:i.Engine,value:I}]}):this.getLastValidExtensionVersionRecursively(f,l.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const f=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},S.CancellationToken.None);if(f.res.statusCode!==200)throw new Error("Could not get extensions report.");const l=await C.asJson(f),g=new Map;if(l)for(const I of l.malicious){const N=g.get(I)||{id:{id:I},malicious:!0,slow:!1};N.malicious=!0,g.set(I,N)}return[...g.values()]}};se=ue([fe(0,C.IRequestService),fe(1,y.ILogService),fe(2,d.IEnvironmentService),fe(3,F.ITelemetryService),fe(4,w.IFileService),fe(5,c.IProductService),fe(6,O.optional(h.IStorageService))],se),t.ExtensionGalleryService=se;async function re(p,f,l,g){const I={"X-Market-Client-Id":`VSCode ${p}`,"User-Agent":`VSCode ${p}`},N=await b.getServiceMachineId(f,l,g);return I["X-Market-User-Id"]=N,I}t.resolveMarketplaceHeaders=re}),define(X[117],Y([0,1,40,84,19,11,27,30,2,20,25]),function(x,t,m,A,D,R,F,C,u,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(c,h){this._configurationService=h,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp(D.escapeRegExpCharacters(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const O=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!O})}))}setExperimentProperty(c,h){this._experimentProperties[c]=h}setEnabled(c){this._enabled=c}_updateUserOptIn(){var c;const h=(c=this._configurationService)===null||c===void 0?void 0:c.getValue(w);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let h=c.sessionID,b=c["common.instanceId"],O=c["common.machineId"],L=c["common.firstSessionDate"],v=c["common.msftInternal"];return{sessionId:h,instanceId:b,machineId:O,firstSessionDate:L,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(c,h,b){return this.isOptedIn?this._commonProperties.then(O=>{h=d.mixin(h,O),h=d.mixin(h,this._experimentProperties),h=d.cloneAndChange(h,L=>{if(typeof L=="string")return this._cleanupInfo(L,b)}),this._appender.log(c,h)},O=>{console.error(O)}):Promise.resolve(void 0)}publicLog2(c,h,b){return this.publicLog(c,h,b)}publicLogError(c,h){return this.sendErrorTelemetry?this.publicLog(c,h,!0):Promise.resolve(void 0)}publicLogError2(c,h){return this.publicLogError(c,h)}_cleanupInfo(c,h){let b=c;if(h){const O=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(c);if(!e)break;O.push([e.index,r.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const r=v.exec(c);if(!r)break;!L.test(r[0])&&O.every(([e,i])=>r.index<e||r.index>=i)&&(b+=c.substring(o,r.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}o<c.length&&(b+=c.substr(o))}for(let O of this._cleanupPatterns)b=b.replace(O,"");return b}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ue([fe(1,R.optional(F.IConfigurationService))],y),t.TelemetryService=y;const w="telemetry";S.Registry.as(C.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:A.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?A.localize(2,null,m.default.privacyStatementUrl):A.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(X[56],Y([0,1,27,20,13,4]),function(x,t,m,A,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,h){return Promise.resolve(void 0)}publicLog2(c,h){return this.publicLog(c,h)}publicLogError(c,h){return Promise.resolve(void 0)}publicLogError2(c,h){return this.publicLogError(c,h)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(h,b,O){}async publicLogError(h,b,O){}}t.NullEndpointTelemetryService=F;function C(...c){return{log:(h,b)=>c.forEach(O=>O.log(h,b)),flush:()=>R.Promises.settled(c.map(h=>h.flush()))}}t.combinedAppender=C,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,h){return h.onDidChangeConfiguration(b=>{b.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(b.source),configurationKeys:w(b.sourceConfig)})})}t.configurationTelemetry=u;function d(c){const h=Object.create(null),b=Object.create(null),O=Object.create(null);y(c,O);for(let L in O){L=L.length>150?L.substr(L.length-149):L;const v=O[L];typeof v=="number"?b[L]=v:typeof v=="boolean"?b[L]=v?1:0:typeof v=="string"?h[L]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(h[L]=v)}return{properties:h,measurements:b}}t.validateTelemetryData=d;function S(c){if(!c)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(O=>{c.indexOf(`${O}+`)===0&&(h=O)}),h}t.cleanRemoteAuthority=S;function y(c,h,b=0,O){if(!!c)for(let L of Object.getOwnPropertyNames(c)){const v=c[L],o=O?O+L:L;Array.isArray(v)?h[o]=A.safeStringify(v):v instanceof Date?h[o]=v.toISOString():D.isObject(v)?b<2?y(v,h,b+1,o+"."):h[o]=A.safeStringify(v):h[o]=v}}function w(c){if(!c)return[];const h=[];return T(h,"",c),h}function T(c,h,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(O=>T(c,h?`${h}.${O}`:O,b[O])):c.push(h)}}),define(X[118],Y([0,1,12,20,56]),function(x,t,m,A,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(C){const u=await new Promise((S,y)=>{x(["applicationinsights"],S,y)});let d;return u.defaultClient?(d=new u.TelemetryClient(C),d.channel.setUseDiskRetryCaching(!0)):(u.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=u.defaultClient),C.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class F{constructor(u,d,S){this._eventPrefix=u,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof S=="function"?this._aiClient=S():this._aiClient=S,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(d=>{u(d)},d=>{m.onUnexpectedError(d),console.error(d)})}}log(u,d){!this._aiClient||(d=A.mixin(d,this._defaultData),d=D.validateTelemetryData(d),this._withAIClient(S=>S.trackEvent({name:this._eventPrefix+"/"+u,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(X[119],Y([0,1,9,3]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function D(R,F){const C=Object.create(null),u=(S,y)=>{const w=JSON.parse(S);C[y]=w};if(F){const S=[],y=await m.Promises.readdir(F);for(const T of y)try{(await m.Promises.stat(A.join(F,T))).isDirectory()&&S.push(T)}catch(c){}const w=[];for(const T of S)(await m.Promises.readdir(A.join(F,T))).filter(h=>h==="telemetry.json").length===1&&w.push(T);for(const T of w){const c=(await m.Promises.readFile(A.join(F,T,"telemetry.json"))).toString();u(c,T)}}let d=(await m.Promises.readFile(A.join(R,"telemetry-core.json"))).toString();return u(d,"vscode-core"),d=(await m.Promises.readFile(A.join(R,"telemetry-extensions.json"))).toString(),u(d,"vscode-extensions"),JSON.stringify(C,null,4)}t.buildTelemetryMessage=D}),define(X[43],Y([0,1,72,3,36,4,9,130,131,13]),function(x,t,m,A,D,R,F,C,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class S extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=S;function y(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function w(r){if(r instanceof S)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new S(e,r)}function T(r,e,i,n,s,a){const E=A.dirname(e),P=A.join(n,E);if(!P.startsWith(n))return Promise.reject(new Error(m.localize(0,null,e)));const U=A.join(n,e);let k;return a.onCancellationRequested(()=>{k&&k.destroy()}),Promise.resolve(F.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((j,B)=>{if(!a.isCancellationRequested)try{k=D.createWriteStream(U,{mode:i}),k.once("close",()=>j()),k.once("error",B),r.once("error",B),r.pipe(k)}catch($){B($)}}))}function c(r,e,i,n){let s=R.createCancelablePromise(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((E,P)=>{const U=new R.Sequencer,k=j=>{j.isCancellationRequested||(a++,r.readEntry())};r.once("error",P),r.once("close",()=>s.then(()=>{n.isCancellationRequested||r.entryCount===a?E():P(new S("Incomplete",new Error(m.localize(1,null,a,r.entryCount))))},P)),r.readEntry(),r.on("entry",j=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(j.fileName)){k(n);return}const B=j.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(B)){const ee=A.join(e,B);s=R.createCancelablePromise(te=>F.Promises.mkdir(ee,{recursive:!0}).then(()=>k(te)).then(void 0,P));return}const $=b(r,j),K=y(j);s=R.createCancelablePromise(ee=>U.queue(()=>$.then(te=>T(te,B,K,e,i,ee).then(()=>k(ee)))).then(null,P))})})}function h(r,e=!1){return new Promise((i,n)=>{C.open(r,e?{lazyEntries:!0}:void 0,(s,a)=>{s?n(w(s)):i(d.assertIsDefined(a))})})}function b(r,e){return new Promise((i,n)=>{r.openReadStream(e,(s,a)=>{s?n(w(s)):i(d.assertIsDefined(a))})})}function O(r,e){return new Promise((i,n)=>{const s=new u.ZipFile;e.forEach(E=>{E.contents?s.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&s.addFile(E.localPath,E.path)}),s.end();const a=D.createWriteStream(r);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(r))})}t.zip=O;function L(r,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=h(r,!0);return i.overwrite&&(a=a.then(E=>F.Promises.rm(e).then(()=>E))),a.then(E=>c(E,e,{sourcePathRegex:s},n))}t.extract=L;function v(r,e){return h(r).then(i=>new Promise((n,s)=>{i.on("entry",a=>{a.fileName===e&&b(i,a).then(E=>n(E),E=>s(E))}),i.once("close",()=>s(new Error(m.localize(2,null,e))))}))}function o(r,e){return v(r,e).then(i=>new Promise((n,s)=>{const a=[];i.once("error",s),i.on("data",E=>a.push(E)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(X[120],Y([0,1,43,77]),function(x,t,m,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function D(R){return m.buffer(R,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(C){throw new Error(A.localize(0,null))}})}t.getManifest=D}),define(X[121],Y([0,1,39,2,9,3,15,23,24,4,7,21,89,78,41,43,14,22,8,18,17,29,12]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h,b,O,L,v,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",a="deleting",E="renaming";let P=class extends A.Disposable{constructor(k,j,B,$,K){super();this.beforeRemovingExtension=k,this.fileService=j,this.logService=B,this.environmentService=$,this.productService=K,this._devSystemExtensionsPath=null,this.systemExtensionsPath=$.builtinExtensionsPath,this.extensionsPath=$.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new d.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const j=[];(k===null||k===0)&&j.push(this.scanSystemExtensions().then(null,B=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(B).message,i)))),(k===null||k===1)&&j.push(this.scanUserExtensions(!0).then(null,B=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(B).message,n))));try{const B=await Promise.all(j);return O.flatten(B)}catch(B){throw this.joinErrors(B)}}async scanUserExtensions(k){this.logService.trace("Started scanning user extensions");let[j,B]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return B=B.filter($=>!j[new u.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]),k&&(B=u.groupByExtension(B,K=>K.identifier).map(K=>K.sort((ee,te)=>m.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",B.length),B}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(k,j,B){const $=k.key(),K=R.join(this.extensionsPath,`.${r.generateUuid()}`),ee=R.join(this.extensionsPath,$);try{await D.Promises.rm(ee)}catch(Q){try{await D.Promises.rm(ee)}catch(oe){}throw new C.ExtensionManagementError(T.localize(0,null,ee,k.id),a)}await this.extractAtLocation(k,j,K,B);let te=await this.scanExtension(S.URI.file(K),1);if(!te)throw new Error(T.localize(1,null,K));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(k,K,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(Q){try{await D.Promises.rm(K)}catch(oe){}if(Q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${e.getErrorMessage(Q)}. Deleted from extracted location`,K),Q}try{te=await this.scanExtension(S.URI.file(ee),1)}catch(Q){}if(te)return te;throw new Error(T.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(k,j){return this.setMetadata(k,j),await this.storeMetadata(k,Object.assign(Object.assign({},j),{installedTimestamp:k.installedTimestamp})),k}async storeMetadata(k,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const B=R.join(k.location.fsPath,"package.json"),$=await D.Promises.readFile(B,"utf8"),{manifest:K}=await this.parseManifest($);return K.__metadata=j,await D.Promises.writeFile(B,JSON.stringify(K,null,"	")),k}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const j=k.map(B=>new u.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version));await this.withUninstalledExtensions(B=>{j.forEach($=>B[$.key()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions($=>delete $[k.key()]);const B=(await this.scanExtensions(1)).find($=>new u.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).equals(k))||null;return B?(await this.storeMetadata(B,{installedTimestamp:Date.now()}),this.scanExtension(B.location,1)):null}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await D.Promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let B={};if(j)try{B=JSON.parse(j)}catch($){}return k&&(k(B),Object.keys(B).length?await D.Promises.writeFile(this.uninstalledPath,JSON.stringify(B)):await D.Promises.rm(this.uninstalledPath)),B})}async removeExtension(k,j){this.logService.trace(`Deleting ${j} extension from disk`,k.identifier.id,k.location.fsPath),await D.Promises.rm(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new u.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version).key()])}async extractAtLocation(k,j,B,$){this.logService.trace(`Started extracting the extension from ${j} to ${B}`);try{await D.Promises.rm(B)}catch(K){throw new C.ExtensionManagementError(this.joinErrors(K).message,a)}try{await h.extract(j,B,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${B}:`,k.id)}catch(K){try{await D.Promises.rm(B)}catch(ee){}throw new C.ExtensionManagementError(K.message,K instanceof h.ExtractError&&K.type?K.type:s)}}async rename(k,j,B,$){try{await D.Promises.rename(j,B)}catch(K){if(b.isWindows&&K&&K.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${j} to ${B} with 'EPERM' error. Trying again...`,k.id),this.rename(k,j,B,$);throw new C.ExtensionManagementError(K.message||T.localize(3,null,j,B),K.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const k=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return k;const j=this.scanDevSystemExtensions(),[B,$]=await Promise.all([k,j]);return[...B,...$]}async scanExtensionsInDir(k,j){const B=new d.Limiter(10),$=await this.fileService.resolve(S.URI.file(k));return $.children?(await Promise.all($.children.filter(ee=>ee.isDirectory).map(ee=>B.queue(async()=>j===1&&o.basename(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,j))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(k,j){var B,$;try{const K=await this.fileService.resolve(k);if(K.children){const{manifest:ee,metadata:te}=await this.readManifest(k.fsPath),Q=(B=K.children.find(({name:p})=>/^readme(\.txt|\.md|)$/i.test(p)))===null||B===void 0?void 0:B.resource,oe=($=K.children.find(({name:p})=>/^changelog(\.txt|\.md|)$/i.test(p)))===null||$===void 0?void 0:$.resource,se={id:u.getGalleryExtensionId(ee.publisher,ee.name)},re={type:j,identifier:se,manifest:ee,location:k,readmeUrl:Q,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return te&&(this.setMetadata(re,te),re.installedTimestamp=te.installedTimestamp),re}}catch(K){j!==0&&this.logService.trace(K)}return null}async scanDefaultSystemExtensions(){const k=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",k.length),k}async scanDevSystemExtensions(){const k=this.getDevSystemExtensionsList();if(k.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter(B=>k.some($=>u.areSameExtensions(B.identifier,{id:$})))}else return[]}setMetadata(k,j){k.publisherDisplayName=j.publisherDisplayName||null,k.publisherId=j.publisherId||null,k.identifier.uuid=j.id,k.isMachineScoped=!!j.isMachineScoped,k.isBuiltin=k.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),B=new Set;for(const ee of j)k[new u.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||B.add(ee.identifier.id.toLowerCase());const $=u.groupByExtension(j,ee=>ee.identifier);await d.Promises.settled($.map(async ee=>{const te=ee.sort((Q,oe)=>m.rcompare(Q.manifest.version,oe.manifest.version))[0];B.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const K=j.filter(ee=>k[new u.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await d.Promises.settled(K.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const k=await this.scanAllUserExtensions(),j=[],B=u.groupByExtension(k,$=>$.identifier);j.push(...O.flatten(B.map($=>$.sort((K,ee)=>m.rcompare(K.manifest.version,ee.manifest.version)).slice(1)))),await d.Promises.settled(j.map($=>this.removeExtension($,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(k=>k.name)}joinErrors(k){const j=Array.isArray(k)?k:[k];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((B,$)=>new Error(`${B.message}${B.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(L.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(k){const j=[D.Promises.readFile(R.join(k,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),D.Promises.readFile(R.join(k,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:B,metadata:$},K]=await Promise.all(j);return{manifest:w.localizeManifest(B,K),metadata:$}}parseManifest(k){return new Promise((j,B)=>{try{const $=JSON.parse(k),K=$.__metadata||null;j({manifest:$,metadata:K})}catch($){B(new Error(T.localize(4,null)))}})}};P=ue([fe(1,v.IFileService),fe(2,F.ILogService),fe(3,y.INativeEnvironmentService),fe(4,c.IProductService)],P),t.ExtensionsScanner=P}),define(X[122],Y([0,1,76,3,9,2,22,43,23,24,21,4,10,39,7,40,14,15,97,28,42,49,17,29,95,11,8,26,120,101,121,102,103,18]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h,b,O,L,v,o,r,e,i,n,s,a,E,P,U,k,j,B,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const K="unsetUninstalled",ee="downloading",te="validating",Q="local",oe="unknown";let se=class extends R.Disposable{constructor(p,f,l,g,I,N,M){super();this.environmentService=p,this.galleryService=f,this.logService=l,this.downloadService=g,this.telemetryService=I,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new w.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new w.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new w.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new w.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const V=this._register(N.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(k.ExtensionsScanner,_=>V.postUninstall(_))),this.manifestCache=this._register(new L.ExtensionsManifestCache(p,this)),this.extensionsDownloader=this._register(N.createInstance(U.ExtensionsDownloader));const W=this._register(new B.ExtensionsWatcher(this,M,p,l));this._register(W.onDidChangeExtensionsByAnotherSource(({added:_,removed:G})=>{_.forEach(J=>this._onDidInstallExtension.fire({identifier:J.identifier,operation:0,local:J})),G.forEach(J=>this._onDidUninstallExtension.fire({identifier:J}))})),this._register(R.toDisposable(()=>{this.installingExtensions.forEach(_=>_.cancel()),this.uninstallingExtensions.forEach(_=>_.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(p){this.logService.trace("ExtensionManagementService#zip",p.identifier.id);const f=await this.collectFiles(p),l=await C.zip(e.joinPath(this.environmentService.tmpDir,i.generateUuid()).fsPath,f);return c.URI.file(l)}async unzip(p){return this.logService.trace("ExtensionManagementService#unzip",p.toString()),(await this.install(p)).identifier}async getManifest(p){const f=await this.downloadVsix(p),l=A.resolve(f.fsPath);return P.getManifest(l)}async collectFiles(p){const f=async g=>{let I=await D.Promises.readdir(g);I=I.map(V=>A.join(g,V));const N=await Promise.all(I.map(V=>D.Promises.stat(V)));let M=Promise.resolve([]);return N.forEach((V,W)=>{const _=I[W];V.isFile()&&(M=M.then(G=>[...G,_])),V.isDirectory()&&(M=M.then(G=>f(_).then(J=>[...G,...J])))}),M};return(await f(p.location.fsPath)).map(g=>({path:`extension/${A.relative(p.location.fsPath,g)}`,localPath:g}))}async install(p,f={}){return this.logService.trace("ExtensionManagementService#install",p.toString()),y.createCancelablePromise(async l=>{const g=await this.downloadVsix(p),I=A.resolve(g.fsPath),N=await P.getManifest(I),M={id:d.getGalleryExtensionId(N.publisher,N.name)};let V=1;if(N.engines&&N.engines.vscode&&!r.isEngineValid(N.engines.vscode,h.default.version,h.default.date))throw new Error(m.localize(0,null,M.id,h.default.version));const W=new d.ExtensionIdentifierWithVersion(M,N.version),G=(await this.getInstalled(1)).find(Z=>d.areSameExtensions(M,Z.identifier));if(G)if(f.isMachineScoped=f.isMachineScoped||G.isMachineScoped,f.isBuiltin=f.isBuiltin||G.isBuiltin,V=2,W.equals(new d.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch(Z){throw new Error(m.localize(1,null,N.displayName||N.name))}else T.gt(G.manifest.version,N.version)&&await this.uninstallExtension(G);else{const Z=await this.unsetUninstalledAndGetLocal(W);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch(ne){throw new Error(m.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",M.id),this._onInstallExtension.fire({identifier:M,zipPath:I});let J;try{J=await this.getGalleryMetadata(d.getGalleryExtensionId(N.publisher,N.name))}catch(Z){}try{const Z=await this.installFromZipPath(W,I,f.installOnlyNewlyAddedFromExtensionPack?G:void 0,Object.assign(Object.assign({},J||{}),f),f,V,l);return this.logService.info("Successfully installed the extension:",M.id),Z}catch(Z){throw this.logService.error("Failed to install the extension:",M.id,Z.message),Z}})}async downloadVsix(p){if(p.scheme===a.Schemas.file)return p;if(!this.downloadService)throw new Error("Download service is not available");const f=e.joinPath(this.environmentService.tmpDir,i.generateUuid());return await this.downloadService.download(p,f),f}async installFromZipPath(p,f,l,g,I,N,M){try{const V=await this.installExtension({zipPath:f,identifierWithVersion:p,metadata:g},M);try{I.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(V,l,I)}catch(W){F.isNonEmptyArray(V.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",V.identifier.id,W.message),F.isNonEmptyArray(V.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",V.identifier.id,W.message)}return this._onDidInstallExtension.fire({identifier:p,zipPath:f,local:V,operation:N}),V}catch(V){throw this._onDidInstallExtension.fire({identifier:p,zipPath:f,operation:N,error:V}),V}}async canInstall(p){return!0}async installFromGallery(p,f={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(3,null));try{p=await this.checkAndGetCompatibleVersion(p)}catch(I){const N=I&&I.code?I.code:oe;throw this.logService.error("Failed to install extension:",p.identifier.id,I?I.message:N),this.reportTelemetry(this.getTelemetryEvent(1),d.getGalleryExtensionTelemetryData(p),void 0,I),I instanceof Error&&(I.name=N),I}const l=new d.ExtensionIdentifierWithVersion(p.identifier,p.version).key();let g=this.installingExtensions.get(l);return g||(g=y.createCancelablePromise(I=>this.doInstallFromGallery(p,f,I)),this.installingExtensions.set(l,g),g.finally(()=>this.installingExtensions.delete(l))),g}async doInstallFromGallery(p,f,l){const g=new Date().getTime();let I=1;this.logService.info("Installing extension:",p.identifier.id),this._onInstallExtension.fire({identifier:p.identifier,gallery:p});try{const M=(await this.getInstalled(1)).find(_=>d.areSameExtensions(_.identifier,p.identifier));M&&(I=2);const V=await this.downloadInstallableExtension(p,I);V.metadata.isMachineScoped=f.isMachineScoped||(M==null?void 0:M.isMachineScoped),V.metadata.isBuiltin=f.isBuiltin||(M==null?void 0:M.isBuiltin);const W=await this.installExtension(V,l);try{await this.extensionsDownloader.delete(c.URI.file(V.zipPath))}catch(_){}if(!f.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(W,M,f)}catch(_){try{await this.uninstall(W)}catch(G){}throw _}return M&&T.neq(M.manifest.version,p.version)&&await this.extensionsScanner.setUninstalled(M),this.logService.info("Extensions installed successfully:",p.identifier.id),this._onDidInstallExtension.fire({identifier:p.identifier,gallery:p,local:W,operation:I}),this.reportTelemetry(this.getTelemetryEvent(I),d.getGalleryExtensionTelemetryData(p),new Date().getTime()-g,void 0),W}catch(N){const M=N&&N.code?N.code:oe;throw this.logService.error("Failed to install extension:",p.identifier.id,N?N.message:M),this._onDidInstallExtension.fire({identifier:p.identifier,gallery:p,operation:I,error:M}),this.reportTelemetry(this.getTelemetryEvent(I),d.getGalleryExtensionTelemetryData(p),new Date().getTime()-g,N),N instanceof Error&&(N.name=M),N}}async checkAndGetCompatibleVersion(p){if(await this.isMalicious(p))throw new u.ExtensionManagementError(m.localize(4,null),u.INSTALL_ERROR_MALICIOUS);const f=await this.galleryService.getCompatibleExtension(p);if(!f)throw new u.ExtensionManagementError(m.localize(5,null,p.identifier.id,h.default.version),u.INSTALL_ERROR_INCOMPATIBLE);return f}async reinstallFromGallery(p){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",p.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(6,null));const f=await this.findGalleryExtension(p);if(!f)throw new Error(m.localize(7,null));await this.extensionsScanner.setUninstalled(p);try{await this.extensionsScanner.removeUninstalledExtension(p)}catch(l){throw new Error(m.localize(8,null,v.toErrorMessage(l)))}await this.installFromGallery(f)}getTelemetryEvent(p){return p===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(p){const f=await this.getExtensionsReport();return d.getMaliciousExtensionsSet(f).has(p.identifier.id)}async downloadInstallableExtension(p,f){const l={id:p.identifier.uuid,publisherId:p.publisherId,publisherDisplayName:p.publisherDisplayName};let g;try{this.logService.trace("Started downloading extension:",p.identifier.id),g=(await this.extensionsDownloader.downloadExtension(p,f)).fsPath,this.logService.info("Downloaded extension:",p.identifier.id,g)}catch(I){throw new u.ExtensionManagementError(this.joinErrors(I).message,ee)}try{const I=await P.getManifest(g);return{zipPath:g,identifierWithVersion:new d.ExtensionIdentifierWithVersion(p.identifier,I.version),metadata:l}}catch(I){throw new u.ExtensionManagementError(this.joinErrors(I).message,te)}}async installExtension(p,f){try{const l=await this.unsetUninstalledAndGetLocal(p.identifierWithVersion);if(l)return p.metadata?this.extensionsScanner.saveMetadataForLocalExtension(l,p.metadata):l}catch(l){throw b.isMacintosh?new u.ExtensionManagementError(m.localize(9,null),K):new u.ExtensionManagementError(m.localize(10,null),K)}return this.extractAndInstall(p,f)}async unsetUninstalledAndGetLocal(p){if(!await this.isUninstalled(p))return null;this.logService.trace("Removing the extension from uninstalled list:",p.id);const l=await this.extensionsScanner.setInstalled(p);return this.logService.info("Removed the extension from uninstalled list:",p.id),l}async extractAndInstall({zipPath:p,identifierWithVersion:f,metadata:l},g){let I=await this.extensionsScanner.extractUserExtension(f,p,g);return this.logService.info("Installation completed.",f.id),l&&(I=await this.extensionsScanner.saveMetadataForLocalExtension(I,l)),I}async installDependenciesAndPackExtensions(p,f,l){if(!this.galleryService.isEnabled())return;const g=p.manifest.extensionDependencies||[];if(p.manifest.extensionPack)for(const I of p.manifest.extensionPack)f&&f.manifest.extensionPack&&f.manifest.extensionPack.some(N=>d.areSameExtensions({id:N},{id:I}))||g.every(N=>!d.areSameExtensions({id:N},{id:I}))&&g.push(I);if(g.length){const I=await this.getInstalled(),N=g.filter(M=>I.every(({identifier:V})=>!d.areSameExtensions(V,{id:M})));if(N.length){const V=(await this.galleryService.query({names:N,pageSize:g.length},E.CancellationToken.None)).firstPage;try{await y.Promises.settled(V.map(W=>this.installFromGallery(W,l)))}catch(W){try{await this.rollback(V)}catch(_){}throw W}}}}async rollback(p){const l=(await this.getInstalled(1)).filter(g=>p.some(I=>new d.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version).equals(new d.ExtensionIdentifierWithVersion(I.identifier,I.version))));await y.Promises.settled(l.map(g=>this.uninstall(g)))}async uninstall(p,f={}){this.logService.trace("ExtensionManagementService#uninstall",p.identifier.id);const l=await this.getInstalled(1),g=l.find(I=>d.areSameExtensions(I.identifier,p.identifier));if(!g)throw new Error(m.localize(11,null,p.manifest.displayName||p.manifest.name));try{await this.checkForDependenciesAndUninstall(g,l,f)}catch(I){throw this.joinErrors(I)}}async updateMetadata(p,f){return this.logService.trace("ExtensionManagementService#updateMetadata",p.identifier.id),p=await this.extensionsScanner.saveMetadataForLocalExtension(p,Object.assign(Object.assign({},p.manifest.__metadata||{}),f)),this.manifestCache.invalidate(),p}async updateExtensionScope(p,f){return this.logService.trace("ExtensionManagementService#updateExtensionScope",p.identifier.id),p=await this.extensionsScanner.saveMetadataForLocalExtension(p,Object.assign(Object.assign({},p.manifest.__metadata||{}),{isMachineScoped:f})),this.manifestCache.invalidate(),p}async getGalleryMetadata(p){const f=await this.findGalleryExtensionByName(p);return f?{id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId}:void 0}async findGalleryExtension(p){if(p.identifier.uuid){const f=await this.findGalleryExtensionById(p.identifier.uuid);return f||this.findGalleryExtensionByName(p.identifier.id)}return this.findGalleryExtensionByName(p.identifier.id)}async findGalleryExtensionById(p){return(await this.galleryService.query({ids:[p],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(p){return(await this.galleryService.query({names:[p],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(p){const f=Array.isArray(p)?p:[p];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((l,g)=>new Error(`${l.message}${l.message?",":""}${g instanceof Error?g.message:g}`),new Error(""))}async checkForDependenciesAndUninstall(p,f,l){try{await this.preUninstallExtension(p);const g=l.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(p,f);await this.uninstallExtensions(p,g,f,l)}catch(g){throw await this.postUninstallExtension(p,new u.ExtensionManagementError(g instanceof Error?g.message:g,Q)),g}await this.postUninstallExtension(p)}async uninstallExtensions(p,f,l,g){const I=[p,...f];if(!g.donotCheckDependents)for(const N of I)this.checkForDependents(N,I,l,p);await y.Promises.settled([this.uninstallExtension(p),...f.map(N=>this.doUninstall(N))])}checkForDependents(p,f,l,g){const I=this.getDependents(p,l);if(I.length){const N=I.filter(M=>f.indexOf(M)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(p,N,g))}}getDependentsErrorMessage(p,f,l){return l===p?f.length===1?m.localize(12,null,l.manifest.displayName||l.manifest.name,f[0].manifest.displayName||f[0].manifest.name):f.length===2?m.localize(13,null,l.manifest.displayName||l.manifest.name,f[0].manifest.displayName||f[0].manifest.name,f[1].manifest.displayName||f[1].manifest.name):m.localize(14,null,l.manifest.displayName||l.manifest.name,f[0].manifest.displayName||f[0].manifest.name,f[1].manifest.displayName||f[1].manifest.name):f.length===1?m.localize(15,null,l.manifest.displayName||l.manifest.name,p.manifest.displayName||p.manifest.name,f[0].manifest.displayName||f[0].manifest.name):f.length===2?m.localize(16,null,l.manifest.displayName||l.manifest.name,p.manifest.displayName||p.manifest.name,f[0].manifest.displayName||f[0].manifest.name,f[1].manifest.displayName||f[1].manifest.name):m.localize(17,null,l.manifest.displayName||l.manifest.name,p.manifest.displayName||p.manifest.name,f[0].manifest.displayName||f[0].manifest.name,f[1].manifest.displayName||f[1].manifest.name)}getAllPackExtensionsToUninstall(p,f,l=[]){if(l.indexOf(p)!==-1)return[];l.push(p);const g=p.manifest.extensionPack?p.manifest.extensionPack:[];if(g.length){const I=f.filter(M=>!M.isBuiltin&&g.some(V=>d.areSameExtensions({id:V},M.identifier))),N=[];for(const M of I)N.push(...this.getAllPackExtensionsToUninstall(M,f,l));return[...I,...N]}return[]}getDependents(p,f){return f.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(g=>d.areSameExtensions({id:g},p.identifier)))}async doUninstall(p){try{await this.preUninstallExtension(p),await this.uninstallExtension(p)}catch(f){throw await this.postUninstallExtension(p,new u.ExtensionManagementError(f instanceof Error?f.message:f,Q)),f}await this.postUninstallExtension(p)}async preUninstallExtension(p){if(!await D.Promises.exists(p.location.fsPath))throw new Error(m.localize(18,null));this.logService.info("Uninstalling extension:",p.identifier.id),this._onUninstallExtension.fire(p.identifier)}async uninstallExtension(p){let f=this.uninstallingExtensions.get(p.identifier.id);return f||(f=y.createCancelablePromise(async()=>{const l=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...l.filter(g=>d.areSameExtensions(g.identifier,p.identifier)))}),this.uninstallingExtensions.set(p.identifier.id,f),f.finally(()=>this.uninstallingExtensions.delete(p.identifier.id))),f}async postUninstallExtension(p,f){if(f)this.logService.error("Failed to uninstall extension:",p.identifier.id,f.message);else if(this.logService.info("Successfully uninstalled extension:",p.identifier.id),p.identifier.uuid)try{await this.galleryService.reportStatistic(p.manifest.publisher,p.manifest.name,p.manifest.version,"uninstall")}catch(g){}this.reportTelemetry("extensionGallery:uninstall",d.getLocalExtensionTelemetryData(p),void 0,f);const l=f?f instanceof u.ExtensionManagementError?f.code:oe:void 0;this._onDidUninstallExtension.fire({identifier:p.identifier,error:l})}getInstalled(p=null){return this.extensionsScanner.scanExtensions(p)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(p){return(await this.filterUninstalled(p)).length===1}async filterUninstalled(...p){const f=[],l=await this.extensionsScanner.getUninstalledExtensions();for(const g of p)l[g.key()]&&f.push(g.key());return f}getExtensionsReport(){const p=new Date().getTime();return(!this.reportedExtensions||p-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=p),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const p=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${p.length} reported extensions from service`),p}catch(p){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(p,f,l,g){const I=g?g instanceof u.ExtensionManagementError?g.code:oe:void 0;this.telemetryService.publicLogError(p,Object.assign(Object.assign({},f),{success:!g,duration:l,errorcode:I}))}};se=ue([fe(0,S.INativeEnvironmentService),fe(1,u.IExtensionGalleryService),fe(2,O.ILogService),fe(3,s.optional(n.IDownloadService)),fe(4,o.ITelemetryService),fe(5,s.IInstantiationService),fe(6,$.IFileService)],se),t.ExtensionManagementService=se}),define(X[123],Y([0,1,132,112,2,13,12,111,27,15,16,21,98]),function(x,t,m,A,D,R,F,C,u,d,S,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let T=class extends D.Disposable{constructor(h,b,O){super();this.environmentService=b,this.logService=O,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,b){this.logService.trace("RequestService#request",h.url);const{proxyUrl:O,strictSSL:L}=this,v=Object.assign(Object.assign({},process.env),await w.resolveShellEnv(this.logService,this.environmentService.args,process.env)),o=h.agent?h.agent:await C.getProxyAgent(h.url||"",v,{proxyUrl:O,strictSSL:L});return h.agent=o,h.strictSSL=L,this.authorization&&(h.headers=Object.assign(Object.assign({},h.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(h,b)}async getNodeRequest(h){return(A.parse(h.url).protocol==="https:"?await new Promise((L,v)=>{x(["https"],L,v)}):await new Promise((L,v)=>{x(["http"],L,v)})).request}_request(h,b){return new Promise(async(O,L)=>{let v;const o=A.parse(h.url),r=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:R.isBoolean(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(e.auth=h.user+":"+h.password),v=r(e,i=>{const n=R.isNumber(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},h),{url:i.headers.location,followRedirects:n-1}),b).then(O,L);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe(m.createGunzip())),O({res:i,stream:S.streamToBufferReadableStream(s)})}}),v.on("error",L),h.timeout&&v.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&v.write(h.data),v.end(),b.onCancellationRequested(()=>{v.abort(),L(F.canceled())})})}async resolveProxy(h){}};T=ue([fe(0,u.IConfigurationService),fe(1,y.INativeEnvironmentService),fe(2,d.ILogService)],T),t.RequestService=T}),define(X[133],Y([0,1,31,36,134,9,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,27,110,118,15,8,105,119,106,18,107,2,41,96,7,104,53,12,28,16,33]),function(x,t,m,A,D,R,F,C,u,d,S,y,w,T,c,h,b,O,L,v,o,r,e,i,n,s,a,E,P,U,k,j,B,$,K,ee,te,Q,oe,se,re,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class l extends $.Disposable{constructor(N){super();this.argv=N,D.gracefulify(A),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,M]=await this.initServices();return N.invokeFunction(async V=>{const W=V.get(a.ILogService),_=V.get(j.IFileService),G=V.get(w.INativeEnvironmentService),J=V.get(c.IExtensionManagementCLIService);return W.info("CLI main",this.argv),this.registerErrorHandler(W),await this.doRun(G,J,_),C.raceTimeout(L.combinedAppender(...M).flush(),1e3)})}async initServices(){const N=new d.ServiceCollection,M=Object.assign({_serviceBrand:void 0},u.default);N.set(K.IProductService,M);const V=new T.NativeEnvironmentService(this.argv,M);N.set(w.INativeEnvironmentService,V),await Promise.all([V.appSettingsHome.fsPath,V.extensionsPath].map(ye=>ye?R.Promises.mkdir(ye,{recursive:!0}):void 0));const W=a.getLogLevel(V),_=[];_.push(new P.SpdLogLogger("cli",F.join(V.logsPath,"cli.log"),!0,W)),W===a.LogLevel.Trace&&_.push(new a.ConsoleLogger(W));const G=this._register(new a.MultiplexLogService(_));N.set(a.ILogService,G);const J=this._register(new k.FileService(G));N.set(j.IFileService,J);const Z=this._register(new B.DiskFileSystemProvider(G));J.registerProvider(E.Schemas.file,Z);const ne=this._register(new n.ConfigurationService(V.settingsResource,J));N.set(i.IConfigurationService,ne),await ne.initialize(),N.set(r.IRequestService,new S.SyncDescriptor(e.RequestService)),N.set(c.IExtensionManagementService,new S.SyncDescriptor(h.ExtensionManagementService)),N.set(c.IExtensionGalleryService,new S.SyncDescriptor(b.ExtensionGalleryService)),N.set(c.IExtensionManagementCLIService,new S.SyncDescriptor(ee.ExtensionManagementCLIService)),N.set(oe.ILocalizationsService,new S.SyncDescriptor(Q.LocalizationsService));const ce=[];if(V.isBuilt&&!V.isExtensionDevelopment&&!V.disableTelemetry&&M.enableTelemetry){M.aiConfig&&M.aiConfig.asimovKey&&ce.push(new s.AppInsightsAppender("monacoworkbench",null,M.aiConfig.asimovKey));const{appRoot:ye,extensionsPath:be,installSourcePath:Ae}=V,Te={appender:L.combinedAppender(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let Se;try{const ke=await R.Promises.readFile(F.join(V.userDataPath,"storage.json"));Se=JSON.parse(ke.toString())[O.machineIdKey]}catch(ke){ke.code!=="ENOENT"&&G.error(ke)}return o.resolveCommonProperties(J,m.release(),m.hostname(),process.arch,M.commit,M.version,Se,M.msftInternalDomains,Ae)})(),piiPaths:[ye,be]};N.set(O.ITelemetryService,new S.SyncDescriptor(v.TelemetryService,[Te]))}else N.set(O.ITelemetryService,L.NullTelemetryService);return[new y.InstantiationService(N),ce]}registerErrorHandler(N){se.setUnexpectedErrorHandler(M=>{const V=re.toErrorMessage(M,!0);!V||N.error(`[uncaught exception in CLI]: ${V}`)})}async doRun(N,M,V){if(this.argv["install-source"])return this.setInstallSource(N,V,this.argv["install-source"]);if(this.argv["list-extensions"])return M.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return M.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return M.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return M.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await U.buildTelemetryMessage(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(M=>/\.vsix$/i.test(M)?te.URI.file(F.isAbsolute(M)?M:F.join(f.cwd(),M)):M)}async setInstallSource(N,M,V){await M.writeFile(te.URI.file(N.installSourcePath),p.VSBuffer.fromString(V.slice(0,30)))}}async function g(I){const N=new l(I);try{await N.run()}finally{N.dispose()}}t.main=g})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3caebff71e514ece73b125468881d102e767ee4d/core/vs/code/node/cliProcessMain.js.map
