/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],ye=function(Z){for(var e=[],m=0,T=Z.length;m<T;m++)e[m]=Ee[Z[m]];return e};define(Ee[38],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(T,S){if(!T)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=m}),define(Ee[75],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function T(n){const I=[];for(let o in n)m.call(n,o)&&I.push(n[o]);return I}e.values=T;function S(n,I){for(let o in n)if(m.call(n,o)&&I({key:o,value:n[o]},function(){delete n[o]})===!1)return}e.forEach=S;function y(n,I){const o=Object.create(null);for(const h of n){const d=I(h);let l=o[d];l||(l=o[d]=[]),l.push(h)}return o}e.groupBy=y;function k(n){const I=Object.create(null);return n&&n.forEach((o,h)=>{I[h]=o}),I}e.fromMap=k;function D(n,I){const o=[],h=[];for(let d of n)I.has(d)||o.push(d);for(let d of I)n.has(d)||h.push(d);return{removed:o,added:h}}e.diffSets=D;function v(n,I){const o=[],h=[];for(let[d,l]of n)I.has(d)||o.push(l);for(let[d,l]of I)n.has(d)||h.push(l);return{removed:o,added:h}}e.diffMaps=v;class C{constructor(){this.map=new Map}add(I,o){let h=this.map.get(I);h||(h=new Set,this.map.set(I,h)),h.add(o)}delete(I,o){const h=this.map.get(I);!h||(h.delete(o),h.size===0&&this.map.delete(I))}forEach(I,o){const h=this.map.get(I);!h||h.forEach(o)}}e.SetMap=C}),define(Ee[48],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(k){return(D,v,C)=>{let n=null,I=null;if(typeof C.value=="function"?(n="value",I=C.value):typeof C.get=="function"&&(n="get",I=C.get),!I)throw new Error("not supported");C[n]=k(I,v)}}e.createDecorator=m;function T(k,D,v){let C=null,n=null;if(typeof v.value=="function"?(C="value",n=v.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(C="get",n=v.get),!n)throw new Error("not supported");const I=`$memoize$${D}`;v[C]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,o)}),this[I]}}e.memoize=T;function S(k,D,v){return m((C,n)=>{const I=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...h){this[o]||(this[o]=v?v():void 0),clearTimeout(this[I]),D&&(this[o]=D(this[o],...h),h=[this[o]]),this[I]=setTimeout(()=>{C.apply(this,h),this[o]=v?v():void 0},k)}})}e.debounce=S;function y(k,D,v){return m((C,n)=>{const I=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...l){if(this[o]||(this[o]=v?v():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),D&&(this[o]=D(this[o],...l)),this[d])return;const _=this[h]+k;_<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[o]]),this[o]=v?v():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),C.apply(this,[this[o]]),this[o]=v?v():void 0},_-Date.now()))}})}e.throttle=y}),define(Ee[11],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function T(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=T;function S(g){v(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=S;function y(g){v(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function k(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=k;const D="Canceled";function v(g){return g instanceof Error&&g.name===D&&g.message===D}e.isPromiseCanceledError=v;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function n(){const g=new Error(D);return g.name=g.message,g}e.canceled=n;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function o(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=o;function h(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function l(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=l;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function c(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function f(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=f}),define(Ee[17],ye([0,1,11]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(Y,x=0){return Y[Y.length-(1+x)]}e.tail=T;function S(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.tail2=S;function y(Y,x,O=(Q,V)=>Q===V){if(Y===x)return!0;if(!Y||!x||Y.length!==x.length)return!1;for(let Q=0,V=Y.length;Q<V;Q++)if(!O(Y[Q],x[Q]))return!1;return!0}e.equals=y;function k(Y,x,O){let Q=0,V=Y.length-1;for(;Q<=V;){const le=(Q+V)/2|0,be=O(Y[le],x);if(be<0)Q=le+1;else if(be>0)V=le-1;else return le}return-(Q+1)}e.binarySearch=k;function D(Y,x){let O=0,Q=Y.length;if(Q===0)return 0;for(;O<Q;){const V=Math.floor((O+Q)/2);x(Y[V])?Q=V:O=V+1}return O}e.findFirstInSorted=D;function v(Y,x,O){if(Y=Y|0,Y>=x.length)throw new TypeError("invalid index");let Q=x[Math.floor(x.length*Math.random())],V=[],le=[],be=[];for(let Te of x){const He=O(Te,Q);He<0?V.push(Te):He>0?le.push(Te):be.push(Te)}return Y<V.length?v(Y,V,O):Y<V.length+be.length?be[0]:v(Y-(V.length+be.length),le,O)}e.quickSelect=v;function C(Y,x){const O=[];let Q;for(const V of Y.slice(0).sort(x))!Q||x(Q[0],V)!==0?(Q=[V],O.push(Q)):Q.push(V);return O}e.groupBy=C;function n(Y,x,O){const Q=[];function V(Te,He,Me){if(He===0&&Me.length===0)return;const qe=Q[Q.length-1];qe&&qe.start+qe.deleteCount===Te?(qe.deleteCount+=He,qe.toInsert.push(...Me)):Q.push({start:Te,deleteCount:He,toInsert:Me})}let le=0,be=0;for(;;){if(le===Y.length){V(le,0,x.slice(be));break}if(be===x.length){V(le,Y.length-le,[]);break}const Te=Y[le],He=x[be],Me=O(Te,He);Me===0?(le+=1,be+=1):Me<0?(V(le,1,[]),le+=1):Me>0&&(V(le,0,[He]),be+=1)}return Q}e.sortedDiff=n;function I(Y,x,O){const Q=n(Y,x,O),V=[],le=[];for(const be of Q)V.push(...Y.slice(be.start,be.start+be.deleteCount)),le.push(...be.toInsert);return{removed:V,added:le}}e.delta=I;function o(Y,x,O){if(O===0)return[];const Q=Y.slice(0,O).sort(x);return d(Y,x,Q,O,Y.length),Q}e.top=o;function h(Y,x,O,Q,V){return O===0?Promise.resolve([]):new Promise((le,be)=>{(async()=>{const Te=Y.length,He=Y.slice(0,O).sort(x);for(let Me=O,qe=Math.min(O+Q,Te);Me<Te;Me=qe,qe=Math.min(qe+Q,Te)){if(Me>O&&await new Promise(nt=>setTimeout(nt)),V&&V.isCancellationRequested)throw m.canceled();d(Y,x,He,Me,qe)}return He})().then(le,be)})}e.topAsync=h;function d(Y,x,O,Q,V){for(const le=O.length;Q<V;Q++){const be=Y[Q];if(x(be,O[le-1])<0){O.pop();const Te=D(O,He=>x(be,He)<0);O.splice(Te,0,be)}}}function l(Y){return Y.filter(x=>!!x)}e.coalesce=l;function _(Y){let x=0;for(let O=0;O<Y.length;O++)Y[O]&&(Y[x]=Y[O],x+=1);Y.length=x}e.coalesceInPlace=_;function b(Y,x,O){Y.splice(O,0,Y.splice(x,1)[0])}e.move=b;function E(Y){return!Array.isArray(Y)||Y.length===0}e.isFalsyOrEmpty=E;function c(Y){return Array.isArray(Y)&&Y.length>0}e.isNonEmptyArray=c;function f(Y,x){if(!x)return Y.filter((Q,V)=>Y.indexOf(Q)===V);const O=Object.create(null);return Y.filter(Q=>{const V=x(Q);return O[V]?!1:(O[V]=!0,!0)})}e.distinct=f;function g(Y){const x=new Set;return Y.filter(O=>x.has(O)?!1:(x.add(O),!0))}e.distinctES6=g;function t(Y){const x=Object.create(null);return O=>{const Q=Y(O);return x[Q]?!1:(x[Q]=!0,!0)}}e.uniqueFilter=t;function i(Y,x){for(let O=Y.length-1;O>=0;O--){const Q=Y[O];if(x(Q))return O}return-1}e.lastIndex=i;function s(Y,x){return Y.length>0?Y[0]:x}e.firstOrDefault=s;function r(Y,x,O=(Q,V)=>Q===V){let Q=0;for(let V=0,le=Math.min(Y.length,x.length);V<le&&O(Y[V],x[V]);V++)Q++;return Q}e.commonPrefixLength=r;function u(Y){return[].concat(...Y)}e.flatten=u;function w(Y,x){let O=typeof x=="number"?Y:0;typeof x=="number"?O=Y:(O=0,x=Y);const Q=[];if(O<=x)for(let V=O;V<x;V++)Q.push(V);else for(let V=O;V>x;V--)Q.push(V);return Q}e.range=w;function p(Y,x,O){return Y.reduce((Q,V)=>(Q[x(V)]=O?O(V):V,Q),Object.create(null))}e.index=p;function P(Y,x){return Y.push(x),()=>A(Y,x)}e.insert=P;function A(Y,x){const O=Y.indexOf(x);if(O>-1)return Y.splice(O,1),x}e.remove=A;function a(Y,x,O){const Q=Y.slice(0,x),V=Y.slice(x);return Q.concat(O,V)}e.arrayInsert=a;function R(Y,x){let O;if(typeof x=="number"){let Q=x;O=()=>{const V=Math.sin(Q++)*179426549;return V-Math.floor(V)}}else O=Math.random;for(let Q=Y.length-1;Q>0;Q-=1){const V=Math.floor(O()*(Q+1)),le=Y[Q];Y[Q]=Y[V],Y[V]=le}}e.shuffle=R;function F(Y,x){const O=Y.indexOf(x);O>-1&&(Y.splice(O,1),Y.unshift(x))}e.pushToStart=F;function U(Y,x){const O=Y.indexOf(x);O>-1&&(Y.splice(O,1),Y.push(x))}e.pushToEnd=U;function X(Y,x){return Array.isArray(Y)?Y.map(x):x(Y)}e.mapArrayOrNot=X;function oe(Y){return Array.isArray(Y)?Y:[Y]}e.asArray=oe;function j(Y){return Y[Math.floor(Math.random()*Y.length)]}e.getRandomElement=j;function W(Y,x){for(const O of Y){const Q=x(O);if(Q!==void 0)return Q}}e.mapFind=W;function K(Y,x){let O=Number.MAX_SAFE_INTEGER,Q=0;return Y.forEach((V,le)=>{const be=x(V);be<O&&(O=be,Q=le)}),Q}e.minIndex=K;function M(Y,x){let O=Number.MIN_SAFE_INTEGER,Q=0;return Y.forEach((V,le)=>{const be=x(V);be>O&&(O=be,Q=le)}),Q}e.maxIndex=M}),define(Ee[49],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(T){const S=this;let y=!1,k;return function(){return y||(y=!0,k=T.apply(S,arguments)),k}}e.once=m}),define(Ee[50],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(Ee[39],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(T){function S(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}T.is=S;const y=Object.freeze([]);function k(){return y}T.empty=k;function*D(g){yield g}T.single=D;function v(g){return g||y}T.from=v;function C(g){return!g||g[Symbol.iterator]().next().done===!0}T.isEmpty=C;function n(g){return g[Symbol.iterator]().next().value}T.first=n;function I(g,t){for(const i of g)if(t(i))return!0;return!1}T.some=I;function o(g,t){for(const i of g)if(t(i))return i}T.find=o;function*h(g,t){for(const i of g)t(i)&&(yield i)}T.filter=h;function*d(g,t){let i=0;for(const s of g)yield t(s,i++)}T.map=d;function*l(...g){for(const t of g)for(const i of t)yield i}T.concat=l;function*_(g){for(const t of g)for(const i of t)yield i}T.concatNested=_;function b(g,t,i){let s=i;for(const r of g)s=t(s,r);return s}T.reduce=b;function*E(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}T.slice=E;function c(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let r=0;r<t;r++){const u=s.next();if(u.done)return[i,T.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return s}}]}T.consume=c;function f(g,t,i=(s,r)=>s===r){const s=g[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const u=s.next(),w=r.next();if(u.done!==w.done)return!1;if(u.done)return!0;if(!i(u.value,w.value))return!1}}T.equals=f})(m=e.Iterable||(e.Iterable={}))}),define(Ee[107],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function k(t,i=!1){let s=0,r=t.length,u="",w=0,p=16,P=0;function A(j){let W=0,K=0;for(;W<j;){const M=t.charCodeAt(s);if(M>=48&&M<=57)K=K*16+M-48;else if(M>=65&&M<=70)K=K*16+M-65+10;else if(M>=97&&M<=102)K=K*16+M-97+10;else break;s++,W++}return W<j&&(K=-1),K}function a(j){s=j,u="",w=0,p=16,P=0}function R(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return P=3,t.substring(j,s);let W=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;W=s}else P=3;return t.substring(j,W)}function F(){let j="",W=s;for(;;){if(s>=r){j+=t.substring(W,s),P=2;break}const K=t.charCodeAt(s);if(K===34){j+=t.substring(W,s),s++;break}if(K===92){if(j+=t.substring(W,s),s++,s>=r){P=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const Y=A(4);Y>=0?j+=String.fromCharCode(Y):P=4;break;default:P=5}W=s;continue}if(K>=0&&K<=31)if(v(K)){j+=t.substring(W,s),P=2;break}else P=6;s++}return j}function U(){if(u="",P=0,w=s,s>=r)return w=r,p=17;let j=t.charCodeAt(s);if(D(j)){do s++,u+=String.fromCharCode(j),j=t.charCodeAt(s);while(D(j));return p=15}if(v(j))return s++,u+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),p=14;switch(j){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,u=F(),p=10;case 47:const W=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!v(t.charCodeAt(s));)s++;return u=t.substring(W,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const K=r-1;let M=!1;for(;s<K;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,P=1),u=t.substring(W,s),p=13}return u+=String.fromCharCode(j),s++,p=16;case 45:if(u+=String.fromCharCode(j),s++,s===r||!C(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=R(),p=11;default:for(;s<r&&X(j);)s++,j=t.charCodeAt(s);if(w!==s){switch(u=t.substring(w,s),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(j),s++,p=16}}function X(j){if(D(j)||v(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let j;do j=U();while(j>=12&&j<=15);return j}return{setPosition:a,getPosition:()=>s,scan:i?oe:U,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>P}}e.createScanner=k;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,i){const s=[],r=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(A,a,R,F){w.value=A,w.offset=a,w.length=R,w.type=F,w.colonOffset=void 0,u=w}try{c(t,{onObjectBegin:(A,a)=>{if(i<=A)throw r;u=void 0,p=i>A,s.push("")},onObjectProperty:(A,a,R)=>{if(i<a||(P(A,a,R,"property"),s[s.length-1]=A,i<=a+R))throw r},onObjectEnd:(A,a)=>{if(i<=A)throw r;u=void 0,s.pop()},onArrayBegin:(A,a)=>{if(i<=A)throw r;u=void 0,s.push(0)},onArrayEnd:(A,a)=>{if(i<=A)throw r;u=void 0,s.pop()},onLiteralValue:(A,a,R)=>{if(i<a||(P(A,a,R,g(A)),i<=a+R))throw r},onSeparator:(A,a,R)=>{if(i<=a)throw r;if(A===":"&&u&&u.type==="property")u.colonOffset=a,p=!1,u=void 0;else if(A===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(p=!0,s[s.length-1]=""),u=void 0}}})}catch(A){if(A!==r)throw A}return{path:s,previousNode:u,isAtPropertyKey:p,matches:A=>{let a=0;for(let R=0;a<A.length&&R<s.length;R++)if(A[a]===s[R]||A[a]==="*")a++;else if(A[a]!=="**")return!1;return a===A.length}}}e.getLocation=I;function o(t,i=[],s=y.DEFAULT){let r=null,u=[];const w=[];function p(A){Array.isArray(u)?u.push(A):r!==null&&(u[r]=A)}return c(t,{onObjectBegin:()=>{const A={};p(A),w.push(u),u=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const A=[];p(A),w.push(u),u=A,r=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:p,onError:(A,a,R)=>{i.push({error:A,offset:a,length:R})}},s),u[0]}e.parse=o;function h(t,i=[],s=y.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(A){r.type==="property"&&(r.length=A-r.offset,r=r.parent)}function w(A){return r.children.push(A),A}c(t,{onObjectBegin:A=>{r=w({type:"object",offset:A,length:-1,parent:r,children:[]})},onObjectProperty:(A,a,R)=>{r=w({type:"property",offset:a,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:A,offset:a,length:R,parent:r})},onObjectEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,u(A+a)},onArrayBegin:(A,a)=>{r=w({type:"array",offset:A,length:-1,parent:r,children:[]})},onArrayEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,u(A+a)},onLiteralValue:(A,a,R)=>{w({type:g(A),offset:a,length:R,parent:r,value:A}),u(a+R)},onSeparator:(A,a,R)=>{r.type==="property"&&(A===":"?r.colonOffset=a:A===","&&u(a))},onError:(A,a,R)=>{i.push({error:A,offset:a,length:R})}},s);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=h;function d(t,i){if(!t)return;let s=t;for(let r of i)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===r){s=w.children[1],u=!0;break}if(!u)return}else{const u=r;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=d;function l(t){if(!t.parent||!t.parent.children)return[];const i=l(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=l;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const i=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(i[s.children[0].value]=_(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function b(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=b;function E(t,i,s=!1){if(b(t,i,s)){const r=t.children;if(Array.isArray(r))for(let u=0;u<r.length&&r[u].offset<=i;u++){const w=E(r[u],i,s);if(w)return w}return t}}e.findNodeAtOffset=E;function c(t,i,s=y.DEFAULT){const r=k(t,!1);function u(be){return be?()=>be(r.getTokenOffset(),r.getTokenLength()):()=>!0}function w(be){return be?Te=>be(Te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=u(i.onObjectBegin),P=w(i.onObjectProperty),A=u(i.onObjectEnd),a=u(i.onArrayBegin),R=u(i.onArrayEnd),F=w(i.onLiteralValue),U=w(i.onSeparator),X=u(i.onComment),oe=w(i.onError),j=s&&s.disallowComments,W=s&&s.allowTrailingComma;function K(){for(;;){const be=r.scan();switch(r.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:j||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(be){case 12:case 13:j?M(10):X();break;case 16:M(1);break;case 15:case 14:break;default:return be}}}function M(be,Te=[],He=[]){if(oe(be),Te.length+He.length>0){let Me=r.getToken();for(;Me!==17;){if(Te.indexOf(Me)!==-1){K();break}else if(He.indexOf(Me)!==-1)break;Me=K()}}}function Y(be){const Te=r.getTokenValue();return be?F(Te):P(Te),K(),!0}function x(){switch(r.getToken()){case 11:let be=0;try{be=JSON.parse(r.getTokenValue()),typeof be!="number"&&(M(2),be=0)}catch(Te){M(2)}F(be);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return K(),!0}function O(){return r.getToken()!==10?(M(3,[],[2,5]),!1):(Y(!1),r.getToken()===6?(U(":"),K(),le()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function Q(){p(),K();let be=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(be||M(4,[],[]),U(","),K(),r.getToken()===2&&W)break}else be&&M(6,[],[]);O()||M(4,[],[2,5]),be=!0}return A(),r.getToken()!==2?M(7,[2],[]):K(),!0}function V(){a(),K();let be=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(be||M(4,[],[]),U(","),K(),r.getToken()===4&&W)break}else be&&M(6,[],[]);le()||M(4,[],[4,5]),be=!0}return R(),r.getToken()!==4?M(8,[4],[]):K(),!0}function le(){switch(r.getToken()){case 3:return V();case 1:return Q();case 10:return Y(!0);default:return x()}}return K(),r.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):le()?(r.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=c;function f(t,i){let s=k(t),r=[],u,w=0,p;do switch(p=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:w!==p&&r.push(t.substring(w,p)),i!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,i)),w=s.getPosition();break}while(u!==17);return r.join("")}e.stripComments=f;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(Ee[108],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new m(()=>S(this.getValue()))}}e.Lazy=m}),define(Ee[7],ye([0,1,49,39]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const S=!1;let y=null;function k(f){y=f}if(e.setDisposableTracker=k,S){const f="__is_disposable_tracked__";y=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[f]||console.log(t)},3e3)}markTracked(g){if(g&&g!==l.None)try{g[f]=!0}catch(t){}}}}function D(f){!y||y.markTracked(f)}function v(f){return y&&y.trackDisposable(f),f}e.trackDisposable=v;class C extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=C;function n(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=n;function I(f){if(T.Iterable.is(f)){let g=[];for(const t of f)if(t){D(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new C(g);return Array.isArray(f)?[]:f}else if(f)return D(f),f.dispose(),f}e.dispose=I;function o(...f){return f.forEach(D),h(()=>I(f))}e.combinedDisposable=o;function h(f){const g=v({dispose:()=>{D(g),f()}});return g}e.toDisposable=h;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return D(g),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this._store=new d,v(this)}dispose(){D(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=l,l.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&D(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,D(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=_;class b{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,r=m.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:r}}}e.ReferenceCollection=b;class E{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=E;class c{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=c}),define(Ee[51],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class T{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let y=this._first;for(;y!==m.Undefined;){const k=y.next;y.prev=m.Undefined,y.next=m.Undefined,y=k}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,k){const D=new m(y);if(this._first===m.Undefined)this._first=D,this._last=D;else if(k){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(D))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const k=y.prev;k.next=y.next,y.next.prev=k}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=T}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ce,_e){for(var Ie=0;Ie<_e.length;Ie++){var ie=_e[Ie];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Ce,ie.key,ie)}}function e(Ce,_e,Ie){return _e&&Z(Ce.prototype,_e),Ie&&Z(Ce,Ie),Ce}function m(Ce,_e){if(!!Ce){if(typeof Ce=="string")return T(Ce,_e);var Ie=Object.prototype.toString.call(Ce).slice(8,-1);if(Ie==="Object"&&Ce.constructor&&(Ie=Ce.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Ce);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return T(Ce,_e)}}function T(Ce,_e){(_e==null||_e>Ce.length)&&(_e=Ce.length);for(var Ie=0,ie=new Array(_e);Ie<_e;Ie++)ie[Ie]=Ce[Ie];return ie}function S(Ce,_e){var Ie;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Ie=m(Ce))||_e&&Ce&&typeof Ce.length=="number"){Ie&&(Ce=Ie);var ie=0;return function(){return ie>=Ce.length?{done:!0}:{done:!1,value:Ce[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ie=Ce[Symbol.iterator](),Ie.next.bind(Ie)}function y(Ce){var _e={exports:{}};return Ce(_e,_e.exports),_e.exports}var k=y(function(Ce){function _e(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ie(ie){Ce.exports.defaults=ie}Ce.exports={defaults:_e(),getDefaults:_e,changeDefaults:Ie}}),D=/[&<>"']/,v=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(_e){return I[_e]};function h(Ce,_e){if(_e){if(D.test(Ce))return Ce.replace(v,o)}else if(C.test(Ce))return Ce.replace(n,o);return Ce}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(Ce){return Ce.replace(d,function(_e,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var _=/(^|[^\[])\^/g;function b(Ce,_e){Ce=Ce.source||Ce,_e=_e||"";var Ie={replace:function(ue,de){return de=de.source||de,de=de.replace(_,"$1"),Ce=Ce.replace(ue,de),Ie},getRegex:function(){return new RegExp(Ce,_e)}};return Ie}var E=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(Ce,_e,Ie){if(Ce){var ie;try{ie=decodeURIComponent(l(Ie)).replace(E,"").toLowerCase()}catch(ue){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}_e&&!c.test(Ie)&&(Ie=r(_e,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch(ue){return null}return Ie}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ce,_e){g[" "+Ce]||(t.test(Ce)?g[" "+Ce]=Ce+"/":g[" "+Ce]=P(Ce,"/",!0)),Ce=g[" "+Ce];var Ie=Ce.indexOf(":")===-1;return _e.substring(0,2)==="//"?Ie?_e:Ce.replace(i,"$1")+_e:_e.charAt(0)==="/"?Ie?_e:Ce.replace(s,"$1")+_e:Ce+_e}var u={exec:function(){}};function w(Ce){for(var _e=1,Ie,ie;_e<arguments.length;_e++){Ie=arguments[_e];for(ie in Ie)Object.prototype.hasOwnProperty.call(Ie,ie)&&(Ce[ie]=Ie[ie])}return Ce}function p(Ce,_e){var Ie=Ce.replace(/\|/g,function(de,ge,$){for(var fe=!1,we=ge;--we>=0&&$[we]==="\\";)fe=!fe;return fe?"|":" |"}),ie=Ie.split(/ \|/),ue=0;if(ie.length>_e)ie.splice(_e);else for(;ie.length<_e;)ie.push("");for(;ue<ie.length;ue++)ie[ue]=ie[ue].trim().replace(/\\\|/g,"|");return ie}function P(Ce,_e,Ie){var ie=Ce.length;if(ie===0)return"";for(var ue=0;ue<ie;){var de=Ce.charAt(ie-ue-1);if(de===_e&&!Ie)ue++;else if(de!==_e&&Ie)ue++;else break}return Ce.substr(0,ie-ue)}function A(Ce,_e){if(Ce.indexOf(_e[1])===-1)return-1;for(var Ie=Ce.length,ie=0,ue=0;ue<Ie;ue++)if(Ce[ue]==="\\")ue++;else if(Ce[ue]===_e[0])ie++;else if(Ce[ue]===_e[1]&&(ie--,ie<0))return ue;return-1}function a(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ce,_e){if(_e<1)return"";for(var Ie="";_e>1;)_e&1&&(Ie+=Ce),_e>>=1,Ce+=Ce;return Ie+Ce}var F={escape:h,unescape:l,edit:b,cleanUrl:f,resolveUrl:r,noopTest:u,merge:w,splitCells:p,rtrim:P,findClosingBracket:A,checkSanitizeDeprecation:a,repeatString:R},U=k.defaults,X=F.rtrim,oe=F.splitCells,j=F.escape,W=F.findClosingBracket;function K(Ce,_e,Ie){var ie=_e.href,ue=_e.title?j(_e.title):null,de=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Ie,href:ie,title:ue,text:de}:{type:"image",raw:Ie,href:ie,title:ue,text:j(de)}}function M(Ce,_e){var Ie=Ce.match(/^(\s+)(?:```)/);if(Ie===null)return _e;var ie=Ie[1];return _e.split(`
`).map(function(ue){var de=ue.match(/^\s+/);if(de===null)return ue;var ge=de[0];return ge.length>=ie.length?ue.slice(ie.length):ue}).join(`
`)}var Y=function(){function Ce(Ie){this.options=Ie||U}var _e=Ce.prototype;return _e.space=function(ie){var ue=this.rules.block.newline.exec(ie);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},_e.code=function(ie){var ue=this.rules.block.code.exec(ie);if(ue){var de=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?de:X(de,`
`)}}},_e.fences=function(ie){var ue=this.rules.block.fences.exec(ie);if(ue){var de=ue[0],ge=M(de,ue[3]||"");return{type:"code",raw:de,lang:ue[2]?ue[2].trim():ue[2],text:ge}}},_e.heading=function(ie){var ue=this.rules.block.heading.exec(ie);if(ue){var de=ue[2].trim();if(/#$/.test(de)){var ge=X(de,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(de=ge.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:de}}},_e.nptable=function(ie){var ue=this.rules.block.nptable.exec(ie);if(ue){var de={type:"table",header:oe(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(de.header.length===de.align.length){var ge=de.align.length,$;for($=0;$<ge;$++)/^ *-+: *$/.test(de.align[$])?de.align[$]="right":/^ *:-+: *$/.test(de.align[$])?de.align[$]="center":/^ *:-+ *$/.test(de.align[$])?de.align[$]="left":de.align[$]=null;for(ge=de.cells.length,$=0;$<ge;$++)de.cells[$]=oe(de.cells[$],de.header.length);return de}}},_e.hr=function(ie){var ue=this.rules.block.hr.exec(ie);if(ue)return{type:"hr",raw:ue[0]}},_e.blockquote=function(ie){var ue=this.rules.block.blockquote.exec(ie);if(ue){var de=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:de}}},_e.list=function(ie){var ue=this.rules.block.list.exec(ie);if(ue){var de=ue[0],ge=ue[2],$=ge.length>1,fe={type:"list",raw:de,ordered:$,start:$?+ge.slice(0,-1):"",loose:!1,items:[]},we=ue[0].match(this.rules.block.item),Pe=!1,Le,$e,We,Ye,tt,ut,pe,De,ae=we.length;We=this.rules.block.listItemStart.exec(we[0]);for(var z=0;z<ae;z++){if(Le=we[z],de=Le,z!==ae-1){if(Ye=this.rules.block.listItemStart.exec(we[z+1]),this.options.pedantic?Ye[1].length>We[1].length:Ye[1].length>We[0].length||Ye[1].length>3){we.splice(z,2,we[z]+`
`+we[z+1]),z--,ae--;continue}else(!this.options.pedantic||this.options.smartLists?Ye[2][Ye[2].length-1]!==ge[ge.length-1]:$===(Ye[2].length===1))&&(tt=we.slice(z+1).join(`
`),fe.raw=fe.raw.substring(0,fe.raw.length-tt.length),z=ae-1);We=Ye}$e=Le.length,Le=Le.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Le.indexOf(`
 `)&&($e-=Le.length,Le=this.options.pedantic?Le.replace(/^ {1,4}/gm,""):Le.replace(new RegExp("^ {1,"+$e+"}","gm"),"")),ut=Pe||/\n\n(?!\s*$)/.test(Le),z!==ae-1&&(Pe=Le.charAt(Le.length-1)===`
`,ut||(ut=Pe)),ut&&(fe.loose=!0),this.options.gfm&&(pe=/^\[[ xX]\] /.test(Le),De=void 0,pe&&(De=Le[1]!==" ",Le=Le.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:pe,checked:De,loose:ut,text:Le})}return fe}},_e.html=function(ie){var ue=this.rules.block.html.exec(ie);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):j(ue[0]):ue[0]}},_e.def=function(ie){var ue=this.rules.block.def.exec(ie);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var de=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:de,raw:ue[0],href:ue[2],title:ue[3]}}},_e.table=function(ie){var ue=this.rules.block.table.exec(ie);if(ue){var de={type:"table",header:oe(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=ue[0];var ge=de.align.length,$;for($=0;$<ge;$++)/^ *-+: *$/.test(de.align[$])?de.align[$]="right":/^ *:-+: *$/.test(de.align[$])?de.align[$]="center":/^ *:-+ *$/.test(de.align[$])?de.align[$]="left":de.align[$]=null;for(ge=de.cells.length,$=0;$<ge;$++)de.cells[$]=oe(de.cells[$].replace(/^ *\| *| *\| *$/g,""),de.header.length);return de}}},_e.lheading=function(ie){var ue=this.rules.block.lheading.exec(ie);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},_e.paragraph=function(ie){var ue=this.rules.block.paragraph.exec(ie);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},_e.text=function(ie){var ue=this.rules.block.text.exec(ie);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},_e.escape=function(ie){var ue=this.rules.inline.escape.exec(ie);if(ue)return{type:"escape",raw:ue[0],text:j(ue[1])}},_e.tag=function(ie,ue,de){var ge=this.rules.inline.tag.exec(ie);if(ge)return!ue&&/^<a /i.test(ge[0])?ue=!0:ue&&/^<\/a>/i.test(ge[0])&&(ue=!1),!de&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?de=!0:de&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(de=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:ue,inRawBlock:de,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):j(ge[0]):ge[0]}},_e.link=function(ie){var ue=this.rules.inline.link.exec(ie);if(ue){var de=ue[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var ge=X(de.slice(0,-1),"\\");if((de.length-ge.length)%2==0)return}else{var $=W(ue[2],"()");if($>-1){var fe=ue[0].indexOf("!")===0?5:4,we=fe+ue[1].length+$;ue[2]=ue[2].substring(0,$),ue[0]=ue[0].substring(0,we).trim(),ue[3]=""}}var Pe=ue[2],Le="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);$e&&(Pe=$e[1],Le=$e[3])}else Le=ue[3]?ue[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(de)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),K(ue,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},ue[0])}},_e.reflink=function(ie,ue){var de;if((de=this.rules.inline.reflink.exec(ie))||(de=this.rules.inline.nolink.exec(ie))){var ge=(de[2]||de[1]).replace(/\s+/g," ");if(ge=ue[ge.toLowerCase()],!ge||!ge.href){var $=de[0].charAt(0);return{type:"text",raw:$,text:$}}return K(de,ge,de[0])}},_e.emStrong=function(ie,ue,de){de===void 0&&(de="");var ge=this.rules.inline.emStrong.lDelim.exec(ie);if(!!ge&&!(ge[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=ge[1]||ge[2]||"";if(!$||$&&(de===""||this.rules.inline.punctuation.exec(de))){var fe=ge[0].length-1,we,Pe,Le=fe,$e=0,We=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(We.lastIndex=0,ue=ue.slice(-1*ie.length+fe);(ge=We.exec(ue))!=null;)if(we=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!we){if(Pe=we.length,ge[3]||ge[4]){Le+=Pe;continue}else if((ge[5]||ge[6])&&fe%3&&!((fe+Pe)%3)){$e+=Pe;continue}if(Le-=Pe,!(Le>0)){if(Le+$e-Pe<=0&&!ue.slice(We.lastIndex).match(We)&&(Pe=Math.min(Pe,Pe+Le+$e)),Math.min(fe,Pe)%2)return{type:"em",raw:ie.slice(0,fe+ge.index+Pe+1),text:ie.slice(1,fe+ge.index+Pe)};if(Math.min(fe,Pe)%2==0)return{type:"strong",raw:ie.slice(0,fe+ge.index+Pe+1),text:ie.slice(2,fe+ge.index+Pe-1)}}}}}},_e.codespan=function(ie){var ue=this.rules.inline.code.exec(ie);if(ue){var de=ue[2].replace(/\n/g," "),ge=/[^ ]/.test(de),$=/^ /.test(de)&&/ $/.test(de);return ge&&$&&(de=de.substring(1,de.length-1)),de=j(de,!0),{type:"codespan",raw:ue[0],text:de}}},_e.br=function(ie){var ue=this.rules.inline.br.exec(ie);if(ue)return{type:"br",raw:ue[0]}},_e.del=function(ie){var ue=this.rules.inline.del.exec(ie);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},_e.autolink=function(ie,ue){var de=this.rules.inline.autolink.exec(ie);if(de){var ge,$;return de[2]==="@"?(ge=j(this.options.mangle?ue(de[1]):de[1]),$="mailto:"+ge):(ge=j(de[1]),$=ge),{type:"link",raw:de[0],text:ge,href:$,tokens:[{type:"text",raw:ge,text:ge}]}}},_e.url=function(ie,ue){var de;if(de=this.rules.inline.url.exec(ie)){var ge,$;if(de[2]==="@")ge=j(this.options.mangle?ue(de[0]):de[0]),$="mailto:"+ge;else{var fe;do fe=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(fe!==de[0]);ge=j(de[0]),de[1]==="www."?$="http://"+ge:$=ge}return{type:"link",raw:de[0],text:ge,href:$,tokens:[{type:"text",raw:ge,text:ge}]}}},_e.inlineText=function(ie,ue,de){var ge=this.rules.inline.text.exec(ie);if(ge){var $;return ue?$=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):j(ge[0]):ge[0]:$=j(this.options.smartypants?de(ge[0]):ge[0]),{type:"text",raw:ge[0],text:$}}},Ce}(),x=F.noopTest,O=F.edit,Q=F.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:x,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=O(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,V.item=O(V.item,"gm").replace(/bull/g,V.bullet).getRegex(),V.listItemStart=O(/^( *)(bull)/).replace("bull",V.bullet).getRegex(),V.list=O(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=O(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=O(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.blockquote=O(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=Q({},V),V.gfm=Q({},V.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.nptable=O(V.gfm.nptable).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.gfm.table=O(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.pedantic=Q({},V.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:O(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var le={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};le._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",le.punctuation=O(le.punctuation).replace(/punctuation/g,le._punctuation).getRegex(),le.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,le.escapedEmSt=/\\\*|\\_/g,le._comment=O(V._comment).replace("(?:-->|$)","-->").getRegex(),le.emStrong.lDelim=O(le.emStrong.lDelim).replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimAst=O(le.emStrong.rDelimAst,"g").replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimUnd=O(le.emStrong.rDelimUnd,"g").replace(/punct/g,le._punctuation).getRegex(),le._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,le._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,le._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,le.autolink=O(le.autolink).replace("scheme",le._scheme).replace("email",le._email).getRegex(),le._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,le.tag=O(le.tag).replace("comment",le._comment).replace("attribute",le._attribute).getRegex(),le._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,le._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,le._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,le.link=O(le.link).replace("label",le._label).replace("href",le._href).replace("title",le._title).getRegex(),le.reflink=O(le.reflink).replace("label",le._label).getRegex(),le.reflinkSearch=O(le.reflinkSearch,"g").replace("reflink",le.reflink).replace("nolink",le.nolink).getRegex(),le.normal=Q({},le),le.pedantic=Q({},le.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",le._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",le._label).getRegex()}),le.gfm=Q({},le.normal,{escape:O(le.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),le.gfm.url=O(le.gfm.url,"i").replace("email",le.gfm._extended_email).getRegex(),le.breaks=Q({},le.gfm,{br:O(le.br).replace("{2,}","*").getRegex(),text:O(le.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var be={block:V,inline:le},Te=k.defaults,He=be.block,Me=be.inline,qe=F.repeatString;function nt(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Je(Ce){var _e="",Ie,ie,ue=Ce.length;for(Ie=0;Ie<ue;Ie++)ie=Ce.charCodeAt(Ie),Math.random()>.5&&(ie="x"+ie.toString(16)),_e+="&#"+ie+";";return _e}var Xe=function(){function Ce(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||Te,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:He.normal,inline:Me.normal};this.options.pedantic?(ie.block=He.pedantic,ie.inline=Me.pedantic):this.options.gfm&&(ie.block=He.gfm,this.options.breaks?ie.inline=Me.breaks:ie.inline=Me.gfm),this.tokenizer.rules=ie}Ce.lex=function(ie,ue){var de=new Ce(ue);return de.lex(ie)},Ce.lexInline=function(ie,ue){var de=new Ce(ue);return de.inlineTokens(ie)};var _e=Ce.prototype;return _e.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},_e.blockTokens=function(ie,ue,de){ue===void 0&&(ue=[]),de===void 0&&(de=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var ge,$,fe,we;ie;){if(ge=this.tokenizer.space(ie)){ie=ie.substring(ge.raw.length),ge.type&&ue.push(ge);continue}if(ge=this.tokenizer.code(ie)){ie=ie.substring(ge.raw.length),we=ue[ue.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+ge.raw,we.text+=`
`+ge.text):ue.push(ge);continue}if(ge=this.tokenizer.fences(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(ge=this.tokenizer.heading(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(ge=this.tokenizer.nptable(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(ge=this.tokenizer.hr(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(ge=this.tokenizer.blockquote(ie)){ie=ie.substring(ge.raw.length),ge.tokens=this.blockTokens(ge.text,[],de),ue.push(ge);continue}if(ge=this.tokenizer.list(ie)){for(ie=ie.substring(ge.raw.length),fe=ge.items.length,$=0;$<fe;$++)ge.items[$].tokens=this.blockTokens(ge.items[$].text,[],!1);ue.push(ge);continue}if(ge=this.tokenizer.html(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(de&&(ge=this.tokenizer.def(ie))){ie=ie.substring(ge.raw.length),this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(ge=this.tokenizer.lheading(ie)){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(de&&(ge=this.tokenizer.paragraph(ie))){ie=ie.substring(ge.raw.length),ue.push(ge);continue}if(ge=this.tokenizer.text(ie)){ie=ie.substring(ge.raw.length),we=ue[ue.length-1],we&&we.type==="text"?(we.raw+=`
`+ge.raw,we.text+=`
`+ge.text):ue.push(ge);continue}if(ie){var Pe="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return ue},_e.inline=function(ie){var ue,de,ge,$,fe,we,Pe=ie.length;for(ue=0;ue<Pe;ue++)switch(we=ie[ue],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},$=we.header.length,de=0;de<$;de++)we.tokens.header[de]=[],this.inlineTokens(we.header[de],we.tokens.header[de]);for($=we.cells.length,de=0;de<$;de++)for(fe=we.cells[de],we.tokens.cells[de]=[],ge=0;ge<fe.length;ge++)we.tokens.cells[de][ge]=[],this.inlineTokens(fe[ge],we.tokens.cells[de][ge]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for($=we.items.length,de=0;de<$;de++)this.inline(we.items[de].tokens);break}}return ie},_e.inlineTokens=function(ie,ue,de,ge){ue===void 0&&(ue=[]),de===void 0&&(de=!1),ge===void 0&&(ge=!1);var $,fe,we=ie,Pe,Le,$e;if(this.tokens.links){var We=Object.keys(this.tokens.links);if(We.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)We.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Pe.index)+"["+qe("a",Pe[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Pe.index)+"["+qe("a",Pe[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Pe.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Le||($e=""),Le=!1,$=this.tokenizer.escape(ie)){ie=ie.substring($.raw.length),ue.push($);continue}if($=this.tokenizer.tag(ie,de,ge)){ie=ie.substring($.raw.length),de=$.inLink,ge=$.inRawBlock;var Ye=ue[ue.length-1];Ye&&$.type==="text"&&Ye.type==="text"?(Ye.raw+=$.raw,Ye.text+=$.text):ue.push($);continue}if($=this.tokenizer.link(ie)){ie=ie.substring($.raw.length),$.type==="link"&&($.tokens=this.inlineTokens($.text,[],!0,ge)),ue.push($);continue}if($=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring($.raw.length);var tt=ue[ue.length-1];$.type==="link"?($.tokens=this.inlineTokens($.text,[],!0,ge),ue.push($)):tt&&$.type==="text"&&tt.type==="text"?(tt.raw+=$.raw,tt.text+=$.text):ue.push($);continue}if($=this.tokenizer.emStrong(ie,we,$e)){ie=ie.substring($.raw.length),$.tokens=this.inlineTokens($.text,[],de,ge),ue.push($);continue}if($=this.tokenizer.codespan(ie)){ie=ie.substring($.raw.length),ue.push($);continue}if($=this.tokenizer.br(ie)){ie=ie.substring($.raw.length),ue.push($);continue}if($=this.tokenizer.del(ie)){ie=ie.substring($.raw.length),$.tokens=this.inlineTokens($.text,[],de,ge),ue.push($);continue}if($=this.tokenizer.autolink(ie,Je)){ie=ie.substring($.raw.length),ue.push($);continue}if(!de&&($=this.tokenizer.url(ie,Je))){ie=ie.substring($.raw.length),ue.push($);continue}if($=this.tokenizer.inlineText(ie,ge,nt)){ie=ie.substring($.raw.length),$.raw.slice(-1)!=="_"&&($e=$.raw.slice(-1)),Le=!0,fe=ue[ue.length-1],fe&&fe.type==="text"?(fe.raw+=$.raw,fe.text+=$.text):ue.push($);continue}if(ie){var ut="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ut);break}else throw new Error(ut)}}return ue},e(Ce,null,[{key:"rules",get:function(){return{block:He,inline:Me}}}]),Ce}(),B=k.defaults,G=F.cleanUrl,ne=F.escape,re=function(){function Ce(Ie){this.options=Ie||B}var _e=Ce.prototype;return _e.code=function(ie,ue,de){var ge=(ue||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(ie,ge);$!=null&&$!==ie&&(de=!0,ie=$)}return ie=ie.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+ne(ge,!0)+'">'+(de?ie:ne(ie,!0))+`</code></pre>
`:"<pre><code>"+(de?ie:ne(ie,!0))+`</code></pre>
`},_e.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},_e.html=function(ie){return ie},_e.heading=function(ie,ue,de,ge){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+ge.slug(de)+'">'+ie+"</h"+ue+`>
`:"<h"+ue+">"+ie+"</h"+ue+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ie,ue,de){var ge=ue?"ol":"ul",$=ue&&de!==1?' start="'+de+'"':"";return"<"+ge+$+`>
`+ie+"</"+ge+`>
`},_e.listitem=function(ie){return"<li>"+ie+`</li>
`},_e.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ie){return"<p>"+ie+`</p>
`},_e.table=function(ie,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ue+`</table>
`},_e.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},_e.tablecell=function(ie,ue){var de=ue.header?"th":"td",ge=ue.align?"<"+de+' align="'+ue.align+'">':"<"+de+">";return ge+ie+"</"+de+`>
`},_e.strong=function(ie){return"<strong>"+ie+"</strong>"},_e.em=function(ie){return"<em>"+ie+"</em>"},_e.codespan=function(ie){return"<code>"+ie+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ie){return"<del>"+ie+"</del>"},_e.link=function(ie,ue,de){if(ie=G(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var ge='<a href="'+ne(ie)+'"';return ue&&(ge+=' title="'+ue+'"'),ge+=">"+de+"</a>",ge},_e.image=function(ie,ue,de){if(ie=G(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var ge='<img src="'+ie+'" alt="'+de+'"';return ue&&(ge+=' title="'+ue+'"'),ge+=this.options.xhtml?"/>":">",ge},_e.text=function(ie){return ie},Ce}(),q=function(){function Ce(){}var _e=Ce.prototype;return _e.strong=function(ie){return ie},_e.em=function(ie){return ie},_e.codespan=function(ie){return ie},_e.del=function(ie){return ie},_e.html=function(ie){return ie},_e.text=function(ie){return ie},_e.link=function(ie,ue,de){return""+de},_e.image=function(ie,ue,de){return""+de},_e.br=function(){return""},Ce}(),se=function(){function Ce(){this.seen={}}var _e=Ce.prototype;return _e.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ie,ue){var de=ie,ge=0;if(this.seen.hasOwnProperty(de)){ge=this.seen[ie];do ge++,de=ie+"-"+ge;while(this.seen.hasOwnProperty(de))}return ue||(this.seen[ie]=ge,this.seen[de]=0),de},_e.slug=function(ie,ue){ue===void 0&&(ue={});var de=this.serialize(ie);return this.getNextSafeSlug(de,ue.dryrun)},Ce}(),he=k.defaults,Re=F.unescape,Be=function(){function Ce(Ie){this.options=Ie||he,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new se}Ce.parse=function(ie,ue){var de=new Ce(ue);return de.parse(ie)},Ce.parseInline=function(ie,ue){var de=new Ce(ue);return de.parseInline(ie)};var _e=Ce.prototype;return _e.parse=function(ie,ue){ue===void 0&&(ue=!0);var de="",ge,$,fe,we,Pe,Le,$e,We,Ye,tt,ut,pe,De,ae,z,Ue,Se,ze,Ze=ie.length;for(ge=0;ge<Ze;ge++)switch(tt=ie[ge],tt.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(tt.tokens),tt.depth,Re(this.parseInline(tt.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(tt.text,tt.lang,tt.escaped);continue}case"table":{for(We="",$e="",we=tt.header.length,$=0;$<we;$++)$e+=this.renderer.tablecell(this.parseInline(tt.tokens.header[$]),{header:!0,align:tt.align[$]});for(We+=this.renderer.tablerow($e),Ye="",we=tt.cells.length,$=0;$<we;$++){for(Le=tt.tokens.cells[$],$e="",Pe=Le.length,fe=0;fe<Pe;fe++)$e+=this.renderer.tablecell(this.parseInline(Le[fe]),{header:!1,align:tt.align[fe]});Ye+=this.renderer.tablerow($e)}de+=this.renderer.table(We,Ye);continue}case"blockquote":{Ye=this.parse(tt.tokens),de+=this.renderer.blockquote(Ye);continue}case"list":{for(ut=tt.ordered,pe=tt.start,De=tt.loose,we=tt.items.length,Ye="",$=0;$<we;$++)z=tt.items[$],Ue=z.checked,Se=z.task,ae="",z.task&&(ze=this.renderer.checkbox(Ue),De?z.tokens.length>0&&z.tokens[0].type==="text"?(z.tokens[0].text=ze+" "+z.tokens[0].text,z.tokens[0].tokens&&z.tokens[0].tokens.length>0&&z.tokens[0].tokens[0].type==="text"&&(z.tokens[0].tokens[0].text=ze+" "+z.tokens[0].tokens[0].text)):z.tokens.unshift({type:"text",text:ze}):ae+=ze),ae+=this.parse(z.tokens,De),Ye+=this.renderer.listitem(ae,Se,Ue);de+=this.renderer.list(Ye,ut,pe);continue}case"html":{de+=this.renderer.html(tt.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(tt.tokens));continue}case"text":{for(Ye=tt.tokens?this.parseInline(tt.tokens):tt.text;ge+1<Ze&&ie[ge+1].type==="text";)tt=ie[++ge],Ye+=`
`+(tt.tokens?this.parseInline(tt.tokens):tt.text);de+=ue?this.renderer.paragraph(Ye):Ye;continue}default:{var et='Token with "'+tt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return de},_e.parseInline=function(ie,ue){ue=ue||this.renderer;var de="",ge,$,fe=ie.length;for(ge=0;ge<fe;ge++)switch($=ie[ge],$.type){case"escape":{de+=ue.text($.text);break}case"html":{de+=ue.html($.text);break}case"link":{de+=ue.link($.href,$.title,this.parseInline($.tokens,ue));break}case"image":{de+=ue.image($.href,$.title,$.text);break}case"strong":{de+=ue.strong(this.parseInline($.tokens,ue));break}case"em":{de+=ue.em(this.parseInline($.tokens,ue));break}case"codespan":{de+=ue.codespan($.text);break}case"br":{de+=ue.br();break}case"del":{de+=ue.del(this.parseInline($.tokens,ue));break}case"text":{de+=ue.text($.text);break}default:{var we='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return de},Ce}(),ve=F.merge,Ke=F.checkSanitizeDeprecation,H=F.escape,ee=k.getDefaults,me=k.changeDefaults,Fe=k.defaults;function Oe(Ce,_e,Ie){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof _e=="function"&&(Ie=_e,_e=null),_e=ve({},Oe.defaults,_e||{}),Ke(_e),Ie){var ie=_e.highlight,ue;try{ue=Xe.lex(Ce,_e)}catch(fe){return Ie(fe)}var de=function(we){var Pe;if(!we)try{Pe=Be.parse(ue,_e)}catch(Le){we=Le}return _e.highlight=ie,we?Ie(we):Ie(null,Pe)};if(!ie||ie.length<3||(delete _e.highlight,!ue.length))return de();var ge=0;Oe.walkTokens(ue,function(fe){fe.type==="code"&&(ge++,setTimeout(function(){ie(fe.text,fe.lang,function(we,Pe){if(we)return de(we);Pe!=null&&Pe!==fe.text&&(fe.text=Pe,fe.escaped=!0),ge--,ge===0&&de()})},0))}),ge===0&&de();return}try{var $=Xe.lex(Ce,_e);return _e.walkTokens&&Oe.walkTokens($,_e.walkTokens),Be.parse($,_e)}catch(fe){if(fe.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+H(fe.message+"",!0)+"</pre>";throw fe}}Oe.options=Oe.setOptions=function(Ce){return ve(Oe.defaults,Ce),me(Oe.defaults),Oe},Oe.getDefaults=ee,Oe.defaults=Fe,Oe.use=function(Ce){var _e=ve({},Ce);if(Ce.renderer&&function(){var ie=Oe.defaults.renderer||new re,ue=function($){var fe=ie[$];ie[$]=function(){for(var we=arguments.length,Pe=new Array(we),Le=0;Le<we;Le++)Pe[Le]=arguments[Le];var $e=Ce.renderer[$].apply(ie,Pe);return $e===!1&&($e=fe.apply(ie,Pe)),$e}};for(var de in Ce.renderer)ue(de);_e.renderer=ie}(),Ce.tokenizer&&function(){var ie=Oe.defaults.tokenizer||new Y,ue=function($){var fe=ie[$];ie[$]=function(){for(var we=arguments.length,Pe=new Array(we),Le=0;Le<we;Le++)Pe[Le]=arguments[Le];var $e=Ce.tokenizer[$].apply(ie,Pe);return $e===!1&&($e=fe.apply(ie,Pe)),$e}};for(var de in Ce.tokenizer)ue(de);_e.tokenizer=ie}(),Ce.walkTokens){var Ie=Oe.defaults.walkTokens;_e.walkTokens=function(ie){Ce.walkTokens(ie),Ie&&Ie(ie)}}Oe.setOptions(_e)},Oe.walkTokens=function(Ce,_e){for(var Ie=S(Ce),ie;!(ie=Ie()).done;){var ue=ie.value;switch(_e(ue),ue.type){case"table":{for(var de=S(ue.tokens.header),ge;!(ge=de()).done;){var $=ge.value;Oe.walkTokens($,_e)}for(var fe=S(ue.tokens.cells),we;!(we=fe()).done;)for(var Pe=we.value,Le=S(Pe),$e;!($e=Le()).done;){var We=$e.value;Oe.walkTokens(We,_e)}break}case"list":{Oe.walkTokens(ue.items,_e);break}default:ue.tokens&&Oe.walkTokens(ue.tokens,_e)}}},Oe.parseInline=function(Ce,_e){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");_e=ve({},Oe.defaults,_e||{}),Ke(_e);try{var Ie=Xe.lexInline(Ce,_e);return _e.walkTokens&&Oe.walkTokens(Ie,_e.walkTokens),Be.parseInline(Ie,_e)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+H(ie.message+"",!0)+"</pre>";throw ie}},Oe.Parser=Be,Oe.parser=Be.parse,Oe.Renderer=re,Oe.TextRenderer=q,Oe.Lexer=Xe,Oe.lexer=Xe.lex,Oe.Tokenizer=Y,Oe.Slugger=se,Oe.parse=Oe;var Qe=Oe;return Qe}),define(Ee[76],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(k,D,v){return Math.min(Math.max(k,D),v)}e.clamp=m;function T(k,D){return(D+k%D)%D}e.rot=T;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class y{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Z(S){const y=[];typeof S=="number"&&y.push("code/timeOrigin",S);function k(v){y.push(v,Date.now())}function D(){const v=[];for(let C=0;C<y.length;C+=2)v.push({name:y[C],startTime:y[C+1]});return v}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))y.push({name:k.name,startTime:Math.round(S+k.startTime)});return y}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function m(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=m(T))}(),define(Ee[21],ye([0,1]),function(Z,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let S=!1,y=!1,k=!1,D=!1,v=!1,C=!1,n=!1,I,o=T,h,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const _=typeof((m=l==null?void 0:l.versions)===null||m===void 0?void 0:m.electron)=="string"&&l.type==="renderer";if(e.isElectronSandboxed=_&&(l==null?void 0:l.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=l==null?void 0:l.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)d=navigator.userAgent,S=d.indexOf("Windows")>=0,y=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,C=!0,I=navigator.language,o=I;else if(typeof l=="object"){S=l.platform==="win32",y=l.platform==="darwin",k=l.platform==="linux",D=k&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,I=T,o=T;const r=l.env.VSCODE_NLS_CONFIG;if(r)try{const u=JSON.parse(r),w=u.availableLanguages["*"];I=u.locale,o=w||T,h=u._translationsConfigFile}catch(u){}v=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function E(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let c=0;y?c=1:S?c=3:k&&(c=2),e.isWindows=S,e.isMacintosh=y,e.isLinux=k,e.isLinuxSnap=D,e.isNative=v,e.isWeb=C,e.isIOS=n,e.platform=c,e.userAgent=d,e.language=o;var f;(function(r){function u(){return e.language}r.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=w;function p(){return e.language==="en"}r.isDefault=p})(f=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let A=0,a=w.length;A<a;A++){const R=w[A];if(R.id===P.data.vscodeSetImmediateId){w.splice(A,1),R.callback();return}}});let p=0;return P=>{const A=++p;w.push({id:A,callback:P}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof(l==null?void 0:l.nextTick)=="function")return l.nextTick.bind(l);const u=Promise.resolve();return w=>u.then(w)}();var g;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||n?2:S?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Ee[40],ye([0,1,21]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const S=m.globals.vscode.process;T={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(y){return m.setImmediate(y)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:T={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(S){return m.setImmediate(S)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(Ee[15],ye([0,1,40]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,S=97,y=90,k=122,D=46,v=47,C=92,n=58,I=63;class o extends Error{constructor(f,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${s} ${i} of type ${g}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function h(c,f){if(typeof c!="string")throw new o(f,"string",c)}function d(c){return c===v||c===C}function l(c){return c===v}function _(c){return c>=T&&c<=y||c>=S&&c<=k}function b(c,f,g,t){let i="",s=0,r=-1,u=0,w=0;for(let p=0;p<=c.length;++p){if(p<c.length)w=c.charCodeAt(p);else{if(t(w))break;w=v}if(t(w)){if(!(r===p-1||u===1))if(u===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const P=i.lastIndexOf(g);P===-1?(i="",s=0):(i=i.slice(0,P),s=i.length-1-i.lastIndexOf(g)),r=p,u=0;continue}else if(i.length!==0){i="",s=0,r=p,u=0;continue}}f&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${c.slice(r+1,p)}`:i=c.slice(r+1,p),s=p-r-1;r=p,u=0}else w===D&&u!==-1?++u:u=-1}return i}function E(c,f){if(f===null||typeof f!="object")throw new o("pathObject","Object",f);const g=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return g?g===f.root?`${g}${t}`:`${g}${c}${t}`:t}e.win32={resolve(...c){let f="",g="",t=!1;for(let i=c.length-1;i>=-1;i--){let s;if(i>=0){if(s=c[i],h(s,"path"),s.length===0)continue}else f.length===0?s=m.cwd():(s=m.env[`=${f}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${f}\\`));const r=s.length;let u=0,w="",p=!1;const P=s.charCodeAt(0);if(r===1)d(P)&&(u=1,p=!0);else if(d(P))if(p=!0,d(s.charCodeAt(1))){let A=2,a=A;for(;A<r&&!d(s.charCodeAt(A));)A++;if(A<r&&A!==a){const R=s.slice(a,A);for(a=A;A<r&&d(s.charCodeAt(A));)A++;if(A<r&&A!==a){for(a=A;A<r&&!d(s.charCodeAt(A));)A++;(A===r||A!==a)&&(w=`\\\\${R}\\${s.slice(a,A)}`,u=A)}}}else u=1;else _(P)&&s.charCodeAt(1)===n&&(w=s.slice(0,2),u=2,r>2&&d(s.charCodeAt(2))&&(p=!0,u=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(t){if(f.length>0)break}else if(g=`${s.slice(u)}\\${g}`,t=p,p&&f.length>0)break}return g=b(g,!t,"\\",d),t?`${f}\\${g}`:`${f}${g}`||"."},normalize(c){h(c,"path");const f=c.length;if(f===0)return".";let g=0,t,i=!1;const s=c.charCodeAt(0);if(f===1)return l(s)?"\\":c;if(d(s))if(i=!0,d(c.charCodeAt(1))){let u=2,w=u;for(;u<f&&!d(c.charCodeAt(u));)u++;if(u<f&&u!==w){const p=c.slice(w,u);for(w=u;u<f&&d(c.charCodeAt(u));)u++;if(u<f&&u!==w){for(w=u;u<f&&!d(c.charCodeAt(u));)u++;if(u===f)return`\\\\${p}\\${c.slice(w)}\\`;u!==w&&(t=`\\\\${p}\\${c.slice(w,u)}`,g=u)}}}else g=1;else _(s)&&c.charCodeAt(1)===n&&(t=c.slice(0,2),g=2,f>2&&d(c.charCodeAt(2))&&(i=!0,g=3));let r=g<f?b(c.slice(g),!i,"\\",d):"";return r.length===0&&!i&&(r="."),r.length>0&&d(c.charCodeAt(f-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(c){h(c,"path");const f=c.length;if(f===0)return!1;const g=c.charCodeAt(0);return d(g)||f>2&&_(g)&&c.charCodeAt(1)===n&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let f,g;for(let s=0;s<c.length;++s){const r=c[s];h(r,"path"),r.length>0&&(f===void 0?f=g=r:f+=`\\${r}`)}if(f===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&d(g.charCodeAt(0))){++i;const s=g.length;s>1&&d(g.charCodeAt(1))&&(++i,s>2&&(d(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<f.length&&d(f.charCodeAt(i));)i++;i>=2&&(f=`\\${f.slice(i)}`)}return e.win32.normalize(f)},relative(c,f){if(h(c,"from"),h(f,"to"),c===f)return"";const g=e.win32.resolve(c),t=e.win32.resolve(f);if(g===t||(c=g.toLowerCase(),f=t.toLowerCase(),c===f))return"";let i=0;for(;i<c.length&&c.charCodeAt(i)===C;)i++;let s=c.length;for(;s-1>i&&c.charCodeAt(s-1)===C;)s--;const r=s-i;let u=0;for(;u<f.length&&f.charCodeAt(u)===C;)u++;let w=f.length;for(;w-1>u&&f.charCodeAt(w-1)===C;)w--;const p=w-u,P=r<p?r:p;let A=-1,a=0;for(;a<P;a++){const F=c.charCodeAt(i+a);if(F!==f.charCodeAt(u+a))break;F===C&&(A=a)}if(a!==P){if(A===-1)return t}else{if(p>P){if(f.charCodeAt(u+a)===C)return t.slice(u+a+1);if(a===2)return t.slice(u+a)}r>P&&(c.charCodeAt(i+a)===C?A=a:a===2&&(A=3)),A===-1&&(A=0)}let R="";for(a=i+A+1;a<=s;++a)(a===s||c.charCodeAt(a)===C)&&(R+=R.length===0?"..":"\\..");return u+=A,R.length>0?`${R}${t.slice(u,w)}`:(t.charCodeAt(u)===C&&++u,t.slice(u,w))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const f=e.win32.resolve(c);if(f.length<=2)return c;if(f.charCodeAt(0)===C){if(f.charCodeAt(1)===C){const g=f.charCodeAt(2);if(g!==I&&g!==D)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(_(f.charCodeAt(0))&&f.charCodeAt(1)===n&&f.charCodeAt(2)===C)return`\\\\?\\${f}`;return c},dirname(c){h(c,"path");const f=c.length;if(f===0)return".";let g=-1,t=0;const i=c.charCodeAt(0);if(f===1)return d(i)?c:".";if(d(i)){if(g=t=1,d(c.charCodeAt(1))){let u=2,w=u;for(;u<f&&!d(c.charCodeAt(u));)u++;if(u<f&&u!==w){for(w=u;u<f&&d(c.charCodeAt(u));)u++;if(u<f&&u!==w){for(w=u;u<f&&!d(c.charCodeAt(u));)u++;if(u===f)return c;u!==w&&(g=t=u+1)}}}}else _(i)&&c.charCodeAt(1)===n&&(g=f>2&&d(c.charCodeAt(2))?3:2,t=g);let s=-1,r=!0;for(let u=f-1;u>=t;--u)if(d(c.charCodeAt(u))){if(!r){s=u;break}}else r=!1;if(s===-1){if(g===-1)return".";s=g}return c.slice(0,s)},basename(c,f){f!==void 0&&h(f,"ext"),h(c,"path");let g=0,t=-1,i=!0,s;if(c.length>=2&&_(c.charCodeAt(0))&&c.charCodeAt(1)===n&&(g=2),f!==void 0&&f.length>0&&f.length<=c.length){if(f===c)return"";let r=f.length-1,u=-1;for(s=c.length-1;s>=g;--s){const w=c.charCodeAt(s);if(d(w)){if(!i){g=s+1;break}}else u===-1&&(i=!1,u=s+1),r>=0&&(w===f.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=u))}return g===t?t=u:t===-1&&(t=c.length),c.slice(g,t)}for(s=c.length-1;s>=g;--s)if(d(c.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":c.slice(g,t)},extname(c){h(c,"path");let f=0,g=-1,t=0,i=-1,s=!0,r=0;c.length>=2&&c.charCodeAt(1)===n&&_(c.charCodeAt(0))&&(f=t=2);for(let u=c.length-1;u>=f;--u){const w=c.charCodeAt(u);if(d(w)){if(!s){t=u+1;break}continue}i===-1&&(s=!1,i=u+1),w===D?g===-1?g=u:r!==1&&(r=1):g!==-1&&(r=-1)}return g===-1||i===-1||r===0||r===1&&g===i-1&&g===t+1?"":c.slice(g,i)},format:E.bind(null,"\\"),parse(c){h(c,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return f;const g=c.length;let t=0,i=c.charCodeAt(0);if(g===1)return d(i)?(f.root=f.dir=c,f):(f.base=f.name=c,f);if(d(i)){if(t=1,d(c.charCodeAt(1))){let A=2,a=A;for(;A<g&&!d(c.charCodeAt(A));)A++;if(A<g&&A!==a){for(a=A;A<g&&d(c.charCodeAt(A));)A++;if(A<g&&A!==a){for(a=A;A<g&&!d(c.charCodeAt(A));)A++;A===g?t=A:A!==a&&(t=A+1)}}}}else if(_(i)&&c.charCodeAt(1)===n){if(g<=2)return f.root=f.dir=c,f;if(t=2,d(c.charCodeAt(2))){if(g===3)return f.root=f.dir=c,f;t=3}}t>0&&(f.root=c.slice(0,t));let s=-1,r=t,u=-1,w=!0,p=c.length-1,P=0;for(;p>=t;--p){if(i=c.charCodeAt(p),d(i)){if(!w){r=p+1;break}continue}u===-1&&(w=!1,u=p+1),i===D?s===-1?s=p:P!==1&&(P=1):s!==-1&&(P=-1)}return u!==-1&&(s===-1||P===0||P===1&&s===u-1&&s===r+1?f.base=f.name=c.slice(r,u):(f.name=c.slice(r,s),f.base=c.slice(r,u),f.ext=c.slice(s,u))),r>0&&r!==t?f.dir=c.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let f="",g=!1;for(let t=c.length-1;t>=-1&&!g;t--){const i=t>=0?c[t]:m.cwd();h(i,"path"),i.length!==0&&(f=`${i}/${f}`,g=i.charCodeAt(0)===v)}return f=b(f,!g,"/",l),g?`/${f}`:f.length>0?f:"."},normalize(c){if(h(c,"path"),c.length===0)return".";const f=c.charCodeAt(0)===v,g=c.charCodeAt(c.length-1)===v;return c=b(c,!f,"/",l),c.length===0?f?"/":g?"./":".":(g&&(c+="/"),f?`/${c}`:c)},isAbsolute(c){return h(c,"path"),c.length>0&&c.charCodeAt(0)===v},join(...c){if(c.length===0)return".";let f;for(let g=0;g<c.length;++g){const t=c[g];h(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(c,f){if(h(c,"from"),h(f,"to"),c===f||(c=e.posix.resolve(c),f=e.posix.resolve(f),c===f))return"";const g=1,t=c.length,i=t-g,s=1,r=f.length-s,u=i<r?i:r;let w=-1,p=0;for(;p<u;p++){const A=c.charCodeAt(g+p);if(A!==f.charCodeAt(s+p))break;A===v&&(w=p)}if(p===u)if(r>u){if(f.charCodeAt(s+p)===v)return f.slice(s+p+1);if(p===0)return f.slice(s+p)}else i>u&&(c.charCodeAt(g+p)===v?w=p:p===0&&(w=0));let P="";for(p=g+w+1;p<=t;++p)(p===t||c.charCodeAt(p)===v)&&(P+=P.length===0?"..":"/..");return`${P}${f.slice(s+w)}`},toNamespacedPath(c){return c},dirname(c){if(h(c,"path"),c.length===0)return".";const f=c.charCodeAt(0)===v;let g=-1,t=!0;for(let i=c.length-1;i>=1;--i)if(c.charCodeAt(i)===v){if(!t){g=i;break}}else t=!1;return g===-1?f?"/":".":f&&g===1?"//":c.slice(0,g)},basename(c,f){f!==void 0&&h(f,"ext"),h(c,"path");let g=0,t=-1,i=!0,s;if(f!==void 0&&f.length>0&&f.length<=c.length){if(f===c)return"";let r=f.length-1,u=-1;for(s=c.length-1;s>=0;--s){const w=c.charCodeAt(s);if(w===v){if(!i){g=s+1;break}}else u===-1&&(i=!1,u=s+1),r>=0&&(w===f.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=u))}return g===t?t=u:t===-1&&(t=c.length),c.slice(g,t)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===v){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":c.slice(g,t)},extname(c){h(c,"path");let f=-1,g=0,t=-1,i=!0,s=0;for(let r=c.length-1;r>=0;--r){const u=c.charCodeAt(r);if(u===v){if(!i){g=r+1;break}continue}t===-1&&(i=!1,t=r+1),u===D?f===-1?f=r:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||t===-1||s===0||s===1&&f===t-1&&f===g+1?"":c.slice(f,t)},format:E.bind(null,"/"),parse(c){h(c,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return f;const g=c.charCodeAt(0)===v;let t;g?(f.root="/",t=1):t=0;let i=-1,s=0,r=-1,u=!0,w=c.length-1,p=0;for(;w>=t;--w){const P=c.charCodeAt(w);if(P===v){if(!u){s=w+1;break}continue}r===-1&&(u=!1,r=w+1),P===D?i===-1?i=w:p!==1&&(p=1):i!==-1&&(p=-1)}if(r!==-1){const P=s===0&&g?1:s;i===-1||p===0||p===1&&i===r-1&&i===s+1?f.base=f.name=c.slice(P,r):(f.name=c.slice(P,i),f.base=c.slice(P,r),f.ext=c.slice(i,r))}return s>0?f.dir=c.slice(0,s-1):g&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ee[52],ye([0,1,21]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=m.globals.performance&&typeof m.globals.performance.now=="function";class S{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new S(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=S}),define(Ee[3],ye([0,1,11,49,7,51,52]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(E){E.None=()=>S.Disposable.None;function c(oe){return(j,W=null,K)=>{let M=!1,Y;return Y=oe(x=>{if(!M)return Y?Y.dispose():M=!0,j.call(W,x)},null,K),M&&Y.dispose(),Y}}E.once=c;function f(oe,j){return u((W,K=null,M)=>oe(Y=>W.call(K,j(Y)),null,M))}E.map=f;function g(oe,j){return u((W,K=null,M)=>oe(Y=>{j(Y),W.call(K,Y)},null,M))}E.forEach=g;function t(oe,j){return u((W,K=null,M)=>oe(Y=>j(Y)&&W.call(K,Y),null,M))}E.filter=t;function i(oe){return oe}E.signal=i;function s(...oe){return(j,W=null,K)=>S.combinedDisposable(...oe.map(M=>M(Y=>j.call(W,Y),null,K)))}E.any=s;function r(oe,j,W){let K=W;return f(oe,M=>(K=j(K,M),K))}E.reduce=r;function u(oe){let j;const W=new o({onFirstListenerAdd(){j=oe(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}function w(oe,j,W=100,K=!1,M){let Y,x,O,Q=0;const V=new o({leakWarningThreshold:M,onFirstListenerAdd(){Y=oe(le=>{Q++,x=j(x,le),K&&!O&&(V.fire(x),x=void 0),clearTimeout(O),O=setTimeout(()=>{const be=x;x=void 0,O=void 0,(!K||Q>1)&&V.fire(be),Q=0},W)})},onLastListenerRemove(){Y.dispose()}});return V.event}E.debounce=w;function p(oe,j=(W,K)=>W===K){let W=!0,K;return t(oe,M=>{const Y=W||!j(M,K);return W=!1,K=M,Y})}E.latch=p;function P(oe,j){return[E.filter(oe,j),E.filter(oe,W=>!j(W))]}E.split=P;function A(oe,j=!1,W=[]){let K=W.slice(),M=oe(O=>{K?K.push(O):x.fire(O)});const Y=()=>{K&&K.forEach(O=>x.fire(O)),K=null},x=new o({onFirstListenerAdd(){M||(M=oe(O=>x.fire(O)))},onFirstListenerDidAdd(){K&&(j?setTimeout(Y):Y())},onLastListenerRemove(){M&&M.dispose(),M=null}});return x.event}E.buffer=A;class a{constructor(j){this.event=j}map(j){return new a(f(this.event,j))}forEach(j){return new a(g(this.event,j))}filter(j){return new a(t(this.event,j))}reduce(j,W){return new a(r(this.event,j,W))}latch(){return new a(p(this.event))}debounce(j,W=100,K=!1,M){return new a(w(this.event,j,W,K,M))}on(j,W,K){return this.event(j,W,K)}once(j,W,K){return c(this.event)(j,W,K)}}function R(oe){return new a(oe)}E.chain=R;function F(oe,j,W=K=>K){const K=(...O)=>x.fire(W(...O)),M=()=>oe.on(j,K),Y=()=>oe.removeListener(j,K),x=new o({onFirstListenerAdd:M,onLastListenerRemove:Y});return x.event}E.fromNodeEventEmitter=F;function U(oe,j,W=K=>K){const K=(...O)=>x.fire(W(...O)),M=()=>oe.addEventListener(j,K),Y=()=>oe.removeEventListener(j,K),x=new o({onFirstListenerAdd:M,onLastListenerRemove:Y});return x.event}E.fromDOMEventEmitter=U;function X(oe){return new Promise(j=>c(oe)(j))}E.toPromise=X})(D=e.Event||(e.Event={}));class v{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${v._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}v._idPool=0;let C=-1;function n(E){const c=C;return C=E,{dispose(){C=c}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(c,f=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let f=C;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||c<f)return;this._stacks||(this._stacks=new Map);const g=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(g)||0;if(this._stacks.set(g,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let i,s=0;for(const[r,u]of this._stacks)(!i||s<u)&&(i=r,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(g)||0;this._stacks.set(g,i-1)}}}class o{constructor(c){var f;this._disposed=!1,this._options=c,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new v(this._options._profName):void 0}get event(){return this._event||(this._event=(c,f,g)=>{var t;this._listeners||(this._listeners=new y.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(f?[c,f]:c);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,f);const r=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let u;return u={dispose:()=>{r&&r(),u.dispose=o._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},g instanceof S.DisposableStore?g.add(u):Array.isArray(g)&&g.push(u),u}),this._event}fire(c){var f,g;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,c]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,i]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,i):t[0].call(t[1],i)}catch(s){m.onUnexpectedError(s)}}(g=this._perfMon)===null||g===void 0||g.stop()}}dispose(){var c,f,g,t,i;this._disposed||(this._disposed=!0,(c=this._listeners)===null||c===void 0||c.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(t=(g=this._options)===null||g===void 0?void 0:g.onLastListenerRemove)===null||t===void 0||t.call(g),(i=this._leakageMon)===null||i===void 0||i.dispose())}}e.Emitter=o,o._noop=function(){};class h extends o{constructor(c){super(c);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=c==null?void 0:c.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=h;class d extends h{constructor(c){var f;super(c);this._delay=(f=c.delay)!==null&&f!==void 0?f:100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=d;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const f={event:c,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const g=()=>{this.hasListeners&&this.unhook(f);const t=this.events.indexOf(f);this.events.splice(t,1)};return S.toDisposable(T.once(g))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(f=>this.emitter.fire(f))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class _{constructor(){this.buffers=[]}wrapEvent(c){return(f,g,t)=>c(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>f.call(g,i)):f.call(g,i)},void 0,t)}bufferEvents(c){const f=[];this.buffers.push(f);const g=c();return this.buffers.pop(),f.forEach(t=>t()),g}}e.EventBufferer=_;class b{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=S.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(Ee[18],ye([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(D,v){const C=setTimeout(D.bind(v),0);return{dispose(){clearTimeout(C)}}});var S;(function(D){function v(C){return C===D.None||C===D.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=v,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(S=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=S.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=k}),define(Ee[77],ye([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const o=this._icons.get(I.id);o?I.description?o.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new T;e.iconRegistry=S;function y(n,I){return new D(n,I)}e.registerCodicon=y;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=k;class D{constructor(I,o,h){this.id=I,this.definition=o,this.description=h,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function v(n,I){const o=["codicon","codicon-"+n];return I&&o.push("codicon-modifier-"+I),o}e.getClassNamesArray=v;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function o(l){if(l instanceof D)return["codicon","codicon-"+l.id];const _=I.exec(l.id);if(!_)return o(D.error);let[,b,E]=_;const c=["codicon","codicon-"+b];return E&&c.push("codicon-modifier-"+E.substr(1)),c}n.asClassNameArray=o;function h(l){return o(l).join(" ")}n.asClassName=h;function d(l){return"."+o(l).join(".")}n.asCSSSelector=d})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(Ee[109],ye([0,1,11,7]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(c){const f=c;return f?[f.on,f.pause,f.resume,f.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=S;function y(c){const f=c;return f?S(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=y;function k(c,f){return new D(c,f)}e.newWriteableStream=k;class D{constructor(f,g){this.reducer=f,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(g=>g(f))}emitError(f){this.listeners.error.length===0?m.onUnexpectedError(f):this.listeners.error.slice(0).forEach(g=>g(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,g){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(f,g){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(c,f){const g=[];let t;for(;(t=c.read())!==null;)g.push(t);return f(g)}e.consumeReadable=v;function C(c,f,g){const t=[];let i;for(;(i=c.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return c.read()}}}e.peekReadable=C;function n(c,f){return new Promise((g,t)=>{const i=[];I(c,{onData:s=>{f&&i.push(s)},onError:s=>{f?t(s):g(void 0)},onEnd:()=>{g(f?f(i):void 0)}})})}e.consumeStream=n;function I(c,f){c.on("error",g=>f.onError(g)),c.on("end",()=>f.onEnd()),c.on("data",g=>f.onData(g))}e.listenStream=I;function o(c,f){return new Promise((g,t)=>{const i=new T.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>f)return i.dispose(),c.pause(),g({stream:c,buffer:s,ended:!1})},u=p=>t(p),w=()=>g({stream:c,buffer:s,ended:!0});i.add(T.toDisposable(()=>c.removeListener("error",u))),c.on("error",u),i.add(T.toDisposable(()=>c.removeListener("end",w))),c.on("end",w),i.add(T.toDisposable(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=o;function h(c,f){const g=k(f);return g.end(c),g}e.toStream=h;function d(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function l(c){let f=!1;return{read:()=>f?null:(f=!0,c)}}e.toReadable=l;function _(c,f,g){const t=k(g);return I(c,{onData:i=>t.write(f.data(i)),onError:i=>t.error(f.error?f.error(i):i),onEnd:()=>t.end()}),t}e.transform=_;function b(c,f,g){let t=!1;return{read:()=>{const i=f.read();return t?i:(t=!0,i!==null?g([c,i]):c)}}}e.prefixedReadable=b;function E(c,f,g){let t=!1;const i=k(g);return I(f,{onData:s=>t?i.write(s):(t=!0,i.write(g([c,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(c)),i.end()}}),i}e.prefixedStream=E}),define(Ee[8],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=m;const T=/{(\d+)}/g;function S($,...fe){return fe.length===0?$:$.replace(T,function(we,Pe){const Le=parseInt(Pe,10);return isNaN(Le)||Le<0||Le>=fe.length?we:fe[Le]})}e.format=S;const y=/{([^}]+)}/g;function k($,fe){return $.replace(y,(we,Pe)=>{var Le;return(Le=fe[Pe])!==null&&Le!==void 0?Le:we})}e.format2=k;function D($){return $.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.escape=D;function v($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function C($,fe){let we=0;const Pe=fe.charCodeAt(0);for(let Le=$.length-1;Le>=0;Le--)$.charCodeAt(Le)===Pe&&we++;return we}e.count=C;function n($,fe,we="\u2026"){return $.length<=fe?$:`${$.substr(0,fe)}${we}`}e.truncate=n;function I($,fe=" "){const we=o($,fe);return h(we,fe)}e.trim=I;function o($,fe){if(!$||!fe)return $;const we=fe.length;if(we===0||$.length===0)return $;let Pe=0;for(;$.indexOf(fe,Pe)===Pe;)Pe=Pe+we;return $.substring(Pe)}e.ltrim=o;function h($,fe){if(!$||!fe)return $;const we=fe.length,Pe=$.length;if(we===0||Pe===0)return $;let Le=Pe,$e=-1;for(;$e=$.lastIndexOf(fe,Le-1),!($e===-1||$e+we!==Le);){if($e===0)return"";Le=$e}return $.substring(0,Le)}e.rtrim=h;function d($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function l($){return $.replace(/\*/g,"")}e.stripWildcards=l;function _($,fe,we={}){if(!$)throw new Error("Cannot create regex from empty string");fe||($=v($)),we.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Pe="";return we.global&&(Pe+="g"),we.matchCase||(Pe+="i"),we.multiline&&(Pe+="m"),we.unicode&&(Pe+="u"),new RegExp($,Pe)}e.createRegExp=_;function b($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function E($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function c($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=c;function f($){return $.split(/\r\n|\r|\n/)}e.splitLines=f;function g($){for(let fe=0,we=$.length;fe<we;fe++){const Pe=$.charCodeAt(fe);if(Pe!==32&&Pe!==9)return fe}return-1}e.firstNonWhitespaceIndex=g;function t($,fe=0,we=$.length){for(let Pe=fe;Pe<we;Pe++){const Le=$.charCodeAt(Pe);if(Le!==32&&Le!==9)return $.substring(fe,Pe)}return $.substring(fe,we)}e.getLeadingWhitespace=t;function i($,fe=$.length-1){for(let we=fe;we>=0;we--){const Pe=$.charCodeAt(we);if(Pe!==32&&Pe!==9)return we}return-1}e.lastNonWhitespaceIndex=i;function s($,fe){return $<fe?-1:$>fe?1:0}e.compare=s;function r($,fe,we=0,Pe=$.length,Le=0,$e=fe.length){for(;we<Pe&&Le<$e;we++,Le++){let tt=$.charCodeAt(we),ut=fe.charCodeAt(Le);if(tt<ut)return-1;if(tt>ut)return 1}const We=Pe-we,Ye=$e-Le;return We<Ye?-1:We>Ye?1:0}e.compareSubstring=r;function u($,fe){return w($,fe,0,$.length,0,fe.length)}e.compareIgnoreCase=u;function w($,fe,we=0,Pe=$.length,Le=0,$e=fe.length){for(;we<Pe&&Le<$e;we++,Le++){let tt=$.charCodeAt(we),ut=fe.charCodeAt(Le);if(tt===ut)continue;const pe=tt-ut;if(!(pe===32&&P(ut))&&!(pe===-32&&P(tt)))return p(tt)&&p(ut)?pe:r($.toLowerCase(),fe.toLowerCase(),we,Pe,Le,$e)}const We=Pe-we,Ye=$e-Le;return We<Ye?-1:We>Ye?1:0}e.compareSubstringIgnoreCase=w;function p($){return $>=97&&$<=122}e.isLowerAsciiLetter=p;function P($){return $>=65&&$<=90}e.isUpperAsciiLetter=P;function A($){return p($)||P($)}function a($,fe){return $.length===fe.length&&R($,fe)}e.equalsIgnoreCase=a;function R($,fe,we=$.length){for(let Pe=0;Pe<we;Pe++){const Le=$.charCodeAt(Pe),$e=fe.charCodeAt(Pe);if(Le!==$e){if(A(Le)&&A($e)){const We=Math.abs(Le-$e);if(We!==0&&We!==32)return!1}else if(String.fromCharCode(Le).toLowerCase()!==String.fromCharCode($e).toLowerCase())return!1}}return!0}function F($,fe){const we=fe.length;return fe.length>$.length?!1:R($,fe,we)}e.startsWithIgnoreCase=F;function U($,fe){let we,Pe=Math.min($.length,fe.length);for(we=0;we<Pe;we++)if($.charCodeAt(we)!==fe.charCodeAt(we))return we;return Pe}e.commonPrefixLength=U;function X($,fe){let we,Pe=Math.min($.length,fe.length);const Le=$.length-1,$e=fe.length-1;for(we=0;we<Pe;we++)if($.charCodeAt(Le-we)!==fe.charCodeAt($e-we))return we;return Pe}e.commonSuffixLength=X;function oe($){return 55296<=$&&$<=56319}e.isHighSurrogate=oe;function j($){return 56320<=$&&$<=57343}e.isLowSurrogate=j;function W($,fe){return($-55296<<10)+(fe-56320)+65536}e.computeCodePoint=W;function K($,fe,we){const Pe=$.charCodeAt(we);if(oe(Pe)&&we+1<fe){const Le=$.charCodeAt(we+1);if(j(Le))return W(Pe,Le)}return Pe}e.getNextCodePoint=K;function M($,fe){const we=$.charCodeAt(fe-1);if(j(we)&&fe>1){const Pe=$.charCodeAt(fe-2);if(oe(Pe))return W(Pe,we)}return we}function Y($,fe){const we=Ce.getInstance(),Pe=fe,Le=$.length,$e=K($,Le,fe);fe+=$e>=65536?2:1;let We=we.getGraphemeBreakType($e);for(;fe<Le;){const Ye=K($,Le,fe),tt=we.getGraphemeBreakType(Ye);if(Oe(We,tt))break;fe+=Ye>=65536?2:1,We=tt}return fe-Pe}e.nextCharLength=Y;function x($,fe){const we=Ce.getInstance(),Pe=fe,Le=M($,fe);fe-=Le>=65536?2:1;let $e=we.getGraphemeBreakType(Le);for(;fe>0;){const We=M($,fe),Ye=we.getGraphemeBreakType(We);if(Oe(Ye,$e))break;fe-=We>=65536?2:1,$e=Ye}return Pe-fe}e.prevCharLength=x;function O($,fe){const we=Ce.getInstance(),Pe=$.length,Le=fe,$e=K($,Pe,fe),We=we.getGraphemeBreakType($e);fe+=$e>=65536?2:1;let Ye=We;for(;fe<Pe;){const ut=K($,Pe,fe),pe=we.getGraphemeBreakType(ut);if(Oe(Ye,pe))break;fe+=ut>=65536?2:1,Ye=pe}const tt=fe;for(fe=Le,Ye=We;fe>0;){const ut=M($,fe),pe=we.getGraphemeBreakType(ut);if(Oe(pe,Ye))break;fe-=ut>=65536?2:1,Ye=pe}return[fe,tt]}function Q($,fe){return fe>0&&j($.charCodeAt(fe))?O($,fe-1):O($,fe)}e.getCharContainingOffset=Q;function V($){const fe=$.length;let we=0,Pe=0;for(;Pe<fe;){const We=K($,fe,Pe);Pe+=We>=65536?2:1,We<128?we+=1:We<2048?we+=2:We<65536?we+=3:we+=4}const Le=new Uint8Array(we);Pe=0;let $e=0;for(;Pe<fe;){const We=K($,fe,Pe);Pe+=We>=65536?2:1,We<128?Le[$e++]=We:We<2048?(Le[$e++]=192|(We&1984)>>>6,Le[$e++]=128|(We&63)>>>0):We<65536?(Le[$e++]=224|(We&61440)>>>12,Le[$e++]=128|(We&4032)>>>6,Le[$e++]=128|(We&63)>>>0):(Le[$e++]=240|(We&1835008)>>>18,Le[$e++]=128|(We&258048)>>>12,Le[$e++]=128|(We&4032)>>>6,Le[$e++]=128|(We&63)>>>0)}return Le}e.encodeUTF8=V;function le($){const fe=$.byteLength,we=[];let Pe=0;for(;Pe<fe;){const Le=$[Pe];let $e;if(Le>=240&&Pe+3<fe?$e=($[Pe++]&7)<<18>>>0|($[Pe++]&63)<<12>>>0|($[Pe++]&63)<<6>>>0|($[Pe++]&63)<<0>>>0:Le>=224&&Pe+2<fe?$e=($[Pe++]&15)<<12>>>0|($[Pe++]&63)<<6>>>0|($[Pe++]&63)<<0>>>0:Le>=192&&Pe+1<fe?$e=($[Pe++]&31)<<6>>>0|($[Pe++]&63)<<0>>>0:$e=$[Pe++],$e>=0&&$e<=55295||$e>=57344&&$e<=65535)we.push(String.fromCharCode($e));else if($e>=65536&&$e<=1114111){const We=$e-65536,Ye=55296+((We&1047552)>>>10),tt=56320+((We&1023)>>>0);we.push(String.fromCharCode(Ye)),we.push(String.fromCharCode(tt))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=le;const be=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Te($){return be.test($)}e.containsRTL=Te;const He=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Me($){return He.test($)}e.containsEmoji=Me;const qe=/^[\t\n\r\x20-\x7E]*$/;function nt($){return qe.test($)}e.isBasicASCII=nt,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Je($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=Je;function Xe($){for(let fe=0,we=$.length;fe<we;fe++)if(B($.charCodeAt(fe)))return!0;return!1}e.containsFullWidthCharacter=Xe;function B($){return $=+$,$>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=B;function G($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129003||$>=129280&&$<=129535||$>=129648&&$<=129750}e.isEmojiImprecise=G;function ne($,fe){if($.length<fe)return $;const we=/\b/g;let Pe=0;for(;we.test($)&&!($.length-we.lastIndex<fe);)Pe=we.lastIndex,we.lastIndex+=1;return $.substring(Pe).replace(/^\s/,"")}e.lcut=ne;const re=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,se=/\x1b\[0?m/g;function he($){return $&&($=$.replace(re,""),$=$.replace(q,""),$=$.replace(se,"")),$}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Be($){return Re($)?$.substr(1):$}e.stripUTF8BOM=Be;function ve($,fe){if(!$||!fe||$.length<fe.length)return!1;const we=fe.length,Pe=$.toLowerCase();let Le=0,$e=-1;for(;Le<we;){const We=Pe.indexOf(fe[Le],$e+1);if(We<0)return!1;$e=We,Le++}return!0}e.fuzzyContains=ve;function Ke($,fe=!1){return $?(fe&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=Ke;function H($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=H;function ee($,fe=1){if(fe===0)return"";let we=-1;do we=$.indexOf(`
`,we+1),fe--;while(fe>0&&we>=0);return we===-1?$:($[we-1]==="\r"&&we--,$.substr(0,we))}e.getNLines=ee;function me($){const fe=90-65+1;return $=$%(2*fe),$<fe?String.fromCharCode(97+$):String.fromCharCode(65+$-fe)}e.singleLetterHash=me;function Fe($){return Ce.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=Fe;function Oe($,fe){return $===0?fe!==5&&fe!==7:$===2&&fe===3?!1:$===4||$===2||$===3||fe===4||fe===2||fe===3?!0:!($===8&&(fe===8||fe===9||fe===11||fe===12)||($===11||$===9)&&(fe===9||fe===10)||($===12||$===10)&&fe===10||fe===5||fe===13||fe===7||$===1||$===13&&fe===14||$===6&&fe===6)}e.breakBetweenGraphemeBreakType=Oe;var Qe;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=_e()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const we=this._data,Pe=we.length/3;let Le=1;for(;Le<=Pe;)if(fe<we[3*Le])Le=2*Le;else if(fe>we[3*Le+1])Le=2*Le+1;else return we[3*Le+2];return 0}}Ce._INSTANCE=null;function _e(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ie($,fe){if($===0)return 0;const we=ie($,fe);if(we!==void 0)return we;const Pe=M(fe,$);return $-=ue(Pe),$}e.getLeftDeleteOffset=Ie;function ie($,fe){let we=M(fe,$);for($-=ue(we);de(we)||we===65039||we===8419;){if($===0)return;we=M(fe,$),$-=ue(we)}if(!!G(we)){if($>=0){const Pe=M(fe,$);Pe===8205&&($-=ue(Pe))}return $}}function ue($){return $>=65536?2:1}function de($){return 127995<=$&&$<=127999}var ge;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(ge||(ge={}))}),define(Ee[23],ye([0,1,8,109]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let D,v;class C{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return S?new C(Buffer.allocUnsafe(p)):new C(new Uint8Array(p))}static wrap(p){return S&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new C(p)}static fromString(p,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&S?new C(Buffer.from(p)):y?(D||(D=new TextEncoder),new C(D.encode(p))):new C(m.encodeUTF8(p))}static concat(p,P){if(typeof P=="undefined"){P=0;for(let R=0,F=p.length;R<F;R++)P+=p[R].byteLength}const A=C.alloc(P);let a=0;for(let R=0,F=p.length;R<F;R++){const U=p[R];A.set(U,a),a+=U.byteLength}return A}toString(){return S?this.buffer.toString():k?(v||(v=new TextDecoder),v.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(p,P){return new C(this.buffer.subarray(p,P))}set(p,P){p instanceof C?this.buffer.set(p.buffer,P):this.buffer.set(p,P)}readUInt32BE(p){return o(this.buffer,p)}writeUInt32BE(p,P){h(this.buffer,p,P)}readUInt32LE(p){return d(this.buffer,p)}writeUInt32LE(p,P){l(this.buffer,p,P)}readUInt8(p){return _(this.buffer,p)}writeUInt8(p,P){b(this.buffer,p,P)}}e.VSBuffer=C;function n(w,p){return w[p+0]<<0>>>0|w[p+1]<<8>>>0}e.readUInt16LE=n;function I(w,p,P){w[P+0]=p&255,p=p>>>8,w[P+1]=p&255}e.writeUInt16LE=I;function o(w,p){return w[p]*2**24+w[p+1]*2**16+w[p+2]*2**8+w[p+3]}e.readUInt32BE=o;function h(w,p,P){w[P+3]=p,p=p>>>8,w[P+2]=p,p=p>>>8,w[P+1]=p,p=p>>>8,w[P]=p}e.writeUInt32BE=h;function d(w,p){return w[p+0]<<0>>>0|w[p+1]<<8>>>0|w[p+2]<<16>>>0|w[p+3]<<24>>>0}e.readUInt32LE=d;function l(w,p,P){w[P+0]=p&255,p=p>>>8,w[P+1]=p&255,p=p>>>8,w[P+2]=p&255,p=p>>>8,w[P+3]=p&255}e.writeUInt32LE=l;function _(w,p){return w[p]}e.readUInt8=_;function b(w,p,P){w[P]=p}e.writeUInt8=b;function E(w){return T.consumeReadable(w,p=>C.concat(p))}e.readableToBuffer=E;function c(w){return T.toReadable(w)}e.bufferToReadable=c;function f(w){return T.consumeStream(w,p=>C.concat(p))}e.streamToBuffer=f;async function g(w){return w.ended?C.concat(w.buffer):C.concat([...w.buffer,await f(w.stream)])}e.bufferedStreamToBuffer=g;function t(w){return T.toStream(w,p=>C.concat(p))}e.bufferToStream=t;function i(w){return T.transform(w,{data:p=>typeof p=="string"?C.fromString(p):C.wrap(p)},p=>C.concat(p))}e.streamToBufferReadableStream=i;function s(w){return T.newWriteableStream(p=>C.concat(p),w)}e.newWriteableBufferStream=s;function r(w,p){return T.prefixedReadable(w,p,P=>C.concat(P))}e.prefixedBufferReadable=r;function u(w,p){return T.prefixedStream(w,p,P=>C.concat(P))}e.prefixedBufferStream=u}),define(Ee[53],ye([0,1,8]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(b){return S(b,0)}e.hash=T;function S(b,E){switch(typeof b){case"object":return b===null?y(349,E):Array.isArray(b)?v(b,E):C(b,E);case"string":return D(b,E);case"boolean":return k(b,E);case"number":return y(b,E);case"undefined":return y(937,E);default:return y(617,E)}}e.doHash=S;function y(b,E){return(E<<5)-E+b|0}function k(b,E){return y(b?433:863,E)}function D(b,E){E=y(149417,E);for(let c=0,f=b.length;c<f;c++)E=y(b.charCodeAt(c),E);return E}e.stringHash=D;function v(b,E){return E=y(104579,E),b.reduce((c,f)=>S(f,c),E)}function C(b,E){return E=y(181387,E),Object.keys(b).sort().reduce((c,f)=>(c=D(f,c),S(b[f],c)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=S(E,this._value),this._value}}e.Hasher=n;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(b,E,c=32){const f=c-E,g=~((1<<f)-1);return(b<<E|(g&b)>>>f)>>>0}function h(b,E=0,c=b.byteLength,f=0){for(let g=0;g<c;g++)b[E+g]=f}function d(b,E,c="0"){for(;b.length<E;)b=c+b;return b}function l(b,E=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((b>>>0).toString(16),E/4)}e.toHexString=l;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const c=E.length;if(c===0)return;const f=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=E.charCodeAt(0),s=0);;){let r=i;if(m.isHighSurrogate(i))if(s+1<c){const u=E.charCodeAt(s+1);m.isLowSurrogate(u)?(s++,r=m.computeCodePoint(i,u)):r=65533}else{t=i;break}else m.isLowSurrogate(i)&&(r=65533);if(g=this._push(f,g,r),s++,s<c)i=E.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(E,c,f){return f<128?E[c++]=f:f<2048?(E[c++]=192|(f&1984)>>>6,E[c++]=128|(f&63)>>>0):f<65536?(E[c++]=224|(f&61440)>>>12,E[c++]=128|(f&4032)>>>6,E[c++]=128|(f&63)>>>0):(E[c++]=240|(f&1835008)>>>18,E[c++]=128|(f&258048)>>>12,E[c++]=128|(f&4032)>>>6,E[c++]=128|(f&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,c=this._buffDV;for(let p=0;p<64;p+=4)E.setUint32(p,c.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)E.setUint32(p,o(E.getUint32(p-12,!1)^E.getUint32(p-32,!1)^E.getUint32(p-56,!1)^E.getUint32(p-64,!1),1),!1);let f=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,r,u,w;for(let p=0;p<80;p++)p<20?(r=g&t|~g&i,u=1518500249):p<40?(r=g^t^i,u=1859775393):p<60?(r=g&t|g&i|t&i,u=2400959708):(r=g^t^i,u=3395469782),w=o(f,5)+r+s+u+E.getUint32(p*4,!1)&4294967295,s=i,i=t,t=o(g,30),g=f,f=w;this._h0=this._h0+f&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Ee[41],ye([0,1,8]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(T||(T={})),function(S){const y="error",k="warning",D="warn",v="info",C="ignore";function n(o){return o?m.equalsIgnoreCase(y,o)?S.Error:m.equalsIgnoreCase(k,o)||m.equalsIgnoreCase(D,o)?S.Warning:m.equalsIgnoreCase(v,o)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(o){switch(o){case S.Error:return y;case S.Warning:return k;case S.Info:return v;default:return C}}S.toString=I}(T||(T={})),e.default=T}),define(Ee[10],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(p){return Array.isArray(p)}e.isArray=m;function T(p){return typeof p=="string"}e.isString=T;function S(p){return Array.isArray(p)&&p.every(P=>T(P))}e.isStringArray=S;function y(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=y;function k(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=k;function D(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=D;function v(p){return p===!0||p===!1}e.isBoolean=v;function C(p){return typeof p=="undefined"}e.isUndefined=C;function n(p){return!I(p)}e.isDefined=n;function I(p){return C(p)||p===null}e.isUndefinedOrNull=I;function o(p,P){if(!p)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=o;function h(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=h;function d(...p){const P=[];for(let A=0;A<p.length;A++){const a=p[A];if(I(a))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);P.push(a)}return P}e.assertAllDefined=d;const l=Object.prototype.hasOwnProperty;function _(p){if(!y(p))return!1;for(let P in p)if(l.call(p,P))return!1;return!0}e.isEmptyObject=_;function b(p){return typeof p=="function"}e.isFunction=b;function E(...p){return p.length>0&&p.every(b)}e.areFunctions=E;function c(p,P){const A=Math.min(p.length,P.length);for(let a=0;a<A;a++)f(p[a],P[a])}e.validateConstraints=c;function f(p,P){if(T(P)){if(typeof p!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(b(P)){try{if(p instanceof P)return}catch(A){}if(!I(p)&&p.constructor===P||P.length===1&&P.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function g(p){let P=[],A=Object.getPrototypeOf(p);for(;Object.prototype!==A;)P=P.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return P}e.getAllPropertyNames=g;function t(p){const P=[];for(const A of g(p))typeof p[A]=="function"&&P.push(A);return P}e.getAllMethodNames=t;function i(p,P){const A=R=>function(){const F=Array.prototype.slice.call(arguments,0);return P(R,F)};let a={};for(const R of p)a[R]=A(R);return a}e.createProxyObject=i;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function r(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=r;function u(p){return class{constructor(){return new Proxy({},{get(P,A){if(P[A])return P[A];throw new Error(`Not Implemented: ${p}->${String(A)}`)}})}}}e.NotImplementedProxy=u;function w(p){throw new Error("Unreachable")}e.assertNever=w}),define(Ee[42],ye([0,1,21,8,15,10]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function D(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function v(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=v;function C(s,r=S.posix.sep){if(!s)return"";const u=s.length,w=s.charCodeAt(0);if(k(w)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let P=3;const A=P;for(;P<u&&!k(s.charCodeAt(P));P++);if(A!==P&&!k(s.charCodeAt(P+1))){for(P+=1;P<u;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,r)}}return r}else if(b(w)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<u;p++)if(k(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=C;function n(s){if(!m.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let u=2;const w=u;for(;u<s.length&&(r=s.charCodeAt(u),r!==92);u++);return!(w===u||(r=s.charCodeAt(u+1),isNaN(r)||r===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,r=m.isWindows){const u=r?I:o;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||r&&h.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function l(s,r,u){const w=s===r;return!u||w?w:!s||!r?!1:T.equalsIgnoreCase(s,r)}e.isEqual=l;function _(s,r,u,w=S.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(u){if(!T.startsWithIgnoreCase(s,r))return!1;if(r.length===s.length)return!0;let P=r.length;return r.charAt(r.length-1)===w&&P--,s.charAt(P)===w}return r.charAt(r.length-1)!==w&&(r+=w),s.indexOf(r)===0}e.isEqualOrParent=_;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function E(s,r){return m.isWindows&&s.endsWith(":")&&(s+=S.sep),S.isAbsolute(s)||(s=S.join(r,s)),s=S.normalize(s),m.isWindows?(s=T.rtrim(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=T.rtrim(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=E;function c(s){const r=S.normalize(s);return m.isWindows?s.length>3?!1:f(r)&&(s.length===2||r.charCodeAt(2)===92):r===S.posix.sep}e.isRootOrDriveLetter=c;function f(s){return m.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function g(s){return f(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,r,u){return r.length>s.length?-1:s===r?0:(u&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function i(s){const r=s.split(":");let u,w,p;if(r.forEach(P=>{const A=Number(P);y.isNumber(A)?w===void 0?w=A:p===void 0&&(p=A):u=u?[u,P].join(":"):P}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:w!==void 0?w:void 0,column:p!==void 0?p:w!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(Ee[24],ye([0,1,10]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const _=Array.isArray(l)?[]:{};return Object.keys(l).forEach(b=>{l[b]&&typeof l[b]=="object"?_[b]=T(l[b]):_[b]=l[b]}),_}e.deepClone=T;function S(l){if(!l||typeof l!="object")return l;const _=[l];for(;_.length>0;){const b=_.shift();Object.freeze(b);for(const E in b)if(y.call(b,E)){const c=b[E];typeof c=="object"&&!Object.isFrozen(c)&&_.push(c)}}return l}e.deepFreeze=S;const y=Object.prototype.hasOwnProperty;function k(l,_){return D(l,_,new Set)}e.cloneAndChange=k;function D(l,_,b){if(m.isUndefinedOrNull(l))return l;const E=_(l);if(typeof E!="undefined")return E;if(m.isArray(l)){const c=[];for(const f of l)c.push(D(f,_,b));return c}if(m.isObject(l)){if(b.has(l))throw new Error("Cannot clone recursive data-structure");b.add(l);const c={};for(let f in l)y.call(l,f)&&(c[f]=D(l[f],_,b));return b.delete(l),c}return l}function v(l,_,b=!0){return m.isObject(l)?(m.isObject(_)&&Object.keys(_).forEach(E=>{E in l?b&&(m.isObject(l[E])&&m.isObject(_[E])?v(l[E],_[E],b):l[E]=_[E]):l[E]=_[E]}),l):_}e.mixin=v;function C(l,_){if(l===_)return!0;if(l==null||_===null||_===void 0||typeof l!=typeof _||typeof l!="object"||Array.isArray(l)!==Array.isArray(_))return!1;let b,E;if(Array.isArray(l)){if(l.length!==_.length)return!1;for(b=0;b<l.length;b++)if(!C(l[b],_[b]))return!1}else{const c=[];for(E in l)c.push(E);c.sort();const f=[];for(E in _)f.push(E);if(f.sort(),!C(c,f))return!1;for(b=0;b<c.length;b++)if(!C(l[c[b]],_[c[b]]))return!1}return!0}e.equals=C;function n(l){const _=new Set;return JSON.stringify(l,(b,E)=>{if(m.isObject(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=n;function I(l,_,b){const E=_(l);return typeof E=="undefined"?b:E}e.getOrDefault=I;function o(l,_){const b=Object.create(null);return!l||!_||Object.keys(_).forEach(c=>{const f=l[c],g=_[c];C(f,g)||(b[c]=g)}),b}e.distinct=o;function h(l,_){const b=_.toLowerCase(),E=Object.keys(l).find(c=>c.toLowerCase()===b);return E?l[E]:l[_]}e.getCaseInsensitive=h;function d(l,_){const b=Object.create(null);for(const E of Object.keys(l))_(E,l[E])&&(b[E]=l[E]);return b}e.filter=d}),define(Ee[78],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function T(y){return y<0?0:y>255?255:y|0}e.toUint8=T;function S(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=S}),define(Ee[2],ye([0,1,21,15]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,y=/^\//,k=/^\/\//;function D(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,r){return!s&&!r?"file":s}function C(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const n="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(r,u,w,p,P,A=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=v(r,A),this.authority=u||n,this.path=C(this.scheme,w||n),this.query=p||n,this.fragment=P||n,D(this,A))}static isUri(r){return r instanceof h?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:u,authority:w,path:p,query:P,fragment:A}=r;return u===void 0?u=this.scheme:u===null&&(u=n),w===void 0?w=this.authority:w===null&&(w=n),p===void 0?p=this.path:p===null&&(p=n),P===void 0?P=this.query:P===null&&(P=n),A===void 0?A=this.fragment:A===null&&(A=n),u===this.scheme&&w===this.authority&&p===this.path&&P===this.query&&A===this.fragment?this:new l(u,w,p,P,A)}static parse(r,u=!1){const w=o.exec(r);return w?new l(w[2]||n,i(w[4]||n),i(w[5]||n),i(w[7]||n),i(w[9]||n),u):new l(n,n,n,n,n)}static file(r){let u=n;if(m.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const w=r.indexOf(I,2);w===-1?(u=r.substring(2),r=I):(u=r.substring(2,w),r=r.substring(w)||I)}return new l("file",u,r,n,n)}static from(r){const u=new l(r.scheme,r.authority,r.path,r.query,r.fragment);return D(u,!0),u}static joinPath(r,...u){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return m.isWindows&&r.scheme==="file"?w=h.file(T.win32.join(c(r,!0),...u)).path:w=T.posix.join(r.path,...u),r.with({path:w})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof h)return r;{const u=new l(r);return u._formatted=r.external,u._fsPath=r._sep===d?r.fsPath:null,u}}else return r}}e.URI=h;const d=m.isWindows?1:void 0;class l extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,r){let u,w=-1;for(let p=0;p<s.length;p++){const P=s.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)w!==-1&&(u+=encodeURIComponent(s.substring(w,p)),w=-1),u!==void 0&&(u+=s.charAt(p));else{u===void 0&&(u=s.substr(0,p));const A=_[P];A!==void 0?(w!==-1&&(u+=encodeURIComponent(s.substring(w,p)),w=-1),u+=A):w===-1&&(w=p)}}return w!==-1&&(u+=encodeURIComponent(s.substring(w))),u!==void 0?u:s}function E(s){let r;for(let u=0;u<s.length;u++){const w=s.charCodeAt(u);w===35||w===63?(r===void 0&&(r=s.substr(0,u)),r+=_[w]):r!==void 0&&(r+=s[u])}return r!==void 0?r:s}function c(s,r){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,m.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=c;function f(s,r){const u=r?E:b;let w="",{scheme:p,authority:P,path:A,query:a,fragment:R}=s;if(p&&(w+=p,w+=":"),(P||p==="file")&&(w+=I,w+=I),P){let F=P.indexOf("@");if(F!==-1){const U=P.substr(0,F);P=P.substr(F+1),F=U.indexOf(":"),F===-1?w+=u(U,!1):(w+=u(U.substr(0,F),!1),w+=":",w+=u(U.substr(F+1),!1)),w+="@"}P=P.toLowerCase(),F=P.indexOf(":"),F===-1?w+=u(P,!1):(w+=u(P.substr(0,F),!1),w+=P.substr(F))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const F=A.charCodeAt(1);F>=65&&F<=90&&(A=`/${String.fromCharCode(F+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const F=A.charCodeAt(0);F>=65&&F<=90&&(A=`${String.fromCharCode(F+32)}:${A.substr(2)}`)}w+=u(A,!0)}return a&&(w+="?",w+=u(a,!1)),R&&(w+="#",w+=r?R:b(R,!1)),w}function g(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,r=>g(r)):s}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[22],ye([0,1,2,8]),function(Z,e,m,T){"use strict";var S,y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,i,s){let r=t.get(i);return r===void 0&&(r=s,t.set(i,r)),r}e.getOrSet=D;function v(t){const i=[];return t.forEach((s,r)=>{i.push(`${r} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=v;function C(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?T.compareSubstring(i,this._value,0,i.length,this._from,this._to):T.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class o{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?T.compareSubstring(i,this._value,0,i.length,this._from,this._to):T.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class d{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return T.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(i){this._iter=i}static forUris(i=()=>!1){return new _(new d(i))}static forPaths(){return new _(new o)}static forStrings(){return new _(new n)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(i,s){const r=this._iter.reset(i);let u;for(this._root||(this._root=new l,this._root.segment=r.value()),u=this._root;;){const p=r.cmp(u.segment);if(p>0)u.left||(u.left=new l,u.left.segment=r.value()),u=u.left;else if(p<0)u.right||(u.right=new l,u.right.segment=r.value()),u=u.right;else if(r.hasNext())r.next(),u.mid||(u.mid=new l,u.mid.segment=r.value()),u=u.mid;else break}const w=u.value;return u.value=s,u.key=i,w}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let r=this._root;for(;r;){const u=s.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const r=this._iter.reset(i),u=[];let w=this._root;for(;w;){const p=r.cmp(w.segment);if(p>0)u.push([1,w]),w=w.left;else if(p<0)u.push([-1,w]),w=w.right;else if(r.hasNext())r.next(),u.push([0,w]),w=w.mid;else{for(s?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[P,A]=u.pop();switch(P){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}w=A}break}}}findSubstr(i){const s=this._iter.reset(i);let r=this._root,u;for(;r;){const w=s.cmp(r.segment);if(w>0)r=r.left;else if(w<0)r=r.right;else if(s.hasNext())s.next(),u=r.value||u,r=r.mid;else break}return r&&r.value||u}findSuperstr(i){const s=this._iter.reset(i);let r=this._root;for(;r;){const u=s.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(i){for(const[s,r]of this)i(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const r=s.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&s.push(r.left),r.mid&&s.push(r.mid),r.right&&s.push(r.right))}}}e.TernarySearchTree=_;class b{constructor(i,s){this[S]="ResourceMap",i instanceof b?(this.map=new Map(i.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=i??b.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[r,u]of this.map)i(u,m.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class c{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const r=this._map.get(i);if(!!r)return s!==0&&this.touch(r,s),r.value}set(i,s,r=0){let u=this._map.get(i);if(u)u.value=s,r!==0&&this.touch(u,r);else{switch(u={key:i,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const r=this._state;let u=this._head;for(;u;){if(s?i.bind(s)(u.value,u.key,this):i(u.value,u.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,s=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const w={value:r.key,done:!1};return r=r.next,w}else return{value:void 0,done:!0}}};return u}values(){const i=this,s=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const w={value:r.value,done:!1};return r=r.next,w}else return{value:void 0,done:!0}}};return u}entries(){const i=this,s=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const w={value:[r.key,r.value],done:!1};return r=r.next,w}else return{value:void 0,done:!0}}};return u}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>i;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,r=i.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const r=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(r.previous=u,u.next=r),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const r=i.next,u=i.previous;i===this._head?(r.previous=void 0,this._head=r):(r.previous=u,u.next=r),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,r)=>{i.push([r,s])}),i}fromJSON(i){this.clear();for(const[s,r]of i)this.set(s,r)}}e.LinkedMap=c;class f extends c{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class g{constructor(i){k.set(this,void 0),rt(this,k,i,"f")}get size(){return xe(this,k,"f").size}forEach(i,s){xe(this,k,"f").forEach(i,s)}get(i){return xe(this,k,"f").get(i)}has(i){return xe(this,k,"f").has(i)}entries(){return xe(this,k,"f").entries()}keys(){return xe(this,k,"f").keys()}values(){return xe(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return xe(this,k,"f").entries()}}e.ReadonlyMapView=g}),define(Ee[110],ye([0,1,22,8]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(se,he){for(let Re=0,Be=q.length;Re<Be;Re++){const ve=q[Re](se,he);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(q,se,he){if(!he||he.length<se.length)return null;let Re;return q?Re=T.startsWithIgnoreCase(he,se):Re=he.indexOf(se)===0,Re?se.length>0?[{start:0,end:se.length}]:[]:null}function k(q,se){const he=se.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=k;function D(q,se){return v(q.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=D;function v(q,se,he,Re){if(he===q.length)return[];if(Re===se.length)return null;if(q[he]===se[Re]){let Be=null;return(Be=v(q,se,he+1,Re+1))?b({start:Re,end:Re+1},Be):null}return v(q,se,he,Re+1)}function C(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function I(q){return 48<=q&&q<=57}function o(q){return q===32||q===9||q===10||q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>h.add(q.charCodeAt(0)));function d(q){return o(q)||h.has(q)}function l(q,se){return q===se||d(q)&&d(se)}function _(q){return C(q)||n(q)||I(q)}function b(q,se){return se.length===0?se=[q]:q.end===se[0].start?se[0].start=q.start:se.unshift(q),se}function E(q,se){for(let he=se;he<q.length;he++){const Re=q.charCodeAt(he);if(n(Re)||I(Re)||he>0&&!_(q.charCodeAt(he-1)))return he}return q.length}function c(q,se,he,Re){if(he===q.length)return[];if(Re===se.length)return null;if(q[he]!==se[Re].toLowerCase())return null;{let Be=null,ve=Re+1;for(Be=c(q,se,he+1,Re+1);!Be&&(ve=E(se,ve))<se.length;)Be=c(q,se,he+1,ve),ve++;return Be===null?null:b({start:Re,end:Re+1},Be)}}function f(q){let se=0,he=0,Re=0,Be=0,ve=0;for(let Fe=0;Fe<q.length;Fe++)ve=q.charCodeAt(Fe),n(ve)&&se++,C(ve)&&he++,_(ve)&&Re++,I(ve)&&Be++;const Ke=se/q.length,H=he/q.length,ee=Re/q.length,me=Be/q.length;return{upperPercent:Ke,lowerPercent:H,alphaPercent:ee,numericPercent:me}}function g(q){const{upperPercent:se,lowerPercent:he}=q;return he===0&&se>.6}function t(q){const{upperPercent:se,lowerPercent:he,alphaPercent:Re,numericPercent:Be}=q;return he>.2&&se<.8&&Re>.6&&Be<.2}function i(q){let se=0,he=0,Re=0,Be=0;for(let ve=0;ve<q.length;ve++)Re=q.charCodeAt(ve),n(Re)&&se++,C(Re)&&he++,o(Re)&&Be++;return(se===0||he===0)&&Be===0?q.length<=30:se<=5}function s(q,se){if(!se||(se=se.trim(),se.length===0)||!i(q)||se.length>60)return null;const he=f(se);if(!t(he)){if(!g(he))return null;se=se.toLowerCase()}let Re=null,Be=0;for(q=q.toLowerCase();Be<se.length&&(Re=c(q,se,0,Be))===null;)Be=E(se,Be+1);return Re}e.matchesCamelCase=s;function r(q,se,he=!1){if(!se||se.length===0)return null;let Re=null,Be=0;for(q=q.toLowerCase(),se=se.toLowerCase();Be<se.length&&(Re=u(q,se,0,Be,he))===null;)Be=w(se,Be+1);return Re}e.matchesWords=r;function u(q,se,he,Re,Be){if(he===q.length)return[];if(Re===se.length)return null;if(l(q.charCodeAt(he),se.charCodeAt(Re))){let ve=null,Ke=Re+1;if(ve=u(q,se,he+1,Re+1,Be),!Be)for(;!ve&&(Ke=w(se,Ke))<se.length;)ve=u(q,se,he+1,Ke,Be),Ke++;return ve===null?null:b({start:Re,end:Re+1},ve)}else return null}function w(q,se){for(let he=se;he<q.length;he++)if(d(q.charCodeAt(he))||he>0&&d(q.charCodeAt(he-1)))return he;return q.length}const p=S(e.matchesPrefix,s,k),P=S(e.matchesPrefix,s,D),A=new m.LRUCache(1e4);function a(q,se,he=!1){if(typeof q!="string"||typeof se!="string")return null;let Re=A.get(q);Re||(Re=new RegExp(T.convertSimple2RegExpPattern(q),"i"),A.set(q,Re));const Be=Re.exec(se);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?P(q,se):p(q,se)}e.matchesFuzzy=a;function R(q,se){const he=nt(q,q.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?U(he):null}e.matchesFuzzy2=R;function F(q,se,he,Re,Be,ve){const Ke=Math.min(13,q.length);for(;he<Ke;he++){const H=nt(q,se,he,Re,Be,ve,!1);if(H)return H}return[0,ve]}e.anyScore=F;function U(q){if(typeof q=="undefined")return[];const se=[],he=q[1];for(let Re=q.length-1;Re>1;Re--){const Be=q[Re]+he,ve=se[se.length-1];ve&&ve.end===Be?ve.end=Be+1:se.push({start:Be,end:Be+1})}return se}e.createMatches=U;const X=128;function oe(){const q=[],se=[];for(let he=0;he<=X;he++)se[he]=0;for(let he=0;he<=X;he++)q.push(se.slice(0));return q}function j(q){const se=[];for(let he=0;he<=q;he++)se[he]=0;return se}const W=j(2*X),K=j(2*X),M=oe(),Y=oe(),x=oe(),O=!1;function Q(q,se,he,Re,Be){function ve(H,ee,me=" "){for(;H.length<ee;)H=me+H;return H}let Ke=` |   |${Re.split("").map(H=>ve(H,3)).join("|")}
`;for(let H=0;H<=he;H++)H===0?Ke+=" |":Ke+=`${se[H-1]}|`,Ke+=q[H].slice(0,Be+1).map(ee=>ve(ee.toString(),3)).join("|")+`
`;return Ke}function V(q,se,he,Re){q=q.substr(se),he=he.substr(Re),console.log(Q(Y,q,q.length,he,he.length)),console.log(Q(x,q,q.length,he,he.length)),console.log(Q(M,q,q.length,he,he.length))}function le(q,se){if(se<0||se>=q.length)return!1;const he=q.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(he)}}function be(q,se){if(se<0||se>=q.length)return!1;switch(q.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Te(q,se,he){return se[q]!==he[q]}function He(q,se,he,Re,Be,ve,Ke=!1){for(;se<he&&Be<ve;)q[se]===Re[Be]&&(Ke&&(W[se]=Be),se+=1),Be+=1;return se===he}e.isPatternInWord=He;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var qe;(function(q){q.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=se})(qe=e.FuzzyScore||(e.FuzzyScore={}));function nt(q,se,he,Re,Be,ve,Ke){const H=q.length>X?X:q.length,ee=Re.length>X?X:Re.length;if(he>=H||ve>=ee||H-he>ee-ve||!He(se,he,H,Be,ve,ee,!0))return;Je(H,ee,he,ve,se,Be);let me=1,Fe=1,Oe=he,Qe=ve;const Ce=[!1];for(me=1,Oe=he;Oe<H;me++,Oe++){const de=W[Oe],ge=K[Oe],$=Oe+1<H?K[Oe+1]:ee;for(Fe=de-ve+1,Qe=de;Qe<$;Fe++,Qe++){let fe=Number.MIN_SAFE_INTEGER,we=!1;Qe<=ge&&(fe=Xe(q,se,Oe,he,Re,Be,Qe,ee,ve,M[me-1][Fe-1]===0,Ce));let Pe=0;fe!==Number.MAX_SAFE_INTEGER&&(we=!0,Pe=fe+Y[me-1][Fe-1]);const Le=Qe>de,$e=Le?Y[me][Fe-1]+(M[me][Fe-1]>0?-5:0):0,We=Qe>de+1&&M[me][Fe-1]>0,Ye=We?Y[me][Fe-2]+(M[me][Fe-2]>0?-5:0):0;if(We&&(!Le||Ye>=$e)&&(!we||Ye>=Pe))Y[me][Fe]=Ye,x[me][Fe]=3,M[me][Fe]=0;else if(Le&&(!we||$e>=Pe))Y[me][Fe]=$e,x[me][Fe]=2,M[me][Fe]=0;else if(we)Y[me][Fe]=Pe,x[me][Fe]=1,M[me][Fe]=M[me-1][Fe-1]+1;else throw new Error("not possible")}}if(O&&V(q,he,Re,ve),!Ce[0]&&!Ke)return;me--,Fe--;const _e=[Y[me][Fe],ve];let Ie=0,ie=0;for(;me>=1;){let de=Fe;do{const ge=x[me][de];if(ge===3)de=de-2;else if(ge===2)de=de-1;else break}while(de>=1);Ie>1&&se[he+me-1]===Be[ve+Fe-1]&&!Te(de+ve-1,Re,Be)&&Ie+1>M[me][de]&&(de=Fe),de===Fe?Ie++:Ie=1,ie||(ie=de),me--,Fe=de-1,_e.push(Fe)}ee===H&&(_e[0]+=2);const ue=ie-H;return _e[0]-=ue,_e}e.fuzzyScore=nt;function Je(q,se,he,Re,Be,ve){let Ke=q-1,H=se-1;for(;Ke>=he&&H>=Re;)Be[Ke]===ve[H]&&(K[Ke]=H,Ke--),H--}function Xe(q,se,he,Re,Be,ve,Ke,H,ee,me,Fe){if(se[he]!==ve[Ke])return Number.MIN_SAFE_INTEGER;let Oe=1,Qe=!1;return Ke===he-Re?Oe=q[he]===Be[Ke]?7:5:Te(Ke,Be,ve)&&(Ke===0||!Te(Ke-1,Be,ve))?(Oe=q[he]===Be[Ke]?7:5,Qe=!0):le(ve,Ke)&&(Ke===0||!le(ve,Ke-1))?Oe=5:(le(ve,Ke-1)||be(ve,Ke-1))&&(Oe=5,Qe=!0),Oe>1&&he===Re&&(Fe[0]=!0),Qe||(Qe=Te(Ke,Be,ve)||le(ve,Ke-1)||be(ve,Ke-1)),he===Re?Ke>ee&&(Oe-=Qe?3:5):me?Oe+=Qe?2:0:Oe+=Qe?0:1,Ke+1===H&&(Oe-=Qe?3:5),Oe}function B(q,se,he,Re,Be,ve,Ke){return ne(q,se,he,Re,Be,ve,!0,Ke)}e.fuzzyScoreGracefulAggressive=B;function G(q,se,he,Re,Be,ve,Ke){return ne(q,se,he,Re,Be,ve,!1,Ke)}e.fuzzyScoreGraceful=G;function ne(q,se,he,Re,Be,ve,Ke,H){let ee=nt(q,se,he,Re,Be,ve,H);if(ee&&!Ke)return ee;if(q.length>=3){const me=Math.min(7,q.length-1);for(let Fe=he+1;Fe<me;Fe++){const Oe=re(q,Fe);if(Oe){const Qe=nt(Oe,Oe.toLowerCase(),he,Re,Be,ve,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function re(q,se){if(se+1>=q.length)return;const he=q[se],Re=q[se+1];if(he!==Re)return q.slice(0,se)+Re+he+q.slice(se+2)}}),define(Ee[111],ye([0,1,77,110,8]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${y.source}`,"g");function D(l){return l.replace(k,(_,b)=>b?_:`\\${_}`)}e.escapeIcons=D;const v=new RegExp(`\\\\${y.source}`,"g");function C(l){return l.replace(v,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(n,(_,b,E,c)=>E?_:b||c||"")}e.stripIcons=I;function o(l){const _=l.indexOf(e.iconStartMarker);return _===-1?{text:l}:h(l,_)}e.parseLabelWithIcons=o;function h(l,_){const b=[];let E="";function c(w){if(w){E+=w;for(const p of w)b.push(t)}}let f=-1,g="",t=0,i,s,r=_;const u=l.length;for(c(l.substr(0,_));r<u;)i=l[r],s=l[r+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=r,c(g),g=e.iconStartMarker,r++):i===")"&&f!==-1?(t+=r-f+1,f=-1,g=""):f!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(c(g),f=-1,g=""):c(i),r++;return c(g),{text:E,iconOffsets:b}}function d(l,_,b=!1){const{text:E,iconOffsets:c}=_;if(!c||c.length===0)return T.matchesFuzzy(l,E,b);const f=S.ltrim(E," "),g=E.length-f.length,t=T.matchesFuzzy(l,f,b);if(t)for(const i of t){const s=c[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=d}),define(Ee[79],ye([0,1,111,11]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",d=!1){var l,_;if(this.value=h,typeof this.value!="string")throw T.illegalArgument("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1):(this.isTrusted=(l=d.isTrusted)!==null&&l!==void 0?l:void 0,this.supportThemeIcons=(_=d.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(h,d=0){return this.value+=C(this.supportThemeIcons?m.escapeIcons(h):h).replace(/([ \t]+)/g,(l,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=y;function k(o){return D(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function D(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function v(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=v;function C(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(o){const h=[],d=o.split("|").map(_=>_.trim());o=d[0];const l=d[1];if(l){const _=/height=(\d+)/.exec(l),b=/width=(\d+)/.exec(l),E=_?_[1]:"",c=b?b[1]:"",f=isFinite(parseInt(c)),g=isFinite(parseInt(E));f&&h.push(`width="${c}"`),g&&h.push(`height="${E}"`)}return{href:o,dimensions:h}}e.parseHrefAndDimensions=I}),define(Ee[54],ye([0,1,23,8,2]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,v)}e.stringify=y;function k(n){let I=JSON.parse(n);return I=C(I),I}e.parse=k;var D;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function v(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:T.regExpFlags(I)}:I}function C(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let o=0;o<n.length;++o)n[o]=C(n[o],I+1);else for(const o in n)Object.hasOwnProperty.call(n,o)&&(n[o]=C(n[o],I+1))}return n}e.revive=C}),define(Ee[12],ye([0,1,2,21]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,C,n){this._hosts[v]=C,this._ports[v]=n}setConnectionToken(v,C){this._connectionTokens[v]=C}rewrite(v){if(this._delegate)return this._delegate(v);const C=v.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[C],o=this._connectionTokens[C];let h=`path=${encodeURIComponent(v.path)}`;return typeof o=="string"&&(h+=`&tkn=${encodeURIComponent(o)}`),m.URI.from({scheme:T.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new y;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(v,C,n){const I=this.toUri(v,C);if(I.scheme===S.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let o=!1;return T.isNative&&(n||T.isPreferringBrowserCodeLoad)&&I.scheme===S.file&&(o=!0),I.scheme===S.file&&typeof T.globals.importScripts=="function"&&T.globals.origin==="vscode-file://vscode-app"&&(o=!0),o?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(v,C){const n=this.toUri(v,C);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(v,C){return m.URI.isUri(v)?v:m.URI.parse(C.toUrl(v))}}e.FileAccess=new k}),define(Ee[25],ye([0,1,42,15,2,8,12,21]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(h){return S.uriToFsPath(h,!0)}e.originalFSPath=v;class C{constructor(d){this._ignorePathCasing=d}compare(d,l,_=!1){return d===l?0:y.compare(this.getComparisonKey(d,_),this.getComparisonKey(l,_))}isEqual(d,l,_=!1){return d===l?!0:!d||!l?!1:this.getComparisonKey(d,_)===this.getComparisonKey(l,_)}getComparisonKey(d,l=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,l,_=!1){if(d.scheme===l.scheme){if(d.scheme===k.Schemas.file)return m.isEqualOrParent(v(d),v(l),this._ignorePathCasing(d))&&d.query===l.query&&(_||d.fragment===l.fragment);if(e.isEqualAuthority(d.authority,l.authority))return m.isEqualOrParent(d.path,l.path,this._ignorePathCasing(d),"/")&&d.query===l.query&&(_||d.fragment===l.fragment)}return!1}joinPath(d,...l){return S.URI.joinPath(d,...l)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let l;return d.scheme===k.Schemas.file?l=S.URI.file(T.dirname(v(d))).path:(l=T.posix.dirname(d.path),d.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),l="/")),d.with({path:l})}normalizePath(d){if(!d.path.length)return d;let l;return d.scheme===k.Schemas.file?l=S.URI.file(T.normalize(v(d))).path:l=T.posix.normalize(d.path),d.with({path:l})}relativePath(d,l){if(d.scheme!==l.scheme||!e.isEqualAuthority(d.authority,l.authority))return;if(d.scheme===k.Schemas.file){const E=T.relative(v(d),v(l));return D.isWindows?m.toSlashes(E):E}let _=d.path||"/",b=l.path||"/";if(this._ignorePathCasing(d)){let E=0;for(const c=Math.min(_.length,b.length);E<c&&!(_.charCodeAt(E)!==b.charCodeAt(E)&&_.charAt(E).toLowerCase()!==b.charAt(E).toLowerCase());E++);_=b.substr(0,E)+_.substr(E)}return T.posix.relative(_,b)}resolvePath(d,l){if(d.scheme===k.Schemas.file){const _=S.URI.file(T.resolve(v(d),l));return d.with({authority:_.authority,path:_.path})}return l=m.toPosixPath(l),d.with({path:T.posix.resolve(d.path,l)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,l){return d===l||y.equalsIgnoreCase(d,l)}hasTrailingPathSeparator(d,l=T.sep){if(d.scheme===k.Schemas.file){const _=v(d);return _.length>m.getRoot(_).length&&_[_.length-1]===l}else{const _=d.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,l=T.sep){return e.hasTrailingPathSeparator(d,l)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,l=T.sep){let _=!1;if(d.scheme===k.Schemas.file){const b=v(d);_=b!==void 0&&b.length===m.getRoot(b).length&&b[b.length-1]===l}else{l="/";const b=d.path;_=b.length===1&&b.charCodeAt(b.length-1)===47}return!_&&!e.hasTrailingPathSeparator(d,l)?d.with({path:d.path+"/"}):d}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===k.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,d){const l=[];for(let _=0;_<h.length;_++){const b=d(h[_]);h.some((E,c)=>c===_?!1:e.isEqualOrParent(b,d(E)))||l.push(h[_])}return l}e.distinctParents=n;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(l){const _=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(c=>{const[f,g]=c.split(":");f&&g&&_.set(f,g)});const E=l.path.substring(0,l.path.indexOf(";"));return E&&_.set(h.META_DATA_MIME,E),_}h.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function o(h,d,l){if(d){let _=h.path;return _&&_[0]!==T.posix.sep&&(_=T.posix.sep+_),h.with({scheme:l,authority:d,path:_})}return h.with({scheme:l})}e.toLocalResource=o}),define(Ee[13],ye([0,1,18,11,3,7,51,25]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(x){return!!x&&typeof x.then=="function"}e.isThenable=v;function C(x){const O=new m.CancellationTokenSource,Q=x(O.token),V=new Promise((le,be)=>{O.token.onCancellationRequested(()=>{be(T.canceled())}),Promise.resolve(Q).then(Te=>{O.dispose(),le(Te)},Te=>{O.dispose(),be(Te)})});return new class{cancel(){O.cancel()}then(le,be){return V.then(le,be)}catch(le){return this.then(void 0,le)}finally(le){return V.finally(le)}}}e.createCancelablePromise=C;function n(x,O,Q){return Promise.race([x,new Promise(V=>O.onCancellationRequested(()=>V(Q)))])}e.raceCancellation=n;async function I(x){let O=-1;const Q=x.map((le,be)=>le.then(Te=>(O=be,Te))),V=await Promise.race(Q);return x.forEach((le,be)=>{be!==O&&le.cancel()}),V}e.raceCancellablePromises=I;function o(x,O,Q){let V;const le=setTimeout(()=>{V==null||V(void 0),Q==null||Q()},O);return Promise.race([x.finally(()=>clearTimeout(le)),new Promise(be=>V=be)])}e.raceTimeout=o;function h(x){return new Promise((O,Q)=>{const V=x();v(V)?V.then(O,Q):O(V)})}e.asPromise=h;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const Q=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(Q,Q).then(V)})}return new Promise((Q,V)=>{this.queuedPromise.then(Q,V)})}return this.activePromise=O(),new Promise((Q,V)=>{this.activePromise.then(le=>{this.activePromise=null,Q(le)},le=>{this.activePromise=null,V(le)})})}}e.Throttler=d;class l{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=l;class _{constructor(){this.promiseMap=new Map}queue(O,Q){var V;const be=((V=this.promiseMap.get(O))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(O)===be&&this.promiseMap.delete(O)});return this.promiseMap.set(O,be),be}}e.SequencerByKey=_;class b{constructor(O){this.defaultDelay=O,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,Q=this.defaultDelay){return this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,le)=>{this.doResolve=V,this.doReject=le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class E{constructor(O){this.delayer=new b(O),this.throttler=new d}trigger(O,Q){return this.delayer.trigger(()=>this.throttler.queue(O),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class c{constructor(){this._isOpen=!1,this._promise=new Promise((O,Q)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class f extends c{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function g(x,O){return O?new Promise((Q,V)=>{const le=setTimeout(Q,x);O.onCancellationRequested(()=>{clearTimeout(le),V(T.canceled())})}):C(Q=>g(x,Q))}e.timeout=g;function t(x,O=0){const Q=setTimeout(x,O);return y.toDisposable(()=>clearTimeout(Q))}e.disposableTimeout=t;function i(x){return x.then(void 0,O=>{})}e.ignoreErrors=i;function s(x){const O=[];let Q=0;const V=x.length;function le(){return Q<V?x[Q++]():null}function be(Te){Te!=null&&O.push(Te);const He=le();return He?He.then(be):Promise.resolve(O)}return Promise.resolve(null).then(be)}e.sequence=s;function r(x,O=V=>!!V,Q=null){let V=0;const le=x.length,be=()=>{if(V>=le)return Promise.resolve(Q);const Te=x[V++];return Promise.resolve(Te()).then(Me=>O(Me)?Promise.resolve(Me):be())};return be()}e.first=r;function u(x,O=V=>!!V,Q=null){if(x.length===0)return Promise.resolve(Q);let V=x.length;const le=()=>{var be,Te;V=-1;for(const He of x)(Te=(be=He).cancel)===null||Te===void 0||Te.call(be)};return new Promise((be,Te)=>{for(const He of x)He.then(Me=>{--V>=0&&O(Me)?(le(),be(Me)):V===0&&be(Q)}).catch(Me=>{--V>=0&&(le(),Te(Me))})})}e.firstParallel=u;class w{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise((Q,V)=>{this.outstandingPromises.push({factory:O,c:Q,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const Q=O.factory();Q.then(O.c,O.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class p extends w{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map}queueFor(O,Q=D.extUri){const V=Q.getComparisonKey(O);let le=this.queues.get(V);return le||(le=new p,S.Event.once(le.onFinished)(()=>{le==null||le.dispose(),this.queues.delete(V)}),this.queues.set(V,le)),le}dispose(){this.queues.forEach(O=>O.dispose()),this.queues.clear()}}e.ResourceQueue=P;class A{constructor(O,Q){this._token=-1,typeof O=="function"&&typeof Q=="number"&&this.setIfNotSet(O,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},Q)}setIfNotSet(O,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},Q))}}e.TimeoutTimer=A;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,Q){this.cancel(),this._token=setInterval(()=>{O()},Q)}}e.IntervalTimer=a;class R{constructor(O,Q){this.timeoutToken=-1,this.runner=O,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(O,Q){super(O,Q);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class U extends y.Disposable{constructor(O,Q,V,le){super();this.maxWorkChunkSize=O,this.maxPendingWork=Q,this.throttleDelay=V,this.handler=le,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.maxPendingWork)return!1}else if(this.pending+O.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=O=>{const Q=setTimeout(()=>O(x));let V=!1;return{dispose(){V||(V=!0,clearTimeout(Q))}}}}else e.runWhenIdle=(x,O)=>{const Q=requestIdleCallback(x,typeof O=="number"?{timeout:O}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(Q))}}}}();class X{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=X;async function oe(x,O,Q){let V;for(let le=0;le<Q;le++)try{return await x()}catch(be){V=be,await g(O)}throw V}e.retry=oe;class j{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var O;(O=this._pending)===null||O===void 0||O.cancel()}setPending(O,Q,V){return this._pending={taskId:O,cancel:()=>V==null?void 0:V(),promise:Q},Q.then(()=>this.donePending(O),()=>this.donePending(O)),Q}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let Q,V;const le=new Promise((be,Te)=>{Q=be,V=Te});this._next={run:O,promise:le,promiseResolve:Q,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class W{constructor(O){this.interval=O,this.lastIncrementTime=0,this.value=0}increment(){const O=Date.now();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,Q)=>{this.completeCallback=O,this.errorCallback=Q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(Q=>{this.completeCallback(O),this.resolved=!0,Q()})}error(O){return new Promise(Q=>{this.errorCallback(O),this.rejected=!0,Q()})}cancel(){new Promise(O=>{this.errorCallback(T.canceled()),this.rejected=!0,O()})}}e.DeferredPromise=K;class M extends S.Emitter{async fireAsync(O,Q,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const le of this._listeners)this._asyncDeliveryQueue.push([le,O]);for(;this._asyncDeliveryQueue.size>0&&!Q.isCancellationRequested;){const[le,be]=this._asyncDeliveryQueue.shift(),Te=[],He=Object.assign(Object.assign({},be),{waitUntil:Me=>{if(Object.isFrozen(Te))throw new Error("waitUntil can NOT be called asynchronous");V&&(Me=V(Me,typeof le=="function"?le:le[0])),Te.push(Me)}});try{typeof le=="function"?le.call(void 0,He):le[0].call(le[1],He)}catch(Me){T.onUnexpectedError(Me);continue}Object.freeze(Te),await Y.settled(Te).catch(Me=>T.onUnexpectedError(Me))}}}}e.AsyncEmitter=M;var Y;(function(x){async function O(Q){let V;const le=await Promise.all(Q.map(be=>be.then(Te=>Te,Te=>{V||(V=Te)})));if(typeof V!="undefined")throw V;return le}x.settled=O})(Y=e.Promises||(e.Promises={}))}),define(Ee[112],ye([0,1,15,13]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new T.IdleValue(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),y=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(A,a,R=!1){const F=A||"",U=a||"",X=S.value.collator.compare(F,U);return S.value.collatorIsNumeric&&X===0&&F!==U?F<U?-1:1:X}e.compareFileNames=D;function v(A,a){const R=y.value.collator;return A=A||"",a=a||"",g(R,A,a)}e.compareFileNamesDefault=v;function C(A,a){const R=y.value.collator;return A=A||"",a=a||"",r(A,a)||g(R,A,a)}e.compareFileNamesUpper=C;function n(A,a){const R=y.value.collator;return A=A||"",a=a||"",s(A,a)||g(R,A,a)}e.compareFileNamesLower=n;function I(A,a){return A=A||"",a=a||"",A===a?0:A<a?-1:1}e.compareFileNamesUnicode=I;function o(A,a,R=!1){R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase());const[F,U]=c(A),[X,oe]=c(a);return F!==X?F<X?-1:1:U===oe?0:U<oe?-1:1}e.noIntlCompareFileNames=o;function h(A,a){const[R,F]=c(A),[U,X]=c(a);let oe=S.value.collator.compare(F,X);if(oe===0){if(S.value.collatorIsNumeric&&F!==X)return F<X?-1:1;if(oe=S.value.collator.compare(R,U),S.value.collatorIsNumeric&&oe===0&&R!==U)return R<U?-1:1}return oe}e.compareFileExtensions=h;function d(A,a){A=A||"",a=a||"";const R=f(A),F=f(a),U=y.value.collator,X=k.value.collator;return g(X,R,F)||g(U,A,a)}e.compareFileExtensionsDefault=d;function l(A,a){A=A||"",a=a||"";const R=f(A),F=f(a),U=y.value.collator,X=k.value.collator;return g(X,R,F)||r(A,a)||g(U,A,a)}e.compareFileExtensionsUpper=l;function _(A,a){A=A||"",a=a||"";const R=f(A),F=f(a),U=y.value.collator,X=k.value.collator;return g(X,R,F)||s(A,a)||g(U,A,a)}e.compareFileExtensionsLower=_;function b(A,a){A=A||"",a=a||"";const R=f(A).toLowerCase(),F=f(a).toLowerCase();return R!==F?R<F?-1:1:A!==a?A<a?-1:1:0}e.compareFileExtensionsUnicode=b;const E=/^(.*?)(\.([^.]*))?$/;function c(A,a=!1){const R=A?E.exec(A):[];let F=[R&&R[1]||"",R&&R[3]||""];return a&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function f(A){const a=A?E.exec(A):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(A,a,R){let F=A.compare(a,R);return F!==0?F:a.length!==R.length?a.length<R.length?-1:1:0}function t(A){const a=A.charAt(0);return a.toLocaleUpperCase()!==a}function i(A){const a=A.charAt(0);return a.toLocaleLowerCase()!==a}function s(A,a){return t(A)&&i(a)?-1:i(A)&&t(a)?1:0}function r(A,a){return i(A)&&t(a)?-1:t(A)&&i(a)?1:0}function u(A,a,R=!1){return R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase()),A===a?0:A<a?-1:1}function w(A,a,R=!1){const F=A.split(m.sep),U=a.split(m.sep),X=F.length-1,oe=U.length-1;let j,W;for(let K=0;;K++){if(j=X===K,W=oe===K,j&&W)return D(F[K],U[K],R);if(j)return-1;if(W)return 1;const M=u(F[K],U[K],R);if(M!==0)return M}}e.comparePaths=w;function p(A,a,R){const F=A.toLowerCase(),U=a.toLowerCase(),X=P(A,a,R);if(X)return X;const oe=F.endsWith(R),j=U.endsWith(R);if(oe!==j)return oe?-1:1;const W=D(F,U);return W!==0?W:F.localeCompare(U)}e.compareAnything=p;function P(A,a,R){const F=A.toLowerCase(),U=a.toLowerCase(),X=F.startsWith(R),oe=U.startsWith(R);if(X!==oe)return X?-1:1;if(X&&oe){if(F.length<U.length)return-1;if(F.length>U.length)return 1}return 0}e.compareByPrefix=P}),define(Ee[27],ye([0,1,8,42,15,22,13]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const v="**",C="/",n="[/\\\\]",I="[^/\\\\]",o=/\//g;function h(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function d(O,Q){if(!O)return[];const V=[];let le=!1,be=!1,Te="";for(const He of O){switch(He){case Q:if(!le&&!be){V.push(Te),Te="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":be=!0;break;case"]":be=!1;break}Te+=He}return Te&&V.push(Te),V}e.splitGlobAware=d;function l(O){if(!O)return"";let Q="";const V=d(O,C);if(V.every(le=>le===v))Q=".*";else{let le=!1;V.forEach((be,Te)=>{if(be===v){le||(Q+=h(2),le=!0);return}let He=!1,Me="",qe=!1,nt="";for(const Je of be){if(Je!=="}"&&He){Me+=Je;continue}if(qe&&(Je!=="]"||!nt)){let Xe;Je==="-"?Xe=Je:(Je==="^"||Je==="!")&&!nt?Xe="^":Je===C?Xe="":Xe=m.escapeRegExpCharacters(Je),nt+=Xe;continue}switch(Je){case"{":He=!0;continue;case"[":qe=!0;continue;case"}":Q+=`(?:${d(Me,",").map(G=>l(G)).join("|")})`,He=!1,Me="";break;case"]":Q+="["+nt+"]",qe=!1,nt="";break;case"?":Q+=I;continue;case"*":Q+=h(1);continue;default:Q+=m.escapeRegExpCharacters(Je)}}Te<V.length-1&&(V[Te+1]!==v||Te+2<V.length)&&(Q+=n),le=!1})}return Q}const _=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function r(O,Q){if(!O)return s;let V;typeof O!="string"?V=O.pattern:V=O,V=V.trim();const le=`${V}_${!!Q.trimForExclusions}`;let be=t.get(le);if(be)return u(be,O);let Te;if(_.test(V)){const He=V.substr(4);be=function(Me,qe){return typeof Me=="string"&&Me.endsWith(He)?V:null}}else(Te=b.exec(w(V,Q)))?be=p(Te[1],V):(Q.trimForExclusions?c:E).test(V)?be=P(V,Q):(Te=f.exec(w(V,Q)))?be=A(Te[1].substr(1),V,!0):(Te=g.exec(w(V,Q)))?be=A(Te[1],V,!1):be=a(V);return t.set(le,be),u(be,O)}function u(O,Q){return typeof Q=="string"?O:function(V,le){return T.isEqualOrParent(V,Q.base)?O(S.relative(Q.base,V),le):null}}function w(O,Q){return Q.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function p(O,Q){const V=`/${O}`,le=`\\${O}`,be=function(He,Me){return typeof He!="string"?null:Me?Me===O?Q:null:He===O||He.endsWith(V)||He.endsWith(le)?Q:null},Te=[O];return be.basenames=Te,be.patterns=[Q],be.allBasenames=Te,be}function P(O,Q){const V=x(O.slice(1,-1).split(",").map(Me=>r(Me,Q)).filter(Me=>Me!==s),O),le=V.length;if(!le)return s;if(le===1)return V[0];const be=function(Me,qe){for(let nt=0,Je=V.length;nt<Je;nt++)if(V[nt](Me,qe))return O;return null},Te=V.find(Me=>!!Me.allBasenames);Te&&(be.allBasenames=Te.allBasenames);const He=V.reduce((Me,qe)=>qe.allPaths?Me.concat(qe.allPaths):Me,[]);return He.length&&(be.allPaths=He),be}function A(O,Q,V){const le=S.sep===S.posix.sep,be=le?O:O.replace(o,S.sep),Te=S.sep+be,He=S.posix.sep+O,Me=V?function(qe,nt){return typeof qe=="string"&&(qe===be||qe.endsWith(Te)||!le&&(qe===O||qe.endsWith(He)))?Q:null}:function(qe,nt){return typeof qe=="string"&&(qe===be||!le&&qe===O)?Q:null};return Me.allPaths=[(V?"*/":"./")+O],Me}function a(O){try{const Q=new RegExp(`^${l(O)}$`);return function(V){return Q.lastIndex=0,typeof V=="string"&&Q.test(V)?O:null}}catch(Q){return s}}function R(O,Q,V){return!O||typeof Q!="string"?!1:F(O)(Q,void 0,V)}e.match=R;function F(O,Q={}){if(!O)return i;if(typeof O=="string"||j(O)){const V=r(O,Q);if(V===s)return i;const le=function(be,Te){return!!V(be,Te)};return V.allBasenames&&(le.allBasenames=V.allBasenames),V.allPaths&&(le.allPaths=V.allPaths),le}return M(O,Q)}e.parse=F;function U(O){if(!O)return;let Q;return V=>(Q||(Q=(O()||Promise.resolve([])).then(le=>le?oe(le):{})),Q.then(le=>!!le[V]))}e.hasSiblingPromiseFn=U;function X(O){if(!O)return;let Q;return V=>{if(!Q){const le=O();Q=le?oe(le):{}}return!!Q[V]}}e.hasSiblingFn=X;function oe(O){const Q={};for(const V of O)Q[V]=!0;return Q}function j(O){const Q=O;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=j;function W(O){return O.allBasenames||[]}e.getBasenameTerms=W;function K(O){return O.allPaths||[]}e.getPathTerms=K;function M(O,Q){const V=x(Object.getOwnPropertyNames(O).map(Me=>Y(Me,O[Me],Q)).filter(Me=>Me!==s)),le=V.length;if(!le)return s;if(!V.some(Me=>!!Me.requiresSiblings)){if(le===1)return V[0];const Me=function(Je,Xe){for(let B=0,G=V.length;B<G;B++){const ne=V[B](Je,Xe);if(ne)return ne}return null},qe=V.find(Je=>!!Je.allBasenames);qe&&(Me.allBasenames=qe.allBasenames);const nt=V.reduce((Je,Xe)=>Xe.allPaths?Je.concat(Xe.allPaths):Je,[]);return nt.length&&(Me.allPaths=nt),Me}const be=function(Me,qe,nt){let Je;for(let Xe=0,B=V.length;Xe<B;Xe++){const G=V[Xe];G.requiresSiblings&&nt&&(qe||(qe=S.basename(Me)),Je||(Je=qe.substr(0,qe.length-S.extname(Me).length)));const ne=G(Me,qe,Je,nt);if(ne)return ne}return null},Te=V.find(Me=>!!Me.allBasenames);Te&&(be.allBasenames=Te.allBasenames);const He=V.reduce((Me,qe)=>qe.allPaths?Me.concat(qe.allPaths):Me,[]);return He.length&&(be.allPaths=He),be}function Y(O,Q,V){if(Q===!1)return s;const le=r(O,V);if(le===s)return s;if(typeof Q=="boolean")return le;if(Q){const be=Q.when;if(typeof be=="string"){const Te=(He,Me,qe,nt)=>{if(!nt||!le(He,Me))return null;const Je=be.replace("$(basename)",qe),Xe=nt(Je);return k.isThenable(Xe)?Xe.then(B=>B?O:null):Xe?O:null};return Te.requiresSiblings=!0,Te}}return le}function x(O,Q){const V=O.filter(Me=>!!Me.basenames);if(V.length<2)return O;const le=V.reduce((Me,qe)=>{const nt=qe.basenames;return nt?Me.concat(nt):Me},[]);let be;if(Q){be=[];for(let Me=0,qe=le.length;Me<qe;Me++)be.push(Q)}else be=V.reduce((Me,qe)=>{const nt=qe.patterns;return nt?Me.concat(nt):Me},[]);const Te=function(Me,qe){if(typeof Me!="string")return null;if(!qe){let Je;for(Je=Me.length;Je>0;Je--){const Xe=Me.charCodeAt(Je-1);if(Xe===47||Xe===92)break}qe=Me.substr(Je)}const nt=le.indexOf(qe);return nt!==-1?be[nt]:null};Te.basenames=le,Te.patterns=be,Te.allBasenames=le;const He=O.filter(Me=>!Me.basenames);return He.push(Te),He}}),define(Ee[80],ye([0,1,2,15,8,12,21,25,42]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,u,w){if(typeof r=="string"&&(r=m.URI.file(r)),w){const P=w.getWorkspaceFolder(r);if(P){const A=w.getWorkspace().folders.length>1;let a;if(D.isEqual(P.uri,r)?a="":a=D.relativePath(P.uri,r),A){const R=P.name?P.name:D.basename(P.uri);a=a?R+" \u2022 "+a:R}return a}}if(r.scheme!==y.Schemas.file&&r.scheme!==y.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if(v.hasDriveLetter(r.fsPath))return T.normalize(I(r.fsPath));let p=T.normalize(r.fsPath);return!k.isWindows&&(u==null?void 0:u.userHome)&&(p=h(p,u.userHome.fsPath)),p}e.getPathLabel=C;function n(r){if(!r)return;typeof r=="string"&&(r=m.URI.file(r));const u=D.basename(r)||(r.scheme===y.Schemas.file?r.fsPath:r.path);return k.isWindows&&v.isRootOrDriveLetter(u)?I(u):u}e.getBaseLabel=n;function I(r){return v.hasDriveLetter(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let o=Object.create(null);function h(r,u){if(k.isWindows||!r||!u)return r;let w=o.original===u?o.normalized:void 0;return w||(w=`${S.rtrim(u,T.posix.sep)}${T.posix.sep}`,o={original:u,normalized:w}),(k.isLinux?r.startsWith(w):S.startsWithIgnoreCase(r,w))&&(r=`~/${r.substr(w.length)}`),r}e.tildify=h;function d(r,u){return r.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=d;const l="\u2026",_="\\\\",b="~";function E(r,u=T.sep){const w=new Array(r.length);let p=!1;for(let P=0;P<r.length;P++){let A=r[P];if(A===""){w[P]=`.${u}`;continue}if(!A){w[P]=A;continue}p=!0;let a="";A.indexOf(_)===0?(a=A.substr(0,A.indexOf(_)+_.length),A=A.substr(A.indexOf(_)+_.length)):A.indexOf(u)===0?(a=A.substr(0,A.indexOf(u)+u.length),A=A.substr(A.indexOf(u)+u.length)):A.indexOf(b)===0&&(a=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const R=A.split(u);for(let F=1;p&&F<=R.length;F++)for(let U=R.length-F;p&&U>=0;U--){p=!1;let X=R.slice(U,U+F).join(u);for(let oe=0;!p&&oe<r.length;oe++)if(oe!==P&&r[oe]&&r[oe].indexOf(X)>-1){const j=U+F===R.length,W=U>0&&r[oe].indexOf(u)>-1?u+X:X,K=r[oe].endsWith(W);p=!j||K}if(!p){let oe="";(R[0].endsWith(":")||a!=="")&&(U===1&&(U=0,F++,X=R[0]+u+X),U>0&&(oe=R[0]+u),oe=a+oe),U>0&&(oe=oe+l+u),oe=oe+X,U+F<R.length&&(oe=oe+u+l),w[P]=oe}}p&&(w[P]=A)}return w}e.shorten=E;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function f(r,u=Object.create(null)){const w=[];let p=!1,P="";for(const A of r)if(A==="$"||p&&A==="{")P&&w.push({value:P,type:c.TEXT}),P="",p=!0;else if(A==="}"&&p){const a=u[P];if(typeof a=="string")a.length&&w.push({value:a,type:c.VARIABLE});else if(a){const R=w[w.length-1];(!R||R.type!==c.SEPARATOR)&&w.push({value:a.label,type:c.SEPARATOR})}P="",p=!1}else P+=A;return P&&!p&&w.push({value:P,type:c.TEXT}),w.filter((A,a)=>{if(A.type===c.SEPARATOR){const R=w[a-1],F=w[a+1];return[R,F].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=f;function g(r,u){return k.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(r,u){return k.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,w=>w==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(r){const u=r.indexOf("/")!==-1?T.posix:T.win32,w=u.basename(r),p=u.dirname(r);return w.length?{name:w,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(Ee[81],ye([0,1,15,8,27,12,25]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let v=[],C=[],n=[];function I(i,s=!1){const r=o(i);v.push(r),r.userConfigured?n.push(r):C.push(r),s&&!r.userConfigured&&v.forEach(u=>{u.mime===r.mime||u.userConfigured||(r.extension&&u.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&u.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&u.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&u.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=I;function o(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(m.posix.sep)>=0:!1}}function h(i){i?(v=v.filter(s=>!s.userConfigured),n=[]):(v=[],C=[],n=[])}e.clearTextMimes=h;function d(i,s){let r;if(i)switch(i.scheme){case y.Schemas.file:r=i.fsPath;break;case y.Schemas.data:r=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:r=i.path}if(!r)return[D.unknown];r=r.toLowerCase();const u=m.basename(r),w=l(r,u,n);if(w)return[w,D.text];const p=l(r,u,C);if(p)return[p,D.text];if(s){const P=_(s);if(P)return[P,D.text]}return[D.unknown]}e.guessMimeTypes=d;function l(i,s,r){let u=null,w=null,p=null;for(let P=r.length-1;P>=0;P--){const A=r[P];if(s===A.filenameLowercase){u=A;break}if(A.filepattern&&(!w||A.filepattern.length>w.filepattern.length)){const a=A.filepatternOnPath?i:s;S.match(A.filepatternLowercase,a)&&(w=A)}A.extension&&(!p||A.extension.length>p.extension.length)&&s.endsWith(A.extensionLowercase)&&(p=A)}return u?u.mime:w?w.mime:p?p.mime:null}function _(i){if(T.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=v.length-1;s>=0;s--){const r=v[s];if(!r.firstline)continue;const u=i.match(r.firstline);if(u&&u.length>0)return r.mime}return null}function b(i){return i?typeof i=="string"?i===D.binary||i===D.text||i===D.unknown:i.length===1&&b(i[0]):!0}e.isUnspecific=b;const E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(i){const s=m.extname(i);return E[s.toLowerCase()]}e.getMediaMime=c;function f(i){for(const s in E)if(E[s]===i)return s}e.getExtensionForMimeType=f;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var r;const u=g.exec(i);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${(r=u[3])!==null&&r!==void 0?r:""}`:s?void 0:i}e.normalizeMimeType=t}),define(Ee[113],ye([0,1,2]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const o=this._uriTransformer.transformIncoming(I);return o===I?I:T(m.URI.from(o))}transformOutgoing(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:T(m.URI.from(o))}transformOutgoingURI(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:m.URI.from(o)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,I,o){if(!n||o>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return I.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const d=y(n[h],I,o+1);d!==null&&(n[h]=d)}}return null}function k(n,I){const o=y(n,I,0);return o===null?n:o}e.transformOutgoingURIs=k;function D(n,I,o,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return o?m.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const l=D(n[d],I,o,h+1);l!==null&&(n[d]=l)}}return null}function v(n,I){const o=D(n,I,!1,0);return o===null?n:o}e.transformIncomingURIs=v;function C(n,I){const o=D(n,I,!0,0);return o===null?n:o}e.transformAndReviveIncomingURIs=C}),define(Ee[34],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(v){return m.test(v)}e.isUUID=T;const S=new Uint8Array(16),y=[];for(let v=0;v<256;v++)y.push(v.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(v){for(let C=0;C<v.length;C++)v[C]=Math.floor(Math.random()*256);return v};function D(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let v=0,C="";return C+=y[S[v++]],C+=y[S[v++]],C+=y[S[v++]],C+=y[S[v++]],C+="-",C+=y[S[v++]],C+=y[S[v++]],C+="-",C+=y[S[v++]],C+=y[S[v++]],C+="-",C+=y[S[v++]],C+=y[S[v++]],C+="-",C+=y[S[v++]],C+=y[S[v++]],C+=y[S[v++]],C+=y[S[v++]],C+=y[S[v++]],C+=y[S[v++]],C}e.generateUuid=D}),define(Ee[82],ye([0,1,78]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(D){let v=m.toUint8(D);this._defaultValue=v,this._asciiMap=T._createAsciiMap(v),this._map=new Map}static _createAsciiMap(D){let v=new Uint8Array(256);for(let C=0;C<256;C++)v[C]=D;return v}set(D,v){let C=m.toUint8(v);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=T;var S;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(S||(S={}));class y{constructor(){this._actual=new T(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=y}),define(Ee[114],ye([0,1,82]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends m.CharacterClassifier{constructor(D){super(0);for(let v=0,C=D.length;v<C;v++)this.set(D.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function y(k){let D={};return v=>(D.hasOwnProperty(v)||(D[v]=k(v)),D[v])}e.getMapForWordSeparators=y(k=>new S(k))}),define(Ee[35],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(S,y){this.lineNumber=S,this.column=y}with(S=this.lineNumber,y=this.column){return S===this.lineNumber&&y===this.column?this:new m(S,y)}delta(S=0,y=0){return this.with(this.lineNumber+S,this.column+y)}equals(S){return m.equals(this,S)}static equals(S,y){return!S&&!y?!0:!!S&&!!y&&S.lineNumber===y.lineNumber&&S.column===y.column}isBefore(S){return m.isBefore(this,S)}static isBefore(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<y.column}isBeforeOrEqual(S){return m.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,y){return S.lineNumber<y.lineNumber?!0:y.lineNumber<S.lineNumber?!1:S.column<=y.column}static compare(S,y){let k=S.lineNumber|0,D=y.lineNumber|0;if(k===D){let v=S.column|0,C=y.column|0;return v-C}return k-D}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new m(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=m}),define(Ee[30],ye([0,1,35]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(y,k,D,v){y>D||y===D&&k>v?(this.startLineNumber=D,this.startColumn=v,this.endLineNumber=y,this.endColumn=k):(this.startLineNumber=y,this.startColumn=k,this.endLineNumber=D,this.endColumn=v)}isEmpty(){return T.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return T.containsPosition(this,y)}static containsPosition(y,k){return!(k.lineNumber<y.startLineNumber||k.lineNumber>y.endLineNumber||k.lineNumber===y.startLineNumber&&k.column<y.startColumn||k.lineNumber===y.endLineNumber&&k.column>y.endColumn)}containsRange(y){return T.containsRange(this,y)}static containsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>y.endColumn)}strictContainsRange(y){return T.strictContainsRange(this,y)}static strictContainsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<=y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>=y.endColumn)}plusRange(y){return T.plusRange(this,y)}static plusRange(y,k){let D,v,C,n;return k.startLineNumber<y.startLineNumber?(D=k.startLineNumber,v=k.startColumn):k.startLineNumber===y.startLineNumber?(D=k.startLineNumber,v=Math.min(k.startColumn,y.startColumn)):(D=y.startLineNumber,v=y.startColumn),k.endLineNumber>y.endLineNumber?(C=k.endLineNumber,n=k.endColumn):k.endLineNumber===y.endLineNumber?(C=k.endLineNumber,n=Math.max(k.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new T(D,v,C,n)}intersectRanges(y){return T.intersectRanges(this,y)}static intersectRanges(y,k){let D=y.startLineNumber,v=y.startColumn,C=y.endLineNumber,n=y.endColumn,I=k.startLineNumber,o=k.startColumn,h=k.endLineNumber,d=k.endColumn;return D<I?(D=I,v=o):D===I&&(v=Math.max(v,o)),C>h?(C=h,n=d):C===h&&(n=Math.min(n,d)),D>C||D===C&&v>n?null:new T(D,v,C,n)}equalsRange(y){return T.equalsRange(this,y)}static equalsRange(y,k){return!!y&&!!k&&y.startLineNumber===k.startLineNumber&&y.startColumn===k.startColumn&&y.endLineNumber===k.endLineNumber&&y.endColumn===k.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(y){return new m.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(y){return new m.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,k){return new T(this.startLineNumber,this.startColumn,y,k)}setStartPosition(y,k){return new T(y,k,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(y){return new T(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,k=y){return new T(y.lineNumber,y.column,k.lineNumber,k.column)}static lift(y){return y?new T(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<y.startColumn)}static areIntersecting(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<=k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,k){if(y&&k){const C=y.startLineNumber|0,n=k.startLineNumber|0;if(C===n){const I=y.startColumn|0,o=k.startColumn|0;if(I===o){const h=y.endLineNumber|0,d=k.endLineNumber|0;if(h===d){const l=y.endColumn|0,_=k.endColumn|0;return l-_}return h-d}return I-o}return C-n}return(y?1:0)-(k?1:0)}static compareRangesUsingEnds(y,k){return y.endLineNumber===k.endLineNumber?y.endColumn===k.endColumn?y.startLineNumber===k.startLineNumber?y.startColumn-k.startColumn:y.startLineNumber-k.startLineNumber:y.endColumn-k.endColumn:y.endLineNumber-k.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=T}),define(Ee[115],ye([0,1,35,30]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class y extends T.Range{constructor(D,v,C,n){super(D,v,C,n);this.selectionStartLineNumber=D,this.selectionStartColumn=v,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return y.selectionsEqual(this,D)}static selectionsEqual(D,v){return D.selectionStartLineNumber===v.selectionStartLineNumber&&D.selectionStartColumn===v.selectionStartColumn&&D.positionLineNumber===v.positionLineNumber&&D.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,v){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,D,v):new y(D,v,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,v){return this.getDirection()===0?new y(D,v,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,D,v)}static fromPositions(D,v=D){return new y(D.lineNumber,D.column,v.lineNumber,v.column)}static liftSelection(D){return new y(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,v){if(D&&!v||!D&&v)return!1;if(!D&&!v)return!0;if(D.length!==v.length)return!1;for(let C=0,n=D.length;C<n;C++)if(!this.selectionsEqual(D[C],v[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,v,C,n,I){return I===0?new y(D,v,C,n):new y(C,n,D,v)}}e.Selection=y}),define(Ee[83],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var m;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(m=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(l){this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace)}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class v{constructor(l,_){this.range=l,this.matches=_}}e.FindMatch=v;var C;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class o{constructor(l,_,b,E,c,f){this.identifier=l,this.range=_,this.text=b,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=c,this._isTracked=f}}e.ValidAnnotatedEditOperation=o;class h{constructor(l,_,b){this.reverseEdits=l,this.changes=_,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=h}),define(Ee[116],ye([0,1,8,114,35,30,83]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class v{constructor(c,f,g,t){this.searchString=c,this.isRegex=f,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=C(this.searchString):c=this.searchString.indexOf(`
`)>=0;let f=null;try{f=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let g=!this.isRegex&&!c;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new n(f,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=v;function C(E){if(!E||E.length===0)return!1;for(let c=0,f=E.length;c<f;c++)if(E.charCodeAt(c)===92){if(c++,c>=f)break;const t=E.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(c,f,g){this.regex=c,this.wordSeparators=f,this.simpleSearch=g}}e.SearchData=n;function I(E,c,f){if(!f)return new k.FindMatch(E,null);let g=[];for(let t=0,i=c.length;t<i;t++)g[t]=c[t];return new k.FindMatch(E,g)}e.createFindMatch=I;class o{constructor(c){let f=[],g=0;for(let t=0,i=c.length;t<i;t++)c.charCodeAt(t)===10&&(f[g++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(c){const f=this._lineFeedsOffsets;let g=0,t=f.length-1;if(t===-1||c<=f[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);f[i]>=c?t=i-1:f[i+1]>=c?(g=i,t=i):g=i+1}return g+1}}class h{static findMatches(c,f,g,t,i){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(c,g,new b(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(c,g,s,t,i):[]}static _getMultilineMatchRange(c,f,g,t,i,s){let r,u=0;t?(u=t.findLineFeedCountBeforeOffset(i),r=f+i+u):r=f+i;let w;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-u;w=r+s.length+a}else w=r+s.length;const p=c.getPositionAt(r),P=c.getPositionAt(w);return new y.Range(p.lineNumber,p.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(c,f,g,t,i){const s=c.getOffsetAt(f.getStartPosition()),r=c.getValueInRange(f,1),u=c.getEOL()===`\r
`?new o(r):null,w=[];let p=0,P;for(g.reset(0);P=g.next(r);)if(w[p++]=I(this._getMultilineMatchRange(c,s,r,u,P.index,P[0]),P,t),p>=i)return w;return w}static _doFindMatchesLineByLine(c,f,g,t,i){const s=[];let r=0;if(f.startLineNumber===f.endLineNumber){const w=c.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(g,w,f.startLineNumber,f.startColumn-1,r,s,t,i),s}const u=c.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(g,u,f.startLineNumber,f.startColumn-1,r,s,t,i);for(let w=f.startLineNumber+1;w<f.endLineNumber&&r<i;w++)r=this._findMatchesInLine(g,c.getLineContent(w),w,0,r,s,t,i);if(r<i){const w=c.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(g,w,f.endLineNumber,0,r,s,t,i)}return s}static _findMatchesInLine(c,f,g,t,i,s,r,u){const w=c.wordSeparators;if(!r&&c.simpleSearch){const A=c.simpleSearch,a=A.length,R=f.length;let F=-a;for(;(F=f.indexOf(A,F+a))!==-1;)if((!w||_(w,f,R,F,a))&&(s[i++]=new k.FindMatch(new y.Range(g,F+1+t,g,F+1+a+t),null),i>=u))return i;return i}const p=new b(c.wordSeparators,c.regex);let P;p.reset(0);do if(P=p.next(f),P&&(s[i++]=I(new y.Range(g,P.index+1+t,g,P.index+1+P[0].length+t),P,r),i>=u))return i;while(P);return i}static findNextMatch(c,f,g,t){const i=f.parseSearchRequest();if(!i)return null;const s=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(c,g,s,t):this._doFindNextMatchLineByLine(c,g,s,t)}static _doFindNextMatchMultiline(c,f,g,t){const i=new S.Position(f.lineNumber,1),s=c.getOffsetAt(i),r=c.getLineCount(),u=c.getValueInRange(new y.Range(i.lineNumber,i.column,r,c.getLineMaxColumn(r)),1),w=c.getEOL()===`\r
`?new o(u):null;g.reset(f.column-1);let p=g.next(u);return p?I(this._getMultilineMatchRange(c,s,u,w,p.index,p[0]),p,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(c,new S.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(c,f,g,t){const i=c.getLineCount(),s=f.lineNumber,r=c.getLineContent(s),u=this._findFirstMatchInLine(g,r,s,f.column,t);if(u)return u;for(let w=1;w<=i;w++){const p=(s+w-1)%i,P=c.getLineContent(p+1),A=this._findFirstMatchInLine(g,P,p+1,1,t);if(A)return A}return null}static _findFirstMatchInLine(c,f,g,t,i){c.reset(t-1);const s=c.next(f);return s?I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(c,f,g,t){const i=f.parseSearchRequest();if(!i)return null;const s=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(c,g,s,t):this._doFindPreviousMatchLineByLine(c,g,s,t)}static _doFindPreviousMatchMultiline(c,f,g,t){const i=this._doFindMatchesMultiline(c,new y.Range(1,1,f.lineNumber,f.column),g,t,10*D);if(i.length>0)return i[i.length-1];const s=c.getLineCount();return f.lineNumber!==s||f.column!==c.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(c,new S.Position(s,c.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(c,f,g,t){const i=c.getLineCount(),s=f.lineNumber,r=c.getLineContent(s).substring(0,f.column-1),u=this._findLastMatchInLine(g,r,s,t);if(u)return u;for(let w=1;w<=i;w++){const p=(i+s-w-1)%i,P=c.getLineContent(p+1),A=this._findLastMatchInLine(g,P,p+1,t);if(A)return A}return null}static _findLastMatchInLine(c,f,g,t){let i=null,s;for(c.reset(0);s=c.next(f);)i=I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=h;function d(E,c,f,g,t){if(g===0)return!0;const i=c.charCodeAt(g-1);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=c.charCodeAt(g);if(E.get(s)!==0)return!0}return!1}function l(E,c,f,g,t){if(g+t===f)return!0;const i=c.charCodeAt(g+t);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=c.charCodeAt(g+t-1);if(E.get(s)!==0)return!0}return!1}function _(E,c,f,g,t){return d(E,c,f,g,t)&&l(E,c,f,g,t)}e.isValidMatch=_;class b{constructor(c,f){this._wordSeparators=c,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const f=c.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(g=this._searchRegex.exec(c),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){m.getNextCodePoint(c,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||_(this._wordSeparators,c,f,t,i))return g}while(g);return null}}e.Searcher=b}),define(Ee[84],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(D=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(v+="\\"+C);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=m();function T(D){let v=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)v=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),v=new RegExp(D.source,C)}return v.lastIndex=0,v}e.ensureValidWordDefinition=T;const S={maxLen:1e3,windowSize:15,timeBudget:150};function y(D,v,C,n,I=S){if(C.length>I.maxLen){let _=D-I.maxLen/2;return _<0?_=0:n+=_,C=C.substring(_,D+I.maxLen/2),y(D,v,C,n,I)}const o=Date.now(),h=D-1-n;let d=-1,l=null;for(let _=1;!(Date.now()-o>=I.timeBudget);_++){const b=h-I.windowSize*_;v.lastIndex=Math.max(0,b);const E=k(v,C,h,d);if(!E&&l||(l=E,b<=0))break;d=b}if(l){let _={word:l[0],startColumn:n+1+l.index,endColumn:n+1+l.index+l[0].length};return v.lastIndex=0,_}return null}e.getWordAtText=y;function k(D,v,C,n){let I;for(;I=D.exec(v);){const o=I.index||0;if(o<=C&&D.lastIndex>=C)return I;if(n>0&&o>n)return null}return null}}),define(Ee[117],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class T{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let v=0,C=D.notIn.length;v<C;v++)switch(D.notIn[v]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=T;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const v of D)y(this.autoClosingPairsOpenByStart,v.open.charAt(0),v),y(this.autoClosingPairsOpenByEnd,v.open.charAt(v.open.length-1),v),y(this.autoClosingPairsCloseByStart,v.close.charAt(0),v),y(this.autoClosingPairsCloseByEnd,v.close.charAt(v.close.length-1),v),v.close.length===1&&v.open.length===1&&y(this.autoClosingPairsCloseSingleChar,v.close,v)}}e.AutoClosingPairs=S;function y(k,D,v){k.has(D)?k.get(D).push(v):k.set(D,[v])}}),define(Ee[55],ye([0,1,27,15]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(y,k,D,v){if(Array.isArray(y)){let C=0;for(const n of y){const I=S(n,k,D,v);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof y=="string")return v?y==="*"?5:y===D?10:0:0;if(y){const{language:C,pattern:n,scheme:I,hasAccessToAllModels:o}=y;if(!v&&!o)return 0;let h=0;if(I)if(I===k.scheme)h=10;else if(I==="*")h=5;else return 0;if(C)if(C===D)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(n){let d;if(typeof n=="string"?d=n:d=Object.assign(Object.assign({},n),{base:T.normalize(n.base)}),d===k.fsPath||m.match(d,k.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(Ee[118],ye([0,1,82]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class S{constructor(d,l,_){const b=new Uint8Array(d*l);for(let E=0,c=d*l;E<c;E++)b[E]=_;this._data=b,this.rows=d,this.cols=l}get(d,l){return this._data[d*this.cols+l]}set(d,l,_){this._data[d*this.cols+l]=_}}e.Uint8Matrix=S;class y{constructor(d){let l=0,_=0;for(let E=0,c=d.length;E<c;E++){let[f,g,t]=d[E];g>l&&(l=g),f>_&&(_=f),t>_&&(_=t)}l++,_++;let b=new S(_,l,0);for(let E=0,c=d.length;E<c;E++){let[f,g,t]=d[E];b.set(f,g,t)}this._states=b,this._maxCharCode=l}nextState(d,l){return l<0||l>=this._maxCharCode?0:this._states.get(d,l)}}e.StateMachine=y;let k=null;function D(){return k===null&&(k=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var v;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(v||(v={}));let C=null;function n(){if(C===null){C=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<h.length;l++)C.set(h.charCodeAt(l),1);const d=".,;";for(let l=0;l<d.length;l++)C.set(d.charCodeAt(l),2)}return C}class I{static _createLink(d,l,_,b,E){let c=E-1;do{const f=l.charCodeAt(c);if(d.get(f)!==2)break;c--}while(c>b);if(b>0){const f=l.charCodeAt(b-1),g=l.charCodeAt(c);(f===40&&g===41||f===91&&g===93||f===123&&g===125)&&c--}return{range:{startLineNumber:_,startColumn:b+1,endLineNumber:_,endColumn:c+2},url:l.substring(b,c+1)}}static computeLinks(d,l=D()){const _=n();let b=[];for(let E=1,c=d.getLineCount();E<=c;E++){const f=d.getLineContent(E),g=f.length;let t=0,i=0,s=0,r=1,u=!1,w=!1,p=!1,P=!1;for(;t<g;){let A=!1;const a=f.charCodeAt(t);if(r===13){let R;switch(a){case 40:u=!0,R=0;break;case 41:R=u?0:1;break;case 91:p=!0,w=!0,R=0;break;case 93:p=!1,R=w?0:1;break;case 123:P=!0,R=0;break;case 125:R=P?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=p?0:1;break;default:R=_.get(a)}R===1&&(b.push(I._createLink(_,f,E,i,t)),A=!0)}else if(r===12){let R;a===91?(w=!0,R=0):R=_.get(a),R===1?A=!0:r=13}else r=l.nextState(r,a),r===0&&(A=!0);A&&(r=1,u=!1,w=!1,P=!1,i=t+1,s=a),t++}r===13&&b.push(I._createLink(_,f,E,i,g))}return b}}e.LinkComputer=I;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:I.computeLinks(h)}e.computeLinks=o}),define(Ee[119],ye([0,1,3,7]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),T.toDisposable(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,D){let v=null,C=!1;return this._promises.set(k,D.then(n=>{this._promises.delete(k),!(C||!n)&&(v=this.register(k,n))})),T.toDisposable(()=>{C=!0,v&&v.dispose()})}getPromise(k){const D=this.get(k);if(D)return Promise.resolve(D);const v=this._promises.get(k);return v?v.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(Ee[85],ye([0,1,23,21]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function y(I){for(let o=0,h=I.length;o<h;o+=4){const d=I[o+0],l=I[o+1],_=I[o+2],b=I[o+3];I[o+0]=b,I[o+1]=_,I[o+2]=l,I[o+3]=d}}function k(I){const o=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||y(o),m.VSBuffer.wrap(o)}function D(I){const o=I.buffer;if(T.isLittleEndian()||y(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const h=new Uint8Array(o.byteLength);return h.set(o),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function v(I){const o=new Uint32Array(C(I));let h=0;if(o[h++]=I.id,I.type==="full")o[h++]=1,o[h++]=I.data.length,o.set(I.data,h),h+=I.data.length;else{o[h++]=2,o[h++]=I.deltas.length;for(const d of I.deltas)o[h++]=d.start,o[h++]=d.deleteCount,d.data?(o[h++]=d.data.length,o.set(d.data,h),h+=d.data.length):o[h++]=0}return k(o)}e.encodeSemanticTokensDto=v;function C(I){let o=0;if(o+=1+1,I.type==="full")o+=1+I.data.length;else{o+=1,o+=(1+1+1)*I.deltas.length;for(const h of I.deltas)h.data&&(o+=h.data.length)}return o}function n(I){const o=D(I);let h=0;const d=o[h++];if(o[h++]===1){const E=o[h++],c=o.subarray(h,h+E);return h+=E,{id:d,type:"full",data:c}}const _=o[h++];let b=[];for(let E=0;E<_;E++){const c=o[h++],f=o[h++],g=o[h++];let t;g>0&&(t=o.subarray(h,h+g),h+=g),b[E]={start:c,deleteCount:f,data:t}}return{id:d,type:"delta",deltas:b}}e.decodeSemanticTokensDto=n}),define(Ee[86],ye([0,1,78]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(k,D){this.index=k,this.remainder=D}}e.PrefixSumIndexOfResult=T;class S{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,D){k=m.toUint32(k);const v=this.values,C=this.prefixSum,n=D.length;return n===0?!1:(this.values=new Uint32Array(v.length+n),this.values.set(v.subarray(0,k),0),this.values.set(v.subarray(k),k+n),this.values.set(D,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,D){return k=m.toUint32(k),D=m.toUint32(D),this.values[k]===D?!1:(this.values[k]=D,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,D){k=m.toUint32(k),D=m.toUint32(D);const v=this.values,C=this.prefixSum;if(k>=v.length)return!1;let n=v.length-k;return D>=n&&(D=n),D===0?!1:(this.values=new Uint32Array(v.length-D),this.values.set(v.subarray(0,k),0),this.values.set(v.subarray(k+D),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=m.toUint32(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),k>=this.values.length&&(k=this.values.length-1);for(let v=D;v<=k;v++)this.prefixSum[v]=this.prefixSum[v-1]+this.values[v];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let D=0,v=this.values.length-1,C=0,n=0,I=0;for(;D<=v;)if(C=D+(v-D)/2|0,n=this.prefixSum[C],I=n-this.values[C],k<I)v=C-1;else if(k>=n)D=C+1;else break;return new T(C,k-I)}}e.PrefixSumComputer=S}),define(Ee[120],ye([0,1,8,35,86]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(D,v,C,n){this._uri=D,this._lines=v,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const v=D.changes;for(const C of v)this._acceptDeleteRange(C.range),this._acceptInsertText(new T.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,v=this._lines.length,C=new Uint32Array(v);for(let n=0;n<v;n++)C[n]=this._lines[n].length+D;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(D,v){this._lines[D]=v,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,v){if(v.length===0)return;let C=m.splitLines(v);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),n[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,n)}}e.MirrorTextModel=y}),define(Ee[121],ye([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(Ee[56],ye([0,1,121,10,17]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?m.localize(0,null,D(C),k(C.stack)||k(C.stacktrace)):D(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?m.localize(1,null,C.message):C.message||m.localize(2,null)}function v(C=null,n=!1){if(!C)return m.localize(3,null);if(Array.isArray(C)){const I=S.coalesce(C),o=v(I[0],n);return I.length>1?m.localize(4,null,o,I.length):o}if(T.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return y(I.error,n);if(I.exception)return y(I.exception,n)}return C.stack?y(C,n):C.message?C.message:m.localize(5,null)}e.toErrorMessage=v}),define(Ee[122],ye([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(Ee[123],ye([0,1,122,21,84]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=k;class D{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,me){this._values[ee]=me}}e.ValidatedEditorOptions=D;class v{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=v;class C{constructor(ee,me,Fe,Oe){this.id=ee,this.name=me,this.defaultValue=Fe,this.schema=Oe}compute(ee,me,Fe){return Fe}}class n{constructor(ee,me=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(ee){return this.defaultValue}}class I{constructor(ee,me,Fe,Oe){this.id=ee,this.name=me,this.defaultValue=Fe,this.schema=Oe}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,me,Fe){return Fe}}function o(H,ee){return typeof H=="undefined"?ee:H==="false"?!1:Boolean(H)}e.boolean=o;class h extends I{constructor(ee,me,Fe,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="boolean",Oe.default=Fe),super(ee,me,Fe,Oe)}validate(ee){return o(ee,this.defaultValue)}}class d extends I{constructor(ee,me,Fe,Oe,Qe,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=Fe,Ce.minimum=Oe,Ce.maximum=Qe),super(ee,me,Fe,Ce),this.minimum=Oe,this.maximum=Qe}static clampedInt(ee,me,Fe,Oe){if(typeof ee=="undefined")return me;let Qe=parseInt(ee,10);return isNaN(Qe)?me:(Qe=Math.max(Fe,Qe),Qe=Math.min(Oe,Qe),Qe|0)}validate(ee){return d.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class l extends I{constructor(ee,me,Fe,Oe,Qe){typeof Qe!="undefined"&&(Qe.type="number",Qe.default=Fe),super(ee,me,Fe,Qe),this.validationFn=Oe}static clamp(ee,me,Fe){return ee<me?me:ee>Fe?Fe:ee}static float(ee,me){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return me;const Fe=parseFloat(ee);return isNaN(Fe)?me:Fe}validate(ee){return this.validationFn(l.float(ee,this.defaultValue))}}class _ extends I{static string(ee,me){return typeof ee!="string"?me:ee}constructor(ee,me,Fe,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.default=Fe),super(ee,me,Fe,Oe)}validate(ee){return _.string(ee,this.defaultValue)}}function b(H,ee,me){return typeof H!="string"||me.indexOf(H)===-1?ee:H}e.stringSet=b;class E extends I{constructor(ee,me,Fe,Oe,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.enum=Oe,Qe.default=Fe),super(ee,me,Fe,Qe),this._allowedValues=Oe}validate(ee){return b(ee,this.defaultValue,this._allowedValues)}}class c extends C{constructor(ee,me,Fe,Oe,Qe,Ce,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.enum=Qe,_e.default=Oe),super(ee,me,Fe,_e),this._allowedValues=Qe,this._convert=Ce}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function f(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,me,Fe){return Fe===0?ee.accessibilitySupport:Fe}}class t extends C{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(H){switch(H){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function w(H){switch(H){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends n{constructor(){super(125,[63,31])}compute(ee,me,Fe){const Oe=["monaco-editor"];return me.get(31)&&Oe.push(me.get(31)),ee.extraEditorClassName&&Oe.push(ee.extraEditorClassName),me.get(63)==="default"?Oe.push("mouse-default"):me.get(63)==="copy"&&Oe.push("mouse-copy"),me.get(98)&&Oe.push("showUnused"),me.get(123)&&Oe.push("showDeprecated"),Oe.join(" ")}}class P extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ee,me,Fe){return Fe&&ee.emptySelectionClipboard}}class A extends C{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:m.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[m.localize(9,null),m.localize(10,null),m.localize(11,null)],description:m.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:m.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:m.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:m.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:m.localize(16,null)},{type:"string",description:m.localize(17,null)}],description:m.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?a.OFF:ee==="true"?a.ON:ee:Boolean(ee)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class R extends n{constructor(){super(40)}compute(ee,me,Fe){return ee.fontInfo}}class F extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(19,null)})}validate(ee){let me=l.float(ee,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(me,6,100)}compute(ee,me,Fe){return ee.fontInfo.fontSize}}class U extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:m.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(d.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class X extends C{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[m.localize(22,null),m.localize(23,null),m.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:m.localize(26,null)},me),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:m.localize(27,null)},me),"editor.gotoLocation.multipleDeclarations":Object.assign({description:m.localize(28,null)},me),"editor.gotoLocation.multipleImplementations":Object.assign({description:m.localize(29,null)},me),"editor.gotoLocation.multipleReferences":Object.assign({description:m.localize(30,null)},me),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Fe,description:m.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Fe,description:m.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Fe,description:m.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Fe,description:m.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Fe,description:m.localize(35,null)}})}validate(ee){var me,Fe,Oe,Qe,Ce;if(!ee||typeof ee!="object")return this.defaultValue;const _e=ee;return{multiple:b(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(me=_e.multipleDefinitions)!==null&&me!==void 0?me:b(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=_e.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:b(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Oe=_e.multipleDeclarations)!==null&&Oe!==void 0?Oe:b(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Qe=_e.multipleImplementations)!==null&&Qe!==void 0?Qe:b(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ce=_e.multipleReferences)!==null&&Ce!==void 0?Ce:b(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class oe extends C{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:m.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:m.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:m.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:d.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky)}}}var j;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class W extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ee,me,Fe){return W.computeLayout(me,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const me=ee.height/ee.lineHeight,Fe=ee.scrollBeyondLastLine?me-1:0,Oe=(ee.viewLineCount+Fe)/(ee.pixelRatio*ee.height),Qe=Math.floor(ee.viewLineCount/Oe);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Fe,desiredRatio:Oe,minimapLineCount:Qe}}static _computeMinimapLayout(ee,me){const Fe=ee.outerWidth,Oe=ee.outerHeight,Qe=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const Ce=me.stableMinimapLayoutInput,_e=Ce&&ee.outerHeight===Ce.outerHeight&&ee.lineHeight===Ce.lineHeight&&ee.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Ce.pixelRatio&&ee.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&ee.minimap.enabled===Ce.minimap.enabled&&ee.minimap.side===Ce.minimap.side&&ee.minimap.size===Ce.minimap.size&&ee.minimap.showSlider===Ce.minimap.showSlider&&ee.minimap.renderCharacters===Ce.minimap.renderCharacters&&ee.minimap.maxColumn===Ce.minimap.maxColumn&&ee.minimap.scale===Ce.minimap.scale&&ee.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&ee.isViewportWrapping===Ce.isViewportWrapping,Ie=ee.lineHeight,ie=ee.typicalHalfwidthCharacterWidth,ue=ee.scrollBeyondLastLine,de=ee.minimap.renderCharacters;let ge=Qe>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const $=ee.minimap.maxColumn,fe=ee.minimap.size,we=ee.minimap.side,Pe=ee.verticalScrollbarWidth,Le=ee.viewLineCount,$e=ee.remainingWidth,We=ee.isViewportWrapping,Ye=de?2:3;let tt=Math.floor(Qe*Oe);const ut=tt/Qe;let pe=!1,De=!1,ae=Ye*ge,z=ge/Qe,Ue=1;if(fe==="fill"||fe==="fit"){const{typicalViewportLineCount:bt,extraLinesBeyondLastLine:_t,desiredRatio:vt,minimapLineCount:Bt}=W.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:ue,height:Oe,lineHeight:Ie,pixelRatio:Qe});if(Le/Bt>1)pe=!0,De=!0,ge=1,ae=1,z=ge/Qe;else{let ht=!1,ct=ge+1;if(fe==="fit"){const ft=Math.ceil((Le+_t)*ae);We&&_e&&$e<=me.stableFitRemainingWidth?(ht=!0,ct=me.stableFitMaxMinimapScale):ht=ft>tt}if(fe==="fill"||ht){pe=!0;const ft=ge;ae=Math.min(Ie*Qe,Math.max(1,Math.floor(1/vt))),We&&_e&&$e<=me.stableFitRemainingWidth&&(ct=me.stableFitMaxMinimapScale),ge=Math.min(ct,Math.max(1,Math.floor(ae/Ye))),ge>ft&&(Ue=Math.min(2,ge/ft)),z=ge/Qe/Ue,tt=Math.ceil(Math.max(bt,Le+_t)*ae),We?(me.stableMinimapLayoutInput=ee,me.stableFitRemainingWidth=$e,me.stableFitMaxMinimapScale=ge):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Se=Math.floor($*z),ze=Math.min(Se,Math.max(0,Math.floor(($e-Pe-2)*z/(ie+z)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(Qe*ze);const et=Ze/Qe;Ze=Math.floor(Ze*Ue);const st=de?1:2,pt=we==="left"?0:Fe-ze-Pe;return{renderMinimap:st,minimapLeft:pt,minimapWidth:ze,minimapHeightIsEditorHeight:pe,minimapIsSampling:De,minimapScale:ge,minimapLineHeight:ae,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:et,minimapCanvasOuterHeight:ut}}static computeLayout(ee,me){const Fe=me.outerWidth|0,Oe=me.outerHeight|0,Qe=me.lineHeight|0,Ce=me.lineNumbersDigitCount|0,_e=me.typicalHalfwidthCharacterWidth,Ie=me.maxDigitWidth,ie=me.pixelRatio,ue=me.viewLineCount,de=ee.get(120),ge=de==="inherit"?ee.get(119):de,$=ge==="inherit"?ee.get(115):ge,fe=ee.get(118),we=ee.get(2),Pe=me.isDominatedByLongLines,Le=ee.get(46),$e=ee.get(57).renderType!==0,We=ee.get(58),Ye=ee.get(92),tt=ee.get(62),ut=ee.get(90),pe=ut.verticalScrollbarSize,De=ut.verticalHasArrows,ae=ut.arrowSize,z=ut.horizontalScrollbarSize,Ue=ee.get(55),Se=ee.get(35);let ze;if(typeof Ue=="string"&&/^\d+(\.\d+)?ch$/.test(Ue)){const At=parseFloat(Ue.substr(0,Ue.length-2));ze=d.clampedInt(At*_e,0,0,1e3)}else ze=d.clampedInt(Ue,0,0,1e3);Se&&(ze+=16);let Ze=0;if($e){const At=Math.max(Ce,We);Ze=Math.round(At*Ie)}let et=0;Le&&(et=Qe);let st=0,pt=st+et,bt=pt+Ze,_t=bt+ze;const vt=Fe-et-Ze-ze;let Bt=!1,Et=!1,ht=-1;we!==2&&(ge==="inherit"&&Pe?(Bt=!0,Et=!0):$==="on"||$==="bounded"?Et=!0:$==="wordWrapColumn"&&(ht=fe));const ct=W._computeMinimapLayout({outerWidth:Fe,outerHeight:Oe,lineHeight:Qe,typicalHalfwidthCharacterWidth:_e,pixelRatio:ie,scrollBeyondLastLine:Ye,minimap:tt,verticalScrollbarWidth:pe,viewLineCount:ue,remainingWidth:vt,isViewportWrapping:Et},me.memory||new v);ct.renderMinimap!==0&&ct.minimapLeft===0&&(st+=ct.minimapWidth,pt+=ct.minimapWidth,bt+=ct.minimapWidth,_t+=ct.minimapWidth);const ft=vt-ct.minimapWidth,Ht=Math.max(1,Math.floor((ft-pe-2)/_e)),kt=De?ae:0;return Et&&(ht=Math.max(1,Ht),$==="bounded"&&(ht=Math.min(ht,fe))),{width:Fe,height:Oe,glyphMarginLeft:st,glyphMarginWidth:et,lineNumbersLeft:pt,lineNumbersWidth:Ze,decorationsLeft:bt,decorationsWidth:ze,contentLeft:_t,contentWidth:ft,minimap:ct,viewportColumn:Ht,isWordWrapMinified:Bt,isViewportWrapping:Et,wrappingColumn:ht,verticalScrollbarWidth:pe,horizontalScrollbarHeight:z,overviewRuler:{top:kt,width:pe,height:Oe-2*kt,right:0}}}}e.EditorLayoutInfoComputer=W;class K extends C{constructor(){const ee={enabled:!0};super(54,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:m.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:o(ee.enabled,this.defaultValue.enabled)}}}class M extends C{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:m.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:m.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:m.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(me.fontFamily,this.defaultValue.fontFamily)}}}class Y extends l{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>l.clamp(ee,0,150),{markdownDescription:m.localize(43,null)})}compute(ee,me,Fe){return ee.fontInfo.lineHeight}}class x extends C{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:m.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(45,null),m.localize(46,null),m.localize(47,null)],default:ee.size,description:m.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:m.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:m.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:m.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:m.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(me.scale,1,1,3),maxColumn:d.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(H){return H==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{top:d.clampedInt(me.top,0,0,1e3),bottom:d.clampedInt(me.bottom,0,0,1e3)}}}class V extends C{constructor(){const ee={enabled:!0,cycle:!1};super(73,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:m.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:m.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class le extends n{constructor(){super(126)}compute(ee,me,Fe){return ee.pixelRatio}}class be extends C{constructor(){const ee={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:m.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:m.localize(59,null)},other:{type:"boolean",default:ee.other,description:m.localize(60,null)}}}],default:ee,description:m.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const me=ee,Fe={other:o(me.other,this.defaultValue.other),comments:o(me.comments,this.defaultValue.comments),strings:o(me.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var Te;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class He extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(62,null),m.localize(63,null),m.localize(64,null),m.localize(65,null)],default:"on",description:m.localize(66,null)})}validate(ee){let me=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(me=4,Fe=ee):ee==="interval"?me=3:ee==="relative"?me=2:ee==="on"?me=1:me=0),{renderType:me,renderFn:Fe}}}function Me(H){const ee=H.get(85);return ee==="editable"?H.get(78):ee!=="on"}e.filterValidationDecorations=Me;class qe extends C{constructor(){const ee=[],me={type:"number",description:m.localize(67,null)};super(89,"rulers",ee,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:m.localize(68,null),format:"color-hex"}}}]},default:ee,description:m.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let me=[];for(let Fe of ee)if(typeof Fe=="number")me.push({column:d.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Oe=Fe;me.push({column:d.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return me.sort((Fe,Oe)=>Fe.column-Oe.column),me}return this.defaultValue}}function nt(H,ee){if(typeof H!="string")return ee;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class Je extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee,Fe=d.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=d.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:nt(me.vertical,this.defaultValue.vertical),horizontal:nt(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:d.clampedInt(me.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:d.clampedInt(me.verticalSliderSize,Oe,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage)}}}class Xe extends C{constructor(){const ee={enabled:!1,mode:"prefix"};super(52,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:m.localize(70,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[m.localize(71,null),m.localize(72,null)],default:ee.mode,description:m.localize(73,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subwordDiff"])}}}class B extends C{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordDiff",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(74,null),m.localize(75,null)],default:ee.insertMode,description:m.localize(76,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:m.localize(77,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:m.localize(78,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:m.localize(79,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:m.localize(80,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:m.localize(81,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:m.localize(82,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:m.localize(83,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[m.localize(84,null),m.localize(85,null)],default:ee.previewMode,description:m.localize(86,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:m.localize(87,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(88,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(89,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(90,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(91,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(92,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(93,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(94,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(95,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(96,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(97,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(98,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(99,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(100,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(101,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(102,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const me=ee;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subwordDiff"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class G extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(119,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends n{constructor(){super(127,[78])}compute(ee,me,Fe){return me.get(78)?!0:ee.tabFocusMode}}var re;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function q(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class se extends n{constructor(){super(129,[128])}compute(ee,me,Fe){const Oe=me.get(128);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}const he="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Re:T.isLinux?Be:he,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(H){return e.editorOptionsRegistry[H.id]=H,H}var Ke;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.inlineSuggest=52]="inlineSuggest",H[H.letterSpacing=53]="letterSpacing",H[H.lightbulb=54]="lightbulb",H[H.lineDecorationsWidth=55]="lineDecorationsWidth",H[H.lineHeight=56]="lineHeight",H[H.lineNumbers=57]="lineNumbers",H[H.lineNumbersMinChars=58]="lineNumbersMinChars",H[H.linkedEditing=59]="linkedEditing",H[H.links=60]="links",H[H.matchBrackets=61]="matchBrackets",H[H.minimap=62]="minimap",H[H.mouseStyle=63]="mouseStyle",H[H.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=65]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",H[H.multiCursorModifier=67]="multiCursorModifier",H[H.multiCursorPaste=68]="multiCursorPaste",H[H.occurrencesHighlight=69]="occurrencesHighlight",H[H.overviewRulerBorder=70]="overviewRulerBorder",H[H.overviewRulerLanes=71]="overviewRulerLanes",H[H.padding=72]="padding",H[H.parameterHints=73]="parameterHints",H[H.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",H[H.quickSuggestions=76]="quickSuggestions",H[H.quickSuggestionsDelay=77]="quickSuggestionsDelay",H[H.readOnly=78]="readOnly",H[H.renameOnType=79]="renameOnType",H[H.renderControlCharacters=80]="renderControlCharacters",H[H.renderIndentGuides=81]="renderIndentGuides",H[H.renderFinalNewline=82]="renderFinalNewline",H[H.renderLineHighlight=83]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=85]="renderValidationDecorations",H[H.renderWhitespace=86]="renderWhitespace",H[H.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",H[H.roundedSelection=88]="roundedSelection",H[H.rulers=89]="rulers",H[H.scrollbar=90]="scrollbar",H[H.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=92]="scrollBeyondLastLine",H[H.scrollPredominantAxis=93]="scrollPredominantAxis",H[H.selectionClipboard=94]="selectionClipboard",H[H.selectionHighlight=95]="selectionHighlight",H[H.selectOnLineNumbers=96]="selectOnLineNumbers",H[H.showFoldingControls=97]="showFoldingControls",H[H.showUnused=98]="showUnused",H[H.snippetSuggestions=99]="snippetSuggestions",H[H.smartSelect=100]="smartSelect",H[H.smoothScrolling=101]="smoothScrolling",H[H.stickyTabStops=102]="stickyTabStops",H[H.stopRenderingLineAfter=103]="stopRenderingLineAfter",H[H.suggest=104]="suggest",H[H.suggestFontSize=105]="suggestFontSize",H[H.suggestLineHeight=106]="suggestLineHeight",H[H.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",H[H.suggestSelection=108]="suggestSelection",H[H.tabCompletion=109]="tabCompletion",H[H.tabIndex=110]="tabIndex",H[H.unusualLineTerminators=111]="unusualLineTerminators",H[H.useShadowDOM=112]="useShadowDOM",H[H.useTabStops=113]="useTabStops",H[H.wordSeparators=114]="wordSeparators",H[H.wordWrap=115]="wordWrap",H[H.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=118]="wordWrapColumn",H[H.wordWrapOverride1=119]="wordWrapOverride1",H[H.wordWrapOverride2=120]="wordWrapOverride2",H[H.wrappingIndent=121]="wrappingIndent",H[H.wrappingStrategy=122]="wrappingStrategy",H[H.showDeprecated=123]="showDeprecated",H[H.inlayHints=124]="inlayHints",H[H.editorClassName=125]="editorClassName",H[H.pixelRatio=126]="pixelRatio",H[H.tabFocusMode=127]="tabFocusMode",H[H.layoutInfo=128]="layoutInfo",H[H.wrappingInfo=129]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(120,null)})),acceptSuggestionOnEnter:ve(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(121,null),""],markdownDescription:m.localize(122,null)})),accessibilitySupport:ve(new g),accessibilityPageSize:ve(new d(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(123,null)})),ariaLabel:ve(new _(4,"ariaLabel",m.localize(124,null))),autoClosingBrackets:ve(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(125,null),m.localize(126,null),""],description:m.localize(127,null)})),autoClosingDelete:ve(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(128,null),""],description:m.localize(129,null)})),autoClosingOvertype:ve(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(130,null),""],description:m.localize(131,null)})),autoClosingQuotes:ve(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(132,null),m.localize(133,null),""],description:m.localize(134,null)})),autoIndent:ve(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null),m.localize(138,null),m.localize(139,null)],description:m.localize(140,null)})),automaticLayout:ve(new h(10,"automaticLayout",!1)),autoSurround:ve(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(141,null),m.localize(142,null),m.localize(143,null),""],description:m.localize(144,null)})),stickyTabStops:ve(new h(102,"stickyTabStops",!1,{description:m.localize(145,null)})),codeLens:ve(new h(12,"codeLens",!0,{description:m.localize(146,null)})),codeLensFontFamily:ve(new _(13,"codeLensFontFamily","",{description:m.localize(147,null)})),codeLensFontSize:ve(new d(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(148,null)})),colorDecorators:ve(new h(15,"colorDecorators",!0,{description:m.localize(149,null)})),columnSelection:ve(new h(16,"columnSelection",!1,{description:m.localize(150,null)})),comments:ve(new t),contextmenu:ve(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new h(19,"copyWithSyntaxHighlighting",!0,{description:m.localize(151,null)})),cursorBlinking:ve(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:m.localize(152,null)})),cursorSmoothCaretAnimation:ve(new h(21,"cursorSmoothCaretAnimation",!1,{description:m.localize(153,null)})),cursorStyle:ve(new c(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:m.localize(154,null)})),cursorSurroundingLines:ve(new d(23,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(155,null)})),cursorSurroundingLinesStyle:ve(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(156,null),m.localize(157,null)],description:m.localize(158,null)})),cursorWidth:ve(new d(25,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(159,null)})),disableLayerHinting:ve(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new h(28,"domReadOnly",!1)),dragAndDrop:ve(new h(29,"dragAndDrop",!0,{description:m.localize(160,null)})),emptySelectionClipboard:ve(new P),extraEditorClassName:ve(new _(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new l(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:m.localize(161,null)})),find:ve(new A),fixedOverflowWidgets:ve(new h(34,"fixedOverflowWidgets",!1)),folding:ve(new h(35,"folding",!0,{description:m.localize(162,null)})),foldingStrategy:ve(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(163,null),m.localize(164,null)],description:m.localize(165,null)})),foldingHighlight:ve(new h(37,"foldingHighlight",!0,{description:m.localize(166,null)})),unfoldOnClickAfterEndOfLine:ve(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(167,null)})),fontFamily:ve(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(168,null)})),fontInfo:ve(new R),fontLigatures2:ve(new a),fontSize:ve(new F),fontWeight:ve(new U),formatOnPaste:ve(new h(44,"formatOnPaste",!1,{description:m.localize(169,null)})),formatOnType:ve(new h(45,"formatOnType",!1,{description:m.localize(170,null)})),glyphMargin:ve(new h(46,"glyphMargin",!0,{description:m.localize(171,null)})),gotoLocation:ve(new X),hideCursorInOverviewRuler:ve(new h(48,"hideCursorInOverviewRuler",!1,{description:m.localize(172,null)})),highlightActiveIndentGuide:ve(new h(49,"highlightActiveIndentGuide",!0,{description:m.localize(173,null)})),hover:ve(new oe),inDiffEditor:ve(new h(51,"inDiffEditor",!1)),letterSpacing:ve(new l(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>l.clamp(H,-5,20),{description:m.localize(174,null)})),lightbulb:ve(new K),lineDecorationsWidth:ve(new I(55,"lineDecorationsWidth",10)),lineHeight:ve(new Y),lineNumbers:ve(new He),lineNumbersMinChars:ve(new d(58,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new h(59,"linkedEditing",!1,{description:m.localize(175,null)})),links:ve(new h(60,"links",!0,{description:m.localize(176,null)})),matchBrackets:ve(new E(61,"matchBrackets","always",["always","near","never"],{description:m.localize(177,null)})),minimap:ve(new x),mouseStyle:ve(new E(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new l(64,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:m.localize(178,null)})),mouseWheelZoom:ve(new h(65,"mouseWheelZoom",!1,{markdownDescription:m.localize(179,null)})),multiCursorMergeOverlapping:ve(new h(66,"multiCursorMergeOverlapping",!0,{description:m.localize(180,null)})),multiCursorModifier:ve(new c(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[m.localize(181,null),m.localize(182,null)],markdownDescription:m.localize(183,null)})),multiCursorPaste:ve(new E(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(184,null),m.localize(185,null)],markdownDescription:m.localize(186,null)})),occurrencesHighlight:ve(new h(69,"occurrencesHighlight",!0,{description:m.localize(187,null)})),overviewRulerBorder:ve(new h(70,"overviewRulerBorder",!0,{description:m.localize(188,null)})),overviewRulerLanes:ve(new d(71,"overviewRulerLanes",3,0,3)),padding:ve(new Q),parameterHints:ve(new V),peekWidgetDefaultFocus:ve(new E(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),definitionLinkOpensInPeek:ve(new h(75,"definitionLinkOpensInPeek",!1,{description:m.localize(192,null)})),quickSuggestions:ve(new be),quickSuggestionsDelay:ve(new d(77,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(193,null)})),readOnly:ve(new h(78,"readOnly",!1)),renameOnType:ve(new h(79,"renameOnType",!1,{description:m.localize(194,null),markdownDeprecationMessage:m.localize(195,null)})),renderControlCharacters:ve(new h(80,"renderControlCharacters",!1,{description:m.localize(196,null)})),renderIndentGuides:ve(new h(81,"renderIndentGuides",!0,{description:m.localize(197,null)})),renderFinalNewline:ve(new h(82,"renderFinalNewline",!0,{description:m.localize(198,null)})),renderLineHighlight:ve(new E(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(199,null)],description:m.localize(200,null)})),renderLineHighlightOnlyWhenFocus:ve(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(201,null)})),renderValidationDecorations:ve(new E(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new E(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(202,null),m.localize(203,null),m.localize(204,null),""],description:m.localize(205,null)})),revealHorizontalRightPadding:ve(new d(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new h(88,"roundedSelection",!0,{description:m.localize(206,null)})),rulers:ve(new qe),scrollbar:ve(new Je),scrollBeyondLastColumn:ve(new d(91,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(207,null)})),scrollBeyondLastLine:ve(new h(92,"scrollBeyondLastLine",!0,{description:m.localize(208,null)})),scrollPredominantAxis:ve(new h(93,"scrollPredominantAxis",!0,{description:m.localize(209,null)})),selectionClipboard:ve(new h(94,"selectionClipboard",!0,{description:m.localize(210,null),included:T.isLinux})),selectionHighlight:ve(new h(95,"selectionHighlight",!0,{description:m.localize(211,null)})),selectOnLineNumbers:ve(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:ve(new E(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(212,null),m.localize(213,null)],description:m.localize(214,null)})),showUnused:ve(new h(98,"showUnused",!0,{description:m.localize(215,null)})),showDeprecated:ve(new h(123,"showDeprecated",!0,{description:m.localize(216,null)})),inlayHints:ve(new M),snippetSuggestions:ve(new E(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(217,null),m.localize(218,null),m.localize(219,null),m.localize(220,null)],description:m.localize(221,null)})),smartSelect:ve(new G),smoothScrolling:ve(new h(101,"smoothScrolling",!1,{description:m.localize(222,null)})),stopRenderingLineAfter:ve(new d(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new B),inlineSuggest:ve(new Xe),suggestFontSize:ve(new d(105,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(223,null)})),suggestLineHeight:ve(new d(106,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(224,null)})),suggestOnTriggerCharacters:ve(new h(107,"suggestOnTriggerCharacters",!0,{description:m.localize(225,null)})),suggestSelection:ve(new E(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(226,null),m.localize(227,null),m.localize(228,null)],description:m.localize(229,null)})),tabCompletion:ve(new E(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),tabIndex:ve(new d(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new E(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null)],description:m.localize(237,null)})),useShadowDOM:ve(new h(112,"useShadowDOM",!0)),useTabStops:ve(new h(113,"useTabStops",!0,{description:m.localize(238,null)})),wordSeparators:ve(new _(114,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:m.localize(239,null)})),wordWrap:ve(new E(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null),m.localize(243,null)],description:m.localize(244,null)})),wordWrapBreakAfterCharacters:ve(new _(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new _(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new d(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(245,null)})),wordWrapOverride1:ve(new E(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new E(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new c(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[m.localize(246,null),m.localize(247,null),m.localize(248,null),m.localize(249,null)],description:m.localize(250,null)})),wrappingStrategy:ve(new E(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(251,null),m.localize(252,null)],description:m.localize(253,null)})),editorClassName:ve(new p),pixelRatio:ve(new le),tabFocusMode:ve(new ne),layoutInfo:ve(new W),wrappingInfo:ve(new se)}}),define(Ee[124],ye([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[125],ye([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[126],ye([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(Ee[127],ye([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(Ee[128],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[129],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[130],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[131],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[132],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[133],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[134],ye([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[135],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[136],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[137],ye([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[138],ye([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[139],ye([0,1,2]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=e.isResourceEditorInput=void 0;function T(v){const C=v;return m.URI.isUri(C==null?void 0:C.resource)}e.isResourceEditorInput=T;var S;(function(v){v[v.ACTIVATE=0]="ACTIVATE",v[v.RESTORE=1]="RESTORE",v[v.PRESERVE=2]="PRESERVE"})(S=e.EditorActivation||(e.EditorActivation={}));var y;(function(v){v[v.PICK=0]="PICK",v[v.DISABLED=1]="DISABLED",v[v.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(y=e.EditorOverride||(e.EditorOverride={}));var k;(function(v){v[v.API=0]="API",v[v.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(v){v[v.Center=0]="Center",v[v.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",v[v.NearTop=2]="NearTop",v[v.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[140],ye([0,1,125]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=y;function k(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=o.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=k;function D(o){if(!o)return null;let h=o.majorBase,d=o.majorMustEqual,l=o.minorBase,_=o.minorMustEqual,b=o.patchBase,E=o.patchMustEqual;o.hasCaret&&(h===0||(_=!1),E=!1);let c=0;if(o.preRelease){const f=S.exec(o.preRelease);if(f){const[,g,t,i]=f;c=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:h,majorMustEqual:d,minorBase:l,minorMustEqual:_,patchBase:b,patchMustEqual:E,isMinimum:o.hasGreaterEquals,notBefore:c}}e.normalizeVersion=D;function v(o,h,d){let l;typeof o=="string"?l=D(k(o)):l=o;let _;h instanceof Date?_=h.getTime():typeof h=="string"&&(_=new Date(h).getTime());let b;if(typeof d=="string"?b=D(k(d)):b=d,!l||!b)return!1;let E=l.majorBase,c=l.minorBase,f=l.patchBase,g=b.majorBase,t=b.minorBase,i=b.patchBase,s=b.notBefore,r=b.majorMustEqual,u=b.minorMustEqual,w=b.patchMustEqual;return b.isMinimum?E>g?!0:E<g?!1:c>t?!0:c<t||_&&_<s?!1:f>=i:(E===1&&g===0&&(!r||!u||!w)&&(g=1,t=0,i=0,r=!0,u=!1,w=!1),E<g?!1:E>g?!r:c<t?!1:c>t?!u:f<i?!1:f>i?!w:!(_&&_<s))}e.isValidVersion=v;function C(o,h,d,l){return d.isBuiltin||typeof d.main=="undefined"?!0:I(o,h,d.engines.vscode,l)}e.isValidExtensionVersion=C;function n(o,h,d){return o==="*"||I(h,d,o)}e.isEngineValid=n;function I(o,h,d,l=[]){let _=D(k(d));if(!_)return l.push(m.localize(0,null,d)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return l.push(m.localize(1,null,d)),!1}else if(!_.majorMustEqual)return l.push(m.localize(2,null,d)),!1;return v(o,h,_)?!0:(l.push(m.localize(3,null,o,d)),!1)}}),define(Ee[87],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(y,k=[],D=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=m;const T=(S,...y)=>new m(S,y);e.createSyncDescriptor=T}),define(Ee[57],ye([0,1,87]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function S(k,D,v){D instanceof m.SyncDescriptor||(D=new m.SyncDescriptor(D,[],v)),T.push([k,D])}e.registerSingleton=S;function y(){return T}e.getSingletonServiceDescriptors=y}),define(Ee[141],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class T{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let k of this._nodes.values())k.outgoing.size===0&&y.push(k);return y}insertEdge(y,k){const D=this.lookupOrInsertNode(y),v=this.lookupOrInsertNode(k);D.outgoing.set(this._hashFn(k),v),v.incoming.set(this._hashFn(y),D)}removeNode(y){const k=this._hashFn(y);this._nodes.delete(k);for(let D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(y){const k=this._hashFn(y);let D=this._nodes.get(k);return D||(D=new m(y),this._nodes.set(k,D)),D}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[k,D]of this._nodes)y.push(`${k}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,k]of this._nodes){const D=new Set([y]),v=this._findCycle(k,D);if(v)return v}}_findCycle(y,k){for(let[D,v]of y.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const C=this._findCycle(v,k);if(C)return C;k.delete(D)}}}e.Graph=T}),define(Ee[5],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function v(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=v})(m=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function T(D,v,C,n){v[m.DI_TARGET]===v?v[m.DI_DEPENDENCIES].push({id:D,index:C,optional:n}):(v[m.DI_DEPENDENCIES]=[{id:D,index:C,optional:n}],v[m.DI_TARGET]=v)}function S(D){if(m.serviceIds.has(D))return m.serviceIds.get(D);const v=function(C,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(v,C,I,!1)};return v.toString=()=>D,m.serviceIds.set(D,v),v}e.createDecorator=S;function y(D){return D}e.refineServiceDecorator=y;function k(D){return function(v,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(D,v,n,!0)}}e.optional=k}),define(Ee[142],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=m.createDecorator("modelService");function T(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(Ee[143],ye([0,1,3,53,7,22,76,55,142]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(C):!!o.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(h,d){let l={selector:h,provider:d,_score:-1,_time:this._clock++};return this._entries.push(l),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S.toDisposable(()=>{if(l){let _=this._entries.indexOf(l);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),l=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const d=[];for(let l of this._entries)l._score>0&&d.push(l.provider);return d}ordered(h){const d=[];return this._orderedForEach(h,l=>d.push(l.provider)),d}orderedGroups(h){const d=[];let l,_;return this._orderedForEach(h,b=>{l&&_===b._score?l.push(b.provider):(_=b._score,l=[b.provider],d.push(l))}),d}_orderedForEach(h,d){if(!!h){this._updateScores(h);for(const l of this._entries)l._score>0&&d(l)}}_updateScores(h){let d={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===d.language&&this._lastCandidate.uri===d.uri)){this._lastCandidate=d;for(let l of this._entries)if(l._score=D.score(l.selector,h.uri,h.getLanguageIdentifier().language,v.shouldSynchronizeModel(h)),C(l.selector)&&l._score>0){for(let _ of this._entries)_._score=0;l._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,d){return h._score<d._score?1:h._score>d._score?-1:h._time<d._time?1:h._time>d._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(h,d,l=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=d,this.max=l,this._cache=new y.LRUCache(50,.7)}_key(h){return h.id+T.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const d=this._key(h),l=this._cache.get(d);return this._clamp(l==null?void 0:l.value)}update(h,d){const l=this._key(h);let _=this._cache.get(l);return _||(_=new k.MovingAverage,this._cache.set(l,_)),_.update(d),this.get(h)}}e.LanguageFeatureRequestDelays=I}),define(Ee[58],ye([0,1,2,30,143,119,77]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class v{constructor(R,F){this.language=R,this.id=F}}e.LanguageIdentifier=v;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(R){return(R&255)>>>0}static getTokenType(R){return(R&1792)>>>8}static getFontStyle(R){return(R&14336)>>>11}static getForeground(R){return(R&8372224)>>>14}static getBackground(R){return(R&4286578688)>>>23}static getClassNameFromMetadata(R){let F=this.getForeground(R),U="mtk"+F,X=this.getFontStyle(R);return X&1&&(U+=" mtki"),X&2&&(U+=" mtkb"),X&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(R,F){const U=this.getForeground(R),X=this.getFontStyle(R);let oe=`color: ${F[U]};`;return X&1&&(oe+="font-style: italic;"),X&2&&(oe+="font-weight: bold;"),X&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=h;var d;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(R){const F=a[R];let U=F&&k.iconRegistry.get(F);return U||(console.info("No codicon found for CompletionItemKind "+R),U=k.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(R,F){let U=a[R];return typeof U=="undefined"&&!F&&(U=9),U}}();var l;(function(a){a[a.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&m.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const R=new Map;R.set("file",0),R.set("module",1),R.set("namespace",2),R.set("package",3),R.set("class",4),R.set("method",5),R.set("property",6),R.set("field",7),R.set("constructor",8),R.set("enum",9),R.set("interface",10),R.set("function",11),R.set("variable",12),R.set("constant",13),R.set("string",14),R.set("number",15),R.set("boolean",16),R.set("array",17),R.set("object",18),R.set("key",19),R.set("null",20),R.set("enum-member",21),R.set("struct",22),R.set("event",23),R.set("operator",24),R.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function U(j){return R.get(j)}a.fromString=U;function X(j){return F.get(j)}a.toString=X;function oe(j,W){const K=F.get(j);let M=K&&k.iconRegistry.get("symbol-"+K);return M||(console.info("No codicon found for SymbolKind "+j),M=k.Codicon.symbolProperty),`${W?"inline":"block"} ${M.classNames}`}a.toCssClassName=oe})(r=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(R){this.value=R}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var w;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(w=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var P;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var A;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[88],ye([0,1,8,5,21]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=S.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",S.isMacintosh),k.set("isLinux",S.isLinux),k.set("isWindows",S.isWindows),k.set("isWeb",S.isWeb),k.set("isMacNative",S.isMacintosh&&!S.isWeb),k.set("isEdge",y.indexOf("Edg/")>=0),k.set("isFirefox",y.indexOf("Firefox")>=0),k.set("isChrome",y.indexOf("Chrome")>=0),k.set("isSafari",y.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var v;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(v=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return o.INSTANCE}static has(a){return h.create(a)}static equals(a,R){return d.create(a,R)}static notEquals(a,R){return b.create(a,R)}static regex(a,R){return i.create(a,R)}static in(a,R){return l.create(a,R)}static not(a){return E.create(a)}static and(...a){return r.create(a)}static or(...a){return u.create(a)}static greater(a,R){return c.create(a,R)}static less(a,R){return g.create(a,R)}static deserialize(a,R=!1){if(!!a)return this._deserializeOrExpression(a,R)}static _deserializeOrExpression(a,R){let F=a.split("||");return u.create(F.map(U=>this._deserializeAndExpression(U,R)))}static _deserializeAndExpression(a,R){let F=a.split("&&");return r.create(F.map(U=>this._deserializeOne(U,R)))}static _deserializeOne(a,R){if(a=a.trim(),a.indexOf("!=")>=0){let F=a.split("!=");return b.create(F[0].trim(),this._deserializeValue(F[1],R))}if(a.indexOf("==")>=0){let F=a.split("==");return d.create(F[0].trim(),this._deserializeValue(F[1],R))}if(a.indexOf("=~")>=0){let F=a.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(a.indexOf(" in ")>=0){let F=a.split(" in ");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const F=a.split(">=");return f.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const F=a.split(">");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const F=a.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const F=a.split("<");return g.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(a)?E.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,R){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let F=/^'([^']*)'$/.exec(a);return F?F[1].trim():a}static _deserializeRegexValue(a,R){if(m.isFalsyOrWhitespace(a)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=a.indexOf("/"),U=a.lastIndexOf("/");if(F===U||F<0){if(R)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let X=a.slice(F+1,U),oe=a[U+1]==="i"?"i":"";try{return new RegExp(X,oe)}catch(j){if(R)throw new Error(`bad regexp-value '${a}', parse error: ${j}`);return console.warn(`bad regexp-value '${a}', parse error: ${j}`),null}}}e.ContextKeyExpr=C;function n(A,a){return A.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class h{constructor(a){this.key=a,this.type=2}static create(a){const R=k.get(a);return typeof R=="boolean"?R?o.INSTANCE:I.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=h;class d{constructor(a,R){this.key=a,this.value=R,this.type=4}static create(a,R){if(typeof R=="boolean")return R?h.create(a):E.create(a);const F=k.get(a);return typeof F=="boolean"?R===(F?"true":"false")?o.INSTANCE:I.INSTANCE:new d(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=d;class l{constructor(a,R){this.key=a,this.valueKey=R,this.type=10}static create(a,R){return new l(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const R=a.getValue(this.valueKey),F=a.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?D.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=l;class _{constructor(a){this._actual=a,this.type=11}static create(a){return new _(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new _(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class b{constructor(a,R){this.key=a,this.value=R,this.type=5}static create(a,R){if(typeof R=="boolean")return R?E.create(a):h.create(a);const F=k.get(a);return typeof F=="boolean"?R===(F?"true":"false")?I.INSTANCE:o.INSTANCE:new b(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class E{constructor(a){this.key=a,this.type=3}static create(a){const R=k.get(a);return typeof R=="boolean"?R?I.INSTANCE:o.INSTANCE:new E(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=E;class c{constructor(a,R){this.key=a,this.value=R,this.type=12}static create(a,R){return new c(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class f{constructor(a,R){this.key=a,this.value=R,this.type=13}static create(a,R){return new f(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class g{constructor(a,R){this.key=a,this.value=R,this.type=14}static create(a,R){return new g(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,R){this.key=a,this.value=R,this.type=15}static create(a,R){return new t(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,R){this.key=a,this.regexp=R,this.type=7}static create(a,R){return new i(a,R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const R=this.regexp?this.regexp.source:"",F=a.regexp?a.regexp.source:"";return R<F?-1:R>F?1:0}equals(a){if(a.type===this.type){const R=this.regexp?this.regexp.source:"",F=a.regexp?a.regexp.source:"";return this.key===a.key&&R===F}return!1}evaluate(a){let R=a.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(a){this.expr=a,this.type=6}static create(a){return r._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const U=n(this.expr[R],a.expr[R]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(a))return!1;return!0}static _normalizeArr(a){const R=[];let F=!1;for(const U of a)if(!!U){if(U.type===1){F=!0;continue}if(U.type===0)return I.INSTANCE;if(U.type===6){R.push(...U.expr);continue}R.push(U)}if(R.length===0&&F)return o.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(n);R.length>1;){const U=R[R.length-1];if(U.type!==9)break;R.pop();const X=R.pop(),oe=u.create(U.expr.map(j=>r.create([j,X])));oe&&(R.push(oe),R.sort(n))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new r(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let R of this.expr)a.push(R.negate());return u.create(a)}}e.ContextKeyAndExpr=r;class u{constructor(a){this.expr=a,this.type=9}static create(a){const R=u._normalizeArr(a);if(R.length!==0)return R.length===1?R[0]:new u(R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const U=n(this.expr[R],a.expr[R]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(a))return!0;return!1}static _normalizeArr(a){let R=[],F=!1;if(a){for(let U=0,X=a.length;U<X;U++){const oe=a[U];if(!!oe){if(oe.type===0){F=!0;continue}if(oe.type===1)return[o.INSTANCE];if(oe.type===9){R=R.concat(oe.expr);continue}R.push(oe)}}if(R.length===0&&F)return[I.INSTANCE];R.sort(n)}return R}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new u(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let F of this.expr)a.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;a.length>1;){const F=a.shift(),U=a.shift(),X=[];for(const oe of R(F))for(const j of R(U))X.push(C.and(oe,j));a.unshift(C.or(...X))}return a[0]}}e.ContextKeyOrExpr=u;class w extends h{constructor(a,R,F){super(a);this._defaultValue=R,typeof F=="object"?w._info.push(Object.assign(Object.assign({},F),{key:a})):F!==!0&&w._info.push({key:a,description:F,type:R!=null?typeof R:void 0})}static all(){return w._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(A,a){return A<a?-1:A>a?1:0}function P(A,a,R,F){return A<R?-1:A>R?1:a<F?-1:a>F?1:0}}),define(Ee[144],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(Ee[26],ye([0,1,8,5]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=S;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,o){if(typeof I=="undefined"||I===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof I=="string"||typeof o=="string"){let h=typeof I=="string"?I:I.value,d=typeof o=="string"?o:o.value;return m.equalsIgnoreCase(h,d)}return I._lower===o._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=D;function v(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(Ee[145],ye([0,1,8,26]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(h,d){return h.uuid&&d.uuid?h.uuid===d.uuid:h.id===d.id?!0:m.compareIgnoreCase(h.id,d.id)===0}e.areSameExtensions=S;class y{constructor(d,l){this.version=l,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof y?S(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=y;function k(h,d){return`${h}.${d}`}e.getExtensionId=k;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function v(h,d){return D(k(h,d))}e.getGalleryExtensionId=v;function C(h,d){const l=[],_=b=>{for(const E of l)if(E.some(c=>S(d(c),d(b))))return E;return null};for(const b of h){const E=_(b);E?E.push(b):l.push([b])}return l}e.groupByExtension=C;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(h){const d=new Set;for(const l of h)l.malicious&&d.add(l.id.id);return d}e.getMaliciousExtensionsSet=o}),define(Ee[59],ye([0,1,126,15,2,5,8,10,22]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function C(W){return W.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(W){W[W.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var o;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=h;function d(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=d;function l(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function _(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=_;var b;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(K,M){super(K);this.code=M}}e.FileSystemProviderError=E;function c(W,K){const M=new E(W.toString(),K);return g(M,K),M}e.createFileSystemProviderError=c;function f(W){return W||c(m.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=f;function g(W,K){return W.name=K?`${K} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=g;function t(W){if(!W)return b.Unknown;if(W instanceof E)return W.code;const K=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!K)return b.Unknown;switch(K[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function i(W){if(W instanceof P)return W.fileOperationResult;switch(t(W)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(K,M,Y){this.resource=K,this.operation=M,this.target=Y}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var u;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(K,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const Y of K)switch(Y.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>M)),this.added.set(Y.resource,Y);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>M)),this.updated.set(Y.resource,Y);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>M)),this.deleted.set(Y.resource,Y);break}}contains(K,...M){return this.doContains(K,{includeChildren:!1},...M)}affects(K,...M){return this.doContains(K,{includeChildren:!0},...M)}doContains(K,M,...Y){var x,O,Q,V,le,be;if(!K)return!1;const Te=Y.length>0;return!!((!Te||Y.includes(1))&&(((x=this.added)===null||x===void 0?void 0:x.get(K))||M.includeChildren&&((O=this.added)===null||O===void 0?void 0:O.findSuperstr(K)))||(!Te||Y.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(K))||M.includeChildren&&((V=this.updated)===null||V===void 0?void 0:V.findSuperstr(K)))||(!Te||Y.includes(2))&&(((le=this.deleted)===null||le===void 0?void 0:le.findSubstr(K))||M.includeChildren&&((be=this.deleted)===null||be===void 0?void 0:be.findSuperstr(K))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=w;function p(W,K,M){return!W||!K||W===K||K.length>W.length?!1:(K.charAt(K.length-1)!==T.sep&&(K+=T.sep),M?k.startsWithIgnoreCase(W,K):W.indexOf(K)===0)}e.isParent=p;class P extends Error{constructor(K,M,Y){super(K);this.fileOperationResult=M,this.options=Y}}e.FileOperationError=P;class A extends P{constructor(K,M,Y){super(K,2,Y);this.stat=M}}e.NotModifiedSinceFileOperationError=A;var a;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=F;async function U(W,K){if(!K.canHandleResource(S.URI.from({scheme:W.scheme})))return new Promise(M=>{const Y=K.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===W.scheme&&x.added&&(Y.dispose(),M())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize(K){return D.isNumber(K)||(K=0),K<X.KB?m.localize(1,null,K.toFixed(0)):K<X.MB?m.localize(2,null,(K/X.KB).toFixed(2)):K<X.GB?m.localize(3,null,(K/X.MB).toFixed(2)):K<X.TB?m.localize(4,null,(K/X.GB).toFixed(2)):m.localize(5,null,(K/X.TB).toFixed(2))}}e.ByteSize=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;var oe;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function j(W){return{maxFileSize:W===0?300*X.MB:16*X.GB,maxHeapSize:W===0?700*X.MB:2*700*X.MB}}e.getPlatformLimits=j}),define(Ee[60],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...S){this._entries=new Map;for(let[y,k]of S)this.set(y,k)}set(S,y){const k=this._entries.get(S);return this._entries.set(S,y),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=m}),define(Ee[146],ye([0,1,11,141,87,5,60,13]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const v=!1;class C extends Error{constructor(d){var l;super("cyclic dependency between services");this.message=(l=d.findCycleSlow())!==null&&l!==void 0?l:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new k.ServiceCollection,l=!1,_){this._activeInstantiations=new Set,this._services=d,this._strict=l,this._parent=_,this._services.set(y.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...l){let _=o.traceInvocation(d),b=!1;try{return d({get:(c,f)=>{if(b)throw m.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(c,_);if(!g&&f!==y.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return g}},...l)}finally{b=!0,_.stop()}}createInstance(d,...l){let _,b;return d instanceof S.SyncDescriptor?(_=o.traceCreation(d.ctor),b=this._createInstance(d.ctor,d.staticArguments.concat(l),_)):(_=o.traceCreation(d),b=this._createInstance(d,l,_)),_.stop(),b}_createInstance(d,l=[],_){let b=y._util.getServiceDependencies(d).sort((f,g)=>f.index-g.index),E=[];for(const f of b){let g=this._getOrCreateServiceInstance(f.id,_);if(!g&&this._strict&&!f.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`);E.push(g)}let c=b.length>0?b[0].index:l.length;if(l.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${l.length} static arguments`);let f=c-l.length;f>0?l=l.concat(new Array(f)):l=l.slice(0,c)}return new d(...[...l,...E])}_setServiceInstance(d,l){if(this._services.get(d)instanceof S.SyncDescriptor)this._services.set(d,l);else if(this._parent)this._parent._setServiceInstance(d,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let l=this._services.get(d);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):l}_getOrCreateServiceInstance(d,l){let _=this._getServiceInstanceOrDescriptor(d);return _ instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,_,l.branch(d,!0)):(l.branch(d,!1),_)}_safeCreateAndCacheServiceInstance(d,l,_){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,l,_)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,l,_){const b=new T.Graph(f=>f.id.toString());let E=0;const c=[{id:d,desc:l,_trace:_}];for(;c.length;){const f=c.pop();if(b.lookupOrInsertNode(f),E++>1e3)throw new C(b);for(let g of y._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${d} depends on ${g.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const i={id:g.id,desc:t,_trace:f._trace.branch(g.id,!0)};b.insertEdge(f,i),c.push(i)}}}for(;;){const f=b.roots();if(f.length===0){if(!b.isEmpty())throw new C(b);break}for(const{data:g}of f){if(this._getServiceInstanceOrDescriptor(g.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}b.removeNode(g)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,l,_=[],b,E){if(this._services.get(d)instanceof S.SyncDescriptor)return this._createServiceInstance(l,_,b,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,l,_,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(d,l=[],_,b){if(_){const E=new D.IdleValue(()=>this._createInstance(d,l,b));return new Proxy(Object.create(null),{get(c,f){if(f in c)return c[f];let g=E.value,t=g[f];return typeof t!="function"||(t=t.bind(g),c[f]=t),t},set(c,f,g){return E.value[f]=g,!0}})}else return this._createInstance(d,l,b)}}e.InstantiationService=n;var I;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(I||(I={}));class o{constructor(d,l){this.type=d,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return v?new o(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(d){return v?new o(0,d.name):o._None}branch(d,l){let _=new o(2,d.toString());return this._dep.push([d,l,_]),_}stop(){let d=Date.now()-this._start;o._totals+=d;let l=!1;function _(E,c){let f=[],g=new Array(E+1).join("	");for(const[t,i,s]of c._dep)if(i&&s){l=!0,f.push(`${g}CREATES -> ${t}`);let r=_(E+1,s);r&&f.push(r)}else f.push(`${g}uses -> ${t}`);return f.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(d>2||l)&&console.log(b.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(Ee[16],ye([0,1,5,7,21,3,56]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function D(){return new Date().toISOString()}var v;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;class C extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(v.Trace)&&this.log(v.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(v.Debug)&&this.log(v.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(v.Info)&&this.log(v.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(v.Warning)&&this.log(v.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(v.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(v.Error,this.format(s))}else this.log(v.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(v.Critical)&&this.log(v.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(u){}i+=(s>0?" ":"")+r}return i}}e.AbstractMessageLogger=n;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...i){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class o extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class h extends C{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:k.toErrorMessage(t,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class l extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=l;class _ extends T.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?v.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class b{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=b;function E(g){if(g.verbose)return v.Trace;if(typeof g.logLevel=="string"){const t=c(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function c(g){switch(g){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=c;function f(g){switch(g){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=f}),define(Ee[89],ye([0,1,5,127,41]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function C(d,l){return l-d}v.compare=C;const n=Object.create(null);n[v.Error]=T.localize(0,null),n[v.Warning]=T.localize(1,null),n[v.Info]=T.localize(2,null);function I(d){return n[d]||""}v.toString=I;function o(d){switch(d){case S.default.Error:return v.Error;case S.default.Warning:return v.Warning;case S.default.Info:return v.Info;case S.default.Ignore:return v.Hint}}v.fromSeverity=o;function h(d){switch(d){case v.Error:return S.default.Error;case v.Warning:return S.default.Warning;case v.Info:return S.default.Info;case v.Hint:return S.default.Ignore}}v.toSeverity=h}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(v){const C="";function n(o){return I(o,!0)}v.makeKey=n;function I(o,h){let d=[C];return o.source?d.push(o.source.replace("\xA6","\\\xA6")):d.push(C),o.code?typeof o.code=="string"?d.push(o.code.replace("\xA6","\\\xA6")):d.push(o.code.value.replace("\xA6","\\\xA6")):d.push(C),o.severity!==void 0&&o.severity!==null?d.push(k.toString(o.severity)):d.push(C),o.message&&h?d.push(o.message.replace("\xA6","\\\xA6")):d.push(C),o.startLineNumber!==void 0&&o.startLineNumber!==null?d.push(o.startLineNumber.toString()):d.push(C),o.startColumn!==void 0&&o.startColumn!==null?d.push(o.startColumn.toString()):d.push(C),o.endLineNumber!==void 0&&o.endLineNumber!==null?d.push(o.endLineNumber.toString()):d.push(C),o.endColumn!==void 0&&o.endColumn!==null?d.push(o.endColumn.toString()):d.push(C),d.push(C),d.join("\xA6")}v.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=m.createDecorator("markerService")}),define(Ee[147],ye([0,1,41,5,3]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=m.default,e.INotificationService=T.createDecorator("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new v,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=D;class v{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=v}),define(Ee[148],ye([0,1,7,8,2,5]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function k(D,v){return S.URI.isUri(D)?T.equalsIgnoreCase(D.scheme,v):T.startsWithIgnoreCase(D,v+":")}e.matchesScheme=k});var Ve=this&&this.__decorate||function(Z,e,m,T){var S=arguments.length,y=S<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,m):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Z,e,m,T);else for(var D=Z.length-1;D>=0;D--)(k=Z[D])&&(y=(S<3?k(y):S>3?k(e,m,y):k(e,m))||y);return S>3&&y&&Object.defineProperty(e,m,y),y},je=this&&this.__param||function(Z,e){return function(m,T){e(m,T,Z)}};define(Ee[149],ye([0,1,5,18,7,13]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=m.createDecorator("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let v=class extends S.Disposable{constructor(I,o){super();this.deferred=new y.DeferredPromise,o.withProgress(I,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(S.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};v=Ve([je(1,e.IProgressService)],v),e.UnmanagedProgress=v;class C extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const o=++this.currentOperationId,h=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(S.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(S.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(S.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:h.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=m.createDecorator("editorProgressService")}),define(Ee[43],ye([0,1,10,38]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(k,D){T.ok(m.isString(k)),T.ok(m.isObject(D)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(Ee[150],ye([0,1,43,3]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class y{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,C){this.schemasById[S(v)]=C,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new y;m.Registry.add(e.Extensions.JSONContribution,k)}),define(Ee[61],ye([0,1,124,3,43,10,150]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const v=S.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,E=!0){this.registerConfigurations([b],E)}registerConfigurations(b,E=!0){const c=[];b.forEach(f=>{c.push(...this.validateAndRegisterProperties(f,E,f.extensionInfo)),this.configurationContributors.push(f),this.registerJSONConfiguration(f)}),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(b){const E=[],c=f=>{if(f.properties)for(const g in f.properties)E.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,f.properties[g]);f.allOf&&f.allOf.forEach(g=>c(g))};for(const f of b){c(f);const g=this.configurationContributors.indexOf(f);g!==-1&&this.configurationContributors.splice(g,1)}v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(b){const E=[],c=[];for(const f of b)for(const g in f)if(E.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),f[g]);const t={type:"object",default:this.defaultValues[g],description:m.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};c.push(I(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=f[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(b){const E=[];for(const c of b)for(const f in c)if(E.push(f),delete this.defaultValues[f],e.OVERRIDE_PROPERTY_PATTERN.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const g=this.configurationProperties[f];g&&(this.updatePropertyDefaultValue(f,g),this.updateSchema(f,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const E of b)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,E=!0,c,f=3){var g;f=y.isUndefinedOrNull(b.scope)?f:b.scope;let t=[],i=b.properties;if(i)for(let r in i){if(E&&d(r)){delete i[r];continue}const u=i[r];if(this.updatePropertyDefaultValue(r,u),e.OVERRIDE_PROPERTY_PATTERN.test(r)?u.scope=void 0:(u.scope=y.isUndefinedOrNull(u.scope)?f:u.scope,u.restricted=y.isUndefinedOrNull(u.restricted)?!!((g=c==null?void 0:c.restrictedConfigurations)===null||g===void 0?void 0:g.includes(r)):u.restricted),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),t.push(r)}let s=b.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,E,c,f));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const E=c=>{let f=c.properties;if(f)for(const t in f)this.updateSchema(t,f[t]);let g=c.allOf;g&&g.forEach(E)};E(b)}updateSchema(b,E){switch(e.allSettings.properties[b]=E,E.scope){case 1:e.applicationSettings.properties[b]=E;break;case 2:e.machineSettings.properties[b]=E;break;case 6:e.machineOverridableSettings.properties[b]=E;break;case 3:e.windowSettings.properties[b]=E;break;case 4:e.resourceSettings.properties[b]=E;break;case 5:e.resourceSettings.properties[b]=E,this.resourceLanguageSettingsSchema.properties[b]=E;break}}removeFromSchema(b,E){switch(delete e.allSettings.properties[b],E.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const E=`[${b}]`,c={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,c),e.allSettings.properties[E]=c,e.applicationSettings.properties[E]=c,e.machineSettings.properties[E]=c,e.machineOverridableSettings.properties[E]=c,e.windowSettings.properties[E]=c,e.resourceSettings.properties[E]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,E){let c=this.defaultValues[b];y.isUndefined(c)&&(c=E.default),y.isUndefined(c)&&(c=o(E.type)),E.default=c}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function I(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=I;function o(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const h=new C;S.Registry.add(e.Extensions.Configuration,h);function d(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?m.localize(5,null,_):h.getConfigurationProperties()[_]!==void 0?m.localize(6,null,_):null:m.localize(4,null)}e.validateProperty=d;function l(){const _=[],b=h.getConfigurationProperties();for(const E of Object.keys(b))_.push([E,b[E].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=l}),define(Ee[90],ye([0,1,24,10,2,43,5,61]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function v(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}e.isConfigurationOverrides=v;var C;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(i,s){const r=s?i?s.keys.filter(R=>i.keys.indexOf(R)===-1):[...s.keys]:[],u=i?s?i.keys.filter(R=>s.keys.indexOf(R)===-1):[...i.keys]:[],w=[];if(s&&i){for(const R of i.keys)if(s.keys.indexOf(R)!==-1){const F=b(i.contents,R),U=b(s.contents,R);m.equals(F,U)||w.push(R)}}const p=[],P=R=>{const F={};for(const U of R)for(const X of U.identifiers)F[g(X)]=U;return F},A=s?P(s.overrides):{},a=i?P(i.overrides):{};if(Object.keys(A).length)for(const R of r){const F=A[R];F&&p.push([D.overrideIdentifierFromKey(R),F.keys])}if(Object.keys(a).length)for(const R of u){const F=a[R];F&&p.push([D.overrideIdentifierFromKey(R),F.keys])}if(Object.keys(A).length&&Object.keys(a).length)for(const R of w){const F=a[R],U=A[R];if(F&&U){const X=I({contents:F.contents,keys:F.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});p.push([D.overrideIdentifierFromKey(R),[...X.added,...X.removed,...X.updated]])}}return{added:r,removed:u,updated:w,overrides:p}}e.compare=I;function o(i,s){const r=[];for(const u of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const w={};for(const p in i[u])w[p]=i[u][p];r.push({identifiers:[D.overrideIdentifierFromKey(u).trim()],keys:Object.keys(w),contents:h(w,s)})}return r}e.toOverrides=o;function h(i,s){const r=Object.create(null);for(let u in i)d(r,u,i[u],s);return r}e.toValuesTree=h;function d(i,s,r,u){const w=s.split("."),p=w.pop();let P=i;for(let A=0;A<w.length;A++){let a=w[A],R=P[a];switch(typeof R){case"undefined":R=P[a]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${w.slice(0,A+1).join(".")} is ${JSON.stringify(R)}`);return}P=R}if(typeof P=="object"&&P!==null)try{P[p]=r}catch(A){u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(P)}`)}else u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=d;function l(i,s){const r=s.split(".");_(i,r)}e.removeFromValueTree=l;function _(i,s){const r=s.shift();if(s.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const u=i[r];typeof u=="object"&&!Array.isArray(u)&&(_(u,s),Object.keys(u).length===0&&delete i[r])}}function b(i,s,r){function u(P,A){let a=P;for(const R of A){if(typeof a!="object"||a===null)return;a=a[R]}return a}const w=s.split("."),p=u(i,w);return typeof p=="undefined"?r:p}e.getConfigurationValue=b;function E(i,s,r){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in i?T.isObject(i[u])&&T.isObject(s[u])?E(i[u],s[u],r):r&&(i[u]=s[u]):i[u]=s[u])})}e.merge=E;function c(){const i=y.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=c;function f(){const i=Object.create(null),s=y.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let u=s[r].default;d(i,r,u,w=>console.error(`Conflict in default settings: ${w}`))}return i}e.getDefaultValues=f;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,r){const u=i.inspect(s),w=i.inspect(r);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Ee[151],ye([0,1,107,22,17,10,24,2,61,90,43,7,3]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?C.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[r],w=i[r];w&&(typeof u=="object"&&typeof w=="object"?(u=k.deepClone(u),this.mergeContents(u,w)):u=w),s[r]=u}return new h(s,this.keys,this.overrides)}merge(...t){const i=k.deepClone(this.contents),s=k.deepClone(this.overrides),r=[...this.keys];for(const u of t){this.mergeContents(i,u.contents);for(const w of u.overrides){const[p]=s.filter(P=>S.equals(P.identifiers,w.identifiers));p?this.mergeContents(p.contents,w.contents):s.push(k.deepClone(w))}for(const w of u.keys)r.indexOf(w)===-1&&r.push(w)}return new h(i,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=k.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),C.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class d extends h{constructor(){const t=C.getDefaultValues(),i=C.getConfigurationKeys(),s=[];for(const r of Object.keys(t))v.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[v.overrideIdentifierFromKey(r).trim()],keys:Object.keys(t[r]),contents:C.toValuesTree(t[r],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,i,s)}}e.DefaultConfigurationModel=d;class l{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:r,overrides:u,restricted:w}=this.doParseRaw(t,i);this._configurationModel=new h(s,r,u),this._restrictedConfigurations=w||[]}doParseContent(t){let i={},s=null,r=[],u=[],w=[];function p(A){Array.isArray(r)?r.push(A):s&&(r[s]=A)}let P={onObjectBegin:()=>{let A={};p(A),u.push(r),r=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{let A=[];p(A),u.push(r),r=A,s=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:p,onError:(A,a,R)=>{w.push({error:A,offset:a,length:R})}};if(t)try{m.visit(t,P),i=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(t,i){const s=n.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,i);t=r.raw;const u=C.toValuesTree(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),w=Object.keys(t),p=C.toOverrides(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:u,keys:w,overrides:p,restricted:r.restricted}}filter(t,i,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const u={},w=[];for(let p in t)if(v.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const P=this.filter(t[p],i,!1,r);u[p]=P.raw,w.push(...P.restricted)}else{const P=i[p],A=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&w.push(p),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&(P==null?void 0:P.restricted)||(u[p]=t[p]))}return{raw:u,restricted:w}}}e.ConfigurationModelParser=l;class _ extends I.Disposable{constructor(t,i,s,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class b{constructor(t,i,s=new h,r=new h,u=new T.ResourceMap,w=new h,p=new T.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=u,this._memoryConfiguration=w,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new h,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const r=this.getConsolidateConfigurationModel(i,s),u=this.getFolderConfigurationModelForResource(i.resource,s),w=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,U=i.overrideIdentifier?w.override(i.overrideIdentifier).getValue(t):w.getValue(t),X=r.getValue(t),oe=S.distinct(S.flatten(r.overrides.map(j=>j.identifiers))).filter(j=>r.getOverrideValue(t,j)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:A,userRemoteValue:a,workspaceValue:R,workspaceFolderValue:F,memoryValue:U,value:X,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:i.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:w.getValue(t),override:i.overrideIdentifier?w.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(r=>v.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const u=v.overrideIdentifierFromKey(r),w=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=t.getKeysForOverrideIdentifier(u),P=[...p.filter(A=>w.indexOf(A)===-1),...w.filter(A=>p.indexOf(A)===-1),...w.filter(A=>!k.equals(this._defaultConfiguration.override(u).getValue(A),t.override(u).getValue(A)))];return[u,P]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:r,overrides:u}=C.compare(this.localUserConfiguration,t),w=[...i,...s,...r];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:r,overrides:u}=C.compare(this.remoteUserConfiguration,t);let w=[...i,...s,...r];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:r,overrides:u}=C.compare(this.workspaceConfiguration,t);let w=[...i,...s,...r];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:r,updated:u,removed:w,overrides:p}=C.compare(s,i);let P=[...r,...u,...w];return(P.length||!s)&&this.updateFolderConfiguration(t,i),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:u,overrides:w}=C.compare(i,void 0);return{keys:[...s,...r,...u],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=s.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:r,keys:u}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:r,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((w,p)=>(w.set(D.URI.revive(p[0]),this.parseConfigurationModel(p[1])),w),new T.ResourceMap);return new b(i,s,new h,r,u,new h,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function E(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const r of g)r.keys.forEach(u=>t.add(u)),r.overrides.forEach(([u,w])=>{const p=T.getOrSet(i,u,new Set);w.forEach(P=>p.add(P))});const s=[];return i.forEach((r,u)=>s.push([u,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class c{constructor(t,i,s,r){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(p=>u.add(p)),t.overrides.forEach(([,p])=>p.forEach(P=>u.add(P))),this.affectedKeys=[...u.values()];const w=new h;this.affectedKeys.forEach(p=>w.setValue(p,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!k.equals(r,u)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=C.toValuesTree({[i]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=c;class f extends c{constructor(t,i,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=f}),define(Ee[91],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(k,D=T.Unknown,v){super(k);this._message=k,this._code=D,this._detail=v,this.isHandled=D===T.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof S&&k.isHandled}}e.RemoteAuthorityResolverError=S}),define(Ee[92],ye([0,1,12]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===m.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function S(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=S;function y(C){return C.scheme!==m.Schemas.file&&C.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=y;function k(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function D(C){var n;return(n=k(C))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D;function v(C){return k(C)!==void 0}e.isVirtualWorkspace=v}),define(Ee[152],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,y,k=5){let D;return D=y(v=>{const C=typeof v=="string"?v:v.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(S),k);n={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,n)}),D}stopBuffering(S){const y=this._terminalBufferMap.get(S);y&&y.dispose()}flushBuffer(S){const y=this._terminalBufferMap.get(S);y&&(this._terminalBufferMap.delete(S),this._callback(S,y.data.join("")))}}e.TerminalDataBufferer=m}),define(Ee[44],ye([0,1,2,25,5,22]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=S.createDecorator("contextService");var k;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function D(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=D;function v(o){const h=o;return!!(h&&typeof h=="object"&&m.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=v;class C{constructor(h,d,l,_){this._id=h,this._configuration=l,this._ignorePathCasing=_,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(h,d){this.raw=d,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return T.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(o){return new n({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=I}),define(Ee[62],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const y=this._idPool++;return this._data.set(y,S),this.logDebugInfo(),y}get(S,y){return this._data.has(S)?this._data.get(S)[y]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(Ee[63],ye([0,1,2,3,5]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=S.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(v=>({name:v.name,group:v.group,resource:m.URI.revive(v.resource),isActive:v.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(Ee[45],ye([0,1,12,5]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(Ee[28],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=m.createDecorator("IExtHostInitDataService")}),define(Ee[153],ye([0,1,13]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,D,v){this._deferredPromises=new Map,this._id=k,this._shared=D,this._storage=v,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const I of C.values())I.error(n)}})()},0)}get keys(){var k;return Object.entries((k=this._value)!==null&&k!==void 0?k:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(k,D){let v=this._value[k];return typeof v=="undefined"&&(v=D),v}update(k,D){this._value[k]=D;let v=this._deferredPromises.get(k);if(v!==void 0)return v.p;const C=new m.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class S extends T{constructor(k,D){super(k.identifier.value,!0,D);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=S}),define(Ee[154],ye([0,1,3,2,16]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(D,v){this._logService=D,this._notebooksAndEditors=v,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,v,C){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptModelChanged(v,C)}$acceptDirtyStateChanged(D,v){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptDirty(v)}$acceptModelSaved(D){const v=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));this._onDidSaveNotebookDocument.fire(v.apiNotebook)}$acceptDocumentPropertiesChanged(D,v){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,v);const C=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));C.acceptDocumentPropertiesChanged(v),v.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=Ve([je(0,S.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(Ee[14],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=m.createDecorator("IExtHostRpcService");class T{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=T});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[155],ye([0,1,26,3]),function(Z,e,m,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(D,v){S.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(D.identifier),rt(this,S,v,"f"),xe(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return xe(this,S,"f").get(this._id,D)}store(D,v){return xe(this,S,"f").store(this._id,D,v)}delete(D){return xe(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=y,S=new WeakMap}),define(Ee[93],ye([0,1,5,3]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=m.createDecorator("IExtHostTelemetry")}),define(Ee[94],ye([0,1,3]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const S=new WeakMap,y=k=>{let D=S.get(k);return D||(D={children:new Map,bus:new m.Emitter},S.set(k,D)),D};e.getPrivateApiFor=y}),define(Ee[64],ye([0,1,5,3,14]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(D){function v(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}D.fromApiTunnel=v;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}D.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=m.createDecorator("IExtHostTunnelService");let k=class{constructor(v){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(v){return v}async openTunnel(v,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(v){return{dispose:()=>{}}}registerPortsAttributesProvider(v,C){return{dispose:()=>{}}}async $providePortAttributes(v,C,n,I,o){return[]}async $forwardPort(v,C){}async $closeTunnel(v){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([je(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[6],ye([0,1,17,11,79,22,81,10,2,34,59,91,94]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o){"use strict";var h,d,l,_,b,E,c,f,g,t,i,s,r,u,w,p,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let R=b=class{constructor(L){h.set(this,void 0),rt(this,h,L,"f")}static from(...L){let te=L;return new b(function(){if(te){for(const ke of te)ke&&typeof ke.dispose=="function"&&ke.dispose();te=void 0}})}dispose(){typeof xe(this,h,"f")=="function"&&(xe(this,h,"f").call(this),rt(this,h,void 0,"f"))}};h=new WeakMap,R=b=Ve([a],R),e.Disposable=R;let F=E=class{constructor(L,te){if(L<0)throw T.illegalArgument("line must be non-negative");if(te<0)throw T.illegalArgument("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let ke=1;ke<L.length;ke++){const Ge=L[ke];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let ke=1;ke<L.length;ke++){const Ge=L[ke];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(L){if(!L)return!1;if(L instanceof E)return!0;let{line:te,character:ke}=L;return typeof te=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw T.illegalArgument();let ke;return typeof L=="undefined"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&te===0?this:new E(this.line+ke,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw T.illegalArgument();let ke;return typeof L=="undefined"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),ke===this.line&&te===this.character?this:new E(ke,te)}toJSON(){return{line:this.line,character:this.character}}};F=E=Ve([a],F),e.Position=F;let U=c=class{constructor(L,te,ke,Ge){let it,ot;if(typeof L=="number"&&typeof te=="number"&&typeof ke=="number"&&typeof Ge=="number"?(it=new F(L,te),ot=new F(ke,Ge)):L instanceof F&&te instanceof F&&(it=L,ot=te),!it||!ot)throw new Error("Invalid arguments");it.isBefore(ot)?(this._start=it,this._end=ot):(this._start=ot,this._end=it)}static isRange(L){return L instanceof c?!0:L?F.isPosition(L.start)&&F.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof c?this.contains(L._start)&&this.contains(L._end):L instanceof F?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=F.Max(L.start,this._start),ke=F.Min(L.end,this._end);if(!te.isAfter(ke))return new c(te,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=F.Min(L.start,this._start),ke=F.Max(L.end,this.end);return new c(te,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw T.illegalArgument();let ke;return L?F.isPosition(L)?ke=L:(ke=L.start||this.start,te=L.end||this.end):ke=this.start,ke.isEqual(this._start)&&te.isEqual(this.end)?this:new c(ke,te)}toJSON(){return[this.start,this.end]}};U=c=Ve([a],U),e.Range=U;let X=f=class extends U{constructor(L,te,ke,Ge){let it,ot;if(typeof L=="number"&&typeof te=="number"&&typeof ke=="number"&&typeof Ge=="number"?(it=new F(L,te),ot=new F(ke,Ge)):L instanceof F&&te instanceof F&&(it=L,ot=te),!it||!ot)throw new Error("Invalid arguments");super(it,ot);this._anchor=it,this._active=ot}static isSelection(L){return L instanceof f?!0:L?U.isRange(L)&&F.isPosition(L.anchor)&&F.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};X=f=Ve([a],X),e.Selection=X;class oe{constructor(L,te,ke){if(typeof L!="string"||L.length===0)throw T.illegalArgument("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw T.illegalArgument("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw T.illegalArgument("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=ke}}e.ResolvedAuthority=oe;class j extends Error{constructor(L,te=I.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L);this._message=L,this._code=te,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(L,te){return new j(L,I.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new j(L,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var W;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var K;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(K=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=g=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof g?!0:L?U.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new g(L,te)}static insert(L,te){return g.replace(new U(L,L),te)}static delete(L){return g.replace(L,"")}static setEndOfLine(L){const te=new g(new U(new F(0,0),new F(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!U.isRange(L))throw T.illegalArgument("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw T.illegalArgument("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw T.illegalArgument("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=g=Ve([a],M),e.TextEdit=M;var Y;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(Y=e.FileEditType||(e.FileEditType={}));let x=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,ke,Ge){this._edits.push({_type:1,from:L,to:te,options:ke,metadata:Ge})}createFile(L,te,ke){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:ke})}deleteFile(L,te,ke){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:ke})}replaceNotebookMetadata(L,te,ke){this._edits.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,ke,Ge,it){let ot,lt,St=[],It;if(qt.isNotebookRange(te)&&Rt.isNotebookCellDataArray(ke)&&!Rt.isNotebookCellDataArray(Ge)?(ot=te.start,lt=te.end,St=ke,It=Ge):typeof te=="number"&&typeof ke=="number"&&Rt.isNotebookCellDataArray(Ge)&&(ot=te,lt=ke,St=Ge,It=it),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||St.length>0)&&this._edits.push({_type:5,uri:L,index:ot,count:lt-ot,cells:St,metadata:It})}replaceNotebookCellMetadata(L,te,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:te,metadata:ke}})}replace(L,te,ke,Ge){this._edits.push({_type:2,uri:L,edit:new M(te,ke),metadata:Ge})}insert(L,te,ke,Ge){this.replace(L,new U(te,te),ke,Ge)}delete(L,te,ke){this.replace(L,te,"",ke)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const ke of te)ke&&this._edits.push({_type:2,uri:L,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[ke]=void 0)}m.coalesceInPlace(this._edits)}}get(L){const te=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===L.toString()&&te.push(ke.edit);return te}entries(){const L=new y.ResourceMap;for(let te of this._edits)if(te._type===2){let ke=L.get(te.uri);ke||(ke=[te.uri,[]],L.set(te.uri,ke)),ke[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};x=Ve([a],x),e.WorkspaceEdit=x;let O=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const ke=new t;ke._tabstop=this._tabstop,L(ke),this._tabstop=ke._tabstop,L=ke.value}else L=t._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const ke=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const ke=new t;ke._tabstop=this._tabstop,te(ke),this._tabstop=ke._tabstop,te=ke.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};O=t=Ve([a],O),e.SnippetString=O;var Q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var V;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(V=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let le=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof U)this.range=te;else if(te instanceof F)this.range=new U(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?U.isRange(L.range)&&v.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};le=i=Ve([a],le),e.Location=le;let be=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&U.isRange(L.location.range)&&v.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};be=Ve([a],be),e.DiagnosticRelatedInformation=be;let Te=class{constructor(L,te,ke=V.Error){if(!U.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=ke}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&m.equals(L.tags,te.tags)&&m.equals(L.relatedInformation,te.relatedInformation,be.isEqual)}};Te=Ve([a],Te),e.Diagnostic=Te;let He=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};He=Ve([a],He),e.Hover=He;var Me;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor(L,te=Me.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Me[this.kind]}}};qe=Ve([a],qe),e.DocumentHighlight=qe;var nt;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(nt=e.SymbolKind||(e.SymbolKind={}));var Je;(function(N){N[N.Deprecated=1]="Deprecated"})(Je=e.SymbolTag||(e.SymbolTag={}));let Xe=s=class{constructor(L,te,ke,Ge,it){this.name=L,this.kind=te,this.containerName=it,typeof ke=="string"&&(this.containerName=ke),Ge instanceof le?this.location=Ge:ke instanceof U&&(this.location=new le(Ge,ke)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:nt[this.kind],location:this.location,containerName:this.containerName}}};Xe=s=Ve([a],Xe),e.SymbolInformation=Xe;let B=r=class{constructor(L,te,ke,Ge,it){this.name=L,this.detail=te,this.kind=ke,this.range=Ge,this.selectionRange=it,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};B=r=Ve([a],B),e.DocumentSymbol=B;var G;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(L,te){this.title=L,this.kind=te}};ne=Ve([a],ne),e.CodeAction=ne;let re=u=class{constructor(L){this.value=L}append(L){return new u(this.value?this.value+u.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+u.sep)}};re.sep=".",re=u=Ve([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let q=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};q=Ve([a],q),e.SelectionRange=q;class se{constructor(L,te,ke,Ge,it,ot){this.kind=L,this.name=te,this.detail=ke,this.uri=Ge,this.range=it,this.selectionRange=ot}}e.CallHierarchyItem=se;class he{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=he;class Re{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=Re;let Be=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};Be=Ve([a],Be),e.CodeLens=Be;let ve=w=class{constructor(L,te=!1){d.set(this,void 0),rt(this,d,new S.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return xe(this,d,"f").value}set value(L){xe(this,d,"f").value=L}get isTrusted(){return xe(this,d,"f").isTrusted}set isTrusted(L){xe(this,d,"f").isTrusted=L}get supportThemeIcons(){return xe(this,d,"f").supportThemeIcons}set supportThemeIcons(L){xe(this,d,"f").supportThemeIcons=L}appendText(L){return xe(this,d,"f").appendText(L),this}appendMarkdown(L){return xe(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,te){return xe(this,d,"f").appendCodeblock(te??"",L),this}};d=new WeakMap,ve=w=Ve([a],ve),e.MarkdownString=ve;let Ke=class{constructor(L,te){this.label=L,this.documentation=te}};Ke=Ve([a],Ke),e.ParameterInformation=Ke;let H=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};H=Ve([a],H),e.SignatureInformation=H;let ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ee=Ve([a],ee),e.SignatureHelp=ee;var me;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Oe=class{constructor(L,te,ke){this.text=L,this.position=te,this.kind=ke}};Oe=Ve([a],Oe),e.InlayHint=Oe;var Qe;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(N){N[N.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let Ie=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ie=Ve([a],Ie),e.CompletionItem=Ie;let ie=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};ie=Ve([a],ie),e.CompletionList=ie;let ue=class{constructor(L,te,ke){this.text=L,this.range=te,this.command=ke}};ue=Ve([a],ue),e.InlineSuggestion=ue;let de=class{constructor(L){this.items=L}};de=Ve([a],de),e.InlineSuggestions=de;var ge;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ge=e.ViewColumn||(e.ViewColumn={}));var $;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})($=e.StatusBarAlignment||(e.StatusBarAlignment={}));var fe;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(fe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var we;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(we=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Pe;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Le;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var $e;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})($e=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(Le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let We=class{constructor(L,te){if(te&&!v.URI.isUri(te))throw T.illegalArgument("target");if(!U.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.target=te}};We=Ve([a],We),e.DocumentLink=We;let Ye=class{constructor(L,te,ke,Ge){this.red=L,this.green=te,this.blue=ke,this.alpha=Ge}};Ye=Ve([a],Ye),e.Color=Ye;let tt=class{constructor(L,te){if(te&&!(te instanceof Ye))throw T.illegalArgument("color");if(!U.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.color=te}};tt=Ve([a],tt),e.ColorInformation=tt;let ut=class{constructor(L){if(!L||typeof L!="string")throw T.illegalArgument("label");this.label=L}};ut=Ve([a],ut),e.ColorPresentation=ut;var pe;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(pe=e.ColorFormat||(e.ColorFormat={}));var De;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ae{constructor(L,te,ke){if(this.startIndex=L,this.length=te,this.tooltip=ke,typeof L!="number"||L<0)throw T.illegalArgument("startIndex");if(typeof te!="number"||te<1)throw T.illegalArgument("length");if(ke!==void 0&&typeof ke!="string")throw T.illegalArgument("tooltip")}}e.TerminalLink=ae;class z{constructor(L){this.options=L,typeof L!="object"&&T.illegalArgument("options")}}e.TerminalProfile=z;var Ue;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Se;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Se=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=p=class{constructor(L,te){if(typeof L!="string"||typeof te!="string")throw T.illegalArgument("name");this._id=L}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};ze.Clean=new p("clean","Clean"),ze.Build=new p("build","Build"),ze.Rebuild=new p("rebuild","Rebuild"),ze.Test=new p("test","Test"),ze=p=Ve([a],ze),e.TaskGroup=ze;function Ze(N){let L="";for(let te=0;te<N.length;te++)L+=N[te].replace(/,/g,",,")+",";return L}let et=class{constructor(L,te,ke){if(typeof L!="string")throw T.illegalArgument("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=ke):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw T.illegalArgument("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Ze(L)}};et=Ve([a],et),e.ProcessExecution=et;let st=class{constructor(L,te,ke){if(this._args=[],Array.isArray(te)){if(!L)throw T.illegalArgument("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L,this._args=te,this._options=ke}else{if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Ze(L)}};st=Ve([a],st),e.ShellExecution=st;var pt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class _t{constructor(L){this._callback=L}computeId(){return"customExecution"+C.generateUuid()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=_t;let vt=P=class{constructor(L,te,ke,Ge,it,ot){this.__deprecated=!1,this._definition=this.definition=L;let lt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=ke,this.execution=Ge,lt=it,this.__deprecated=!0):te===bt.Global||te===bt.Workspace?(this.target=te,this._name=this.name=ke,this._source=this.source=Ge,this.execution=it,lt=ot):(this.target=te,this._name=this.name=ke,this._source=this.source=Ge,this.execution=it,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(L){if(L==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw T.illegalArgument("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(P.EmptyType===te||P.ProcessType===te||P.ShellType===te||P.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=P=Ve([a],vt),e.Task=vt;var Bt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Bt=e.ProgressLocation||(e.ProgressLocation={}));let Et=class{constructor(L,te=ht.None){this.collapsibleState=te,v.URI.isUri(L)?this.resourceUri=L:this.label=L}};Et=Ve([a],Et),e.TreeItem=Et;var ht;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ct=class{constructor(L,te){this.id=L,this.color=te}};ct=Ve([a],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let ft=class{constructor(L){this.id=L}};ft=Ve([a],ft),e.ThemeColor=ft;var Ht;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,te){if(typeof L!="string"&&(!L||!v.URI.isUri(L)&&!v.URI.isUri(L.uri)))throw T.illegalArgument("base");if(typeof te!="string")throw T.illegalArgument("pattern");typeof L=="string"?(this.baseFolder=v.URI.file(L),this.base=L):v.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};kt=Ve([a],kt),e.RelativePattern=kt;let At=class{constructor(L,te,ke,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};At=Ve([a],At),e.Breakpoint=At;let Kt=class extends At{constructor(L,te,ke,Ge,it){super(te,ke,Ge,it);if(L===null)throw T.illegalArgument("location");this.location=L}};Kt=Ve([a],Kt),e.SourceBreakpoint=Kt;let yt=class extends At{constructor(L,te,ke,Ge,it){super(te,ke,Ge,it);this.functionName=L}};yt=Ve([a],yt),e.FunctionBreakpoint=yt;let en=class extends At{constructor(L,te,ke,Ge,it,ot,lt){super(Ge,it,ot,lt);if(!te)throw T.illegalArgument("dataId");this.label=L,this.dataId=te,this.canPersist=ke}};en=Ve([a],en),e.DataBreakpoint=en;let tn=class{constructor(L,te,ke){this.command=L,this.args=te||[],this.options=ke}};tn=Ve([a],tn),e.DebugAdapterExecutable=tn;let gt=class{constructor(L,te){this.port=L,this.host=te}};gt=Ve([a],gt),e.DebugAdapterServer=gt;let Qt=class{constructor(L){this.path=L}};Qt=Ve([a],Qt),e.DebugAdapterNamedPipeServer=Qt;let zt=class{constructor(L){this.implementation=L}};zt=Ve([a],zt),e.DebugAdapterInlineImplementation=zt;let nn=class{constructor(L,te){this.range=L,this.expression=te}};nn=Ve([a],nn),e.EvaluatableExpression=nn;var _n;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(_n=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dt=class{constructor(L,te){this.range=L,this.text=te}};Dt=Ve([a],Dt),e.InlineValueText=Dt;let Yt=class{constructor(L,te,ke=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=ke}};Yt=Ve([a],Yt),e.InlineValueVariableLookup=Yt;let rn=class{constructor(L,te){this.range=L,this.expression=te}};rn=Ve([a],rn),e.InlineValueEvaluatableExpression=rn;let $t=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};$t=Ve([a],$t),e.InlineValueContext=$t;var dt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(dt=e.FileChangeType||(e.FileChangeType={}));let sn=A=class extends Error{constructor(L,te=n.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(v.URI.isUri(L)?L.toString(!0):L);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",n.markAsFileSystemProviderError(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(L){return new A(L,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(L){return new A(L,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(L){return new A(L,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(L){return new A(L,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};sn=A=Ve([a],sn),e.FileSystemError=sn;let Tt=class{constructor(L,te,ke){this.start=L,this.end=te,this.kind=ke}};Tt=Ve([a],Tt),e.FoldingRange=Tt;var Vt;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Vt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var En;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(En=e.CommentMode||(e.CommentMode={}));class fn{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=fn;function yn(N){return typeof N=="undefined"||D.isStringArray(N)}class Jt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,ke=L.tokenTypes.length;te<ke;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,ke=L.tokenModifiers.length;te<ke;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,ke,Ge,it){if(typeof L=="number"&&typeof te=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(L,te,ke,Ge,it);if(U.isRange(L)&&typeof te=="string"&&yn(ke))return this._push(L,te,ke);throw T.illegalArgument()}_push(L,te,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,it=L.start.character,ot=L.end.character-L.start.character,lt=this._tokenTypeStrToInt.get(te);let St=0;if(ke)for(const It of ke){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(It);St|=1<<Ft>>>0}this._pushEncoded(Ge,it,ot,lt,St)}_pushEncoded(L,te,ke,Ge,it){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Ft=0;for(let Nt=0;Nt<St;Nt++){let Ut=this._data[5*Nt],cn=this._data[5*Nt+1];Ut===0?(Ut=It,cn+=Ft):Ut+=It,this._data[5*Nt]=Ut,this._data[5*Nt+1]=cn,It=Ut,Ft=cn}}let ot=L,lt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=it,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const ke=L.length/5|0;for(let lt=0;lt<ke;lt++)te[lt]=lt;te.sort((lt,St)=>{const It=L[5*lt],Ft=L[5*St];if(It===Ft){const Nt=L[5*lt+1],Ut=L[5*St+1];return Nt-Ut}return It-Ft});const Ge=new Uint32Array(L.length);let it=0,ot=0;for(let lt=0;lt<ke;lt++){const St=5*te[lt],It=L[St+0],Ft=L[St+1],Nt=L[St+2],Ut=L[St+3],cn=L[St+4],Nn=It-it,Wn=Nn===0?Ft-ot:Ft,dn=5*lt;Ge[dn+0]=Nn,Ge[dn+1]=Wn,Ge[dn+2]=Nt,Ge[dn+3]=Ut,Ge[dn+4]=cn,it=It,ot=Ft}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new Lt(new Uint32Array(this._data),L):new Lt(Jt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Jt;class Lt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=Lt;class Sn{constructor(L,te,ke){this.start=L,this.deleteCount=te,this.data=ke}}e.SemanticTokensEdit=Sn;class on{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=on;var an;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new ct("arrow-left")},Xt=Ve([a],Xt),e.QuickInputButtons=Xt;var jt;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(jt=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(L,te,ke){this.badge=L,this.tooltip=te,this.color=ke}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor(L){this.kind=L}};ln=Ve([a],ln),e.ColorTheme=ln;var kn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(kn=e.ColorThemeKind||(e.ColorThemeKind={}));class qt{constructor(L,te){if(L<0)throw T.illegalArgument("start must be positive");if(te<0)throw T.illegalArgument("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof qt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,ke=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(ke=L.end),te===this._start&&ke===this._end?this:new qt(te,ke)}}e.NotebookRange=qt;class Rt{constructor(L,te,ke,Ge,it,ot,lt){this.kind=L,this.value=te,this.languageId=ke,this.mime=Ge,this.outputs=it??[],this.metadata=ot,this.executionSummary=lt,Rt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Rt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Rt;class mn{constructor(L){this.cells=L}}e.NotebookData=mn;class Pt{constructor(L,te){this.data=L,this.mime=te;const ke=k.normalizeMimeType(te,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+te);this.mime=ke}static isNotebookCellOutputItem(L){return L instanceof Pt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Pt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Pt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Pt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Pt(L,te)}static text(L,te=k.Mimes.text){const ke=xe(Pt,l,"f",_).encode(String(L));return new Pt(ke,te)}static json(L,te="application/json"){const ke=JSON.stringify(L,void 0,"	");return Pt.text(ke,te)}}e.NotebookCellOutputItem=Pt,l=Pt,_={value:new TextEncoder};class Wt{constructor(L,te,ke){this.items=Wt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=ke):(this.id=C.generateUuid(),this.metadata=te??ke)}static isNotebookCellOutput(L){return L instanceof Wt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&D.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const ke=new Set,Ge=new Set;for(let it=0;it<L.length;it++){const ot=L[it],lt=k.normalizeMimeType(ot.mime);if(!ke.has(lt)){ke.add(lt);continue}Ge.add(it),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ge.size===0?L:L.filter((it,ot)=>!Ge.has(ot))}}e.NotebookCellOutput=Wt;var Ne;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Ne=e.NotebookCellKind||(e.NotebookCellKind={}));var un;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class In{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=In;var Pn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(L,te=[]){this.uri=L,this.provides=m.asArray(te)}}e.NotebookRendererScript=pn;let Zt=class{constructor(L,te){this.label=L,this.timestamp=te}};Zt=Ve([a],Zt),e.TimelineItem=Zt;var An;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Fn;class vn{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=vn;var Ln;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var bn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));const Mt=(N,L,te,ke)=>{let Ge=te;return{enumerable:!0,configurable:!1,get(){return Ge},set(it){ke(Ge,it)||(Ge=it,N.bus.fire([3,L,it]))}}},Ot=(N,L)=>N===L,Mn=(N,L)=>N===L?!0:!N||!L?!1:N.isEqual(L);class J{constructor(L,te,ke=!1){this.tests=L,this.exclude=te,this.debug=ke}}e.TestRunRequest=J;class ce{constructor(L,te,ke,Ge,it){this.data=Ge;const ot=o.getPrivateApiFor(this);if(Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,value:it,writable:!1},children:{value:new y.ReadonlyMapView(ot.children),enumerable:!0,writable:!1},range:Mt(ot,"range",void 0,Mn),label:Mt(ot,"label",te,Ot),description:Mt(ot,"description",void 0,Ot),runnable:Mt(ot,"runnable",!0,Ot),debuggable:Mt(ot,"debuggable",!1,Ot),canResolveChildren:Mt(ot,"canResolveChildren",!1,Ot),busy:Mt(ot,"busy",!1,Ot),error:Mt(ot,"error",void 0,Ot)}),it){if(!(it instanceof ce))throw new Error(`The "parent" passed in for TestItem ${L} is invalid`);const lt=o.getPrivateApiFor(it);if(lt.children.has(L))throw new Error(`Attempted to insert a duplicate test item ID ${L}`);lt.children.set(L,this),lt.bus.fire([0,this])}}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){this.parent&&o.getPrivateApiFor(this.parent).children.delete(this.id),o.getPrivateApiFor(this).bus.fire([1])}}e.TestItemImpl=ce;class Ae{constructor(L){this.message=L,this.severity=bn.Error}static diff(L,te,ke){const Ge=new Ae(L);return Ge.expectedOutput=te,Ge.actualOutput=ke,Ge}}e.TestMessage=Ae;var at;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(at=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(wt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ct;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(Ee[95],ye([0,1,38,12,8,120,84,6,17]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(d,l){l?C.set(d,l):C.delete(d)}e.setWordDefinitionFor=n;function I(d){return C.get(d)}e.getWordDefinitionFor=I;class o extends y.MirrorTextModel{constructor(l,_,b,E,c,f,g,t){super(_,b,E,c);this._proxy=l,this._languageId=f,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){m.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return v.equals(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===T.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(_){return _?l._getTextInRange(_):l.getText()},get eol(){return l._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(_){return l._lineAt(_)},offsetAt(_){return l._offsetAt(_)},positionAt(_){return l._positionAt(_)},validateRange(_){return l._validateRange(_)},validatePosition(_){return l._validatePosition(_)},getWordRangeAtPosition(_,b){return l._getWordRangeAtPosition(_,b)}}}return Object.freeze(this._document)}_acceptLanguageId(l){m.ok(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){m.ok(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const _=this._validateRange(l);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const b=this._eol,E=_.start.line,c=_.end.line,f=[];f.push(this._lines[E].substring(_.start.character));for(let g=E+1;g<c;g++)f.push(this._lines[g]);return f.push(this._lines[c].substring(0,_.end.character)),f.join(b)}_lineAt(l){let _;if(l instanceof D.Position?_=l.line:typeof l=="number"&&(_=l),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new h(_,this._lines[_],_===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(l),b=this._lines[_.index].length;return new D.Position(_.index,Math.min(_.remainder,b))}_validateRange(l){if(!(l instanceof D.Range))throw new Error("Invalid argument");const _=this._validatePosition(l.start),b=this._validatePosition(l.end);return _===l.start&&b===l.end?l:new D.Range(_.line,_.character,b.line,b.character)}_validatePosition(l){if(!(l instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:_,character:b}=l,E=!1;if(_<0)_=0,b=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,b=this._lines[_].length,E=!0;else{const c=this._lines[_].length;b<0?(b=0,E=!0):b>c&&(b=c,E=!0)}return E?new D.Position(_,b):l}_getWordRangeAtPosition(l,_){const b=this._validatePosition(l);if(!_)_=I(this._languageId);else if(S.regExpLeadsToEndlessLoop(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=k.getWordAtText(b.character+1,k.ensureValidWordDefinition(_),this._lines[b.line],0);if(E)return new D.Range(b.line,E.startColumn-1,b.line,E.endColumn-1)}}e.ExtHostDocumentData=o;class h{constructor(l,_,b){this._line=l,this._text=_,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(Ee[156],ye([0,1,6,3,86,7,55,22,2,34]),function(Z,e,m,T,S,y,k,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(o,h,d,l){this._notebook=d,this._selector=l,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=v.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(b=>{const E=this._cellUris.get(b.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(b=>_(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const o=[],h=[];for(const d of this._notebook.getCells())d.kind===m.NotebookCellKind.Code&&(!this._selector||k.score(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),o.push(d.document.getText().length+1),h.push(d.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(o){var h,d;if(!o){let c="";for(const f of this._cells)c+=f.document.getText()+`
`;return c=c.slice(0,-1),c}if(o.isEmpty)return"";const l=this.locationAt(o.start),_=this.locationAt(o.end),b=this._cells[(h=this._cellUris.get(l.uri))!==null&&h!==void 0?h:-1],E=this._cells[(d=this._cellUris.get(_.uri))!==null&&d!==void 0?d:-1];if(!b||!E)return"";if(b===E)return b.document.getText(new m.Range(l.range.start,_.range.end));{const c=b.document.getText(new m.Range(l.range.start,new m.Position(b.document.lineCount,0))),f=E.document.getText(new m.Range(new m.Position(0,0),_.range.end));return c+`
`+f}}offsetAt(o){const h=this._cellLines.getIndexOf(o.line),d=this._cellLengths.getPrefixSum(h.index-1),l=this._cells[h.index].document.offsetAt(o.with(h.remainder));return d+l}positionAt(o){if(typeof o=="number"){const d=this._cellLengths.getIndexOf(o),l=this._cellLines.getPrefixSum(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(l)}const h=this._cellUris.get(o.uri);if(h!==void 0){const d=this._cellLines.getPrefixSum(h-1);return new m.Position(d+o.range.start.line,o.range.start.character)}return new m.Position(0,0)}locationAt(o){m.Range.isRange(o)||(o=new m.Range(o,o));const h=this._cellLines.getIndexOf(o.start.line);let d=h;o.isEmpty||(d=this._cellLines.getIndexOf(o.end.line));const l=new m.Position(h.remainder,o.start.character),_=new m.Position(d.remainder,o.end.character),b=new m.Range(l,_),E=this._cells[h.index];return new m.Location(E.document.uri,E.document.validateRange(b))}contains(o){return this._cellUris.has(o)}validateRange(o){const h=this.validatePosition(o.start),d=this.validatePosition(o.end);return o.with(h,d)}validatePosition(o){const h=this._cellLines.getIndexOf(o.line),d=new m.Position(h.remainder,o.character),l=this._cells[h.index].document.validatePosition(d),_=this._cellLines.getPrefixSum(h.index-1);return new m.Position(_+l.line,l.character)}}e.ExtHostNotebookConcatDocument=n}),define(Ee[157],ye([0,1,6,14,3]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(D){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let v=D==="light"?m.ColorThemeKind.Light:D==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([je(0,T.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(Ee[65],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=m.createDecorator("IURITransformerService");class T{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(Ee[158],ye([0,1,23]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(v){let C=this.buffers.indexOf(v);return C<0&&(C=this.buffers.length,this.buffers.push(v)),C}}function S(D,v){if(v.serializeBuffersForPostMessage){const C=new T,n=(h,d)=>{if(d instanceof ArrayBuffer){const l=C.add(d);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(d)){const l=y(d);if(l){const _=C.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:l,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},I=JSON.stringify(D,n),o=C.buffers.map(h=>{const d=new Uint8Array(h);return m.VSBuffer.wrap(d)});return{message:I,buffers:o}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function y(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(D,v){const C=v.map(o=>{const h=new ArrayBuffer(o.byteLength);return new Uint8Array(h).set(o.buffer),h}),n=v.length?(o,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const d=h,{index:l}=d,_=C[l];if(d.view)switch(d.view.type){case 1:return new Int8Array(_,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return h}:void 0;return{message:JSON.parse(D,n),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(Ee[66],ye([0,1,12,2]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(y,k){return y.scheme===m.Schemas.http||y.scheme===m.Schemas.https?y:(k&&k.authority&&k.isRemote&&y.scheme===m.Schemas.file&&(y=T.URI.from({scheme:m.Schemas.vscodeRemote,authority:k.authority,path:y.path})),T.URI.from({scheme:m.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=S}),define(Ee[159],ye([0,1,3,7,66]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,v,C){this._proxy=D,this._editors=v,this._initData=C,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const n=v.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,v,C,n,I){let o;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){o=c;break}if(!o)throw new Error("not a visible editor");const h=this,d=this._handlePool++,l=new m.Emitter,_=new m.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return S.asWebviewUri(c,h._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(c){this._options=c,h._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,h._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(c){return h._proxy.$postMessage(d,c)}},E=new class{constructor(){this.editor=D,this.line=v,this.height=C,this.webview=b,this.onDidDispose=_.event}dispose(){h._insets.has(d)&&(h._insets.delete(d),h._proxy.$disposeEditorInset(d),_.fire(),_.dispose(),l.dispose())}};return this._proxy.$createEditorInset(d,o.id,o.value.document.uri,v+1,C,n||{},I.identifier,I.extensionLocation),this._insets.set(d,{editor:D,inset:E,onDidReceiveMessage:l}),E}$onDidDispose(D){const v=this._insets.get(D);v&&v.inset.dispose()}$onDidReceiveMessage(D,v){const C=this._insets.get(D);C&&C.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=y}),define(Ee[160],ye([0,1,3,13,135]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,v,C,n){const I={command:D};if(v&&Object.keys(v).length>0&&(I.arguments=v),this.internalSend("request",I),typeof n=="number"){const o=setTimeout(()=>{clearTimeout(o);const h=this.pendingRequests.get(I.seq);if(h){this.pendingRequests.delete(I.seq);const d={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:S.localize(0,null,n,D)};h(d)}},n)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,v){return D.type!=="event"||v.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await T.timeout(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const v=D,C=this.pendingRequests.get(v.request_seq);C&&(this.pendingRequests.delete(v.request_seq),C(v));break}}}internalSend(D,v){v.type=D,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((v,C)=>D.set(C,v)),await T.timeout(500),D.forEach((v,C)=>{v({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(Ee[161],ye([0,1,8,2,15,24,12]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function v(i,s,r){return i.replace(D,function(u,w){return s&&w.length>0&&w[0]!=="_"?u:r&&r.hasOwnProperty(w)?r[w]:u})}e.formatPII=v;function C(i){const s={};for(const r of Object.keys(i))r.startsWith("!")||(s[r]=i[r]);return s}e.filterExceptionsFromTelemetry=C;function n(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||n(i.parentSession))}e.isSessionAttach=n;function I(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),m.equalsIgnoreCase(s,"extensionhost")||m.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function o(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=o;function h(i,s,r){let u,w=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=p.exec(i);){let A=P.index+1,a=A+P[0].length;if(A<=s&&a>=r){u=P[0],w=A;break}}if(u){let A=/\w+/g,a=null;for(;(a=A.exec(u))&&!(a.index+1+w+a[0].length>=r););a&&(u=u.substring(0,A.lastIndex))}return u?{start:w,end:w+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(i){return!!(i&&i.match(d))}e.isUri=l;function _(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(l(i.path))return T.URI.parse(i.path);if(S.isAbsolute(i.path))return T.URI.file(i.path)}return i.path}function b(i){if(typeof i.path=="object"){const s=T.URI.revive(i.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return i.path}function E(i,s){const r=s?_:b,u=y.deepClone(i);return f(u,(w,p)=>{w&&p&&(p.path=r(p))}),u}e.convertToDAPaths=E;function c(i,s){const r=s?_:b,u=y.deepClone(i);return f(u,(w,p)=>{!w&&p&&(p.path=r(p))}),u}e.convertToVSCPaths=c;function f(i,s){switch(i.type){case"event":const r=i;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const u=i;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const w=i;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":w.body.sources.forEach(p=>s(!1,p));break;case"scopes":w.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":w.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function g(i){return i.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(Ee[67],ye([0,1,27,81,12,15,21,88]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var v;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(v=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.markdown,"application/json",T.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var o;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(o=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var _;(function(a){a.scheme=S.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function F(W,K){return W.with({scheme:a.scheme,fragment:`ch${K.toString().padStart(7,"0")}${W.scheme!==S.Schemas.file?W.scheme:""}`})}a.generate=F;function U(W){if(W.scheme!==a.scheme)return;const K=R.exec(W.fragment);return K?{handle:Number(K[1]),notebook:W.with({scheme:W.fragment.substr(K[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parse=U;function X(W){if(W.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const K=R.exec(W.fragment);return K?{handle:Number(K[1]),notebook:W.with({scheme:W.fragment.substr(K[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=X;function oe(W,K,M){return W.with({scheme:M,fragment:`ch${K.toString().padStart(7,"0")}${W.scheme!==S.Schemas.file?W.scheme:""}`})}a.generateCellUri=oe;function j(W,K){if(W.scheme!==K)return;const M=R.exec(W.fragment);return M?{handle:Number(M[1]),notebook:W.with({scheme:W.fragment.substr(M[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellUri=j})(_=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(a){var R,F;return(F=(R=b.get(a))===null||R===void 0?void 0:R.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=E;function c(a){var R,F;return(F=(R=b.get(a))===null||R===void 0?void 0:R.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=c;function f(a){var R,F;return(F=(R=b.get(a))===null||R===void 0?void 0:R.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=f;function g(a,R){return k.isWindows&&(a=a.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),m.match(a,R)}function t(a,R,F){let U=0;for(let X=0;X<R.length;X++){if(g(R[X],a))return U;U++}for(let X=0;X<F.length;X++){if(g(F[X],a))return U;U++}return U}function i(a,R,F){return a.sort((U,X)=>t(U,R,F)-t(X,R,F))}e.sortMimeTypes=i;function s(a,R,F,U=(X,oe)=>X===oe){const X=[];function oe(K,M,Y){if(M===0&&Y.length===0)return;const x=X[X.length-1];x&&x.start+x.deleteCount===K?(x.deleteCount+=M,x.toInsert.push(...Y)):X.push({start:K,deleteCount:M,toInsert:Y})}let j=0,W=0;for(;;){if(j===a.length){oe(j,0,R.slice(W));break}if(W===R.length){oe(j,a.length-j,[]);break}const K=a[j],M=R[W];if(U(K,M)){j+=1,W+=1;continue}F(M)?(oe(j,1,[]),j+=1):(oe(j,0,[M]),W+=1)}return X}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(a){const R=a;return!!((typeof R.include=="string"||m.isRelativePattern(R.include))&&(typeof R.exclude=="string"||m.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=u;function w(a,R,F){if(Array.isArray(a.viewType)&&a.viewType.indexOf(R)>=0||a.viewType===R)return!0;if(a.filenamePattern){let U=u(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,X=u(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(m.match(U,y.basename(F.fsPath).toLowerCase()))return!(X&&m.match(X,y.basename(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=w;class p{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)R[F]=this.textModel.cells[F].getHashValue();return R}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var P;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(P=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(R){return`${A._prefix}${R}`}static parse(R){if(R.startsWith(A._prefix))return R.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(Ee[162],ye([0,1,137,5,88]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[163],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=m;function T(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=T}),define(Ee[96],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const m=v=>({testId:v.item.extId,controllerId:v.controllerId});e.identifyTest=m;var T;(function(v){v[v.NotExpandable=0]="NotExpandable",v[v.Expandable=1]="Expandable",v[v.BusyExpanding=2]="BusyExpanding",v[v.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const S=(v,C)=>{C.expand!==void 0&&(v.expand=C.expand),C.item!==void 0&&(v.item=v.item?Object.assign(v.item,C.item):C.item)};e.applyTestItemUpdate=S;var y;(function(v){v[v.Add=0]="Add",v[v.Update=1]="Update",v[v.Remove=2]="Remove",v[v.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",v[v.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(C){}update(C){}remove(C,n){}complete(){}}e.IncrementalChangeCollector=k;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const n=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const o=I[1];if(o.parent){if(this.items.has(o.parent)){const h=this.items.get(o.parent);h.children.add(o.item.extId);const d=this.createItem(o,h);this.items.set(o.item.extId,d),n.add(d)}}else{const h=this.createItem(o);this.roots.add(h),this.items.set(o.item.extId,h),n.add(h)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=I[1],h=this.items.get(o.extId);if(!h)break;o.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,o),n.update(h);break}case 2:{const o=this.items.get(I[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o);const h=[[I[1]]];for(;h.length;)for(const d of h.pop()){const l=this.items.get(d);l&&(h.push(l.children),this.items.delete(d),n.remove(l,l!==o),l.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}n.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=D}),define(Ee[164],ye([0,1,15,40,10,24,21,80,138]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,o,h){this._contributedVariables=new Map,this._context=I,this._labelService=o,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(k.isWindows){const o=Object.create(null);return Object.keys(I).forEach(h=>{o[h.toLowerCase()]=I[h]}),o}return I}resolveWithEnvironment(I,o,h){return this.recursiveResolve(this.prepareEnv(I),o?o.uri:void 0,h)}async resolveAsync(I,o){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o)}async resolveAnyBase(I,o,h,d){const l=y.deepClone(o);return k.isWindows&&l.windows?Object.keys(l.windows).forEach(_=>l[_]=l.windows[_]):k.isMacintosh&&l.osx?Object.keys(l.osx).forEach(_=>l[_]=l.osx[_]):k.isLinux&&l.linux&&Object.keys(l.linux).forEach(_=>l[_]=l.linux[_]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l,h,d)}async resolveAnyAsync(I,o,h){return this.resolveAnyBase(I,o,h)}async resolveAnyMap(I,o,h){const d=new Map;return{newConfig:await this.resolveAnyBase(I,o,h,d),resolvedVariables:d}}resolveWithInteractionReplace(I,o,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,o,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,o){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,o)}recursiveResolve(I,o,h,d,l){if(S.isString(h))return this.resolveString(I,o,h,d,l);if(S.isArray(h))return h.map(_=>this.recursiveResolve(I,o,_,d,l));if(S.isObject(h)){let _=Object.create(null);return Object.keys(h).forEach(b=>{const E=this.resolveString(I,o,b,d,l);_[E]=this.recursiveResolve(I,o,h[b],d,l)}),_}return h}resolveString(I,o,h,d,l){return h.replace(C.VARIABLE_REGEXP,(b,E)=>{if(E.includes(C.VARIABLE_LHS))return b;let c=this.evaluateSingleVariable(I,b,E,o,d);return l&&l.set(E,c),c!==b&&S.isString(c)&&c.match(C.VARIABLE_REGEXP)&&(c=this.resolveString(I,o,c,d,l)),c})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,o,h,d,l){let _;const b=h.split(":");b.length>1&&(h=b[0],_=b[1]);const E=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(v.localize(0,null,o))},c=()=>{const g=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(v.localize(1,null,o,m.basename(g)))},f=()=>{if(_){const g=this._context.getFolderUri(_);if(g)return g;throw new Error(v.localize(2,null,o,_))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error(v.localize(3,null,o)):new Error(v.localize(4,null,o))};switch(h){case"env":if(_){if(I){const g=I[k.isWindows?_.toLowerCase():_];if(S.isString(g))return g}return""}throw new Error(v.localize(5,null,o));case"config":if(_){const g=this._context.getConfigurationValue(d,_);if(S.isUndefinedOrNull(g))throw new Error(v.localize(6,null,o,_));if(S.isObject(g))throw new Error(v.localize(7,null,o,_));return g}throw new Error(v.localize(8,null,o));case"command":return this.resolveFromMap(o,_,l,"command");case"input":return this.resolveFromMap(o,_,l,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return D.normalizeDriveLetter(this.fsPath(f()));case"cwd":return d||_?D.normalizeDriveLetter(this.fsPath(f())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(f()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(v.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(v.localize(10,null,o));case"file":return E();case"fileWorkspaceFolder":return c();case"relativeFile":return d||_?m.relative(this.fsPath(f()),E()):E();case"relativeFileDirname":const i=m.dirname(E());if(d||_){const w=m.relative(this.fsPath(f()),i);return w.length===0?".":w}return i;case"fileDirname":return m.dirname(E());case"fileExtname":return m.extname(E());case"fileBasename":return m.basename(E());case"fileBasenameNoExtension":const s=m.basename(E());return s.slice(0,s.length-m.extname(s).length);case"fileDirnameBasename":return m.basename(m.dirname(E()));case"execPath":const r=this._context.getExecPath();return r||o;case"execInstallFolder":const u=this._context.getAppRoot();return u||o;case"pathSeparator":return m.sep;default:try{const w=_?`${h}:${_}`:h;return this.resolveFromMap(o,w,l,void 0)}catch(w){return o}}}}resolveFromMap(I,o,h,d){if(o&&h){const l=d===void 0?h[o]:h[d+":"+o];if(typeof l=="string")return l;throw new Error(v.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[165],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=m.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var S;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var k;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var v;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(v=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function I(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(Ee[166],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=m.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(Ee[9],ye([0,1,17,79,222,54,24,10,2,30,58,139,89,67,166,6]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(pe){function De(z){const{selectionStartLineNumber:Ue,selectionStartColumn:Se,positionLineNumber:ze,positionColumn:Ze}=z,et=new l.Position(Ue-1,Se-1),st=new l.Position(ze-1,Ze-1);return new l.Selection(et,st)}pe.to=De;function ae(z){const{anchor:Ue,active:Se}=z;return{selectionStartLineNumber:Ue.line+1,selectionStartColumn:Ue.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}pe.from=ae})(_=e.Selection||(e.Selection={}));var b;(function(pe){function De(z){if(!z)return;const{start:Ue,end:Se}=z;return{startLineNumber:Ue.line+1,startColumn:Ue.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}pe.from=De;function ae(z){if(!z)return;const{startLineNumber:Ue,startColumn:Se,endLineNumber:ze,endColumn:Ze}=z;return new l.Range(Ue-1,Se-1,ze-1,Ze-1)}pe.to=ae})(b=e.Range||(e.Range={}));var E;(function(pe){function De(ae){switch(ae){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 4:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}pe.to=De})(E=e.TokenType||(e.TokenType={}));var c;(function(pe){function De(z){return new l.Position(z.lineNumber-1,z.column-1)}pe.to=De;function ae(z){return{lineNumber:z.line+1,column:z.character+1}}pe.from=ae})(c=e.Position||(e.Position={}));var f;(function(pe){function De(z){switch(z){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}pe.from=De;function ae(z){switch(z){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}pe.to=ae})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(pe){function De(z){let Ue;return z.code&&(D.isString(z.code)||D.isNumber(z.code)?Ue=String(z.code):Ue={value:String(z.code.value),target:z.code.target}),Object.assign(Object.assign({},b.from(z.range)),{message:z.message,source:z.source,code:Ue,severity:i.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(t.from),tags:Array.isArray(z.tags)?m.coalesce(z.tags.map(f.from)):void 0})}pe.from=De;function ae(z){var Ue;const Se=new l.Diagnostic(b.to(z),z.message,i.to(z.severity));return Se.source=z.source,Se.code=D.isString(z.code)?z.code:(Ue=z.code)===null||Ue===void 0?void 0:Ue.value,Se.relatedInformation=z.relatedInformation&&z.relatedInformation.map(t.to),Se.tags=z.tags&&m.coalesce(z.tags.map(f.to)),Se}pe.to=ae})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function De(z){return Object.assign(Object.assign({},b.from(z.location.range)),{message:z.message,resource:z.location.uri})}pe.from=De;function ae(z){return new l.DiagnosticRelatedInformation(new l.Location(z.resource,b.to(z)),z.message)}pe.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(pe){function De(z){switch(z){case l.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}pe.from=De;function ae(z){switch(z){case o.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}pe.to=ae})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(pe){function De(z){return typeof z=="number"&&z>=l.ViewColumn.One?z-1:z===l.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}pe.from=De;function ae(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function r(pe){return typeof pe.range!="undefined"}function u(pe){return pe.length===0?!0:!!r(pe[0])}e.isDecorationOptionsArr=u;var w;(function(pe){function De(Ze){return Ze.map(pe.from)}pe.fromMany=De;function ae(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function z(Ze){let et;if(ae(Ze)){const{language:_t,value:vt}=Ze;et={value:"```"+_t+`
`+vt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ze)?et={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?et={value:Ze}:et={value:""};const st=Object.create(null);et.uris=st;const pt=_t=>{try{let vt=v.URI.parse(_t,!0);vt=vt.with({query:Ue(vt.query,st)}),st[_t]=vt}catch(vt){}return""},bt=new S.Renderer;return bt.link=pt,bt.image=_t=>pt(T.parseHrefAndDimensions(_t).href),S(et.value,{renderer:bt}),et}pe.from=z;function Ue(Ze,et){if(!Ze)return Ze;let st;try{st=y.parse(Ze)}catch(bt){}if(!st)return Ze;let pt=!1;return st=k.cloneAndChange(st,bt=>{if(v.URI.isUri(bt)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[_t]=bt,pt=!0,_t}else return}),pt?JSON.stringify(st):Ze}function Se(Ze){const et=new l.MarkdownString(Ze.value,Ze.supportThemeIcons);return et.isTrusted=Ze.isTrusted,et}pe.to=Se;function ze(Ze){if(!!Ze)return typeof Ze=="string"?Ze:pe.from(Ze)}pe.fromStrict=ze})(w=e.MarkdownString||(e.MarkdownString={}));function p(pe){return u(pe)?pe.map(De=>({range:b.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?w.fromMany(De.hoverMessage):De.hoverMessage?w.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):pe.map(De=>({range:b.from(De)}))}e.fromRangeOrRangeWithMessage=p;function P(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?v.URI.file(pe):pe}e.pathOrURIToURI=P;var A;(function(pe){function De(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?P(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}pe.from=De})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(pe){function De(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?A.from(ae.before):void 0,after:ae.after?A.from(ae.after):void 0}}pe.from=De})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(pe){function De(ae){if(typeof ae=="undefined")return ae;switch(ae){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=De})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(pe){function De(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?a.from(ae.light):void 0,dark:ae.dark?a.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?A.from(ae.before):void 0,after:ae.after?A.from(ae.after):void 0}}pe.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(pe){function De(z){return{text:z.newText,eol:z.newEol&&H.from(z.newEol),range:b.from(z.range)}}pe.from=De;function ae(z){const Ue=new l.TextEdit(b.to(z.range),z.text);return Ue.newEol=typeof z.eol=="undefined"?void 0:H.to(z.eol),Ue}pe.to=ae})(U=e.TextEdit||(e.TextEdit={}));var X;(function(pe){function De(z,Ue,Se){var ze,Ze;const et={edits:[]};if(z instanceof l.WorkspaceEdit)for(let st of z._allEntries())if(st._type===1)et.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const pt=Ue==null?void 0:Ue.getDocument(st.uri);et.edits.push({_type:2,resource:st.uri,edit:U.from(st.edit),modelVersionId:pt==null?void 0:pt.version,metadata:st.metadata})}else st._type===3?et.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(ze=Se==null?void 0:Se.getNotebookDocument(st.uri,!0))===null||ze===void 0?void 0:ze.apiNotebook.version}):st._type===5&&et.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(Ze=Se==null?void 0:Se.getNotebookDocument(st.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(de.from)}});return et}pe.from=De;function ae(z){const Ue=new l.WorkspaceEdit;for(const Se of z.edits)Se.edit?Ue.replace(v.URI.revive(Se.resource),b.to(Se.edit.range),Se.edit.text):Ue.renameFile(v.URI.revive(Se.oldUri),v.URI.revive(Se.newUri),Se.options);return Ue}pe.to=ae})(X=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(pe){const De=Object.create(null);De[l.SymbolKind.File]=0,De[l.SymbolKind.Module]=1,De[l.SymbolKind.Namespace]=2,De[l.SymbolKind.Package]=3,De[l.SymbolKind.Class]=4,De[l.SymbolKind.Method]=5,De[l.SymbolKind.Property]=6,De[l.SymbolKind.Field]=7,De[l.SymbolKind.Constructor]=8,De[l.SymbolKind.Enum]=9,De[l.SymbolKind.Interface]=10,De[l.SymbolKind.Function]=11,De[l.SymbolKind.Variable]=12,De[l.SymbolKind.Constant]=13,De[l.SymbolKind.String]=14,De[l.SymbolKind.Number]=15,De[l.SymbolKind.Boolean]=16,De[l.SymbolKind.Array]=17,De[l.SymbolKind.Object]=18,De[l.SymbolKind.Key]=19,De[l.SymbolKind.Null]=20,De[l.SymbolKind.EnumMember]=21,De[l.SymbolKind.Struct]=22,De[l.SymbolKind.Event]=23,De[l.SymbolKind.Operator]=24,De[l.SymbolKind.TypeParameter]=25;function ae(Ue){return typeof De[Ue]=="number"?De[Ue]:6}pe.from=ae;function z(Ue){for(const Se in De)if(De[Se]===Ue)return Number(Se);return l.SymbolKind.Property}pe.to=z})(oe=e.SymbolKind||(e.SymbolKind={}));var j;(function(pe){function De(z){switch(z){case l.SymbolTag.Deprecated:return 1}}pe.from=De;function ae(z){switch(z){case 1:return l.SymbolTag.Deprecated}}pe.to=ae})(j=e.SymbolTag||(e.SymbolTag={}));var W;(function(pe){function De(z){return{name:z.name,kind:oe.from(z.kind),tags:z.tags&&z.tags.map(j.from),containerName:z.containerName,location:O.from(z.location)}}pe.from=De;function ae(z){const Ue=new l.SymbolInformation(z.name,oe.to(z.kind),z.containerName,O.to(z.location));return Ue.tags=z.tags&&z.tags.map(j.to),Ue}pe.to=ae})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(pe){function De(z){var Ue,Se;const ze={name:z.name||"!!MISSING: name!!",detail:z.detail,range:b.from(z.range),selectionRange:b.from(z.selectionRange),kind:oe.from(z.kind),tags:(Se=(Ue=z.tags)===null||Ue===void 0?void 0:Ue.map(j.from))!==null&&Se!==void 0?Se:[]};return z.children&&(ze.children=z.children.map(De)),ze}pe.from=De;function ae(z){const Ue=new l.DocumentSymbol(z.name,z.detail,oe.to(z.kind),b.to(z.range),b.to(z.selectionRange));return m.isNonEmptyArray(z.tags)&&(Ue.tags=z.tags.map(j.to)),z.children&&(Ue.children=z.children.map(ae)),Ue}pe.to=ae})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(pe){function De(ae){const z=new l.CallHierarchyItem(oe.to(ae.kind),ae.name,ae.detail||"",v.URI.revive(ae.uri),b.to(ae.range),b.to(ae.selectionRange));return z._sessionId=ae._sessionId,z._itemId=ae._itemId,z}pe.to=De})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Y;(function(pe){function De(ae){return new l.CallHierarchyIncomingCall(M.to(ae.from),ae.fromRanges.map(z=>b.to(z)))}pe.to=De})(Y=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var x;(function(pe){function De(ae){return new l.CallHierarchyOutgoingCall(M.to(ae.to),ae.fromRanges.map(z=>b.to(z)))}pe.to=De})(x=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(pe){function De(z){return{range:z.range&&b.from(z.range),uri:z.uri}}pe.from=De;function ae(z){return new l.Location(v.URI.revive(z.uri),b.to(z.range))}pe.to=ae})(O=e.location||(e.location={}));var Q;(function(pe){function De(z){const Ue=z,Se=z;return{originSelectionRange:Ue.originSelectionRange?b.from(Ue.originSelectionRange):void 0,uri:Ue.targetUri?Ue.targetUri:Se.uri,range:b.from(Ue.targetRange?Ue.targetRange:Se.range),targetSelectionRange:Ue.targetSelectionRange?b.from(Ue.targetSelectionRange):void 0}}pe.from=De;function ae(z){return{targetUri:v.URI.revive(z.uri),targetRange:b.to(z.range),targetSelectionRange:z.targetSelectionRange?b.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?b.to(z.originSelectionRange):void 0}}pe.to=ae})(Q=e.DefinitionLink||(e.DefinitionLink={}));var V;(function(pe){function De(z){return{range:b.from(z.range),contents:w.fromMany(z.contents)}}pe.from=De;function ae(z){return new l.Hover(z.contents.map(w.to),b.to(z.range))}pe.to=ae})(V=e.Hover||(e.Hover={}));var le;(function(pe){function De(z){return{range:b.from(z.range),expression:z.expression}}pe.from=De;function ae(z){return new l.EvaluatableExpression(b.to(z.range),z.expression)}pe.to=ae})(le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var be;(function(pe){function De(z){if(z instanceof l.InlineValueText)return{type:"text",range:b.from(z.range),text:z.text};if(z instanceof l.InlineValueVariableLookup)return{type:"variable",range:b.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=De;function ae(z){switch(z.type){case"text":return{range:b.to(z.range),text:z.text};case"variable":return{range:b.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:b.to(z.range),expression:z.expression}}}pe.to=ae})(be=e.InlineValue||(e.InlineValue={}));var Te;(function(pe){function De(z){return{frameId:z.frameId,stoppedLocation:b.from(z.stoppedLocation)}}pe.from=De;function ae(z){return new l.InlineValueContext(z.frameId,b.to(z.stoppedLocation))}pe.to=ae})(Te=e.InlineValueContext||(e.InlineValueContext={}));var He;(function(pe){function De(z){return{range:b.from(z.range),kind:z.kind}}pe.from=De;function ae(z){return new l.DocumentHighlight(b.to(z.range),z.kind)}pe.to=ae})(He=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(pe){function De(ae){switch(ae){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}pe.to=De})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(pe){function De(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}pe.to=De})(qe=e.CompletionContext||(e.CompletionContext={}));var nt;(function(pe){function De(z){switch(z){case l.CompletionItemTag.Deprecated:return 1}}pe.from=De;function ae(z){switch(z){case 1:return l.CompletionItemTag.Deprecated}}pe.to=ae})(nt=e.CompletionItemTag||(e.CompletionItemTag={}));var Je;(function(pe){const De=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ae(Se){var ze;return(ze=De.get(Se))!==null&&ze!==void 0?ze:9}pe.from=ae;const z=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ue(Se){var ze;return(ze=z.get(Se))!==null&&ze!==void 0?ze:l.CompletionItemKind.Property}pe.to=Ue})(Je=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(pe){function De(ae,z){var Ue;const Se=new l.CompletionItem(ae.label);return Se.insertText=ae.insertText,Se.kind=Je.to(ae.kind),Se.tags=(Ue=ae.tags)===null||Ue===void 0?void 0:Ue.map(nt.to),Se.detail=ae.detail,Se.documentation=T.isMarkdownString(ae.documentation)?w.to(ae.documentation):ae.documentation,Se.sortText=ae.sortText,Se.filterText=ae.filterText,Se.preselect=ae.preselect,Se.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?Se.range=b.to(ae.range):typeof ae.range=="object"&&(Se.range={inserting:b.to(ae.range.insert),replacing:b.to(ae.range.replace)}),Se.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Se.insertText=new l.SnippetString(ae.insertText):(Se.insertText=ae.insertText,Se.textEdit=Se.range instanceof l.Range?new l.TextEdit(Se.range,Se.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Se.additionalTextEdits=ae.additionalTextEdits.map(ze=>U.to(ze))),Se.command=z&&ae.command?z.fromInternal(ae.command):void 0,Se}pe.to=De})(Xe=e.CompletionItem||(e.CompletionItem={}));var B;(function(pe){function De(z){return{label:z.label,documentation:z.documentation?w.fromStrict(z.documentation):void 0}}pe.from=De;function ae(z){return{label:z.label,documentation:T.isMarkdownString(z.documentation)?w.to(z.documentation):z.documentation}}pe.to=ae})(B=e.ParameterInformation||(e.ParameterInformation={}));var G;(function(pe){function De(z){return{label:z.label,documentation:z.documentation?w.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(B.from):[],activeParameter:z.activeParameter}}pe.from=De;function ae(z){return{label:z.label,documentation:T.isMarkdownString(z.documentation)?w.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(B.to):[],activeParameter:z.activeParameter}}pe.to=ae})(G=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(pe){function De(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(G.from):[]}}pe.from=De;function ae(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(G.to):[]}}pe.to=ae})(ne=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(pe){function De(z){var Ue;return{text:z.text,position:c.from(z.position),kind:q.from((Ue=z.kind)!==null&&Ue!==void 0?Ue:l.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}pe.from=De;function ae(z){const Ue=new l.InlayHint(z.text,c.to(z.position),q.to(z.kind));return Ue.whitespaceAfter=z.whitespaceAfter,Ue.whitespaceBefore=z.whitespaceBefore,Ue}pe.to=ae})(re=e.InlayHint||(e.InlayHint={}));var q;(function(pe){function De(z){return z}pe.from=De;function ae(z){return z}pe.to=ae})(q=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(pe){function De(z){return{range:b.from(z.range),url:z.target,tooltip:z.tooltip}}pe.from=De;function ae(z){let Ue;if(z.url)try{Ue=typeof z.url=="string"?v.URI.parse(z.url,!0):v.URI.revive(z.url)}catch(Se){}return new l.DocumentLink(b.to(z.range),Ue)}pe.to=ae})(se=e.DocumentLink||(e.DocumentLink={}));var he;(function(pe){function De(z){const Ue=new l.ColorPresentation(z.label);return z.textEdit&&(Ue.textEdit=U.to(z.textEdit)),z.additionalTextEdits&&(Ue.additionalTextEdits=z.additionalTextEdits.map(Se=>U.to(Se))),Ue}pe.to=De;function ae(z){return{label:z.label,textEdit:z.textEdit?U.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(Ue=>U.from(Ue)):void 0}}pe.from=ae})(he=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(pe){function De(z){return new l.Color(z[0],z[1],z[2],z[3])}pe.to=De;function ae(z){return[z.red,z.green,z.blue,z.alpha]}pe.from=ae})(Re=e.Color||(e.Color={}));var Be;(function(pe){function De(z){return{range:b.from(z.range)}}pe.from=De;function ae(z){return new l.SelectionRange(b.to(z.range))}pe.to=ae})(Be=e.SelectionRange||(e.SelectionRange={}));var ve;(function(pe){function De(ae){switch(ae){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}pe.to=De})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(pe){function De(z){switch(z){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=De;function ae(z){switch(z){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}pe.to=ae})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var H;(function(pe){function De(z){if(z===l.EndOfLine.CRLF)return 1;if(z===l.EndOfLine.LF)return 0}pe.from=De;function ae(z){if(z===1)return l.EndOfLine.CRLF;if(z===0)return l.EndOfLine.LF}pe.to=ae})(H=e.EndOfLine||(e.EndOfLine={}));var ee;(function(pe){function De(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=De})(ee=e.ProgressLocation||(e.ProgressLocation={}));var me;(function(pe){function De(ae){const z={start:ae.start+1,end:ae.end+1};return ae.kind&&(z.kind=Fe.from(ae.kind)),z}pe.from=De})(me=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(pe){function De(ae){if(ae)switch(ae){case l.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}pe.from=De})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(pe){function De(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?b.from(ae.selection):void 0,override:typeof ae.override=="boolean"?I.EditorOverride.DISABLED:void 0}}pe.from=De})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Qe;(function(pe){function De(z){return z instanceof l.RelativePattern||typeof z=="string"?z:ae(z)?new l.RelativePattern(z.base,z.pattern):z}pe.from=De;function ae(z){const Ue=z;return Ue&&typeof Ue.base=="string"&&typeof Ue.pattern=="string"}})(Qe=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(pe){function De(ae){if(ae){if(Array.isArray(ae))return ae.map(De);if(typeof ae=="string")return ae;{const z=ae;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:Qe.from(z.pattern),exclusive:z.exclusive}}}else return}pe.from=De})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var _e;(function(pe){function De(z){return{start:z.start,end:z.end}}pe.from=De;function ae(z){return new l.NotebookRange(z.start,z.end)}pe.to=ae})(_e=e.NotebookRange||(e.NotebookRange={}));var Ie;(function(pe){function De(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}pe.to=De;function ae(z){var Ue,Se;return{lastRunSuccess:z.success,runStartTime:(Ue=z.timing)===null||Ue===void 0?void 0:Ue.startTime,runEndTime:(Se=z.timing)===null||Se===void 0?void 0:Se.endTime,executionOrder:z.executionOrder}}pe.from=ae})(Ie=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ie;(function(pe){function De(z){switch(z){case l.NotebookCellKind.Markup:return h.CellKind.Markup;case l.NotebookCellKind.Code:default:return h.CellKind.Code}}pe.from=De;function ae(z){switch(z){case h.CellKind.Markup:return l.NotebookCellKind.Markup;case h.CellKind.Code:default:return l.NotebookCellKind.Code}}pe.to=ae})(ie=e.NotebookCellKind||(e.NotebookCellKind={}));var ue;(function(pe){function De(z){var Ue;const Se={metadata:(Ue=z.metadata)!==null&&Ue!==void 0?Ue:Object.create(null),cells:[]};for(let ze of z.cells)l.NotebookCellData.validate(ze),Se.cells.push(de.from(ze));return Se}pe.from=De;function ae(z){const Ue=new l.NotebookData(z.cells.map(de.to));return D.isEmptyObject(z.metadata)||(Ue.metadata=z.metadata),Ue}pe.to=ae})(ue=e.NotebookData||(e.NotebookData={}));var de;(function(pe){function De(z){var Ue;return{cellKind:ie.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:Ie.from((Ue=z.executionSummary)!==null&&Ue!==void 0?Ue:{}),outputs:z.outputs?z.outputs.map($.from):[]}}pe.from=De;function ae(z){return new l.NotebookCellData(ie.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map($.to):void 0,z.metadata,z.internalMetadata?Ie.to(z.internalMetadata):void 0)}pe.to=ae})(de=e.NotebookCellData||(e.NotebookCellData={}));var ge;(function(pe){function De(z){return{mime:z.mime,valueBytes:Array.from(z.data)}}pe.from=De;function ae(z){return new l.NotebookCellOutputItem(new Uint8Array(z.valueBytes),z.mime)}pe.to=ae})(ge=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var $;(function(pe){function De(z){return{outputId:z.id,items:z.items.map(ge.from),metadata:z.metadata}}pe.from=De;function ae(z){const Ue=z.items.map(ge.to);return new l.NotebookCellOutput(Ue,z.outputId,z.metadata)}pe.to=ae})($=e.NotebookCellOutput||(e.NotebookCellOutput={}));var fe;(function(pe){function De(Se){if(Se!=null){if(Se instanceof l.RelativePattern||typeof Se=="string")return Se;if(Ue(Se))return new l.RelativePattern(Se.base,Se.pattern);if(z(Se))return{include:Qe.from(Se.include)||void 0,exclude:Qe.from(Se.exclude)||void 0}}}pe.from=De;function ae(Se){return typeof Se=="string"?Se:Ue(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}pe.to=ae;function z(Se){const ze=Se,Ze=Qe.from(ze.include);if(!(Ze&&Ze instanceof l.RelativePattern||typeof Ze=="string"))return!1;const et=Qe.from(ze.exclude);return!!(et&&et instanceof l.RelativePattern||typeof et=="string")}function Ue(Se){const ze=Se;return ze&&typeof ze.base=="string"&&typeof ze.pattern=="string"}})(fe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var we;(function(pe){function De(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?A.from(ae.top):void 0}}pe.from=De})(we=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Pe;(function(pe){function De(ae,z,Ue){const Se=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(Se,Ue),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}pe.from=De})(Pe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Le;(function(pe){function De(ae){var z,Ue,Se;return{transientOutputs:(z=ae==null?void 0:ae.transientOutputs)!==null&&z!==void 0?z:!1,transientCellMetadata:(Ue=ae==null?void 0:ae.transientCellMetadata)!==null&&Ue!==void 0?Ue:{},transientDocumentMetadata:(Se=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Se!==void 0?Se:{}}}pe.from=De})(Le=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var $e;(function(pe){function De(z){return{uri:z.uri,provides:z.provides}}pe.from=De;function ae(z){return new l.NotebookRendererScript(v.URI.revive(z.uri),z.provides)}pe.to=ae})($e=e.NotebookRendererScript||(e.NotebookRendererScript={}));var We;(function(pe){function De(z){return{message:w.fromStrict(z.message)||"",severity:z.severity,expectedOutput:z.expectedOutput,actualOutput:z.actualOutput,location:z.location?O.from(z.location):void 0}}pe.from=De;function ae(z){const Ue=new l.TestMessage(typeof z.message=="string"?z.message:w.to(z.message));return Ue.severity=z.severity,Ue.actualOutput=z.actualOutput,Ue.expectedOutput=z.expectedOutput,Ue}pe.to=ae})(We=e.TestMessage||(e.TestMessage={}));var Ye;(function(pe){function De(ze){var Ze,et;return{extId:ze.id,label:ze.label,uri:ze.uri,range:b.from(ze.range)||null,debuggable:(Ze=ze.debuggable)!==null&&Ze!==void 0?Ze:!1,description:ze.description||null,runnable:(et=ze.runnable)!==null&&et!==void 0?et:!0,error:ze.error&&w.fromStrict(ze.error)||null}}pe.from=De;function ae(ze){return{extId:ze.id,label:ze.label,uri:ze.uri,range:b.from(ze.range)||null,debuggable:!1,description:ze.description||null,error:null,runnable:!0}}pe.fromResultSnapshot=ae;function z(ze){return{id:ze.extId,label:ze.label,uri:v.URI.revive(ze.uri),range:b.to(ze.range||void 0),dispose:()=>{},canResolveChildren:!1,busy:!1,data:void 0,debuggable:ze.debuggable,description:ze.description||void 0,runnable:ze.runnable}}pe.toPlain=z;function Ue(ze,Ze){const et=new l.TestItemImpl(ze.extId,ze.label,v.URI.revive(ze.uri),void 0,Ze);return et.range=b.to(ze.range||void 0),et.debuggable=ze.debuggable,et.description=ze.description||void 0,et.runnable=ze.runnable,et}pe.to=Ue;function Se(ze){let Ze;for(const et of ze.tests)Ze=Ue(et.item,Ze);return Ze}pe.toItemFromContext=Se})(Ye=e.TestItem||(e.TestItem={}));var tt;(function(pe){const De=(z,Ue)=>Object.assign(Object.assign({},Ye.toPlain(z.item)),{taskStates:z.tasks.map(Se=>({state:Se.state,duration:Se.duration,messages:Se.messages.map(We.to)})),children:z.children.map(Se=>Ue.get(Se)).filter(D.isDefined).map(Se=>De(Se,Ue))});function ae(z){const Ue=[],Se=new Map;for(const ze of z.items)Se.set(ze.item.extId,ze),ze.direct&&Ue.push(ze);return{completedAt:z.completedAt,results:Ue.map(ze=>De(ze,Se))}}pe.to=ae})(tt=e.TestResults||(e.TestResults={}));var ut;(function(pe){function De(ae){switch(ae){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}pe.to=De})(ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(Ee[167],ye([0,1,2,11,6,9,51]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,n,I,o={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=o,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,I,o)=>{const d={dispose:this._callbacks.push([n,I,C])};return Array.isArray(o)&&o.push(d),d}}async $participateInSave(C,n){const I=m.URI.revive(C);let o=!1;const h=setTimeout(()=>o=!0,this._thresholds.timeout),d=[];try{for(let l of[...this._callbacks]){if(o)break;const _=this._documents.getDocument(I),b=await this._deliverEventAsyncAndBlameBadListeners(l,{document:_,reason:y.TextDocumentSaveReason.to(n)});d.push(b)}}finally{clearTimeout(h)}return d}_deliverEventAsyncAndBlameBadListeners([C,n,I],o){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,n,o).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const l=this._badListeners.get(C);this._badListeners.set(C,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,I,o){const h=[],d=Date.now(),{document:l,reason:_}=o,{version:b}=l,E=Object.freeze({document:l,reason:_,waitUntil(c){if(Object.isFrozen(h))throw T.illegalState("waitUntil can not be called async");h.push(Promise.resolve(c))}});try{n.apply(I,[E])}catch(c){return Promise.reject(c)}return Object.freeze(h),new Promise((c,f)=>{const g=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(g),c(t)}).catch(t=>{clearTimeout(g),f(t)})}).then(c=>{const f={edits:[]};for(const g of c)if(Array.isArray(g)&&g.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:i,range:s}of g)f.edits.push({_type:2,resource:l.uri,edit:{range:s&&y.Range.from(s),text:t,eol:i&&y.EndOfLine.from(i)}});if(f.edits.length!==0)return b===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(Ee[168],ye([0,1,3,13,27,2,9,6]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class v{constructor(I,o,h,d,l){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,h&&(this._config+=1),d&&(this._config+=2),l&&(this._config+=4);const _=S.parse(o),b=I(E=>{if(!h)for(let c of E.created){const f=y.URI.revive(c);_(f.fsPath)&&this._onDidCreate.fire(f)}if(!d)for(let c of E.changed){const f=y.URI.revive(c);_(f.fsPath)&&this._onDidChange.fire(f)}if(!l)for(let c of E.deleted){const f=y.URI.revive(c);_(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,o,h){this._logService=o,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,o,h,d){return new v(this._onFileSystemEvent.event,I,o,h,d)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,o){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(h=>y.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(h=>y.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,o){return(h,d,l)=>{const _=function(E){h.call(d,E)};return _.extension=I,o.event(_,void 0,l)}}async $onWillRunFileOperation(I,o,h,d){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(l=>({oldUri:y.URI.revive(l.source),newUri:y.URI.revive(l.target)}))},h,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(l=>y.URI.revive(l.target))},h,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(l=>y.URI.revive(l.target))},h,d)}}async _fireWillEvent(I,o,h,d){const l=new Set,_=[];if(await I.fireAsync(o,d,async(E,c)=>{var f;const g=Date.now(),t=await Promise.resolve(E);t instanceof D.WorkspaceEdit&&(_.push(t),l.add((f=c.extension.displayName)!==null&&f!==void 0?f:c.extension.identifier.value)),Date.now()-g>h&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),d.isCancellationRequested||_.length===0)return;const b={edits:[]};for(let E of _){let{edits:c}=k.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(c)}return{edit:b,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=C}),define(Ee[169],ye([0,1,12,24,2,9,6,67]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class v{constructor(o,h,d,l){this.start=o,this.deletedCount=h,this.deletedItems=d,this.items=l}static asApiEvents(o){return o.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(d=>d.apiCell)}))}}class C{constructor(o,h,d){var l,_,b;this.notebook=o,this._extHostDocument=h,this._cellData=d,this.handle=d.handle,this.uri=S.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(l=d.internalMetadata)!==null&&l!==void 0?l:{},this._metadata=(_=d.metadata)!==null&&_!==void 0?_:{},this._previousResult=y.NotebookCellExecutionSummary.to((b=d.internalMetadata)!==null&&b!==void 0?b:{})}static asModelAddData(o,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return o._mime},set mime(d){o._mime=d},get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(y.NotebookCellOutput.to)}setOutputItems(o,h,d){const l=d.map(y.NotebookCellOutputItem.to),_=this._outputs.find(b=>b.id===o);_&&(h||(_.items.length=0),_.items.push(...l))}setMetadata(o){this._metadata=o}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=y.NotebookCellExecutionSummary.to(o)}setMime(o){}}e.ExtHostCell=C;class n{constructor(o,h,d,l,_,b){var E;this._proxy=o,this._textDocumentsAndEditors=h,this._textDocuments=d,this._emitter=l,this.uri=_,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=(E=b.metadata)!==null&&E!==void 0?E:Object.create(null),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===m.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(h){return h=o._validateIndex(h),o._cells[h].apiCell},getCells(h){return(h?o._getCells(h):o._cells).map(l=>l.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),o.metadata))}acceptDirty(o){this._isDirty=o}acceptModelChanged(o,h){this._versionId=o.versionId,this._isDirty=h;for(const d of o.rawEvents)d.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===D.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let h=o.start|0,d=o.end|0;return h<0&&(h=0),d>this._cells.length&&(d=this._cells.length),o.with({start:h,end:d})}_getCells(o){o=this._validateRange(o);const h=[];for(let d=o.start;d<o.end;d++)h.push(this._cells[d]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,h){if(this._disposed)return;const d=[],l=[],_=[];o.reverse().forEach(b=>{const c=b[2].map(t=>{const i=new C(this,this._textDocumentsAndEditors,t);return h||l.push(C.asModelAddData(this.apiNotebook,t)),i}),f=new v(b[0],b[1],[],c),g=this._cells.splice(b[0],b[1],...c);for(const t of g)_.push(t.uri),f.deletedItems.push(t.apiCell);d.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:_}),h||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:v.asApiEvents(d)}))}_moveCell(o,h){const d=this._cells.splice(o,1);this._cells.splice(h,0,...d);const l=[new v(o,1,d.map(_=>_.apiCell),[]),new v(h,0,[],d)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:v.asApiEvents(l)}))}_setCellOutputs(o,h){const d=this._cells[o];d.setOutputs(h),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(o,h,d,l){const _=this._cells[o];_.setOutputItems(h,d,l),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(o,h){const d=this._cells[o];d.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(d.uri,h)}_changeCellMime(o,h){const d=this._cells[o];d.apiCell.mime=h}_changeCellMetadata(o,h){const d=this._cells[o],l=d.apiCell.metadata;d.setMetadata(h);const _=d.apiCell.metadata;T.equals(l,_)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(o,h){var d;const l=this._cells[o],_=l.internalMetadata;if(l.setInternalMetadata(h),_.runState!==h.runState){const b=(d=h.runState)!==null&&d!==void 0?d:k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:l.apiCell,state:b}))}}getCellFromApiCell(o){return this._cells.find(h=>h.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(h=>h.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(Ee[97],ye([0,1,6,9,11]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(v){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=v}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(v){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:v})}replaceCellMetadata(v,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:v,metadata:C})}replaceCells(v,C,n){this._throwIfFinalized(),!(v===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:v,count:C-v,cells:n.map(T.NotebookCellData.from)})}}class k{constructor(v,C,n,I,o,h){this.id=v,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._visibleRanges=I,this._viewColumn=h}get apiEditor(){if(!this._editor){const v=this;this._editor={get document(){return v.notebookData.apiNotebook},get selections(){return v._selections},set selections(C){if(!Array.isArray(C)||!C.every(m.NotebookRange.isNotebookRange))throw S.illegalArgument("selections");v._selections=C,v._trySetSelections(C)},get visibleRanges(){return v._visibleRanges},revealRange(C,n){v._proxy.$tryRevealRange(v.id,T.NotebookRange.from(C),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return v._viewColumn},edit(C){const n=new y(this.document.version);return C(n),v._applyEdit(n.finalize())},setDecorations(C,n){return v.setDecorations(C,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(v){this._visible=v}_acceptVisibleRanges(v){this._visibleRanges=v}_acceptSelections(v){this._selections=v}_trySetSelections(v){this._proxy.$trySetSelections(this.id,v.map(T.NotebookRange.from))}_acceptViewColumn(v){this._viewColumn=v}_applyEdit(v){if(v.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let I=0;I<v.cellEdits.length;I++){if(n<0){C.push(v.cellEdits[I]),n++;continue}const h=C[n],d=v.cellEdits[I];if(h.editType===1&&d.editType===1&&h.index===d.index){h.cells.push(...v.cellEdits[I].cells),h.count+=v.cellEdits[I].count;continue}C.push(v.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,v.documentVersionId,C)}setDecorations(v,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(v.key)))return C.isEmpty?this._hasDecorationsForKey.delete(v.key):this._hasDecorationsForKey.add(v.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(C),v.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(Ee[170],ye([0,1,9,149,130,18,48]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,o,h){const d=this._handles++,{title:l,location:_,cancellable:b}=o,E={label:S.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(d,{location:m.ProgressLocation.from(_),title:l,source:E,cancellable:b},I),this._withProgress(d,h,!!b)}_withProgress(I,o,h){let d;h&&(d=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,d));const l=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),d&&d.dispose()};let _;try{_=o(new C(this._proxy,I),h&&d?d.token:y.CancellationToken.None)}catch(b){throw l(I),b}return _.then(b=>l(I),b=>l(I)),_}$acceptProgressCanceled(I){const o=this._mapHandleToCancellationSource.get(I);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function v(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class C extends T.Progress{constructor(I,o){super(h=>this.throttledReport(h));this._proxy=I,this._handle=o}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([k.throttle(100,(n,I)=>v(n,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Ee[98],ye([0,1,38,11,50,9,6]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(o,h,d){const l=D._Keys.nextId();o.$registerTextEditorDecorationType(h.identifier,l,y.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:l,dispose(){o.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class v{constructor(o,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,h){this._throwIfFinalized();let d=null;if(o instanceof k.Position)d=new k.Range(o,o);else if(o instanceof k.Range)d=o;else throw new Error("Unrecognized location");this._pushEdit(d,h,!1)}insert(o,h){this._throwIfFinalized(),this._pushEdit(new k.Range(o,o),h,!0)}delete(o){this._throwIfFinalized();let h=null;if(o instanceof k.Range)h=o;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(o,h,d){const l=this._document.validateRange(o);this._collectedEdits.push({range:l,text:h,forceMoveMarkers:d})}setEndOfLine(o){if(this._throwIfFinalized(),o!==k.EndOfLine.LF&&o!==k.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=v;class C{constructor(o,h,d,l){this._proxy=o,this._id=h,this._accept(d),this._logService=l;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(b){_._setTabSize(b)},get insertSpaces(){return _._insertSpaces},set insertSpaces(b){_._setInsertSpaces(b)},get cursorStyle(){return _._cursorStyle},set cursorStyle(b){_._setCursorStyle(b)},get lineNumbers(){return _._lineNumbers},set lineNumbers(b){_._setLineNumbers(b)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const h=Math.floor(o);return h>0?h:null}if(typeof o=="string"){const h=parseInt(o,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(o){const h=this._validateTabSize(o);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const h=this._validateInsertSpaces(o);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(o)})))}assign(o){const h={};let d=!1;if(typeof o.tabSize!="undefined"){const l=this._validateTabSize(o.tabSize);l==="auto"?(d=!0,h.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,d=!0,h.tabSize=l)}if(typeof o.insertSpaces!="undefined"){const l=this._validateInsertSpaces(o.insertSpaces);l==="auto"?(d=!0,h.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,d=!0,h.insertSpaces=l)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,d=!0,h.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,d=!0,h.lineNumbers=y.TextEditorLineNumbersStyle.from(o.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(o){o.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class n{constructor(o,h,d,l,_,b,E,c){this.id=o,this._proxy=h,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new C(this._proxy,this.id,b,d),this._visibleRanges=E,this._viewColumn=c;const f=this;this.value=Object.freeze({get document(){return l.getValue()},set document(g){throw T.readonly("document")},get selection(){return f._selections&&f._selections[0]},set selection(g){if(!(g instanceof k.Selection))throw T.illegalArgument("selection");f._selections=[g],f._trySetSelection()},get selections(){return f._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof k.Selection)))throw T.illegalArgument("selections");f._selections=g,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(g){throw T.readonly("visibleRanges")},get options(){return f._options.value},set options(g){f._disposed||f._options.assign(g)},get viewColumn(){return f._viewColumn},set viewColumn(g){throw T.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new v(l.getValue(),t);return g(i),f._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f._selections.map(r=>y.Range.from(r));else if(t instanceof k.Position){const{lineNumber:r,column:u}=y.Position.from(t);s=[{startLineNumber:r,startColumn:u,endLineNumber:r,endColumn:u}]}else if(t instanceof k.Range)s=[y.Range.from(t)];else{s=[];for(const r of t)if(r instanceof k.Range)s.push(y.Range.from(r));else{const{lineNumber:u,column:w}=y.Position.from(r);s.push({startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w})}}return h.$tryInsertSnippet(o,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!f._hasDecorationsForKey.has(g.key)||(i?f._hasDecorationsForKey.delete(g.key):f._hasDecorationsForKey.add(g.key),f._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return h.$trySetDecorations(o,g.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,u=t.length;r<u;r++){const w=t[r];s[4*r]=w.start.line+1,s[4*r+1]=w.start.character+1,s[4*r+2]=w.end.line+1,s[4*r+3]=w.end.character+1}return h.$trySetDecorationsFast(o,g.key,s)}}))},revealRange(g,t){f._runOnProxy(()=>h.$tryRevealRange(o,y.Range.from(g),t||k.TextEditorRevealType.Default))},show(g){h.$tryShowEditor(o,y.ViewColumn.from(g))},hide(){h.$tryHideEditor(o)}})}dispose(){m.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){m.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){m.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){m.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){m.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const h=o.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const d=h.edits.map(_=>_.range);d.sort((_,b)=>_.end.line===b.end.line?_.end.character===b.end.character?_.start.line===b.start.line?_.start.character-b.start.character:_.start.line-b.start.line:_.end.character-b.end.character:_.end.line-b.end.line);for(let _=0,b=d.length-1;_<b;_++){const E=d[_].end;if(d[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=h.edits.map(_=>({range:y.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,l,{setEndOfLine:typeof h.setEndOfLine=="number"?y.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(Ee[171],ye([0,1,133,25,2,3,7,13,6,10,17,9,18]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(_,b){if(C.isString(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let E;return Array.isArray(_.highlights)&&(E=_.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),E=E.length?E:void 0),{label:_.label,highlights:E}}}class d{constructor(b,E,c){this._proxy=b,this.commands=E,this.logService=c,this.treeViews=new Map;function f(g){return g&&g.$treeViewId&&g.$treeItemHandle}E.registerArgumentProcessor({processArgument:g=>f(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>f(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(b,E,c){const f=this.createTreeView(b,{treeDataProvider:E},c);return{dispose:()=>f.dispose()}}createTreeView(b,E,c){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=E.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:f}),t=this.createExtHostTreeView(b,E,c);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(b),t.dispose()}}}$getChildren(b,E){const c=this.treeViews.get(b);return c?c.getChildren(E):Promise.reject(new Error(m.localize(0,null,b)))}$onDrop(b,E,c){const f=this.treeViews.get(b);return f?f.onDrop(E,c):Promise.reject(new Error(m.localize(1,null,b)))}async $hasResolve(b){const E=this.treeViews.get(b);if(!E)throw new Error(m.localize(2,null,b));return E.hasResolve}$resolve(b,E,c){const f=this.treeViews.get(b);if(!f)throw new Error(m.localize(3,null,b));return f.resolveTreeItem(E,c)}$setExpanded(b,E,c){const f=this.treeViews.get(b);if(!f)throw new Error(m.localize(4,null,b));f.setExpanded(E,c)}$setSelection(b,E){const c=this.treeViews.get(b);if(!c)throw new Error(m.localize(5,null,b));c.setSelection(E)}$setVisible(b,E){const c=this.treeViews.get(b);if(!c)throw new Error(m.localize(6,null,b));c.setVisible(E)}createExtHostTreeView(b,E,c){const f=new l(b,E,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(b,f),f}convertArgument(b){const E=this.treeViews.get(b.$treeViewId);return E?E.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=d;class l extends k.Disposable{constructor(b,E,c,f,g,t){super();if(this.viewId=b,this.proxy=c,this.commands=f,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const u of t.contributes.views[r])u.id===b&&(this._title=u.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(r,u)=>(r||(r={message:!1,elements:[]}),u.element!==!1&&(i||(i=new Promise(w=>s=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(u.element)?r.elements.push(...u.element):r.elements.push(u.element)),u.message&&(r.message=!0),r),200,!0)(({message:r,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=s;return i=null,this.refresh(u).then(()=>w())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!C.isUndefinedOrNull(b))}getChildren(b){const E=b?this.getExtensionElement(b):void 0;if(b&&!E)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(b);return(c?Promise.resolve(c):this.fetchChildrenNodes(E)).then(f=>f.map(g=>g.item))}getExtensionElement(b){return this.elements.get(b)}reveal(b,E){E=E||{select:!0,focus:!1};const c=C.isUndefinedOrNull(E.select)?!0:E.select,f=C.isUndefinedOrNull(E.focus)?!1:E.focus,g=C.isUndefinedOrNull(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:c,focus:f,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:f,expand:g})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,E){const c=this.getExtensionElement(b);c&&(E?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(b){n.equals(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(b,E){const c=b.map(g=>this.getExtensionElement(g)).filter(g=>!C.isUndefinedOrNull(g)),f=this.getExtensionElement(E);return c&&f?D.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(c,f)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,E){var c;if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(b);if(f){const g=this.nodes.get(f);if(g){const t=(c=await this.dataProvider.resolveTreeItem(g.extensionItem,f,E))!==null&&c!==void 0?c:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(E=>E?this.resolveUnknownParentChain(E).then(c=>this.resolveTreeNode(E,c[c.length-1]).then(f=>(c.push(f),c))):Promise.resolve([]))}resolveParent(b){const E=this.nodes.get(b);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):D.asPromise(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,E){const c=this.nodes.get(b);return c?Promise.resolve(c):D.asPromise(()=>this.dataProvider.getTreeItem(b)).then(f=>this.createHandle(b,f,E,!0)).then(f=>this.getChildren(E?E.item.handle:void 0).then(()=>{const g=this.getExtensionElement(f);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${f}`)}))}getChildrenNodes(b){if(b){let E;if(typeof b=="string"){const c=this.getExtensionElement(b);E=c?this.nodes.get(c):void 0}else E=b;return E&&E.children||null}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const E=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=b?this.nodes.get(b):void 0,f=await this.dataProvider.getChildren(b);if(E.token.isCancellationRequested)return[];const g=await Promise.all(n.coalesce(f||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,c):null}));return E.token.isCancellationRequested?[]:n.coalesce(g)}finally{E.dispose()}}refresh(b){if(b.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(b);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const E=new Set,c=b.map(g=>this.nodes.get(g));for(const g of c)if(g&&!E.has(g.item.handle)){let t=g;for(;t&&t.parent&&c.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&E.add(g.item.handle)}const f=[];return E.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!E.has(i.parent.item.handle))&&f.push(g)}}),f}refreshHandles(b){const E={};return Promise.all(b.map(c=>this.refreshNode(c).then(f=>{f&&(E[c]=f.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(b){const E=this.getExtensionElement(b);if(E){const c=this.nodes.get(E);if(c)return this.clearChildren(E),D.asPromise(()=>this.dataProvider.getTreeItem(E)).then(f=>{if(f){const g=this.createTreeNode(E,f,c.parent);return this.updateNodeCache(E,g,c,c.parent),c.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,E,c){const f=this.createTreeNode(b,E,c);if(E.id&&this.elements.has(f.item.handle))throw new Error(m.localize(7,null,E.id));return this.addNodeToCache(b,f),this.addNodeToParentCache(f,c),f}getTooltip(b){return v.MarkdownString.isMarkdownString(b)?I.MarkdownString.from(b):b}getCommand(b,E){return E?this.commands.toInternal(E,b):void 0}createTreeNode(b,E,c){const f=new k.DisposableStore,g=this.createHandle(b,E,c),t=this.getLightIconPath(E);return{item:{handle:g,parentHandle:c?c.item.handle:void 0,label:h(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(f,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:C.isUndefinedOrNull(E.collapsibleState)?v.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:c,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(b){return b.iconPath instanceof v.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:E,label:c,resourceUri:f},g,t){if(E)return`${l.ID_HANDLE_PREFIX}/${E}`;const i=h(c,this.extension),s=g?g.item.handle:l.LABEL_HANDLE_PREFIX;let r=i?i.label:f?T.basename(f):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const u=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,w=this.getChildrenNodes(g)||[];let p,P=0;do{if(p=`${s}/${P}:${r}`,t||!this.elements.has(p)||u===p)break;P++}while(P<=w.length);return p}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof v.ThemeIcon))return typeof b.iconPath=="string"||S.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof v.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return S.URI.isUri(b)?b:S.URI.file(b)}addNodeToCache(b,E){this.elements.set(E.item.handle,b),this.nodes.set(b,E)}updateNodeCache(b,E,c,f){this.elements.delete(E.item.handle),this.nodes.delete(b),E.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(b,E);const g=this.getChildrenNodes(f)||[],t=g.filter(i=>i.item.handle===c.item.handle)[0];t&&g.splice(g.indexOf(t),1,E)}addNodeToParentCache(b,E){E?(E.children||(E.children=[]),E.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const E=this.nodes.get(b);if(E){if(E.children)for(const c of E.children){const f=this.elements.get(c.item.handle);f&&this.clear(f)}E.children=void 0}}else this.clearAll()}clear(b){const E=this.nodes.get(b);if(E){if(E.children)for(const c of E.children){const f=this.elements.get(c.item.handle);f&&this.clear(f)}this.nodes.delete(b),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}l.LABEL_HANDLE_PREFIX="0",l.ID_HANDLE_PREFIX="1"}),define(Ee[172],ye([0,1,13,3,39,7,10,94,9,6,96]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var I;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));class o{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(l){if(this.map.has(l.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${l.item.extId}`);this.map.set(l.item.extId,l),l.parent||this._roots.add(l)}has(l){return this.map.has(l)}delete(l){const _=this.map.get(l);return _?(this.map.delete(l),this._roots.delete(_),!0):!1}get(l){return this.map.get(l)}comparePositions(l,_){const b=typeof l=="string"?this.map.get(l):l,E=typeof _=="string"?this.map.get(_):_;if(!b||!E)return 0;if(b===E)return 3;for(let c=this.map.get(E.parent);c;c=this.map.get(c.parent))if(c===b)return 1;for(let c=this.map.get(b.parent);c;c=this.map.get(c.parent))if(c===E)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=o;class h extends y.Disposable{constructor(l){super();this.controllerId=l,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.root=new C.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new o,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(l){this._resolveHandler=l;for(const _ of this.testItemToInternal.values())this.updateExpandability(_)}get roots(){return S.Iterable.filter(this.testItemToInternal.values(),l=>l.parent===null)}getTestByReference(l){return this.testItemToInternal.get(l)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const _=this.diff[this.diff.length-1];if(_&&l[0]===1){if(_[0]===1&&_[1].extId===l[1].extId){n.applyTestItemUpdate(_[1],l[1]);return}if(_[0]===0&&_[1].item.extId===l[1].extId){n.applyTestItemUpdate(_[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,_){var b;const E=this.tree.get(l);if(!!E){if((E.expandLevels===void 0||_>E.expandLevels)&&(E.expandLevels=_),E.expand===1){const c=this.resolveChildren(E);return c.isOpen()?this.expandChildren(E,_-1):c.wait().then(()=>this.expandChildren(E,_-1))}else if(E.expand===3)return((b=E.resolveBarrier)===null||b===void 0?void 0:b.isOpen())===!1?E.resolveBarrier.wait().then(()=>this.expandChildren(E,_-1)):this.expandChildren(E,_-1)}}dispose(){for(const l of this.testItemToInternal.values())D.getPrivateApiFor(l.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(l,_){const b=l==null?void 0:l.actual.id;switch(_[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(l);break;case 0:this.addItemInner(_[1],l);break;case 3:const[E,c,f]=_;switch(c){case"canResolveChildren":this.updateExpandability(l);break;case"range":this.pushDiff([1,{extId:b,item:{range:v.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:v.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[c]:f??null}}]);break}break;default:k.assertNever(_[0])}}addItemInner(l,_){if(!(l instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);if(this.testItemToInternal.has(l))throw new Error(`Attempted to add a single TestItem ${l.id} multiple times to the tree`);if(this.tree.has(l.id))throw new Error(`Attempted to insert a duplicate test item ID ${l.id}`);const b=_?_.item.extId:null,E=_?_.expandLevels:1,c={actual:l,parent:b,item:v.TestItem.from(l),expandLevels:E?E-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(c),this.testItemToInternal.set(l,c),this.pushDiff([0,{parent:b,controllerId:this.controllerId,expand:c.expand,item:c.item}]);const f=D.getPrivateApiFor(l);f.bus.event(this.onTestItemEvent.bind(this,c)),this.updateExpandability(c);for(const g of f.children.values())this.testItemToInternal.has(g)||this.addItemInner(g,c)}updateExpandability(l){let _;this._resolveHandler?l.resolveBarrier?_=l.resolveBarrier.isOpen()?3:2:_=l.actual.canResolveChildren?1:0:_=0,_!==l.expand&&(l.expand=_,this.pushDiff([1,{extId:l.actual.id,expand:_}]),_===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,_){if(_<0)return;const b=[...l.actual.children.values()].map(E=>this.expand(E.id,_)).filter(m.isThenable);if(b.length)return Promise.all(b).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const E=new m.Barrier;return E.open(),E}l.expand=2,this.pushExpandStateUpdate(l);const _=l.resolveBarrier=new m.Barrier;let b;try{b=this._resolveHandler(l.actual)}catch(E){l.actual.error=E.stack||E.message}return m.isThenable(b)?b.catch(E=>l.actual.error=E.stack||E.message).then(()=>{_.open(),this.updateExpandability(l)}):(_.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.actual.id,expand:l.expand}])}removeItem(l){this.pushDiff([2,l.actual.id]);const _=[l];for(;_.length;){const b=_.pop();if(!!b){this.tree.delete(b.item.extId),this.testItemToInternal.delete(b.actual);for(const E of b.actual.children.values())_.push(this.tree.get(E.id))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=h}),define(Ee[173],ye([0,1,5,144]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=m.refineServiceDecorator(T.IEnvironmentService)}),define(Ee[174],ye([0,1,26,3,15]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class k{constructor(n){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(v),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(o=>I.add(m.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>I.has(m.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const o=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(o.map(h=>h.identifier)),I.length>0){const h=new Set;I.forEach(d=>h.add(m.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!h.has(m.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(o)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,b){this.addNode(_),this.addNode(b),this._arcs.has(_)?this._arcs.get(_).push(b):this._arcs.set(_,[b])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,b){const E=I.getArcs(_);for(let c=0;c<E.length;c++)if(!b.has(E[c]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let _ of n){const b=m.ExtensionIdentifier.toKey(_.identifier);if(o.set(b,_),_.extensionDependencies)for(let E of _.extensionDependencies){const c=m.ExtensionIdentifier.toKey(E);I.addArc(b,c)}}let h=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>h.add(_));let d=I.getNodes().filter(_=>!h.has(_)),l;do{l=!1;for(let _=0;_<d.length;_++){const b=d[_];I.hasOnlyGoodArcs(b,h)&&(d.splice(_,1),_--,h.add(b),l=!0)}}while(l);return d.map(_=>o.get(_))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=k;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function v(C,n){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,o=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==o)return I-o;const h=S.posix.basename(C.extensionLocation.path),d=S.posix.basename(n.extensionLocation.path);return h<d?-1:h>d?1:0}}),define(Ee[175],ye([0,1,23]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function y(D){const v=m.VSBuffer.alloc(1);switch(D){case 0:v.writeUInt8(1,0);break;case 1:v.writeUInt8(2,0);break;case 2:v.writeUInt8(3,0);break}return v}e.createMessageOfType=y;function k(D,v){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return v===0;case 2:return v===1;case 3:return v===2;default:return!1}}e.isMessageOfType=k}),define(Ee[29],ye([0,1,3,2,5,26,145]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=S.createDecorator("extensionService");class D{constructor(E){this.dependency=E}}e.MissingExtensionDependency=D;var v;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,c,f,g){this.codeLoadingTime=E,this.activateCallTime=c,this.activateResolvedTime=f,this.activationReason=g}}e.ActivationTimes=C;class n{constructor(E,c){this.description=E,this.value=c}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function o(b){b.enableProposedApi||h(b)}e.checkProposedApiEnabled=o;function h(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=h;function d(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:k.getGalleryExtensionId(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=d;function l(b,E){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!E,extensionLocation:b.location},b.manifest),{uuid:b.identifier.uuid})}e.toExtensionDescription=l;class _{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,c){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,c,f,g,t){}_onDidActivateExtensionError(E,c){}_onExtensionRuntimeError(E,c){}_onExtensionHostExit(E){}}e.NullExtensionService=_}),define(Ee[176],ye([0,1,26,29,16]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(d,l,_,b){this.startup=d,this.codeLoadingTime=l,this.activateCallTime=_,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,l){return d===-1||l===-1?-1:l-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class v{constructor(d,l,_,b,E,c){this.activationFailed=d,this.activationFailedError=l,this.activationTimes=_,this.module=b,this.exports=E,this.subscriptions=c}}e.ActivatedExtension=v;class C extends v{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends v{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends v{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let o=class{constructor(d,l,_,b,E){this._logService=E,this._registry=d,this._resolvedExtensionsSet=new Set,l.forEach(c=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,_.forEach(c=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const l=m.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(l)}getActivatedExtension(d){const l=m.ExtensionIdentifier.toKey(d),_=this._activatedExtensions.get(l);if(!_)throw new Error("Extension `"+d.value+"` is not known or not activated");return _}activateByEvent(d,l){if(this._alreadyActivatedEvents[d])return y;const _=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(_.map(b=>({id:b.identifier,reason:{startup:l,extensionId:b.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,l){const _=this._registry.getExtensionDescription(d);if(!_)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:_.identifier,reason:l}])}_handleActivateRequest(d,l,_){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(d.id))){l[m.ExtensionIdentifier.toKey(d.id)]=d;return}const b=this._registry.getExtensionDescription(d.id);if(!b){const f=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,f,new T.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(d.id),new I(f));return}const E=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let f=0,g=E.length;f<g;f++){const t=E[f];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const w=b.displayName||b.identifier.value,p=this._registry.getExtensionDescription(t),P=p&&p.displayName||t,A=new Error(`Cannot activate the '${w}' extension because its dependency '${P}' failed to activate`);A.detail=i.activationFailedError,this._host.onExtensionActivationError(b.identifier,A,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(b.identifier),new I(A));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){c=!1,l[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){c=!1,l[m.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:d.reason};continue}const r=b.displayName||b.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,u,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(b.identifier),new I(u));return}c?l[m.ExtensionIdentifier.toKey(b.identifier)]=d:_.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(E=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(E.id))),d.length===0))return Promise.resolve(void 0);const l=Object.create(null),_=[];for(let E=0,c=d.length;E<c;E++)this._handleActivateRequest(d[E],l,_);for(let E=0,c=_.length;E<c;E++){const f=m.ExtensionIdentifier.toKey(_[E].id);l[f]&&delete l[f]}const b=Object.keys(l).map(E=>l[E]);return _.length===0?Promise.all(b.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(b).then(E=>this._activateExtensions(_))}_activateExtension(d,l){const _=m.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const b=this._activatingExtensions.get(_);if(b)return b;const E=this._host.actualActivateExtension(d,l).then(void 0,c=>{const f=new Error;return c&&c.name&&(f.name=c.name),c&&c.message?f.message=`Activating extension '${d.value}' failed: ${c.message}.`:f.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(f.stack=c.stack),this._host.onExtensionActivationError(d,f,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new I(c)}).then(c=>{this._activatedExtensions.set(_,c),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};o=Ve([je(4,S.ILogService)],o),e.ExtensionsActivator=o}),define(Ee[177],ye([0,1,11]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,k)=>{this._actualOk=y,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):m.onUnexpectedError(y))}then(y,k){return this._ensureActual().then(y,k)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=T}),define(Ee[99],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(v,C){this.isMain=v,this.sid=C,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const T=[];function S(D){const v=new m(!0,D);return T[v.nid]=v,v}e.createMainContextProxyIdentifier=S;function y(D){const v=new m(!1,D);return T[v.nid]=v,v}e.createExtHostContextProxyIdentifier=y;function k(D){return T[D].sid}e.getStringIdentifierForProxy=k}),define(Ee[4],ye([0,1,54,2,99]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var v;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(v=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(c){c.name="$ident";function f(t,i){return Object.defineProperty(t,c.name,{value:i,enumerable:!0}),t}c.mixin=f;function g(t){return t[c.name]}c.of=g})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(f){return f._id=h._n++,f}}e.IdObject=h,h._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(c){if(c&&c.edits)for(const f of c.edits)typeof f.resource=="object"?f.resource=T.URI.revive(f.resource):(f.newUri=T.URI.revive(f.newUri),f.oldUri=T.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=m.revive(f.metadata));return c}e.reviveWorkspaceEditDto=b;var E;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:S.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:S.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:S.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:S.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:S.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:S.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:S.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:S.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:S.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:S.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:S.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:S.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:S.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:S.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:S.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:S.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:S.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:S.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:S.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:S.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:S.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:S.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:S.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:S.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:S.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:S.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:S.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:S.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:S.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:S.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:S.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:S.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:S.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:S.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:S.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:S.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:S.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:S.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:S.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:S.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:S.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:S.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:S.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:S.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:S.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:S.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:S.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:S.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:S.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:S.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:S.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:S.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:S.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:S.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:S.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:S.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:S.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:S.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:S.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:S.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:S.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:S.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:S.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:S.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:S.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:S.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:S.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:S.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:S.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:S.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:S.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:S.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:S.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:S.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:S.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:S.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:S.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:S.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:S.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:S.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:S.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:S.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:S.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:S.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:S.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:S.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:S.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:S.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:S.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:S.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:S.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:S.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:S.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:S.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:S.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:S.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:S.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:S.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:S.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:S.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:S.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:S.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:S.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:S.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(Ee[68],ye([0,1,4,3,5]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(D){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,v){return this._proxy.$getPassword(D,v)}store(D,v,C){return this._proxy.$setPassword(D,v,C)}delete(D,v){return this._proxy.$deletePassword(D,v)}}e.ExtHostSecretState=y,e.IExtHostSecretState=S.createDecorator("IExtHostSecretState")}),define(Ee[69],ye([0,1,5,16,4,14]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=m.createDecorator("IExtHostApiDeprecationService");let k=class{constructor(v,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(S.MainContext.MainThreadTelemetry)}report(v,C,n){const I=this.getUsageKey(v,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:v}))}getUsageKey(v,C){return`${v}-${C.identifier.value}`}};k=Ve([je(0,y.IExtHostRpcService),je(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(D,v,C){}})}),define(Ee[178],ye([0,1,3,4,6,26]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(v){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new m.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=v.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(v){return this._providers=v,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(v,C,n,I={}){const o=y.ExtensionIdentifier.toKey(v.identifier),h=this._inFlightRequests.get(o)||[],d=[...n].sort().join(" ");let l=h.find(_=>_.scopes===d);if(l)return l.result;{const _=this._getSession(v,o,C,n,I);l={scopes:d,result:_},h.push(l),this._inFlightRequests.set(o,h);try{await _}finally{const b=h.findIndex(E=>E.scopes===d);b>-1&&(h.splice(b),this._inFlightRequests.set(o,h))}return _}}async _getSession(v,C,n,I,o={}){await this._proxy.$ensureProvider(n);const h=v.displayName||v.name;return this._proxy.$getSession(n,I,C,h,o)}async removeSession(v,C){const n=this._authenticationProviders.get(v);return n?n.provider.removeSession(C):this._proxy.$removeSession(v,C)}registerAuthenticationProvider(v,C,n,I){var o;if(this._authenticationProviders.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this._authenticationProviders.set(v,{label:C,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===v)||this._providers.push({id:v,label:C});const h=n.onDidChangeSessions(d=>{var l,_,b;this._proxy.$sendDidChangeSessions(v,{added:(l=d.added)!==null&&l!==void 0?l:[],changed:(_=d.changed)!==null&&_!==void 0?_:[],removed:(b=d.removed)!==null&&b!==void 0?b:[]})});return this._proxy.$registerAuthenticationProvider(v,C,(o=I==null?void 0:I.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new S.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(v);const d=this._providers.findIndex(l=>l.id===v);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(v)})}$createSession(v,C){const n=this._authenticationProviders.get(v);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,C){const n=this._authenticationProviders.get(v);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,C){const n=this._authenticationProviders.get(v);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,C){return this._onDidChangeSessions.fire({provider:{id:v,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(v,C){return v.forEach(n=>{this._providers.some(I=>I.id===n.id)||this._providers.push(n)}),C.forEach(n=>{const I=this._providers.findIndex(o=>o.id===n.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:v,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(Ee[179],ye([0,1,4,14,9]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(D,v){this._extHostDocumentsAndEditors=v,this._proxy=D.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const v=S.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(v)}};y=Ve([je(0,T.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(Ee[180],ye([0,1,4]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(y){const k=y.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(D){return k.$writeText(D)}})}}e.ExtHostClipboard=T}),define(Ee[70],ye([0,1,10,6,9,24,4,17,16,54,30,35,2,7,5,14]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=i,this.converter=new b(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===c.Void?r:void 0},i),this._argumentProcessors=[{processArgument(s){return C.revive(s)}},{processArgument(s){return y.cloneAndChange(s,function(r){if(n.Range.isIRange(r))return S.Range.to(r);if(I.Position.isIPosition(r))return S.Position.to(r);if(n.Range.isIRange(r.range)&&o.URI.isUri(r.uri))return S.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((w,p)=>{if(!w.validate(s[p]))throw new Error(`Invalid argument '${w.name}' when running '${t.id}', received: ${s[p]}`);return w.convert(s[p])}),u=await this.executeCommand(t.internalId,...r);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,r,u){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:r,description:u}),t&&this._proxy.$registerCommand(i),new T.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=y.cloneAndChange(i,function(u){if(u instanceof T.Position)return S.Position.from(u);if(u instanceof T.Range)return S.Range.from(u);if(u instanceof T.Location)return S.location.from(u);if(T.NotebookRange.isNotebookRange(u))return S.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,r,s);return C.revive(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw u}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:u,description:w}=s;if(w)for(let p=0;p<w.args.length;p++)try{m.validateConstraint(i[p],w.args[p].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${w.args[p].name}' - ${w.args[p].description}`)}try{return await r.apply(u,i)}catch(p){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...i);P&&(t=P.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((r,u)=>u.processArgument(r),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:r}=s;r&&(t[i]=r)}return Promise.resolve(t)}};_=Ve([je(0,l.IExtHostRpcService),je(1,v.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=d.createDecorator("IExtHostCommands");class b{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((u,w)=>u.convert(t.arguments&&t.arguments[w]));else if(D.isNonEmptyArray(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),i.add(h.toDisposable(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}fromInternal(t){const i=k.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class E{constructor(t,i,s,r){this.name=t,this.description=i,this.validate=s,this.convert=r}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new E(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",g=>o.URI.isUri(g),g=>g),E.Position=new E("position","A position in a text document",g=>T.Position.isPosition(g),S.Position.from),E.Range=new E("range","A range in a text document",g=>T.Range.isRange(g),S.Range.from),E.Selection=new E("selection","A selection in a text document",g=>T.Selection.isSelection(g),S.Selection.from),E.Number=new E("number","",g=>typeof g=="number",g=>g),E.String=new E("string","",g=>typeof g=="string",g=>g),E.CallHierarchyItem=new E("item","A call hierarchy item",g=>g instanceof T.CallHierarchyItem,S.CallHierarchyItem.to);class c{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=c,c.Void=new c("no result",g=>g);class f{constructor(t,i,s,r,u){this.id=t,this.internalId=i,this.description=s,this.args=r,this.result=u}}e.ApiCommand=f}),define(Ee[181],ye([0,1,9,6,58,70,17,85]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,h)=>{if(k.isFalsyOrEmpty(o))return;class d extends T.SymbolInformation{static to(_){const b=new d(_.name,m.SymbolKind.to(_.kind),_.containerName||"",new T.Location(h[0],m.Range.to(_.range)));return b.detail=_.detail,b.range=b.location.range,b.selectionRange=m.Range.to(_.selectionRange),b.children=_.children?_.children.map(d.to):[],b}}return o.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(h=>T.Position.isPosition(h)),o=>o.map(m.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(h=>{let d;for(const l of h.reverse())d=new T.SelectionRange(m.Range.to(l),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const h=[];if(Array.isArray(o))for(let d of o)h.push(...d[1].map(m.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(m.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return m.WorkspaceEdit.to(o)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(m.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=D.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=D.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,h,d)=>{if(!o)return new T.CompletionList([]);const l=o.suggestions.map(_=>m.CompletionItem.to(_,d));return new T.CompletionList(l,o.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return m.SignatureHelp.to(o)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,h,d)=>n(l=>new T.CodeLens(m.Range.to(l.range),l.command&&d.fromInternal(l.command)))(o))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?m.Selection.from(o):m.Range.from(o)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,h,d)=>n(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(l.command)}else{const _=new T.CodeAction(l.title,l.kind?new T.CodeActionKind(l.kind):void 0);return l.edit&&(_.edit=m.WorkspaceEdit.to(l.edit)),l.command&&(_.command=d.fromInternal(l.command)),_.isPreferred=l.isPreferred,_}})(o))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(h=>new T.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,m.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:m.Range.from(o.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(m.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(m.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(m.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[m.ViewColumn.from(o.viewColumn),m.TextEditorOpenOptions.from(o)]).optional()],y.ApiCommandResult.Void)];class C{static register(h){v.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function n(o){return h=>{if(Array.isArray(h))return h.map(o)}}function I(o){if(!Array.isArray(o))return;const h=[];for(const d of o)S.isLocationLink(d)?h.push(m.DefinitionLink.to(d)):h.push(m.location.to(d));return h}}),define(Ee[182],ye([0,1,13,48,3,7,2,58,26,9,6,4]),function(Z,e,m,T,S,y,k,D,v,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(f,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=f.getProxy(I.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let u=i.commentUniqueId,w=r.getCommentByUniqueId(u);return w||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const r=s.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let u=i.text,w=i.commentUniqueId,p=r.getCommentByUniqueId(w);return p?(p.body=u,p):i}return i}})}createCommentController(f,g,t){const i=o.handlePool++,s=new d(f,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(v.ExtensionIdentifier.toKey(f.identifier))||[];return r.push(s),this._commentControllersByExtension.set(v.ExtensionIdentifier.toKey(f.identifier),r),s}$createCommentThreadTemplate(f,g,t){const i=this._commentControllers.get(f);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(f,g,t){const i=this._commentControllers.get(f);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(f,g){const t=this._commentControllers.get(f);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(f,g,t){const i=this._commentControllers.get(f);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(k.URI.revive(g));return m.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(u=>C.Range.from(u)):void 0)}$toggleReaction(f,g,t,i,s){const r=this._commentControllers.get(f);return!r||!r.reactionHandler?Promise.resolve(void 0):m.asPromise(()=>{const u=r.getCommentThread(g);if(u){const w=u.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&w&&r.reactionHandler)return r.reactionHandler(w,b(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class h{constructor(f,g,t,i,s,r,u){this._proxy=f,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=r,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const f=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};f("range")&&(g.range=C.Range.from(this._range)),f("label")&&(g.label=this.label),f("contextValue")&&(g.contextValue=this.contextValue),f("comments")&&(g.comments=this._comments.map(t=>l(this,this._commentController,t,this._commentsMap))),f("collapsibleState")&&(g.collapseState=E(this._collapseState)),f("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(f){for(let g of this._commentsMap){let t=g[0],i=g[1];if(f===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([T.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class d{constructor(f,g,t,i,s){this._extension=f,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(f,g,t,i){if(typeof f=="string"){const s=new h(this._proxy,this,f,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new h(this._proxy,this,void 0,f,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(f,g){const t=new h(this._proxy,this,void 0,k.URI.revive(f),C.Range.to(g),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(f,g){let t=this._threads.get(f);t&&(t.range=C.Range.to(g))}$deleteCommentThread(f){let g=this._threads.get(f);g&&g.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function l(c,f,g,t){let i=t.get(g);i||(i=++c.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:C.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(r=>_(r)):void 0}}function _(c){return{label:c.label,iconPath:c.iconPath?C.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function b(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?k.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function E(c){if(c!==void 0)switch(c){case n.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(Ee[100],ye([0,1,2,4,6,5,14,16,17,8,15]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(h,d){this._logService=d,this._provider=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,d){const l=wn._handlePool++;this._provider.set(l,{provider:h,extensionId:d}),this._proxy.$registerDecorationProvider(l,d.value);const _=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(l,null);return}let E=v.asArray(b);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(l,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,E.length);const c=E.map(t=>({uri:t,rank:C.count(t.path,"/")})),f=v.groupBy(c,(t,i)=>t.rank-i.rank||C.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of f){let i;for(let s of t){let r=n.dirname(s.uri.path);if(i!==r&&(i=r,g.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(l,g)});return new S.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(h,d,l){if(!this._provider.has(h))return Object.create(null);const _=Object.create(null),{provider:b,extensionId:E}=this._provider.get(h);return await Promise.all(d.map(async c=>{try{const{uri:f,id:g}=c,t=await Promise.resolve(b.provideFileDecoration(m.URI.revive(f),l));if(!t)return;try{S.FileDecoration.validate(t),_[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${E.value}': ${i}`)}}catch(f){this._logService.error(f)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([je(0,k.IExtHostRpcService),je(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(Ee[183],ye([0,1,128,89,2,4,6,9,3,16,22]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(d,l,_,b,E){this._name=d,this._owner=l,this._maxDiagnosticsPerFile=_,this._proxy=b,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,l){if(!d){this.clear();return}this._checkDisposed();let _=[];if(S.URI.isUri(d)){if(!l){this.delete(d);return}this._data.set(d,l.slice()),_=[d]}else if(Array.isArray(d)){_=[];let E;d=[...d].sort(I._compareIndexedTuplesByUri);for(const c of d){const[f,g]=c;if((!E||f.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=f,_.push(f),this._data.set(f,[])),g){const t=this._data.get(f);t&&t.push(...g)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const b=[];for(let E of _){let c=[];const f=this._data.get(E);if(f)if(f.length>this._maxDiagnosticsPerFile){c=[];const g=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of f)if(i.severity===g[t]&&c.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;c.push({severity:T.MarkerSeverity.Info,message:m.localize(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=f.map(g=>D.Diagnostic.from(g));b.push([E,c])}this._proxy.$changeMany(this._owner,b)}delete(d){this._checkDisposed(),this._onDidChangeDiagnostics.fire([d]),this._data.delete(d),this._proxy&&this._proxy.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(d,l){this._checkDisposed();for(let _ of this._data.keys())d.apply(l,[_,this.get(_),this])}get(d){this._checkDisposed();const l=this._data.get(d);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(this._data.get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,l){return d[0].toString()<l[0].toString()?-1:d[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=I;let o=class Gt{constructor(d,l){this._logService=l,this._collections=new Map,this._onDidChangeDiagnostics=new v.Emitter,this.onDidChangeDiagnostics=v.Event.map(v.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=d.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(d,l){return d?d.concat(l):l}static _mapper(d){const l=new n.ResourceMap;for(const _ of d)l.set(_,_);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(d,l){const{_collections:_,_proxy:b,_onDidChangeDiagnostics:E,_logService:c}=this,f=new class{$changeMany(i,s){b.$changeMany(i,s),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,i,s.length===0?"CLEARING":s)}$clear(i){b.$clear(i),c.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,i)}dispose(){b.dispose()}};let g;if(!l)l="_generated_diagnostic_collection_name_#"+Gt._idPool++,g=l;else if(!_.has(l))g=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do g=l+Gt._idPool++;while(_.has(g))}return new class extends I{constructor(){super(l,g,Gt._maxDiagnosticsPerFile,f,E);_.set(g,this)}dispose(){super.dispose(),_.delete(g)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const l=new Map,_=[];for(const b of this._collections.values())b.forEach((E,c)=>{let f=l.get(E.toString());typeof f=="undefined"&&(f=_.length,l.set(E.toString(),f),_.push([E,[]])),_[f][1]=_[f][1].concat(...c)});return _}}_getDiagnostics(d){let l=[];for(let _ of this._collections.values())_.has(d)&&(l=l.concat(_.get(d)));return l}$acceptMarkersChange(d){if(!this._mirrorCollection){const l="_generated_mirror",_=new I(l,l,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(l,_),this._mirrorCollection=_}for(const[l,_]of d)this._mirrorCollection.set(S.URI.revive(l),_.map(D.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=Ve([je(1,C.ILogService)],o),e.ExtHostDiagnostics=o}),define(Ee[184],ye([0,1,2,4]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(k){this._proxy=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(D=>D?D.map(v=>m.URI.revive(v)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(D=>D?m.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(Ee[185],ye([0,1,11,2,6,4,12,18,8]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,o,h){this._documentsAndEditors=o,this._logService=h,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,o){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,o),this._proxy.$registerTextContentProvider(h,I);let d;return typeof o.onDidChange=="function"&&(d=o.onDidChange(l=>{if(l.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(h,l).then(_=>{if(!_&&typeof _!="string")return;const b=this._documentsAndEditors.getDocument(l);if(!b)return;const E=v.splitLines(_);if(!b.equalLines(E))return this._proxy.$onVirtualDocumentChange(l,_)},m.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(I,o){const h=this._documentContentProviders.get(I);return h?Promise.resolve(h.provideTextDocumentContent(T.URI.revive(o),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(Ee[186],ye([0,1,3,7,2,4,95,9,10,24]),function(Z,e,m,T,S,y,k,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(o,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const l of d)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const l of d)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const h=this._documentsAndEditors.getDocument(o);if(h)return h}getDocument(o){const h=this.getDocumentData(o);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return h.document}ensureDocumentData(o){const h=this._documentsAndEditors.getDocument(o);if(h)return Promise.resolve(h);let d=this._documentLoader.get(o.toString());return d||(d=this._proxy.$tryOpenDocument(o).then(l=>{this._documentLoader.delete(o.toString());const _=S.URI.revive(l);return v.assertIsDefined(this._documentsAndEditors.getDocument(_))},l=>(this._documentLoader.delete(o.toString()),Promise.reject(l))),this._documentLoader.set(o.toString(),d)),d}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(h=>S.URI.revive(h))}$acceptModelModeChanged(o,h){const d=S.URI.revive(o),l=this._documentsAndEditors.getDocument(d);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(h),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(o){const h=S.URI.revive(o),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(o,h){const d=S.URI.revive(o),l=this._documentsAndEditors.getDocument(d);if(!l)throw new Error("unknown document");l._acceptIsDirty(h),this._onDidChangeDocument.fire({document:l.document,contentChanges:[]})}$acceptModelChanged(o,h,d){const l=S.URI.revive(o),_=this._documentsAndEditors.getDocument(l);if(!_)throw new Error("unknown document");_._acceptIsDirty(d),_.onEvents(h),this._onDidChangeDocument.fire(C.deepFreeze({document:_.document,contentChanges:h.changes.map(b=>({range:D.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text}))}))}setWordDefinitionFor(o,h){k.setWordDefinitionFor(o,h)}}e.ExtHostDocuments=n}),define(Ee[46],ye([0,1,38,3,7,2,5,4,95,14,98,9,16,22,12,39,108]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(f,g){this._extHostRpc=f,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const g=[],t=[],i=[];if(f.removedDocuments)for(const s of f.removedDocuments){const r=y.URI.revive(s),u=this._documents.get(r);(u==null?void 0:u.unref())&&(this._documents.delete(r),g.push(u.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const r=y.URI.revive(s.uri);let u=this._documents.get(r);if(u&&r.scheme!==d.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);u||(u=new b(new v.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,u),t.push(u.value)),u.ref()}if(f.removedEditors)for(const s of f.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&i.push(r)}if(f.addedEditors)for(const s of f.addedEditors){const r=y.URI.revive(s.documentUri);m.ok(this._documents.has(r),`document '${r}' does not exist`),m.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(r).value,w=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>u.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(p=>I.Range.to(p)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,w)}f.newActiveEditor!==void 0&&(m.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),S.dispose(g),S.dispose(i),f.removedDocuments&&this._onDidRemoveDocuments.fire(g),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){var g;return(g=this._documents.get(f))===null||g===void 0?void 0:g.value}allDocuments(){return l.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return f?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};E=Ve([je(0,C.IExtHostRpcService),je(1,o.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=k.createDecorator("IExtHostDocumentsAndEditors")}),define(Ee[187],ye([0,1,2,4,7,6,9,118,8,23]),function(Z,e,m,T,S,y,k,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const d=this._schemes.indexOf(h);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),d=[];let l,_,b=14,E=14;for(const c of h){let f=l?v.commonPrefixLength(l,c):0;for(f===0?_=1:_=E;f<c.length;f++)f+1===c.length?(b=E,E=9):E+=1,d.push([_,c.toUpperCase().charCodeAt(f),E]),d.push([_,c.toLowerCase().charCodeAt(f),E]),_=E;l=c,E=b}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new D.StateMachine(d)}}provideDocumentLinks(h){this._initStateMachine();const d=[],l=D.LinkComputer.computeLinks({getLineContent(_){return h.lineAt(_-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const _ of l){const b=k.DocumentLink.to(_);b.target&&d.push(b)}return d}}class I{constructor(h,d){this._extHostLanguageFeatures=d,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,d,l,_={},b){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(E,l),this._enableProposedApi.set(E,b??!1);let c=2;_.isCaseSensitive&&(c+=1024),_.isReadonly&&(c+=2048),typeof l.copy=="function"&&(c+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(E,d,c).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${d}`),console.error(g)});const f=l.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:r}=i;if(s.scheme!==d)continue;let u;switch(r){case y.FileChangeType.Changed:u=0;break;case y.FileChangeType.Created:u=1;break;case y.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}this._proxy.$onFileSystemChange(E,t)});return S.toDisposable(()=>{f.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(h,d){const{type:l,ctime:_,mtime:b,size:E,permissions:c}=h;return d?{type:l,ctime:_,mtime:b,size:E,permissions:c}:{type:l,ctime:_,mtime:b,size:E}}$stat(h,d){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(d))).then(l=>{var _;return I._asIStat(l,(_=this._enableProposedApi.get(h))!==null&&_!==void 0?_:!1)})}$readdir(h,d){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(d)))}$readFile(h,d){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(d))).then(l=>C.VSBuffer.wrap(l))}$writeFile(h,d,l,_){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(d),l.buffer,_))}$delete(h,d,l){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(d),l))}$rename(h,d,l,_){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(d),m.URI.revive(l),_))}$copy(h,d,l,_){const b=this._getFsProvider(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(m.URI.revive(d),m.URI.revive(l),_))}$mkdir(h,d){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(d)))}$watch(h,d,l,_){const b=this._getFsProvider(h).watch(m.URI.revive(l),_);this._watches.set(d,b)}$unwatch(h,d){const l=this._watches.get(d);l&&(l.dispose(),this._watches.delete(d))}$open(h,d,l){const _=this._getFsProvider(h);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(m.URI.revive(d),l))}$close(h,d){const l=this._getFsProvider(h);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(d))}$read(h,d,l,_){const b=this._getFsProvider(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(_);return Promise.resolve(b.read(d,l,E.buffer,0,_)).then(c=>E.slice(0,c))}$write(h,d,l,_){const b=this._getFsProvider(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(d,l,_.buffer,0,_.byteLength))}_getFsProvider(h){const d=this._fsProvider.get(h);if(!d){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return d}}e.ExtHostFileSystem=I}),define(Ee[71],ye([0,1,4,59,6,23,5,14,45]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class xt{constructor(I,o){const h=I.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return h.$stat(d).catch(xt._handleError)},readDirectory(d){return h.$readdir(d).catch(xt._handleError)},createDirectory(d){return h.$mkdir(d).catch(xt._handleError)},async readFile(d){return h.$readFile(d).then(l=>l.buffer).catch(xt._handleError)},writeFile(d,l){return h.$writeFile(d,y.VSBuffer.wrap(l)).catch(xt._handleError)},delete(d,l){return h.$delete(d,Object.assign({recursive:!1,useTrash:!1},l)).catch(xt._handleError)},rename(d,l,_){return h.$rename(d,l,Object.assign({overwrite:!1},_)).catch(xt._handleError)},copy(d,l,_){return h.$copy(d,l,Object.assign({overwrite:!1},_)).catch(xt._handleError)},isWritableFileSystem(d){const l=o.getCapabilities(d);if(typeof l=="number")return!(l&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};C=Ve([je(0,D.IExtHostRpcService),je(1,v.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=k.createDecorator("IExtHostConsumerFileSystem")}),define(Ee[188],ye([0,1,7,4]),function(Z,e,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,k),m.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(Ee[189],ye([0,1,2,24,9,6,13,4,8,30,17,10,115,7,85,50,62,52,11,3]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(B,G){this._documents=B,this._provider=G}provideDocumentSymbols(B,G){const ne=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideDocumentSymbols(ne,G)).then(re=>{if(!n.isFalsyOrEmpty(re))return re[0]instanceof y.DocumentSymbol?re.map(S.DocumentSymbol.from):f._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree(B){var G;B=B.slice(0).sort((q,se)=>{let he=q.location.range.start.compareTo(se.location.range.start);return he===0&&(he=se.location.range.end.compareTo(q.location.range.end)),he});const ne=[],re=[];for(const q of B){const se={name:q.name||"!!MISSING: name!!",kind:S.SymbolKind.from(q.kind),tags:((G=q.tags)===null||G===void 0?void 0:G.map(S.SymbolTag.from))||[],detail:"",containerName:q.containerName,range:S.Range.from(q.location.range),selectionRange:S.Range.from(q.location.range),children:[]};for(;;){if(re.length===0){re.push(se),ne.push(se);break}const he=re[re.length-1];if(C.Range.containsRange(he.range,se.range)&&!C.Range.equalsRange(he.range,se.range)){he.children&&he.children.push(se),re.push(se);break}re.pop()}}return ne}}class g{constructor(B,G,ne){this._documents=B,this._commands=G,this._provider=ne,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,G){const ne=this._documents.getDocument(B),re=await this._provider.provideCodeLenses(ne,G);if(!re||G.isCancellationRequested)return;const q=this._cache.add(re),se=new h.DisposableStore;this._disposables.set(q,se);const he={cacheId:q,lenses:[]};for(let Re=0;Re<re.length;Re++)he.lenses.push({cacheId:[q,Re],range:S.Range.from(re[Re].range),command:this._commands.toInternal(re[Re].command,se)});return he}async resolveCodeLens(B,G){var ne;const re=B.cacheId&&this._cache.get(...B.cacheId);if(!re)return;let q;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?q=re:q=await this._provider.resolveCodeLens(re,G),q||(q=re),G.isCancellationRequested)return;const se=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!se)return B.command=this._commands.toInternal((ne=q.command)!==null&&ne!==void 0?ne:g._badCmd,se),B}releaseCodeLenses(B){var G;(G=this._disposables.get(B))===null||G===void 0||G.dispose(),this._disposables.delete(B),this._cache.delete(B)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Xe){return Array.isArray(Xe)?Xe.map(S.DefinitionLink.from):Xe?[S.DefinitionLink.from(Xe)]:[]}class i{constructor(B,G){this._documents=B,this._provider=G}provideDefinition(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideDefinition(re,q,ne)).then(t)}}class s{constructor(B,G){this._documents=B,this._provider=G}provideDeclaration(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideDeclaration(re,q,ne)).then(t)}}class r{constructor(B,G){this._documents=B,this._provider=G}provideImplementation(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideImplementation(re,q,ne)).then(t)}}class u{constructor(B,G){this._documents=B,this._provider=G}provideTypeDefinition(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideTypeDefinition(re,q,ne)).then(t)}}class w{constructor(B,G){this._documents=B,this._provider=G}provideHover(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideHover(re,q,ne)).then(se=>{if(!(!se||n.isFalsyOrEmpty(se.contents)))return se.range||(se.range=re.getWordRangeAtPosition(q)),se.range||(se.range=new y.Range(q,q)),S.Hover.from(se)})}}class p{constructor(B,G){this._documents=B,this._provider=G}provideEvaluatableExpression(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideEvaluatableExpression(re,q,ne)).then(se=>{if(se)return S.EvaluatableExpression.from(se)})}}class P{constructor(B,G){this._documents=B,this._provider=G}provideInlineValues(B,G,ne,re){const q=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideInlineValues(q,S.Range.to(G),S.InlineValueContext.to(ne),re)).then(se=>{if(Array.isArray(se))return se.map(he=>S.InlineValue.from(he))})}}class A{constructor(B,G){this._documents=B,this._provider=G}provideDocumentHighlights(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideDocumentHighlights(re,q,ne)).then(se=>{if(Array.isArray(se))return se.map(S.DocumentHighlight.from)})}}class a{constructor(B,G){this._documents=B,this._provider=G}provideLinkedEditingRanges(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.provideLinkedEditingRanges(re,q,ne)).then(se=>{if(se&&Array.isArray(se.ranges))return{ranges:n.coalesce(se.ranges.map(S.Range.from)),wordPattern:se.wordPattern}})}}class R{constructor(B,G){this._documents=B,this._provider=G}provideReferences(B,G,ne,re){const q=this._documents.getDocument(B),se=S.Position.to(G);return k.asPromise(()=>this._provider.provideReferences(q,se,ne,re)).then(he=>{if(Array.isArray(he))return he.map(S.location.from)})}}class F{constructor(B,G,ne,re,q,se,he){this._documents=B,this._commands=G,this._diagnostics=ne,this._provider=re,this._logService=q,this._extension=se,this._apiDeprecation=he,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(B,G,ne,re){const q=this._documents.getDocument(B),se=o.Selection.isISelection(G)?S.Selection.to(G):S.Range.to(G),he=[];for(const Be of this._diagnostics.getDiagnostics(B))if(se.intersection(Be.range)&&he.push(Be)>F._maxCodeActionsPerFile)break;const Re={diagnostics:he,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:S.CodeActionTriggerKind.to(ne.trigger)};return k.asPromise(()=>this._provider.provideCodeActions(q,se,Re,re)).then(Be=>{var ve;if(!n.isNonEmptyArray(Be)||re.isCancellationRequested)return;const Ke=this._cache.add(Be),H=new h.DisposableStore;this._disposables.set(Ke,H);const ee=[];for(let me=0;me<Be.length;me++){const Fe=Be[me];!Fe||(F._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ee.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,H)})):(Re.only&&(Fe.kind?Re.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ee.push({cacheId:[Ke,me],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,H),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(S.Diagnostic.from),edit:Fe.edit&&S.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(ve=Fe.disabled)===null||ve===void 0?void 0:ve.reason})))}return{cacheId:Ke,actions:ee}})}async resolveCodeAction(B,G){var ne;const[re,q]=B,se=this._cache.get(re,q);if(!se||F._isCommand(se)||!this._provider.resolveCodeAction)return;const he=(ne=await this._provider.resolveCodeAction(se,G))!==null&&ne!==void 0?ne:se;return(he==null?void 0:he.edit)?S.WorkspaceEdit.from(he.edit):void 0}releaseCodeActions(B){var G;(G=this._disposables.get(B))===null||G===void 0||G.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}F._maxCodeActionsPerFile=1e3;class U{constructor(B,G){this._documents=B,this._provider=G}provideDocumentFormattingEdits(B,G,ne){const re=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,G,ne)).then(q=>{if(Array.isArray(q))return q.map(S.TextEdit.from)})}}class X{constructor(B,G){this._documents=B,this._provider=G}provideDocumentRangeFormattingEdits(B,G,ne,re){const q=this._documents.getDocument(B),se=S.Range.to(G);return k.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(q,se,ne,re)).then(he=>{if(Array.isArray(he))return he.map(S.TextEdit.from)})}}class oe{constructor(B,G){this._documents=B,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(B,G,ne,re,q){const se=this._documents.getDocument(B),he=S.Position.to(G);return k.asPromise(()=>this._provider.provideOnTypeFormattingEdits(se,he,ne,re,q)).then(Re=>{if(Array.isArray(Re))return Re.map(S.TextEdit.from)})}}class j{constructor(B,G){this._provider=B,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(B,G){const ne=D.IdObject.mixin({symbols:[]});return k.asPromise(()=>this._provider.provideWorkspaceSymbols(B,G)).then(re=>{if(n.isNonEmptyArray(re))for(const q of re){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const se=D.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(se._id,q),ne.symbols.push(se)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(B,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return B;const ne=this._symbolCache.get(B._id);if(ne){const re=await k.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,G));return re&&T.mixin(B,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(B){const G=this._resultCache.get(B);if(G){for(let[ne,re]=G;ne<=re;ne++)this._symbolCache.delete(ne);this._resultCache.delete(B)}}}class W{constructor(B,G,ne){this._documents=B,this._provider=G,this._logService=ne}static supportsResolving(B){return typeof B.prepareRename=="function"}provideRenameEdits(B,G,ne,re){const q=this._documents.getDocument(B),se=S.Position.to(G);return k.asPromise(()=>this._provider.provideRenameEdits(q,se,ne,re)).then(he=>{if(!!he)return S.WorkspaceEdit.from(he)},he=>{const Re=W._asMessage(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)})}resolveRenameLocation(B,G,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(B),q=S.Position.to(G);return k.asPromise(()=>this._provider.prepareRename(re,q,ne)).then(se=>{let he,Re;if(y.Range.isRange(se)?(he=se,Re=re.getText(se)):I.isObject(se)&&(he=se.range,Re=se.placeholder),!!he){if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(he),text:Re}}},se=>{const he=W._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)})}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class K{constructor(B,G){this.resultId=B,this.tokens=G}}class M{constructor(B,G){this._documents=B,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(B,G,ne){const re=this._documents.getDocument(B),q=G!==0?this._previousResults.get(G):null;return k.asPromise(()=>q&&typeof q.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,q.resultId,ne):this._provider.provideDocumentSemanticTokens(re,ne)).then(se=>(q&&this._previousResults.delete(G),se?(se=M._fixProvidedSemanticTokens(se),this._send(M._convertToEdits(q,se),se)):null))}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return M._isSemanticTokens(B)?M._isCorrectSemanticTokens(B)?B:new y.SemanticTokens(new Uint32Array(B.data),B.resultId):M._isSemanticTokensEdits(B)?M._isCorrectSemanticTokensEdits(B)?B:new y.SemanticTokensEdits(B.edits.map(G=>new y.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const G of B.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,G){if(!M._isSemanticTokens(G)||!B||!B.tokens)return G;const ne=B.tokens,re=ne.length,q=G.data,se=q.length;let he=0;const Re=Math.min(re,se);for(;he<Re&&ne[he]===q[he];)he++;if(he===re&&he===se)return new y.SemanticTokensEdits([],G.resultId);let Be=0;const ve=Re-he;for(;Be<ve&&ne[re-Be-1]===q[se-Be-1];)Be++;return new y.SemanticTokensEdits([{start:he,deleteCount:re-he-Be,data:q.subarray(he,se-Be)}],G.resultId)}_send(B,G){if(M._isSemanticTokens(B)){const ne=this._nextResultId++;return this._previousResults.set(ne,new K(B.resultId,B.data)),d.encodeSemanticTokensDto({id:ne,type:"full",data:B.data})}if(M._isSemanticTokensEdits(B)){const ne=this._nextResultId++;return M._isSemanticTokens(G)?this._previousResults.set(ne,new K(G.resultId,G.data)):this._previousResults.set(ne,new K(B.resultId)),d.encodeSemanticTokensDto({id:ne,type:"delta",deltas:(B.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class Y{constructor(B,G){this._documents=B,this._provider=G}provideDocumentRangeSemanticTokens(B,G,ne){const re=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(G),ne)).then(q=>q?this._send(q):null)}_send(B){return d.encodeSemanticTokensDto({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=Y;class x{constructor(B,G,ne,re,q){this._documents=B,this._commands=G,this._provider=ne,this._apiDeprecation=re,this._extension=q,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,G,ne,re){const q=this._documents.getDocument(B),se=S.Position.to(G),he=q.getWordRangeAtPosition(se)||new y.Range(se,se),Re=he.with({end:se}),Be=new b.StopWatch(!0),ve=await k.asPromise(()=>this._provider.provideCompletionItems(q,se,re,S.CompletionContext.to(ne)));if(!ve||re.isCancellationRequested)return;const Ke=Array.isArray(ve)?new y.CompletionList(ve):ve,H=x.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),ee=new h.DisposableStore;this._disposables.set(H,ee);const me=[],Fe={x:H,b:me,a:{replace:S.Range.from(he),insert:S.Range.from(Re)},c:Ke.isIncomplete||void 0,d:Be.elapsed()};for(let Oe=0;Oe<Ke.items.length;Oe++){const Qe=Ke.items[Oe],Ce=this._convertCompletionItem(Qe,[H,Oe],Re,he);me.push(Ce)}return Fe}async resolveCompletionItem(B,G){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...B);if(!ne)return;const re=await k.asPromise(()=>this._provider.resolveCompletionItem(ne,G));if(!!re)return this._convertCompletionItem(re,B)}releaseCompletionItems(B){var G;(G=this._disposables.get(B))===null||G===void 0||G.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,G,ne,re){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const se={x:G,a:B.label,b:B.kind!==void 0?S.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(S.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(B.command,q)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=B.textEdit.newText):typeof B.insertText=="string"?se.h=B.insertText:B.insertText instanceof y.SnippetString&&(se.h=B.insertText.value,se.i|=4);let he;return B.textEdit?he=B.textEdit.range:B.range&&(he=B.range),y.Range.isRange(he)?se.j=S.Range.from(he):he&&(!(ne==null?void 0:ne.isEqual(he.inserting))||!(re==null?void 0:re.isEqual(he.replacing)))&&(se.j={insert:S.Range.from(he.inserting),replace:S.Range.from(he.replacing)}),se}}class O{constructor(B,G,ne){this._documents=B,this._provider=G,this._commands=ne,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(B,G,ne,re){const q=this._documents.getDocument(B),se=S.Position.to(G),he=await k.asPromise(()=>this._provider.provideInlineCompletionItems(q,se,ne,re));if(!he||re.isCancellationRequested)return;const Re=I.isArray(he)?{items:he}:he,Be=this._cache.add(Re.items);let ve;return{pid:Be,items:Re.items.map((Ke,H)=>{let ee;return Ke.command&&(ve||(ve=new h.DisposableStore,this._disposables.set(Be,ve)),ee=this._commands.toInternal(Ke.command,ve)),{text:Ke.text,range:Ke.range?S.Range.from(Ke.range):void 0,command:ee,idx:H}})}}disposeCompletions(B){this._cache.delete(B);const G=this._disposables.get(B);G&&G.clear(),this._disposables.delete(B)}handleDidShowCompletionItem(B,G){const ne=this._cache.get(B,G);ne&&Q.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class Q{constructor(){this._onDidShowCompletionItemEmitter=new c.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(B){let G=Q.map.get(B);return G||(G=new Q,Q.map.set(B,G)),G}fireOnDidShowCompletionItem(B){this._onDidShowCompletionItemEmitter.fire(B)}}e.InlineCompletionController=Q,Q.map=new WeakMap;class V{constructor(B,G){this._documents=B,this._provider=G,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(B,G,ne,re){const q=this._documents.getDocument(B),se=S.Position.to(G),he=this.reviveContext(ne);return k.asPromise(()=>this._provider.provideSignatureHelp(q,se,re,he)).then(Re=>{if(Re){const Be=this._cache.add([Re]);return Object.assign(Object.assign({},S.SignatureHelp.from(Re)),{id:Be})}})}reviveContext(B){let G;if(B.activeSignatureHelp){const ne=S.SignatureHelp.to(B.activeSignatureHelp),re=this._cache.get(B.activeSignatureHelp.id,0);re?(G=re,G.activeSignature=ne.activeSignature,G.activeParameter=ne.activeParameter):G=ne}return Object.assign(Object.assign({},B),{activeSignatureHelp:G})}releaseSignatureHelp(B){this._cache.delete(B)}}class le{constructor(B,G){this._documents=B,this._provider=G}provideInlayHints(B,G,ne){const re=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideInlayHints(re,S.Range.to(G),ne)).then(q=>q?{hints:q.map(S.InlayHint.from)}:void 0)}}class be{constructor(B,G){this._documents=B,this._provider=G,this._cache=new _.Cache("DocumentLink")}async provideLinks(B,G){const ne=this._documents.getDocument(B),re=await k.asPromise(()=>this._provider.provideDocumentLinks(ne,G));if(!(!Array.isArray(re)||re.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(be._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(re),se={links:[],id:q};for(let he=0;he<re.length;he++){if(!be._validateLink(re[he]))continue;const Re=S.DocumentLink.from(re[he]);Re.cacheId=[q,he],se.links.push(Re)}return se}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,G){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...B);if(!ne)return;const re=await k.asPromise(()=>this._provider.resolveDocumentLink(ne,G));if(!(!re||!be._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks(B){this._cache.delete(B)}}class Te{constructor(B,G){this._documents=B,this._provider=G}provideColors(B,G){const ne=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideDocumentColors(ne,G)).then(re=>Array.isArray(re)?re.map(se=>({color:S.Color.from(se.color),range:S.Range.from(se.range)})):[])}provideColorPresentations(B,G,ne){const re=this._documents.getDocument(B),q=S.Range.to(G.range),se=S.Color.to(G.color);return k.asPromise(()=>this._provider.provideColorPresentations(se,{document:re,range:q},ne)).then(he=>{if(!!Array.isArray(he))return he.map(S.ColorPresentation.from)})}}class He{constructor(B,G){this._documents=B,this._provider=G}provideFoldingRanges(B,G,ne){const re=this._documents.getDocument(B);return k.asPromise(()=>this._provider.provideFoldingRanges(re,G,ne)).then(q=>{if(!!Array.isArray(q))return q.map(S.FoldingRange.from)})}}class Me{constructor(B,G,ne){this._documents=B,this._provider=G,this._logService=ne}provideSelectionRanges(B,G,ne){const re=this._documents.getDocument(B),q=G.map(S.Position.to);return k.asPromise(()=>this._provider.provideSelectionRanges(re,q,ne)).then(se=>{if(!n.isNonEmptyArray(se))return[];if(se.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<q.length;Re++){const Be=[];he.push(Be);let ve=q[Re],Ke=se[Re];for(;;){if(!Ke.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(S.SelectionRange.from(Ke)),!Ke.parent)break;ve=Ke.range,Ke=Ke.parent}}return he})}}class qe{constructor(B,G){this._documents=B,this._provider=G,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(B,G,ne){const re=this._documents.getDocument(B),q=S.Position.to(G),se=await this._provider.prepareCallHierarchy(re,q,ne);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo(B,G,ne){const re=this._itemFromCache(B,G);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(re,ne);if(!!q)return q.map(se=>({from:this._cacheAndConvertItem(B,se.from),fromRanges:se.fromRanges.map(he=>S.Range.from(he))}))}async provideCallsFrom(B,G,ne){const re=this._itemFromCache(B,G);if(!re)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(re,ne);if(!!q)return q.map(se=>({to:this._cacheAndConvertItem(B,se.to),fromRanges:se.fromRanges.map(he=>S.Range.from(he))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,G){var ne;const re=this._cache.get(B),q={_sessionId:B,_itemId:re.size.toString(36),name:G.name,detail:G.detail,kind:S.SymbolKind.from(G.kind),uri:G.uri,range:S.Range.from(G.range),selectionRange:S.Range.from(G.selectionRange),tags:(ne=G.tags)===null||ne===void 0?void 0:ne.map(S.SymbolTag.from)};return re.set(q._itemId,G),q}_itemFromCache(B,G){const ne=this._cache.get(B);return ne==null?void 0:ne.get(G)}}class nt{constructor(B,G){this.adapter=B,this.extension=G}}class Je{constructor(B,G,ne,re,q,se,he){this._adapter=new Map,this._uriTransformer=G,this._proxy=B.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=re,this._diagnostics=q,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector(B){return n.coalesce(n.asArray(B).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(B){if(typeof B=="string")return{$serialized:!0,language:B};if(B)return{$serialized:!0,language:B.language,scheme:this._transformScheme(B.scheme),pattern:typeof B.pattern=="undefined"?void 0:S.GlobPattern.from(B.pattern),exclusive:B.exclusive}}_transformScheme(B){return this._uriTransformer&&typeof B=="string"?this._uriTransformer.transformOutgoingScheme(B):B}_createDisposable(B){return new y.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Je._handlePool++}_withAdapter(B,G,ne,re,q=!1){const se=this._adapter.get(B);if(!se)return Promise.resolve(re);if(se.adapter instanceof G){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${G.name}'`));const Re=ne(se.adapter,se.extension),Be=se.extension;return Be&&Promise.resolve(Re).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),ve=>{q&&ve instanceof E.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(ve))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(B,G){const ne=this._nextHandle();return this._adapter.set(ne,new nt(B,G)),ne}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,G,ne,re){const q=this._addNewAdapter(new f(this._documents,ne),B),se=re&&re.label||Je._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),se),this._createDisposable(q)}$provideDocumentSymbols(B,G,ne){return this._withAdapter(B,f,re=>re.provideDocumentSymbols(m.URI.revive(G),ne),void 0)}registerCodeLensProvider(B,G,ne){const re=this._nextHandle(),q=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new nt(new g(this._documents,this._commands.converter,ne),B)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(G),q);let se=this._createDisposable(re);if(q!==void 0){const he=ne.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));se=y.Disposable.from(se,he)}return se}$provideCodeLenses(B,G,ne){return this._withAdapter(B,g,re=>re.provideCodeLenses(m.URI.revive(G),ne),void 0)}$resolveCodeLens(B,G,ne){return this._withAdapter(B,g,re=>re.resolveCodeLens(G,ne),void 0)}$releaseCodeLenses(B,G){this._withAdapter(B,g,ne=>Promise.resolve(ne.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(B,G,ne){const re=this._addNewAdapter(new i(this._documents,ne),B);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDefinition(B,G,ne,re){return this._withAdapter(B,i,q=>q.provideDefinition(m.URI.revive(G),ne,re),[])}registerDeclarationProvider(B,G,ne){const re=this._addNewAdapter(new s(this._documents,ne),B);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDeclaration(B,G,ne,re){return this._withAdapter(B,s,q=>q.provideDeclaration(m.URI.revive(G),ne,re),[])}registerImplementationProvider(B,G,ne){const re=this._addNewAdapter(new r(this._documents,ne),B);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideImplementation(B,G,ne,re){return this._withAdapter(B,r,q=>q.provideImplementation(m.URI.revive(G),ne,re),[])}registerTypeDefinitionProvider(B,G,ne){const re=this._addNewAdapter(new u(this._documents,ne),B);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideTypeDefinition(B,G,ne,re){return this._withAdapter(B,u,q=>q.provideTypeDefinition(m.URI.revive(G),ne,re),[])}registerHoverProvider(B,G,ne,re){const q=this._addNewAdapter(new w(this._documents,ne),B);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(B,G,ne,re){return this._withAdapter(B,w,q=>q.provideHover(m.URI.revive(G),ne,re),void 0)}registerEvaluatableExpressionProvider(B,G,ne,re){const q=this._addNewAdapter(new p(this._documents,ne),B);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(B,G,ne,re){return this._withAdapter(B,p,q=>q.provideEvaluatableExpression(m.URI.revive(G),ne,re),void 0)}registerInlineValuesProvider(B,G,ne,re){const q=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new P(this._documents,ne),B);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(G),q);let he=this._createDisposable(se);if(q!==void 0){const Re=ne.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(q));he=y.Disposable.from(he,Re)}return he}$provideInlineValues(B,G,ne,re,q){return this._withAdapter(B,P,se=>se.provideInlineValues(m.URI.revive(G),ne,re,q),void 0)}registerDocumentHighlightProvider(B,G,ne){const re=this._addNewAdapter(new A(this._documents,ne),B);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentHighlights(B,G,ne,re){return this._withAdapter(B,A,q=>q.provideDocumentHighlights(m.URI.revive(G),ne,re),void 0)}registerLinkedEditingRangeProvider(B,G,ne){const re=this._addNewAdapter(new a(this._documents,ne),B);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideLinkedEditingRanges(B,G,ne,re){return this._withAdapter(B,a,async q=>{const se=await q.provideLinkedEditingRanges(m.URI.revive(G),ne,re);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Je._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(B,G,ne){const re=this._addNewAdapter(new R(this._documents,ne),B);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideReferences(B,G,ne,re,q){return this._withAdapter(B,R,se=>se.provideReferences(m.URI.revive(G),ne,re,q),void 0)}registerCodeActionProvider(B,G,ne,re){var q,se;const he=new h.DisposableStore,Re=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(G),{providedKinds:(q=re==null?void 0:re.providedCodeActionKinds)===null||q===void 0?void 0:q.map(Be=>Be.value),documentation:(se=re==null?void 0:re.documentation)===null||se===void 0?void 0:se.map(Be=>({kind:Be.kind.value,command:this._commands.converter.toInternal(Be.command,he)}))},Je._extLabel(B),Boolean(ne.resolveCodeAction)),he.add(this._createDisposable(Re)),he}$provideCodeActions(B,G,ne,re,q){return this._withAdapter(B,F,se=>se.provideCodeActions(m.URI.revive(G),ne,re,q),void 0)}$resolveCodeAction(B,G,ne){return this._withAdapter(B,F,re=>re.resolveCodeAction(G,ne),void 0)}$releaseCodeActions(B,G){this._withAdapter(B,F,ne=>Promise.resolve(ne.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(B,G,ne){const re=this._addNewAdapter(new U(this._documents,ne),B);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(G),B.identifier,B.displayName||B.name),this._createDisposable(re)}$provideDocumentFormattingEdits(B,G,ne,re){return this._withAdapter(B,U,q=>q.provideDocumentFormattingEdits(m.URI.revive(G),ne,re),void 0)}registerDocumentRangeFormattingEditProvider(B,G,ne){const re=this._addNewAdapter(new X(this._documents,ne),B);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(G),B.identifier,B.displayName||B.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(B,G,ne,re,q){return this._withAdapter(B,X,se=>se.provideDocumentRangeFormattingEdits(m.URI.revive(G),ne,re,q),void 0)}registerOnTypeFormattingEditProvider(B,G,ne,re){const q=this._addNewAdapter(new oe(this._documents,ne),B);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),re,B.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(B,G,ne,re,q,se){return this._withAdapter(B,oe,he=>he.provideOnTypeFormattingEdits(m.URI.revive(G),ne,re,q,se),void 0)}registerWorkspaceSymbolProvider(B,G){const ne=this._addNewAdapter(new j(G,this._logService),B);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(B,G,ne){return this._withAdapter(B,j,re=>re.provideWorkspaceSymbols(G,ne),{symbols:[]})}$resolveWorkspaceSymbol(B,G,ne){return this._withAdapter(B,j,re=>re.resolveWorkspaceSymbol(G,ne),void 0)}$releaseWorkspaceSymbols(B,G){this._withAdapter(B,j,ne=>ne.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(B,G,ne){const re=this._addNewAdapter(new W(this._documents,ne,this._logService),B);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(G),W.supportsResolving(ne)),this._createDisposable(re)}$provideRenameEdits(B,G,ne,re,q){return this._withAdapter(B,W,se=>se.provideRenameEdits(m.URI.revive(G),ne,re,q),void 0)}$resolveRenameLocation(B,G,ne,re){return this._withAdapter(B,W,q=>q.resolveRenameLocation(m.URI.revive(G),ne,re),void 0)}registerDocumentSemanticTokensProvider(B,G,ne,re){const q=this._nextHandle(),se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new nt(new M(this._documents,ne),B)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),re,se);let he=this._createDisposable(q);if(se){const Re=ne.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=y.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens(B,G,ne,re){return this._withAdapter(B,M,q=>q.provideDocumentSemanticTokens(m.URI.revive(G),ne,re),null,!0)}$releaseDocumentSemanticTokens(B,G){this._withAdapter(B,M,ne=>ne.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(B,G,ne,re){const q=this._addNewAdapter(new Y(this._documents,ne),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),re),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(B,G,ne,re){return this._withAdapter(B,Y,q=>q.provideDocumentRangeSemanticTokens(m.URI.revive(G),ne,re),null,!0)}registerCompletionItemProvider(B,G,ne,re){const q=this._addNewAdapter(new x(this._documents,this._commands.converter,ne,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),re,x.supportsResolving(ne),`${B.identifier.value}(${re.join("")})`),this._createDisposable(q)}$provideCompletionItems(B,G,ne,re,q){return this._withAdapter(B,x,se=>se.provideCompletionItems(m.URI.revive(G),ne,re,q),void 0)}$resolveCompletionItem(B,G,ne){return this._withAdapter(B,x,re=>re.resolveCompletionItem(G,ne),void 0)}$releaseCompletionItems(B,G){this._withAdapter(B,x,ne=>ne.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(B,G,ne){const re=this._addNewAdapter(new O(this._documents,ne,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideInlineCompletions(B,G,ne,re,q){return this._withAdapter(B,O,se=>se.provideInlineCompletions(m.URI.revive(G),ne,re,q),void 0)}$handleInlineCompletionDidShow(B,G,ne){this._withAdapter(B,O,async re=>{re.handleDidShowCompletionItem(G,ne)},void 0)}$freeInlineCompletionsList(B,G){this._withAdapter(B,O,async ne=>{ne.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(B,G,ne,re){const q=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,se=this._addNewAdapter(new V(this._documents,ne),B);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(G),q),this._createDisposable(se)}$provideSignatureHelp(B,G,ne,re,q){return this._withAdapter(B,V,se=>se.provideSignatureHelp(m.URI.revive(G),ne,re,q),void 0)}$releaseSignatureHelp(B,G){this._withAdapter(B,V,ne=>ne.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(B,G,ne){const re=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new le(this._documents,ne),B);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),re);let se=this._createDisposable(q);if(re!==void 0){const he=ne.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(re));se=y.Disposable.from(se,he)}return se}$provideInlayHints(B,G,ne,re){return this._withAdapter(B,le,q=>q.provideInlayHints(m.URI.revive(G),ne,re),void 0)}registerDocumentLinkProvider(B,G,ne){const re=this._addNewAdapter(new be(this._documents,ne),B);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(G),typeof ne.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(B,G,ne){return this._withAdapter(B,be,re=>re.provideLinks(m.URI.revive(G),ne),void 0)}$resolveDocumentLink(B,G,ne){return this._withAdapter(B,be,re=>re.resolveLink(G,ne),void 0)}$releaseDocumentLinks(B,G){this._withAdapter(B,be,ne=>ne.releaseLinks(G),void 0)}registerColorProvider(B,G,ne){const re=this._addNewAdapter(new Te(this._documents,ne),B);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentColors(B,G,ne){return this._withAdapter(B,Te,re=>re.provideColors(m.URI.revive(G),ne),[])}$provideColorPresentations(B,G,ne,re){return this._withAdapter(B,Te,q=>q.provideColorPresentations(m.URI.revive(G),ne,re),void 0)}registerFoldingRangeProvider(B,G,ne){const re=this._nextHandle(),q=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new nt(new He(this._documents,ne),B)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(G),q);let se=this._createDisposable(re);if(q!==void 0){const he=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));se=y.Disposable.from(se,he)}return se}$provideFoldingRanges(B,G,ne,re){return this._withAdapter(B,He,q=>q.provideFoldingRanges(m.URI.revive(G),ne,re),void 0)}registerSelectionRangeProvider(B,G,ne){const re=this._addNewAdapter(new Me(this._documents,ne,this._logService),B);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideSelectionRanges(B,G,ne,re){return this._withAdapter(B,Me,q=>q.provideSelectionRanges(m.URI.revive(G),ne,re),[])}registerCallHierarchyProvider(B,G,ne){const re=this._addNewAdapter(new qe(this._documents,ne),B);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$prepareCallHierarchy(B,G,ne,re){return this._withAdapter(B,qe,q=>Promise.resolve(q.prepareSession(m.URI.revive(G),ne,re)),void 0)}$provideCallHierarchyIncomingCalls(B,G,ne,re){return this._withAdapter(B,qe,q=>q.provideCallsTo(G,ne,re),void 0)}$provideCallHierarchyOutgoingCalls(B,G,ne,re){return this._withAdapter(B,qe,q=>q.provideCallsFrom(G,ne,re),void 0)}$releaseCallHierarchy(B,G){this._withAdapter(B,qe,ne=>Promise.resolve(ne.releaseSession(G)),void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:v.regExpFlags(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Je._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Je._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Je._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Je._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Je._serializeRegExp(B.beforeText),afterText:B.afterText?Je._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Je._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Je._serializeOnEnterRule)}setLanguageConfiguration(B,G,ne){let{wordPattern:re}=ne;if(re&&v.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(G,re):this._documents.setWordDefinitionFor(G,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const q=this._nextHandle(),se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Je._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Je._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Je._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,se),this._createDisposable(q)}$setWordDefinitions(B){for(const G of B)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Je,Je._handlePool=0}),define(Ee[190],ye([0,1,4,9,6]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(D,v){this._proxy=D.getProxy(m.MainContext.MainThreadLanguages),this._documents=v}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,v){await this._proxy.$changeLanguage(D,v);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,v){var C;const n=D.version,I=T.Position.from(v),o=await this._proxy.$tokensAtPosition(D.uri,I),h={type:S.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(v))!==null&&C!==void 0?C:new S.Range(v.line,v.character,v.line,v.character)};if(!o)return h;const d={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!d.range.contains(v)||n!==D.version?h:d}}e.ExtHostLanguages=y}),define(Ee[191],ye([0,1,4,16,29]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(D){return D&&D.title}let k=class{constructor(v,C){this._logService=C,this._proxy=v.getProxy(m.MainContext.MainThreadMessageService)}showMessage(v,C,n,I,o){const h={extension:v};let d;typeof I=="string"||y(I)?d=[I,...o]:(h.modal=I==null?void 0:I.modal,h.useCustom=I==null?void 0:I.useCustom,h.detail=I==null?void 0:I.detail,d=o),h.useCustom&&S.checkProposedApiEnabled(v);const l=[];for(let _=0;_<d.length;_++){const b=d[_];if(typeof b=="string")l.push({title:b,handle:_,isCloseAffordance:!1});else if(typeof b=="object"){let{title:E,isCloseAffordance:c}=b;l.push({title:E,isCloseAffordance:!!c,handle:_})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(C,n,h,l).then(_=>{if(typeof _=="number")return d[_]})}};k=Ve([je(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(Ee[192],ye([0,1,23,3,53,7,22,8,10,2,62,4,9,6,169,97]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(E,c,f,g,t){this._textDocumentsAndEditors=f,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=E.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const r=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,u=i.cell.handle,w=this._documents.get(r),p=w==null?void 0:w.getCell(u);if(p)return p.apiCell}return i}})}get activeNotebookEditor(){var E;return(E=this._activeNotebookEditor)===null||E===void 0?void 0:E.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}getEditorById(E){const c=this._editors.get(E);if(!c)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(E){for(const[c,f]of this._editors)if(f.apiEditor===E)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,c){const f=this._documents.get(E);if(!f&&!c)throw new Error(`NO notebook document for '${E}'`);return f}_getProviderData(E){const c=this._notebookContentProviders.get(E);if(!c)throw new Error(`NO provider for '${E}'`);return c}registerNotebookContentProvider(E,c,f,g,t){if(D.isFalsyOrWhitespace(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:E,provider:f});let i;return f.onDidChangeNotebookContentOptions&&(i=f.onDidChangeNotebookContentOptions(()=>{const s=o.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(c,s)})),this._notebookProxy.$registerNotebookProvider({id:E.identifier,location:E.extensionLocation},c,o.NotebookDocumentContentOptions.from(g),_._convertNotebookRegistrationData(E,t)),new h.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(E,c){if(!c)return;const f=c.filenamePattern.map(g=>o.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(c.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:c.displayName,filenamePattern:f,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,c,f){const g=_._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,c);let i;return t!==void 0&&(i=f.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(E){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&o.NotebookData.from(E.content)});return C.URI.revive(c)}async openNotebookDocument(E){const c=this._documents.get(E);if(c)return c.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(E),g=this._documents.get(C.URI.revive(f));return v.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(E,c){var f;C.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let g;typeof c=="object"?g={position:o.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(o.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,g),i=t&&((f=this._editors.get(t))===null||f===void 0?void 0:f.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,c,f,g){const t=this._notebookStatusBarItemProviders.get(E),i=C.URI.revive(c),s=this._documents.get(i);if(!s||!t)return;const r=s.getCellFromIndex(f);if(!r)return;const u=await t.provideCellStatusBarItems(r.apiCell,g);if(!u)return;const w=new y.DisposableStore,p=this._statusBarCache.add([w]),A=(Array.isArray(u)?u:[u]).map(a=>o.NotebookStatusBarItem.from(a,this._commandsConverter,w));return{cacheId:p,items:A}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,c,f,g,t){if(D.isFalsyOrWhitespace(c))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,f),this._notebookProxy.$registerNotebookSerializer(i,{id:E.identifier,location:E.extensionLocation},c,o.NotebookDocumentContentOptions.from(g),_._convertNotebookRegistrationData(E,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(E,c,f){const g=this._notebookSerializer.get(E);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(c.buffer,f);return o.NotebookData.from(t)}async $notebookToData(E,c,f){const g=this._notebookSerializer.get(E);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(o.NotebookData.to(c),f);return m.VSBuffer.wrap(t)}async $openNotebook(E,c,f,g,t){var i;const{provider:s}=this._getProviderData(E),r=await s.openNotebook(C.URI.revive(c),{backupId:f,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=r.metadata)!==null&&i!==void 0?i:Object.create(null),cells:r.cells.map(o.NotebookCellData.from)}}async $saveNotebook(E,c,f){const g=this.getNotebookDocument(C.URI.revive(c)),{provider:t}=this._getProviderData(E);return await t.saveNotebook(g.apiNotebook,f),!0}async $saveNotebookAs(E,c,f,g){const t=this.getNotebookDocument(C.URI.revive(c)),{provider:i}=this._getProviderData(E);return await i.saveNotebookAs(C.URI.revive(f),t.apiNotebook,g),!0}async $backupNotebook(E,c,f){var g;const t=this.getNotebookDocument(C.URI.revive(c)),i=this._getProviderData(E),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),r=String(S.hash([t.uri.toString(),this._backupIdPool++])),u=C.URI.joinPath(s,r),w=await i.provider.backupNotebook(t.apiNotebook,{destination:u},f);return t.updateBackup(w),w.id}_createExtHostEditor(E,c,f){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const g=new l.ExtHostNotebookEditor(c,this._notebookEditorsProxy,E,f.visibleRanges.map(o.NotebookRange.to),f.selections.map(o.NotebookRange.to),typeof f.viewColumn=="number"?o.ViewColumn.to(f.viewColumn):void 0);this._editors.set(c,g)}$acceptDocumentAndEditorsDelta(E){var c,f,g;if(E.removedDocuments)for(const i of E.removedDocuments){const s=C.URI.revive(i),r=this._documents.get(s);r&&(r.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===s.toString()&&this._editors.delete(u.id)}if(E.addedDocuments){const i=[];for(const s of E.addedDocuments){const r=C.URI.revive(s.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const u=this,w=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){u._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){u._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){u._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){u._onDidChangeCellExecutionState.fire(p)}},r,s);i.push(...s.cells.map(p=>d.ExtHostCell.asModelAddData(w.apiNotebook,p))),(c=this._documents.get(r))===null||c===void 0||c.dispose(),this._documents.set(r,w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(w.apiNotebook)}}if(E.addedEditors)for(const i of E.addedEditors){if(this._editors.has(i.id))return;const s=C.URI.revive(i.documentUri),r=this._documents.get(s);r&&this._createExtHostEditor(r,i.id,i)}const t=[];if(E.removedEditors)for(const i of E.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(E.visibleEditors){this._visibleNotebookEditors=E.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const r=i.has(s.id);s._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.newActiveEditor===null?this._activeNotebookEditor=void 0:E.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(E.newActiveEditor)),E.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(Ee[193],ye([0,1,3,50,16,4,14,9]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class v{constructor(I,o){const h=v._Keys.nextId();I.$registerNotebookEditorDecorationType(h,D.NotebookDecorationRenderOptions.from(o)),this.value={key:h,dispose(){I.$removeNotebookEditorDecorationType(h)}}}}v._Keys=new T.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,o,h){this._logService=I,this._extHostRpc=o,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new v(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,o){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,o);const h=this._notebooksAndEditors.getEditorById(I);o.visibleRanges&&h._acceptVisibleRanges(o.visibleRanges.ranges.map(D.NotebookRange.to)),o.selections&&h._acceptSelections(o.selections.selections.map(D.NotebookRange.to)),o.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),o.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const o in I)this._notebooksAndEditors.getEditorById(o)._acceptViewColumn(D.ViewColumn.to(I[o]))}};C=Ve([je(0,S.ILogService),je(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(Ee[194],ye([0,1,3,7,4,26,2,9,66,22,13,67,18,17,16,6,29]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,i,s,r){this._initData=i,this._extHostNotebook=s,this._logService=r,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,r,u,w){for(let x of this._kernelData.values())if(x.controller.id===i&&y.ExtensionIdentifier.equals(t.identifier,x.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const p=this._handlePool++,P=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${i}`);const A=()=>console.warn(`NO execute handler from notebook controller '${X.id}' of extension: '${t.identifier}'`);let a=!1;const R=new T.DisposableStore,F=new m.Emitter,U=new m.Emitter,X={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:w?w.map(D.NotebookRendererScript.from):[]};let oe=u??A,j;this._proxy.$addKernel(p,X).catch(x=>{console.log(x),a=!0});let W=0;const K=()=>{if(a)return;const x=++W;Promise.resolve().then(()=>{x===W&&this._proxy.$updateKernel(p,X)})},M=new C.ResourceMap,Y={get id(){return i},get notebookType(){return X.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return X.label},set label(x){var O;X.label=(O=x??t.displayName)!==null&&O!==void 0?O:t.name,K()},get detail(){var x;return(x=X.detail)!==null&&x!==void 0?x:""},set detail(x){X.detail=x,K()},get description(){var x;return(x=X.description)!==null&&x!==void 0?x:""},set description(x){X.description=x,K()},get supportedLanguages(){return X.supportedLanguages},set supportedLanguages(x){X.supportedLanguages=x,K()},get supportsExecutionOrder(){var x;return(x=X.supportsExecutionOrder)!==null&&x!==void 0?x:!1},set supportsExecutionOrder(x){X.supportsExecutionOrder=x,K()},get rendererScripts(){return X.preloads?X.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(x){oe=x??A},get interruptHandler(){return j},set interruptHandler(x){j=x,X.supportsInterrupt=Boolean(x),K()},createNotebookCellExecution(x){if(a)throw new Error("notebook controller is DISPOSED");if(!M.has(x.notebook.uri))throw P._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(O=>O.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return P._createNotebookCellExecution(x)},dispose:()=>{a||(this._logService.trace(`NotebookController[${p}], DISPOSED`),a=!0,this._kernelData.delete(p),R.dispose(),F.dispose(),U.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(x,O){P._proxy.$updateNotebookPriority(p,x.uri,O)},onDidReceiveMessage:U.event,postMessage(x,O){return _.checkProposedApiEnabled(t),P._proxy.$postMessage(p,O&&P._extHostNotebook.getIdByEditor(O),x)},asWebviewUri(x){return _.checkProposedApiEnabled(t),v.asWebviewUri(x,P._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:Y,onDidReceiveMessage:U,onDidChangeSelection:F,associatedNotebooks:M}),Y}$acceptNotebookAssociation(t,i,s){const r=this._kernelData.get(t);if(r){const u=this._extHostNotebook.getNotebookDocument(k.URI.revive(i));s?r.associatedNotebooks.set(u.uri,!0):r.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,u.uri.toString(),s),r.onDidChangeSelection.fire({selected:s,notebook:u.apiNotebook})}}async $executeCells(t,i,s){const r=this._kernelData.get(t);if(!r)return;const u=this._extHostNotebook.getNotebookDocument(k.URI.revive(i)),w=[];for(let p of s){const P=u.getCell(p);P&&w.push(P.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,u.uri.toString(),w.length),await r.controller.executeHandler.call(r.controller,w,u.apiNotebook,r.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,i,s){var r;const u=this._kernelData.get(t);if(!u)return;const w=this._extHostNotebook.getNotebookDocument(k.URI.revive(i));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,w.apiNotebook);else for(let p of s){const P=w.getCell(p);P&&((r=this._activeExecutions.get(P.uri))===null||r===void 0||r.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const r=this._kernelData.get(t);if(!r)return;const u=this._extHostNotebook.getEditorById(i);r.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const r=new c(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,r);const u=r.onDidChangeState(()=>{r.state===E.Resolved&&(r.dispose(),u.dispose(),this._activeExecutions.delete(s.uri))});return r.asApiObject()}};b=Ve([je(3,d.ILogService)],b),e.ExtHostNotebookKernels=b;var E;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(E||(E={}));class c extends T.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new m.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new f(10,r=>this.applyEdits(r)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=l.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?D.NotebookCellOutput.from(i):D.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const r=this.cellIndexToHandle(i),u=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:r,append:s,outputs:u})}async updateOutputItems(t,i,s){return t=l.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(D.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===E.Resolved||t._state===E.Started)throw new Error("Cannot call start again");t._state=E.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,r){if(t._state===E.Resolved)throw new Error("Cannot call resolve twice");t._state=E.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:r??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!0)},replaceOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!1)},appendOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!0)},replaceOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!1)}})}}class f{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=n.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(Ee[195],ye([0,1,3,4,97]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(D,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,v,C){var n;const I=this._extHostNotebook.getEditorById(D);(n=this._rendererMessageEmitters.get(v))===null||n===void 0||n.fire({editor:I.apiEditor,message:C})}createRendererMessaging(D){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(D).event(...C),postMessage:(C,n)=>{const I=S.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,D,n)}}}getOrCreateEmitterFor(D){let v=this._rendererMessageEmitters.get(D);return v||(v=new m.Emitter({onLastListenerRemove:()=>{v==null||v.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,v),v)}}e.ExtHostNotebookRenderers=y}),define(Ee[101],ye([0,1,4,3,7,23,5,14]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class v extends S.Disposable{constructor(d,l,_,b){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=b,this._id=b.$register(this.name,l,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?y.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(l=>this._proxy.$clear(l,d))}show(d,l){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof d=="boolean"?d:l)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=v;class C extends v{constructor(d,l){super(d,!1,void 0,l)}append(d){super.append(d),this._id.then(l=>this._proxy.$append(l,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends v{constructor(d,l,_){super(d,!0,l,_)}append(d){throw new Error("Not supported")}}class I{constructor(d,l){this.name=d,this._channel=l}append(d){this._channel.then(l=>l.append(d))}appendLine(d){this._channel.then(l=>l.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,l){this._channel.then(_=>_.show(d,l))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=I;let o=class{constructor(d){this._proxy=d.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new C(d,this._proxy)}createOutputChannelFromLogFile(d,l){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new n(d,l,this._proxy)}};o=Ve([je(0,D.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=k.createDecorator("IExtHostOutputService")}),define(Ee[196],ye([0,1,13,18,3,7,4,2,6,11,17,41]),function(Z,e,m,T,S,y,k,D,v,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(h,d,l){const _=h.getProxy(k.MainContext.MainThreadQuickOpen);class b{constructor(r,u){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=u}showQuickPick(r,u,w,p=T.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(r),A=++this._instances,a=_.$show(A,{title:w==null?void 0:w.title,placeHolder:w==null?void 0:w.placeHolder,matchOnDescription:w==null?void 0:w.matchOnDescription,matchOnDetail:w==null?void 0:w.matchOnDetail,ignoreFocusLost:w==null?void 0:w.ignoreFocusOut,canPickMany:w==null?void 0:w.canPickMany},p),R={},F=a.then(()=>R);return Promise.race([F,P]).then(U=>{if(U!==R)return P.then(X=>{const oe=[];for(let j=0;j<X.length;j++){const W=X[j];let K,M,Y,x,O;typeof W=="string"?K=W:(K=W.label,M=W.description,Y=W.detail,x=W.picked,O=W.alwaysShow),oe.push({label:K,description:M,handle:j,detail:Y,picked:x,alwaysShow:O})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{w.onDidSelectItem(X[j])}),_.$setItems(A,oe),a.then(j=>{if(typeof j=="number")return X[j];if(Array.isArray(j))return j.map(W=>X[W])})})}).then(void 0,U=>{if(!C.isPromiseCanceledError(U))return _.$setError(A,U),Promise.reject(U)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,u=T.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,_.$input(r,typeof this._validateInput=="function",u).then(void 0,w=>{if(!C.isPromiseCanceledError(w))return Promise.reject(w)})}$validateInput(r){return this._validateInput?m.asPromise(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,u=T.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!w)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(P=>P.uri.toString()===w.uri.toString())}createQuickPick(r,u){const w=new t(r,u,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(r){const u=new i(r,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(r,u){const w=this._sessions.get(r);w&&w._fireDidChangeValue(u)}$onDidAccept(r){const u=this._sessions.get(r);u&&u._fireDidAccept()}$onDidChangeActive(r,u){const w=this._sessions.get(r);w instanceof t&&w._fireDidChangeActive(u)}$onDidChangeSelection(r,u){const w=this._sessions.get(r);w instanceof t&&w._fireDidChangeSelection(u)}$onDidTriggerButton(r,u){const w=this._sessions.get(r);w&&w._fireDidTriggerButton(u)}$onDidHide(r){const u=this._sessions.get(r);u&&u._fireDidHide()}}class E{constructor(r,u){this._extensionId=r,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((u,w)=>{const p=u===v.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(p,u)}),this.update({buttons:r.map((u,w)=>({iconPath:c(u.iconPath),tooltip:u.tooltip,handle:u===v.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const u=this._handlesToButtons.get(r);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(r){if(!this._disposed){for(const u of Object.keys(r)){const w=r[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function c(s){if(s instanceof v.ThemeIcon)return{id:s.id};const r=g(s),u=f(s);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof u=="string"?D.URI.file(u):u}}function f(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends E{constructor(r,u,w){super(r,w);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:r.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(r){const u=n.coalesce(r.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(r){const u=n.coalesce(r.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class i extends E{constructor(r,u){super(r,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new b(d,l)}e.createExtHostQuickOpen=o}),define(Ee[197],ye([0,1,2,3,48,7,13,4,17,112,16,26,29]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(r){if(r)return typeof r.iconPath=="string"?m.URI.file(r.iconPath):r.iconPath}function d(r,u){if(!r.iconPath&&!u.iconPath)return 0;if(r.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return C.comparePaths(w,p)}function l(r,u){let w=0;if(r.strikeThrough!==u.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==u.faded)return r.faded?1:-1;if(r.tooltip!==u.tooltip)return(r.tooltip||"").localeCompare(u.tooltip||"");if(w=d(r,u),w!==0)return w;if(r.light&&u.light)w=d(r.light,u.light);else{if(r.light)return 1;if(u.light)return-1}if(w!==0)return w;if(r.dark&&u.dark)w=d(r.dark,u.dark);else{if(r.dark)return 1;if(u.dark)return-1}return w}function _(r,u){if(r.command!==u.command)return r.command<u.command?-1:1;if(r.title!==u.title)return r.title<u.title?-1:1;if(r.tooltip!==u.tooltip){if(r.tooltip!==void 0&&u.tooltip!==void 0)return r.tooltip<u.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(r.arguments===u.arguments)return 0;if(r.arguments)if(u.arguments){if(r.arguments.length!==u.arguments.length)return r.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<r.arguments.length;w++){const p=r.arguments[w],P=u.arguments[w];if(p!==P)return p<P?-1:1}return 0}function b(r,u){let w=C.comparePaths(r.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(r.command&&u.command)w=_(r.command,u.command);else{if(r.command)return 1;if(u.command)return-1}if(w!==0)return w;if(r.decorations&&u.decorations)w=l(r.decorations,u.decorations);else{if(r.decorations)return 1;if(u.decorations)return-1}return w}function E(r,u){for(let w=0;w<r.length;w++)if(r[w]!==u[w])return!1;return!0}function c(r,u){return r.command===u.command&&r.title===u.title&&r.tooltip===u.tooltip&&(r.arguments&&u.arguments?E(r.arguments,u.arguments):r.arguments===u.arguments)}function f(r,u){return v.equals(r,u,c)}class g{constructor(u,w,p){this._extension=u,this._proxy=w,this._sourceControlHandle=p,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(u){if(o.checkProposedApiEnabled(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=g;class t{constructor(u,w,p,P,A){this._proxy=u,this._commands=w,this._sourceControlHandle=p,this._id=P,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const p=this._resourceStatesCommandsMap.get(u);return p?k.asPromise(()=>this._commands.executeCommand(p.command,...p.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const w=[...this._resourceStates].sort(b),P=v.sortedDiff(this._resourceSnapshot,w,b).map(R=>{const F=R.toInsert.map(U=>{const X=this._resourceHandlePool++;this._resourceStatesMap.set(X,U);const oe=U.resourceUri,j=h(U.decorations),W=U.decorations&&h(U.decorations.light)||j,K=U.decorations&&h(U.decorations.dark)||j,M=[];let Y;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const be=new y.DisposableStore;Y=this._commands.converter.toInternal(U.command,be),this._resourceStatesDisposablesMap.set(X,be)}else this._resourceStatesCommandsMap.set(X,U.command);W&&M.push(W),K&&K.toString()!==(W==null?void 0:W.toString())&&M.push(K);const x=U.decorations&&U.decorations.tooltip||"",O=U.decorations&&!!U.decorations.strikeThrough,Q=U.decorations&&!!U.decorations.faded,V=U.contextValue||"";return{rawResource:[X,oe,M,x,O,Q,V,Y],handle:X}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),A=P.map(({start:R,deleteCount:F,toInsert:U})=>[R,F,U.map(X=>X.rawResource)]),a=P.reverse();for(const{start:R,deleteCount:F,toInsert:U}of a){const X=U.map(j=>j.handle),oe=this._handlesSnapshot.splice(R,F,...X);for(const j of oe)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),(u=this._resourceStatesDisposablesMap.get(j))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=w,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(u,w,p,P,A,a){this._proxy=w,this._commands=p,this._id=P,this._label=A,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,A,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&f(this._statusBarCommands,u))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const p=new t(this._proxy,this._commands,this.handle,u,w),P=T.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,P),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const u=[],w=[];for(const[p,P]of this.createdResourceGroups){P.dispose();const A=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});T.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),A.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),u.push([p.handle,p.id,p.label,p.features]);const a=p._takeResourceStateSnapshot();a.length>0&&w.push([p.handle,a]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const p=w._takeResourceStateSnapshot();p.length!==0&&u.push([w.handle,p])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([S.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([S.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class On{constructor(u,w,p){this._commands=w,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const A=this._sourceControls.get(P.sourceControlHandle);if(!A)return P;const a=A.getResourceGroup(P.groupHandle);return a?a.getResourceState(P.handle):P}else if(P&&P.$mid===4){const A=this._sourceControls.get(P.sourceControlHandle);return A?A.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const A=this._sourceControls.get(P.handle);return A||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,p,P){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,p,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const A=On._handlePool++,a=new i(u,this._proxy,this._commands,w,p,P);this._sourceControls.set(A,a);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return R.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),R),a}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),p=w&&w[w.length-1];return p&&p.inputBox}$provideOriginalResource(u,w,p){const P=m.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,P.toString());const A=this._sourceControls.get(u);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):k.asPromise(()=>A.quickDiffProvider.provideOriginalResource(P,p)).then(a=>a||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const p=this._sourceControls.get(u);return p&&p.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,p,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,p);const A=this._sourceControls.get(u);if(!A)return Promise.resolve(void 0);const a=A.getResourceGroup(w);return a?a.$executeResourceCommand(p,P):Promise.resolve(void 0)}$validateInput(u,w,p){this.logService.trace("ExtHostSCM#$validateInput",u);const P=this._sourceControls.get(u);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):k.asPromise(()=>P.inputBox.validateInput(w,p)).then(A=>A?Promise.resolve([A.message,A.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var w,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((w=this._sourceControls.get(u))===null||w===void 0||w.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([je(2,n.ILogService)],s),e.ExtHostSCM=s});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[198],ye([0,1,6,4,131,7,9]),function(Z,e,m,T,S,y,k){"use strict";var D,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(h,d,l,_,b=m.StatusBarAlignment.Left,E){D.set(this,void 0),v.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,rt(this,D,h,"f"),rt(this,v,d,"f"),this._entryId=C.ID_GEN++,this._extension=l,this._id=_,this._alignment=b,this._priority=E}get id(){var h;return(h=this._id)!==null&&h!==void 0?h:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set tooltip2(h){this._tooltip2=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!C.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var d;((d=this._command)===null||d===void 0?void 0:d.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:xe(this,v,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:xe(this,v,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let l;this._name?l=this._name:l=S.localize(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip2!==void 0?k.MarkdownString.fromStrict(this._tooltip2):this.tooltip;xe(this,D,"f").$setEntry(this._entryId,d,l,this._text,b,(h=this._command)===null||h===void 0?void 0:h.internal,_,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,D=new WeakMap,v=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=S.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const d={message:h};return this._messages.unshift(d),this._update(),new m.Disposable(()=>{const l=this._messages.indexOf(d);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(h,d){this._proxy=h.getProxy(T.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new n(this)}createStatusBarEntry(h,d,l,_){return new C(this._proxy,this._commands,h,d,l,_)}setStatusBarMessage(h,d){const l=this._statusMessage.setMessage(h);let _;return typeof d=="number"?_=setTimeout(()=>l.dispose(),d):typeof d!="undefined"&&d.then(()=>l.dispose(),()=>l.dispose()),new m.Disposable(()=>{l.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=I}),define(Ee[72],ye([0,1,4,3,5]),function(Z,e,m,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(D){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,v){this._proxy.$registerExtensionStorageKeysToSync(D,v)}getValue(D,v,C){return this._proxy.$getValue(D,v).then(n=>n||C)}setValue(D,v,C){return this._proxy.$setValue(D,v,C)}$acceptValue(D,v,C){this._onDidChangeStorage.fire({shared:D,key:v,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=S.createDecorator("IExtHostStorage")}),define(Ee[73],ye([0,1,5,28,16,71,2]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=m.createDecorator("IExtensionStoragePaths");let D=class{constructor(C,n,I){var o;this._logService=n,this._extHostFileSystem=I,this._workspace=(o=C.workspace)!==null&&o!==void 0?o:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,I=k.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=k.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=Ve([je(0,T.IExtHostInitDataService),je(1,S.ILogService),je(2,y.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(Ee[36],ye([0,1,3,4,5,2,14,7,6,132,11,163,18,34,152,10]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=S.createDecorator("IExtHostTerminalService");class _{constructor(s,r,u,w){this._proxy=s,this._id=r,this._creationOptions=u,this._name=w,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},sendText(P,A=!0){p._checkDisposed(),p._proxy.$sendText(p._id,P,A)},show(P){p._checkDisposed(),p._proxy.$show(p._id,P)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:l.withNullAsUndefined(s.shellPath),shellArgs:l.withNullAsUndefined(s.shellArgs),cwd:l.withNullAsUndefined(s.cwd),env:l.withNullAsUndefined(s.env),icon:l.withNullAsUndefined(t(s.iconPath)),initialText:l.withNullAsUndefined(s.message),strictEnv:l.withNullAsUndefined(s.strictEnv),hideFromUser:l.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:l.withNullAsUndefined(r==null?void 0:r.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:l.withNullAsUndefined(r==null?void 0:r.useShellEnvironment),isSplitTerminal:l.withNullAsUndefined(r==null?void 0:r.isSplitTerminal)})}async createExtensionTerminal(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:r,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,r){return s===this._cols&&r===this._rows||s===0||r===0?!1:(this._cols=s,this._rows=r,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=_;class b{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,r){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:r})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let E=1,c=class extends D.Disposable{constructor(s,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this._onDidOpenTerminal=new m.Emitter,this._onDidChangeActiveTerminal=new m.Emitter,this._onDidChangeTerminalDimensions=new m.Emitter,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[u,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.path)||""}getDefaultShellArgs(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.args)||[]}createExtensionTerminal(s,r){const u=new _(this._proxy,h.generateUuid(),s,s.name),w=new b(s.pty);return u.createExtensionTerminal(r==null?void 0:r.isSplitTerminal,t(s.iconPath)).then(p=>{const P=this._setupExtHostProcessListeners(p,w);this._terminalProcessDisposables[p]=P}),this._terminals.push(u),u.value}attachPtyToTerminal(s,r){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const w=new b(r),p=this._setupExtHostProcessListeners(s,w);this._terminalProcessDisposables[s]=p}async $acceptActiveTerminalChanged(s){const r=this._activeTerminal;if(s===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(s);u&&(this._activeTerminal=u,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,r){const u=this._getTerminalById(s);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:r})}async $acceptTerminalDimensions(s,r,u){const w=this._getTerminalById(s);w&&w.setDimensions(r,u)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(s,r,u){var w;(w=this._terminalProcesses.get(s))===null||w===void 0||w.resize(r,u)}async $acceptTerminalTitleChange(s,r){const u=this._getTerminalById(s);u&&(u.name=r)}async $acceptTerminalClosed(s,r){const u=this._getTerminalObjectIndexById(this._terminals,s);if(u!==null){const w=this._terminals.splice(u,1)[0];w.setExitCode(r),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(s,r,u,w){if(r){const A=this._getTerminalObjectIndexById(this._terminals,r);if(A!==null){this._terminals[A]._id=s,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const p={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:y.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},P=new _(this._proxy,s,p,u);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(s,r){const u=this._getTerminalById(s);u&&u._setProcessId(r)}async $startExtensionTerminal(s,r){const u=this._getTerminalById(s);if(!u)return{message:C.localize(0,null,s)};u.isOpen||await new Promise(p=>{const P=this.onDidOpenTerminal(async A=>{A===u.value&&(P.dispose(),p())})});const w=this._terminalProcesses.get(s);w?w.startSendingEvents(r):this._extensionTerminalAwaitingStart[s]={initialDimensions:r}}_setupExtHostProcessListeners(s,r){const u=new D.DisposableStore;u.add(r.onProcessReady(p=>this._proxy.$sendProcessReady(s,p.pid,p.cwd))),u.add(r.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(s,p))),this._bufferer.startBuffering(s,r.onProcessData),u.add(r.onProcessExit(p=>this._onProcessExit(s,p))),r.onProcessOverrideDimensions&&u.add(r.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(s,p))),this._terminalProcesses.set(s,r);const w=this._extensionTerminalAwaitingStart[s];return w&&r instanceof b&&(r.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),u}$acceptProcessAckDataEvent(s,r){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.acknowledgeDataEvent(r)}$acceptProcessInput(s,r){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.input(r)}$acceptProcessResize(s,r,u){var w;try{(w=this._terminalProcesses.get(s))===null||w===void 0||w.resize(r,u)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(s,r){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.shutdown(r)}$acceptProcessRequestInitialCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(s,u))}$acceptProcessRequestCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getCwd().then(u=>this._proxy.$sendProcessCwd(s,u))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,r,u){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,u),this._proxy.$registerProfileProvider(r,s.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(s,r){var u;const w=new o.CancellationTokenSource().token,p=await((u=this._profileProviders.get(s))===null||u===void 0?void 0:u.provideTerminalProfile(w));if(!w.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,{isSplitTerminal:r});return}this.createTerminalFromOptions(p.options,{isSplitTerminal:r})}}async $provideLinks(s,r){const u=this._getTerminalById(s);if(!u)return[];this._terminalLinkCache.delete(s);const w=this._terminalLinkCancellationSource.get(s);w&&w.dispose(!0);const p=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,p);const P=[],A={terminal:u.value,line:r},a=[];for(const U of this._linkProviders)a.push(new Promise(async X=>{p.token.onCancellationRequested(()=>X({provider:U,links:[]}));const oe=await U.provideTerminalLinks(A,p.token)||[];p.token.isCancellationRequested||X({provider:U,links:oe})}));const R=await Promise.all(a);if(p.token.isCancellationRequested)return[];const F=new Map;for(const U of R)U&&U.links.length>0&&P.push(...U.links.map(X=>{const oe={id:E++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return F.set(oe.id,{provider:U.provider,link:X}),oe}));return this._terminalLinkCache.set(s,F),P}$activateLink(s,r){var u;const w=(u=this._terminalLinkCache.get(s))===null||u===void 0?void 0:u.get(r);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(s,r){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const u=this._terminalProcessDisposables[s];u&&(u.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,r)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,r){const u=this._getTerminalObjectIndexById(s,r);return u!==null?s[u]:null}_getTerminalObjectIndexById(s,r){let u=null;return s.some((w,p)=>w._id===r?(u=p,!0):!1),u}getEnvironmentVariableCollection(s){let r=this._environmentVariableCollections.get(s.identifier.value);return r||(r=new f,this._setEnvironmentVariableCollection(s.identifier.value,r)),r}_syncEnvironmentVariableCollection(s,r){const u=I.serializeEnvironmentVariableCollection(r.map);this._proxy.$setEnvironmentVariableCollection(s,r.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(s){s.forEach(r=>{const u=r[0],w=new f(r[1]);this._setEnvironmentVariableCollection(u,w)})}$acceptDefaultProfile(s,r){this._defaultProfile=s,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(s,r){this._environmentVariableCollections.set(s,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,r)})}};c=Ve([je(1,k.IExtHostRpcService)],c),e.BaseExtHostTerminalService=c;class f{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,r){this._setIfDiffers(s,{value:r,type:v.EnvironmentVariableMutatorType.Replace})}append(s,r){this._setIfDiffers(s,{value:r,type:v.EnvironmentVariableMutatorType.Append})}prepend(s,r){this._setIfDiffers(s,{value:r,type:v.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,r){const u=this.map.get(s);(!u||u.value!==r.value||u.type!==r.type)&&(this.map.set(s,r),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,r){this.map.forEach((u,w)=>s.call(r,w,u,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let g=class extends c{constructor(s){super(!1,s)}createTerminal(s,r,u){throw new n.NotSupportedError}createTerminalFromOptions(s,r){throw new n.NotSupportedError}};g=Ve([je(0,k.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[199],ye([0,1,17,13,23,18,3,49,39,7,24,10,34,4,14,9,6,172,96]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E){"use strict";var c,f,g,t,i;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(F,U){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(h.MainContext.MainThreadTesting),this.observer=new a(this.proxy),this.runTracker=new u(this.proxy),U.registerArgumentProcessor({processArgument:X=>(X==null?void 0:X.$mid)===13?l.TestItem.toItemFromContext(X):X})}createTestController(F){const U=new C.DisposableStore,X=U.add(new b.SingleUseTestCollection(F)),oe=U.add(new T.RunOnceScheduler(()=>X.expand(X.root.id,0),0)),j={root:X.root,createTestRun:(W,K,M=!0)=>this.runTracker.createTestRun(F,W,K,M),createTestItem(W,K,M,Y,x){if(!(M instanceof _.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${W} is invalid`);return new _.TestItemImpl(W,K,Y,x,M)},set resolveChildrenHandler(W){X.resolveHandler=W,W&&oe.schedule()},get resolveChildrenHandler(){return X.resolveHandler},dispose:()=>{U.dispose()}};return this.proxy.$registerTestController(F),U.add(C.toDisposable(()=>this.proxy.$unregisterTestController(F))),this.controllers.set(F,{controller:j,collection:X}),U.add(C.toDisposable(()=>this.controllers.delete(F))),U.add(X.onDidGenerateDiff(W=>this.proxy.$publishDiff(F,W))),j}createTestObserver(){return this.observer.checkout()}async runTests(F,U=y.CancellationToken.None){const X=oe=>oe.map(this.getInternalTestForReference,this).filter(I.isDefined).map(j=>({controllerId:j.controllerId,testId:j.item.extId}));await this.proxy.$runTests({exclude:F.exclude?X(F.exclude).map(oe=>oe.testId):void 0,tests:X(F.tests),debug:F.debug},U)}$publishTestResults(F){this.results=Object.freeze(F.map(U=>n.deepFreeze(l.TestResults.to(U))).concat(this.results).sort((U,X)=>X.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:F,testId:U},X){var oe;const j=(oe=this.controllers.get(F))===null||oe===void 0?void 0:oe.collection;j&&(await j.expand(U,X<0?Infinity:X),j.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,U){var X;const oe=this.controllers.get(F.controllerId);if(!oe)return;const{controller:j,collection:W}=oe,K=F.testIds.map(O=>W.tree.get(O)).filter(I.isDefined),M=F.excludeExtIds.map(O=>oe.collection.tree.get(O)).filter(I.isDefined).filter(O=>K.some(Q=>W.tree.comparePositions(Q,O)===1));if(!K.length)return;const Y={tests:K.map(O=>O.actual),exclude:M.map(O=>O.actual),debug:F.debug},x=this.runTracker.prepareForMainThreadTestRun(Y,w.fromInternal(F),U);try{await((X=j.runHandler)===null||X===void 0?void 0:X.call(j,Y,U))}finally{x.isRunning&&!U.isCancellationRequested&&await k.Event.toPromise(x.onEnd),this.runTracker.cancelRunById(F.runId)}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}getInternalTestForReference(F){var U;return(U=m.mapFind(this.controllers.values(),({collection:X})=>X.getTestByReference(F)))!==null&&U!==void 0?U:this.observer.getMirroredTestDataByReference(F)}};s=Ve([je(0,d.IExtHostRpcService)],s),e.ExtHostTesting=s;class r extends C.Disposable{constructor(F,U,X){super();this.dto=F,this.proxy=U,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(X)),this._register(this.cts.token.onCancellationRequested(()=>{for(const oe of this.task)oe.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(F){const U=new p(F,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(U),this.isRunning||this.dispose()});return this.task.add(U),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class u{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,U,X){return this.getTracker(F,U,X)}cancelRunById(F){for(const U of this.tracked.values())if(U.id===F){U.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,U,X,oe){var j,W;const K=this.tracked.get(U);if(K)return K.createRun(X);const M=w.fromPublic(F,U);this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(W=(j=U.exclude)===null||j===void 0?void 0:j.map(x=>x.id))!==null&&W!==void 0?W:[],id:M.id,tests:U.tests.map(x=>x.id),persist:oe});const Y=this.getTracker(U,M);return Y.onEnd(()=>this.proxy.$finishedExtensionTestRun(M.id)),Y.createRun(X)}getTracker(F,U,X){const oe=new r(U,this.proxy,X);return this.tracked.set(F,oe),oe.onEnd(()=>this.tracked.delete(F)),oe}}e.TestRunCoordinator=u;class w{constructor(F,U,X,oe){this.controllerId=F,this.id=U,this.include=X,this.exclude=oe}static fromPublic(F,U){var X,oe;return new w(F,o.generateUuid(),new Set(U.tests.map(j=>j.id)),new Set((oe=(X=U.exclude)===null||X===void 0?void 0:X.map(j=>j.id))!==null&&oe!==void 0?oe:v.Iterable.empty()))}static fromInternal(F){return new w(F.controllerId,F.runId,new Set(F.testIds),new Set(F.excludeExtIds))}isIncluded(F){for(let U=F;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!1}}e.TestRunDto=w;class p{constructor(F,U,X,oe,j,W){this.name=F,this.token=U,c.set(this,void 0),f.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,!1),this.taskId=o.generateUuid(),rt(this,t,W,"f"),rt(this,c,j,"f"),rt(this,f,X,"f"),rt(this,g,oe,"f"),j.$startedTestRunTask(X.id,{id:this.taskId,name:F,running:!0})}setState(F,U,X){!xe(this,i,"f")&&xe(this,f,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),xe(this,c,"f").$updateTestStateInRun(xe(this,f,"f").id,this.taskId,F.id,U,X))}appendMessage(F,U){!xe(this,i,"f")&&xe(this,f,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),xe(this,c,"f").$appendTestMessageInRun(xe(this,f,"f").id,this.taskId,F.id,l.TestMessage.from(U)))}appendOutput(F){xe(this,i,"f")||xe(this,c,"f").$appendOutputToRun(xe(this,f,"f").id,this.taskId,S.VSBuffer.fromString(F))}end(){xe(this,i,"f")||(rt(this,i,!0,"f"),xe(this,c,"f").$finishedTestRunTask(xe(this,f,"f").id,this.taskId),xe(this,t,"f").call(this))}ensureTestIsKnown(F){const U=xe(this,g,"f");if(U.has(F.id))return;const X=[];for(;X.unshift(l.TestItem.from(F)),!(U.has(F.id)||(U.add(F.id),!F.parent));)F=F.parent;xe(this,c,"f").$addTestsToRun(xe(this,f,"f").controllerId,xe(this,f,"f").id,X)}}c=new WeakMap,f=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap;class P extends E.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,l.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:U,removed:X}=this;return{get added(){return[...F].map(oe=>oe.revived)},get updated(){return[...U].map(oe=>oe.revived)},get removed(){return[...X].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class A extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,U){return Object.assign(Object.assign({},F),{revived:l.TestItem.toPlain(F.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new P(this.changeEmitter)}}e.MirroredTestCollection=A;class a{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(U=>U.revived)},dispose:D.once(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){var U;return(U=this.current)===null||U===void 0?void 0:U.tests.getMirroredTestDataByReference(F)}applyDiff(F){var U;(U=this.current)===null||U===void 0||U.tests.apply(F)}createObserverData(){const F=new A;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}}),define(Ee[200],ye([0,1,3,17,4,98,9,6]),function(Z,e,m,T,S,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(o=>o.value)}async showTextDocument(n,I,o){let h;typeof I=="number"?h={position:k.ViewColumn.from(I),preserveFocus:o}:typeof I=="object"?h={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:h={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(n.uri,h),l=d&&this._extHostDocumentsAndEditors.getEditor(d);if(l)return l.value;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new y.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const o=this._extHostDocumentsAndEditors.getEditor(n);if(!o)throw new Error("unknown text editor");if(I.options&&o._acceptOptions(I.options),I.selections){const h=I.selections.selections.map(k.Selection.to);o._acceptSelections(h)}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(k.Range.to));o._acceptVisibleRanges(h)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const h=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),d=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:d,kind:h})}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const I in n){const o=this._extHostDocumentsAndEditors.getEditor(I);if(!o)throw new Error("Unknown text editor");const h=k.ViewColumn.to(n[I]);o.value.viewColumn!==h&&(o._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=v});var $n=this&&this.__rest||function(Z,e){var m={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(m[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(Z);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[S])&&(m[T[S]]=Z[T[S]]);return m};define(Ee[201],ye([0,1,2,5,4,7,6]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class D{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:o=>{var h,d;if(o&&o.$mid===11){const l=o.uri===void 0?void 0:m.URI.revive(o.uri);return(d=(h=this._itemsBySourceAndUriMap.get(o.source))===null||h===void 0?void 0:h.get(v(l)))===null||d===void 0?void 0:d.get(o.handle)}return o}})}async $getTimeline(n,I,o,h,d){const l=this._providers.get(n);return l==null?void 0:l.provideTimeline(m.URI.revive(I),o,h,d)}registerTimelineProvider(n,I,o,h){const d=new y.DisposableStore,l=this.convertTimelineItem(I.id,h,d).bind(this);let _;I.onDidChange&&(_=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:n,onDidChange:void 0,async provideTimeline(E,c,f,g){var t;(g==null?void 0:g.resetCache)&&(d.clear(),(t=b.get(I.id))===null||t===void 0||t.clear());const i=await I.provideTimeline(E,c,f);if(i==null)return;const s=l(E,g);return Object.assign(Object.assign({},i),{source:I.id,items:i.items.map(s)})},dispose(){var E;for(const c of b.values())(E=c.get(I.id))===null||E===void 0||E.clear();_==null||_.dispose(),d.dispose()}}))}convertTimelineItem(n,I,o){return(h,d)=>{let l;if(d==null?void 0:d.cacheResults){let _=this._itemsBySourceAndUriMap.get(n);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(n,_));const b=v(h);l=_.get(b),l===void 0&&(l=new Map,_.set(b,l))}return _=>{var b,E;const{iconPath:c}=_,f=$n(_,["iconPath"]),g=`${n}|${(b=_.id)!==null&&b!==void 0?b:_.timestamp}`;l==null||l.set(g,_);let t,i,s;return _.iconPath&&(c instanceof k.ThemeIcon?s={id:c.id}:m.URI.isUri(c)?(t=c,i=c):{light:t,dark:i}=c),Object.assign(Object.assign({},f),{id:(E=f.id)!==null&&E!==void 0?E:void 0,handle:g,source:n,command:_.command?I.toInternal(_.command,o):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),y.toDisposable(()=>{var o;for(const h of this._itemsBySourceAndUriMap.values())(o=h.get(n.id))===null||o===void 0||o.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=D;function v(C){return C==null?void 0:C.toString()}}),define(Ee[202],ye([0,1,7,12,2,4]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(v){this._openers=new Map,this._proxy=v.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,C,n,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const o=I.schemes.find(h=>!k.supportedSchemes.has(h));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,I.schemes,v,I.label),m.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(v,C,n){const I=this._openers.get(v);if(!I)throw new Error(`Unknown opener with id: ${v}`);const o=S.URI.revive(C);return I.canOpenExternalUri(o,n)}async $openUri(v,C,n){const I=this._openers.get(v);if(!I)throw new Error(`Unknown opener id: '${v}'`);return I.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(Ee[203],ye([0,1,4,2,7,11,26]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,C),S.toDisposable(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,n){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(n))}catch(o){y.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(C){return T.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[47],ye([0,1,3,2,140,158,66,4]),function(Z,e,m,T,S,y,k,D){"use strict";var v,C,n,I,o,h,d,l,_,b,E,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(p,P,A,a,R,F,U){v.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,""),l.set(this,void 0),_.set(this,!1),b.set(this,!1),E.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new m.Emitter),this._onDidDispose=xe(this,c,"f").event,rt(this,v,p,"f"),rt(this,C,P,"f"),rt(this,l,A,"f"),rt(this,I,a,"f"),rt(this,o,R,"f"),rt(this,h,F,"f"),rt(this,E,g(F),"f"),rt(this,n,U,"f")}dispose(){rt(this,_,!0,"f"),xe(this,c,"f").fire(),xe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return rt(this,b,!0,"f"),k.asWebviewUri(p,xe(this,I,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),xe(this,d,"f")}set html(p){this.assertNotDisposed(),xe(this,d,"f")!==p&&(rt(this,d,p,"f"),!xe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(rt(this,b,!0,"f"),xe(this,n,"f").report("Webview vscode-resource: uris",xe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,C,"f").$setHtml(xe(this,v,"f"),p))}get options(){return this.assertNotDisposed(),xe(this,l,"f")}set options(p){this.assertNotDisposed(),xe(this,C,"f").$setOptions(xe(this,v,"f"),s(xe(this,h,"f"),xe(this,o,"f"),p)),rt(this,l,p,"f")}async postMessage(p){if(xe(this,_,"f"))return!1;const P=y.serializeWebviewMessage(p,{serializeBuffersForPostMessage:xe(this,E,"f")});return xe(this,C,"f").$postMessage(xe(this,v,"f"),P.message,...P.buffers)}assertNotDisposed(){if(xe(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,v=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,l=new WeakMap,_=new WeakMap,b=new WeakMap,E=new WeakMap,c=new WeakMap;function g(w){try{const p=S.normalizeVersion(S.parseVersion(w.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(p,P,A,a,R){this.initData=P,this.workspace=A,this._logService=a,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=p.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(p,P,...A){const a=this.getWebview(p);if(a){const{message:R}=y.deserializeWebviewMessage(P,A);a._onMessageEmitter.fire(R)}}$onMissingCsp(p,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,P,A){const a=new f(p,this._webviewProxy,r(P),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(p,a),a._onDidDispose(()=>{this._webviews.delete(p)}),a}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function i(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=i;function s(w,p,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||u(w,p)}}e.serializeWebviewOptions=s;function r(w){var p;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(p=w.localResourceRoots)===null||p===void 0?void 0:p.map(P=>T.URI.from(P))}}e.reviveOptions=r;function u(w,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(P=>P.uri),w.extensionLocation]}}),define(Ee[204],ye([0,1,18,53,7,12,25,2,9,47,62,4,6]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return k.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class d{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const u=new h(i,s);return this._documents.set(r,u),u}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var l;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(l||(l={}));class _{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:r}),new o.Disposable(()=>this._providers.delete(i))}}class b{constructor(t,i,s,r,u){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=u,this._editorProviders=new _,this._documents=new d,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,r){const u=new S.DisposableStore;return E(s)?(u.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),i,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(u.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(w=>{const p=this.getCustomDocumentEntry(i,w.document.uri);if(c(w)){const P=p.addEdit(w);this._proxy.$onDidEdit(w.document.uri,i,P,w.label)}else this._proxy.$onContentChange(w.document.uri,i)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(u,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,r,u){var w;const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${i}'`);const P=D.URI.revive(t),A=await p.provider.openCustomDocument(P,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},u);let a;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(a=(w=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(i,A,a),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=D.URI.revive(t),{document:u}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,u),u.dispose()}async $resolveWebviewEditor(t,i,s,r,u,w){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const P=v.ViewColumn.to(u),A=this._extHostWebview.createNewWebview(i,r.webviewOptions,p.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,r.title,P,r.panelOptions,A),R=D.URI.revive(t);switch(p.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,R);return p.provider.resolveCustomEditor(F,a,w)}case 0:{const F=this._extHostDocuments.getDocument(R);return p.provider.resolveCustomTextEditor(F,a,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const w=D.URI.revive(i),p=this._extHostDocuments.getDocument(w);await r.provider.moveCustomTextEditor(p,u,m.CancellationToken.None)}async $undo(t,i,s,r){return this.getCustomDocumentEntry(i,t).undo(s,r)}async $redo(t,i,s,r){return this.getCustomDocumentEntry(i,t).redo(s,r)}async $revert(t,i,s){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,i,s){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,i,s,r){const u=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(u.document,D.URI.revive(s),r)}async $backup(t,i,s){const r=this.getCustomDocumentEntry(i,t),w=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(w),w.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,D.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function E(g){return typeof g.resolveCustomTextEditor=="function"}function c(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function f(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return T.hash(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[205],ye([0,1,3,7,2,34,9,47,4,6]),function(Z,e,m,T,S,y,k,D,v,C){"use strict";var n,I,o,h,d,l,_,b,E,c,f,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends T.Disposable{constructor(w,p,P,A,a,R,F){super();n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),l.set(this,void 0),_.set(this,void 0),b.set(this,void 0),E.set(this,!0),c.set(this,!0),f.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=xe(this,g,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,rt(this,n,w,"f"),rt(this,I,p,"f"),rt(this,o,P,"f"),rt(this,d,R,"f"),rt(this,b,a,"f"),rt(this,l,A,"f"),rt(this,h,F,"f")}dispose(){xe(this,f,"f")||(rt(this,f,!0,"f"),xe(this,g,"f").fire(),xe(this,I,"f").$disposeWebview(xe(this,n,"f")),xe(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,h,"f")}get viewType(){return this.assertNotDisposed(),xe(this,o,"f")}get title(){return this.assertNotDisposed(),xe(this,l,"f")}set title(w){this.assertNotDisposed(),xe(this,l,"f")!==w&&(rt(this,l,w,"f"),xe(this,I,"f").$setTitle(xe(this,n,"f"),w))}get iconPath(){return this.assertNotDisposed(),xe(this,_,"f")}set iconPath(w){this.assertNotDisposed(),xe(this,_,"f")!==w&&(rt(this,_,w,"f"),xe(this,I,"f").$setIconPath(xe(this,n,"f"),S.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return xe(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,b,"f")=="number"&&xe(this,b,"f")<0))return xe(this,b,"f")}get active(){return this.assertNotDisposed(),xe(this,c,"f")}get visible(){return this.assertNotDisposed(),xe(this,E,"f")}_updateViewState(w){xe(this,f,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(rt(this,c,w.active,"f"),rt(this,E,w.visible,"f"),rt(this,b,w.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(w,p){this.assertNotDisposed(),xe(this,I,"f").$reveal(xe(this,n,"f"),{viewColumn:w?k.ViewColumn.from(w):void 0,preserveFocus:!!p})}assertNotDisposed(){if(xe(this,f,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,l=new WeakMap,_=new WeakMap,b=new WeakMap,E=new WeakMap,c=new WeakMap,f=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(w,p,P){this.webviews=p,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=w.getProxy(v.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(w,p,P,A,a={}){const R=typeof A=="object"?A.viewColumn:A,F={viewColumn:k.ViewColumn.from(R),preserveFocus:typeof A=="object"&&!!A.preserveFocus},U=D.shouldSerializeBuffersForPostMessage(w),X=s.newHandle();this._proxy.$createWebviewPanel(D.toExtensionData(w),X,p,{title:P,panelOptions:r(a),webviewOptions:D.serializeWebviewOptions(w,this.workspace,a),serializeBuffersForPostMessage:U},F);const oe=this.webviews.createNewWebview(X,a,w);return this.createNewWebviewPanel(X,p,P,R,a,oe)}$onDidChangeWebviewPanelViewStates(w){const p=Object.keys(w);p.sort((P,A)=>{const a=w[P],R=w[A];return a.active?1:R.active?-1:+a.visible-+R.visible});for(const P of p){const A=this.getWebviewPanel(P);if(!A)continue;const a=w[P];A._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(w){const p=this.getWebviewPanel(w);p==null||p.dispose(),this._webviewPanels.delete(w),this.webviews.deleteWebview(w)}registerWebviewPanelSerializer(w,p,P){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:P,extension:w}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:D.shouldSerializeBuffersForPostMessage(w)}),new C.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(w,p,P,A){const a=this._serializers.get(p);if(!a)throw new Error(`No serializer found for '${p}'`);const{serializer:R,extension:F}=a,U=this.webviews.createNewWebview(w,P.webviewOptions,F),X=this.createNewWebviewPanel(w,p,P.title,A,P.panelOptions,U);await R.deserializeWebviewPanel(X,P.state)}createNewWebviewPanel(w,p,P,A,a,R){const F=new i(w,this._proxy,p,P,A,a,R);return this._webviewPanels.set(w,F),F}getWebviewPanel(w){return this._webviewPanels.get(w)}}e.ExtHostWebviewPanels=s;function r(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[206],ye([0,1,3,7,47,4,6]),function(Z,e,m,T,S,y,k){"use strict";var D,v,C,n,I,o,h,d,l,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(f,g,t,i,s,r){super();D.set(this,void 0),v.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,!1),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),l.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=xe(this,l,"f").event,_.set(this,this._register(new m.Emitter)),this.onDidDispose=xe(this,_,"f").event,rt(this,C,t,"f"),rt(this,h,i,"f"),rt(this,D,f,"f"),rt(this,v,g,"f"),rt(this,n,s,"f"),rt(this,o,r,"f")}dispose(){xe(this,I,"f")||(rt(this,I,!0,"f"),xe(this,_,"f").fire(),xe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,h,"f")}set title(f){this.assertNotDisposed(),xe(this,h,"f")!==f&&(rt(this,h,f,"f"),xe(this,v,"f").$setWebviewViewTitle(xe(this,D,"f"),f))}get description(){return this.assertNotDisposed(),xe(this,d,"f")}set description(f){this.assertNotDisposed(),xe(this,d,"f")!==f&&(rt(this,d,f,"f"),xe(this,v,"f").$setWebviewViewDescription(xe(this,D,"f"),f))}get visible(){return xe(this,o,"f")}get webview(){return xe(this,n,"f")}get viewType(){return xe(this,C,"f")}_setVisible(f){f===xe(this,o,"f")||xe(this,I,"f")||(rt(this,o,f,"f"),xe(this,l,"f").fire())}show(f){this.assertNotDisposed(),xe(this,v,"f").$show(xe(this,D,"f"),!!f)}assertNotDisposed(){if(xe(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,v=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,l=new WeakMap,_=new WeakMap;class E{constructor(f,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider(S.toExtensionData(f),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(f,g,t,i,s){const r=this._viewProviders.get(g);if(!r)throw new Error(`No view provider found for '${g}'`);const{provider:u,extension:w}=r,p=this._extHostWebview.createNewWebview(f,{},w),P=new b(f,this._proxy,g,t,p,!0);this._webviewViews.set(f,P),await u.resolveWebviewView(P,{state:i},s)}async $onDidChangeWebviewViewVisibility(f,g){this.getWebviewView(f)._setVisible(g)}async $disposeWebviewView(f){const g=this.getWebviewView(f);this._webviewViews.delete(f),g.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const g=this._webviewViews.get(f);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=E}),define(Ee[102],ye([0,1,3,4,2,12,8,5,14]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Un{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,o){let h;if(typeof I=="string"){h=I;try{I=S.URI.parse(I)}catch(d){return Promise.reject(`Invalid uri - '${I}'`)}}return k.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,h,o)}async asExternalUri(I,o){if(k.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(I,o);return S.URI.from(h)}};C.InitialState={focused:!0},C=Ve([je(0,v.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=D.createDecorator("IExtHostWindow")}),define(Ee[207],ye([0,1,16,4,28,14]),function(Z,e,m,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends m.AbstractLogger{constructor(v,C){super();this._proxy=v.getProxy(T.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(v){this.setLevel(v)}trace(v,...C){this.getLevel()<=m.LogLevel.Trace&&this._proxy.$log(this._logFile,m.LogLevel.Trace,Array.from(arguments))}debug(v,...C){this.getLevel()<=m.LogLevel.Debug&&this._proxy.$log(this._logFile,m.LogLevel.Debug,Array.from(arguments))}info(v,...C){this.getLevel()<=m.LogLevel.Info&&this._proxy.$log(this._logFile,m.LogLevel.Info,Array.from(arguments))}warn(v,...C){this.getLevel()<=m.LogLevel.Warning&&this._proxy.$log(this._logFile,m.LogLevel.Warning,Array.from(arguments))}error(v,...C){this.getLevel()<=m.LogLevel.Error&&this._proxy.$log(this._logFile,m.LogLevel.Error,Array.from(arguments))}critical(v,...C){this.getLevel()<=m.LogLevel.Critical&&this._proxy.$log(this._logFile,m.LogLevel.Critical,Array.from(arguments))}flush(){}};k=Ve([je(0,y.IExtHostRpcService),je(1,S.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(Ee[208],ye([0,1,13,18,11,3,7,113,177,99,23]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(r,u){try{return JSON.stringify(r,u)}catch(w){return"null"}}function h(r,u){return JSON.stringify(r,u)}function d(r){return r?(u,w)=>w&&w.$mid===1?r.transformOutgoing(w):w:null}var l;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},E=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class f extends k.Disposable{constructor(u,w=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=w,this._uriTransformer=p,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,A=C.ProxyIdentifier.count;P<A;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?D.transformIncomingURIs(u,this._uriTransformer):u}getProxy(u){const{nid:w,sid:p}=u;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,p)),this._proxies[w]}_createProxy(u,w){let p={get:(P,A)=>(typeof A=="string"&&!P[A]&&A.charCodeAt(0)===36&&(P[A]=(...a)=>this._remoteCall(u,A,a)),A===c?w:P[A])};return new Proxy(Object.create(null),p)}set(u,w){return this._locals[u.nid]=w,w}assertRegistered(u){for(let w=0,p=u.length;w<p;w++){const P=u[w];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const w=u.byteLength,p=g.read(u,0),P=p.readUInt8(),A=p.readUInt32();switch(P){case 1:case 2:{let{rpcId:a,method:R,args:F}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(F=D.transformIncomingURIs(F,this._uriTransformer)),this._receiveRequest(w,A,a,R,F,P===2);break}case 3:case 4:{let{rpcId:a,method:R,args:F}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(F=D.transformIncomingURIs(F,this._uriTransformer)),this._receiveRequest(w,A,a,R,F,P===4);break}case 5:{this._logger&&this._logger.logIncoming(w,A,0,"ack"),this._onDidReceiveAcknowledge(A);break}case 6:{this._receiveCancel(w,A);break}case 7:{this._receiveReply(w,A,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(p);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(w,A,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(p);this._receiveReply(w,A,a);break}case 10:{let a=t.deserializeReplyErrError(p);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(w,A,a);break}case 11:{this._receiveReplyErr(w,A,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,w,p,P,A,a){this._logger&&this._logger.logIncoming(u,w,1,`receiveRequest ${C.getStringIdentifierForProxy(p)}.${P}(`,A);const R=String(w);let F,U;if(a){const oe=new T.CancellationTokenSource;A.push(oe.token),F=this._invokeHandler(p,P,A),U=()=>oe.cancel()}else F=this._invokeHandler(p,P,A),U=b;this._cancelInvokedHandlers[R]=U;const X=t.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(X.byteLength,w,1,"ack"),this._protocol.send(X),F.then(oe=>{delete this._cancelInvokedHandlers[R];const j=t.serializeReplyOK(w,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,w,1,"reply:",oe),this._protocol.send(j)},oe=>{delete this._cancelInvokedHandlers[R];const j=t.serializeReplyErr(w,oe);this._logger&&this._logger.logOutgoing(j.byteLength,w,1,"replyErr:",oe),this._protocol.send(j)})}_receiveCancel(u,w){this._logger&&this._logger.logIncoming(u,w,1,"receiveCancel");const p=String(w);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(u,w,p){this._logger&&this._logger.logIncoming(u,w,0,"receiveReply:",p);const P=String(w);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],A.resolveOk(p)}_receiveReplyErr(u,w,p){this._logger&&this._logger.logIncoming(u,w,0,"receiveReplyErr:",p);const P=String(w);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let a;p&&(p.$isError?(a=new Error,a.name=p.name,a.message=p.message,a.stack=p.stack):a=p),A.resolveErr(a)}_invokeHandler(u,w,p){try{return Promise.resolve(this._doInvokeHandler(u,w,p))}catch(P){return Promise.reject(P)}}_doInvokeHandler(u,w,p){const P=this._locals[u];if(!P)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(u));let A=P[w];if(typeof A!="function")throw new Error("Unknown method "+w+" on actor "+C.getStringIdentifierForProxy(u));return A.apply(P,p)}_remoteCall(u,w,p){if(this._isDisposed)return Promise.reject(S.canceled());let P=null;if(p.length>0&&T.CancellationToken.isCancellationToken(p[p.length-1])&&(P=p.pop()),P&&P.isCancellationRequested)return Promise.reject(S.canceled());const A=t.serializeRequestArguments(p,this._uriReplacer),a=++this._lastMessageId,R=String(a),F=new v.LazyPromise;P&&P.onCancellationRequested(()=>{const X=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(X.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(a);const U=t.serializeRequest(a,u,w,A,!!P);return this._logger&&this._logger.logOutgoing(U.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(u)}.${w}(`,p),this._protocol.send(U),F}}e.RPCProtocol=f,I=E,f.UNRESPONSIVE_TIME=3*1e3;class g{constructor(u,w){this._buff=u,this._offset=w}static alloc(u,w,p){let P=new g(n.VSBuffer.alloc(p+1+4),0);return P.writeUInt8(u),P.writeUInt32(w),P}static read(u,w){return new g(u,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,p}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,p}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,w}static sizeMixedArray(u,w){let p=0;p+=1;for(let P=0,A=u.length;P<A;P++){const a=u[P],R=w[P];switch(p+=1,R){case 1:p+=this.sizeLongString(a);break;case 2:p+=this.sizeVSBuffer(a);break;case 3:break}}return p}writeMixedArray(u,w){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let p=0,P=u.length;p<P;p++){const A=u[p];switch(w[p]){case 1:this.writeUInt8(1),this.writeLongString(A);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(u);for(let p=0;p<u;p++)switch(this.readUInt8()){case 1:w[p]=this.readLongString();break;case 2:w[p]=this.readVSBuffer();break;case 3:w[p]=void 0;break}return w}}class t{static _arrayContainsBufferOrUndefined(u){for(let w=0,p=u.length;w<p;w++)if(u[w]instanceof n.VSBuffer||typeof u[w]=="undefined")return!0;return!1}static serializeRequestArguments(u,w){if(this._arrayContainsBufferOrUndefined(u)){let p=[],P=[];for(let A=0,a=u.length;A<a;A++){const R=u[A];R instanceof n.VSBuffer?(p[A]=R,P[A]=2):typeof R=="undefined"?(p[A]=n.VSBuffer.alloc(0),P[A]=3):(p[A]=n.VSBuffer.fromString(h(R,w)),P[A]=1)}return{type:"mixed",args:p,argsType:P}}return{type:"simple",args:h(u,w)}}static serializeRequest(u,w,p,P,A){return P.type==="mixed"?this._requestMixedArgs(u,w,p,P.args,P.argsType,A):this._requestJSONArgs(u,w,p,P.args,A)}static _requestJSONArgs(u,w,p,P,A){const a=n.VSBuffer.fromString(p),R=n.VSBuffer.fromString(P);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(a),F+=g.sizeLongString(R);let U=g.alloc(A?2:1,u,F);return U.writeUInt8(w),U.writeShortString(a),U.writeLongString(R),U.buffer}static deserializeRequestJSONArgs(u){const w=u.readUInt8(),p=u.readShortString(),P=u.readLongString();return{rpcId:w,method:p,args:JSON.parse(P)}}static _requestMixedArgs(u,w,p,P,A,a){const R=n.VSBuffer.fromString(p);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(R),F+=g.sizeMixedArray(P,A);let U=g.alloc(a?4:3,u,F);return U.writeUInt8(w),U.writeShortString(R),U.writeMixedArray(P,A),U.buffer}static deserializeRequestMixedArgs(u){const w=u.readUInt8(),p=u.readShortString(),P=u.readMixedArray(),A=new Array(P.length);for(let a=0,R=P.length;a<R;a++){const F=P[a];typeof F=="string"?A[a]=JSON.parse(F):A[a]=F}return{rpcId:w,method:p,args:A}}static serializeAcknowledged(u){return g.alloc(5,u,0).buffer}static serializeCancel(u){return g.alloc(6,u,0).buffer}static serializeReplyOK(u,w,p){return typeof w=="undefined"?this._serializeReplyOKEmpty(u):w instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(u,w):this._serializeReplyOKJSON(u,o(w,p))}static _serializeReplyOKEmpty(u){return g.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,w){let p=0;p+=g.sizeVSBuffer(w);let P=g.alloc(8,u,p);return P.writeVSBuffer(w),P.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,w){const p=n.VSBuffer.fromString(w);let P=0;P+=g.sizeLongString(p);let A=g.alloc(9,u,P);return A.writeLongString(p),A.buffer}static deserializeReplyOKJSON(u){const w=u.readLongString();return JSON.parse(w)}static serializeReplyErr(u,w){return w?this._serializeReplyErrEror(u,w):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,w){const p=n.VSBuffer.fromString(o(S.transformErrorForSerialization(w),null));let P=0;P+=g.sizeLongString(p);let A=g.alloc(10,u,P);return A.writeLongString(p),A.buffer}static deserializeReplyErrError(u){const w=u.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(u){return g.alloc(11,u,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(Ee[209],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(y){const k=D=>{self.removeEventListener("message",k);const v=D.data;Object.defineProperties(self,{postMessage:{value(C,n){v.postMessage(C,n)}},onmessage:{get(){return v.onmessage},set(C){v.onmessage=C}}}),v.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),v.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(y)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(y,k,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const v=`((${m})('${k}'))`,C=new Blob([v],{type:"application/javascript"}),n=URL.createObjectURL(C),I=new MessageChannel,o=n,h={type:"_newWorker",id:o,port:I.port2,url:n,options:D};y(h,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const d={type:"_terminateWorker",id:o};I.port1.postMessage(d),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(d){I.port1.onmessage=d}},onmessageerror:{get(){return I.port1.onmessageerror},set(d){I.port1.onmessageerror=d}}}),I.port1.addEventListener("messageerror",d=>{const l=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(l)}),I.port1.addEventListener("message",d=>{const l=new MessageEvent("message",{data:d.data});this.dispatchEvent(l)}),I.port1.start()}}e.NestedWorker=T}),define(Ee[210],ye([0,1,5]),function(Z,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=m.createDecorator("remoteAgentService")}),define(Ee[211],ye([0,1,12,15,21,2,5,92,44,173,210]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=k.createDecorator("pathService");let I=class xn{constructor(h,d,l,_){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=l,this.contextService=_,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||S.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||h})()}get defaultUriScheme(){return xn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const l=D.getVirtualWorkspaceScheme(d.getWorkspace());if(l)return l;const _=d.getWorkspace().folders[0];if(_)return _.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:m.Schemas.file}async userHome(h){return(h==null?void 0:h.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?T.win32:T.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const _=h.indexOf("/",2);_===-1?(d=h.substring(2),h="/"):(d=h.substring(2,_),h=h.substring(_)||"/")}return y.URI.from({scheme:m.Schemas.file,authority:d,path:h,query:"",fragment:""})}};I=Ve([je(1,n.IRemoteAgentService),je(2,C.IWorkbenchEnvironmentService),je(3,v.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(Ee[103],ye([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(k,D){this.line=k,this.character=D}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,D){return new m(0,0)}with(k){return new m(0,0)}}e.Position=m;class T{constructor(k,D,v,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(k,D),this.end=new m(v,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var S;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[37],ye([0,1,17,27,24,42,8,5,15,11,103]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",o=" characters skipped \u27EB",h=(I.length+o.length+5)*2;e.ISearchService=D.createDecorator("searchService");var d;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function _(M){return!!M.preview}e.resultIsMatch=_;function b(M){return!!M.resource}e.isFileMatch=b;function E(M){return!!M.message}e.isProgressMessage=E;var c;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(Y){this.resource=Y,this.results=[]}}e.FileMatch=f;class g{constructor(Y,x,O){this.ranges=x;const Q=Array.isArray(x)?x:[x];if(O&&O.matchLines===1&&t(Q)){Y=k.getNLines(Y,O.matchLines);let V="",le=0,be=0;const Te=Math.floor(O.charsPerLine/5),He=[];for(const Me of Q){const qe=Math.max(Me.startColumn-Te,0),nt=Me.startColumn+O.charsPerLine;if(qe>be+Te+h){const Je=I+(qe-be)+o;V+=Je+Y.slice(qe,nt),le+=qe-(be+Je.length)}else V+=Y.slice(be,nt);He.push(new s(0,Me.startColumn-le,Me.endColumn-le)),be=nt}this.preview={text:V,matches:Array.isArray(this.ranges)?He:He[0]}}else{const V=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:Y,matches:m.mapArrayOrNot(x,le=>new i(le.startLineNumber-V,le.startColumn,le.endLineNumber-V,le.endColumn))}}}}e.TextSearchMatch=g;function t(M){const Y=M[0].startLineNumber;for(const x of M)if(x.startLineNumber!==Y||x.endLineNumber!==Y)return!1;return!0}class i{constructor(Y,x,O,Q){this.startLineNumber=Y,this.startColumn=x,this.endLineNumber=O,this.endColumn=Q}}e.SearchRange=i;class s extends i{constructor(Y,x,O){super(Y,x,Y,O)}}e.OneLineRange=s;var r;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function u(M,Y=!0){const x=M&&M.files&&M.files.exclude,O=Y&&M&&M.search&&M.search.exclude;if(!x&&!O)return;if(!x||!O)return x||O;let Q=Object.create(null);return Q=S.mixin(Q,S.deepClone(x)),Q=S.mixin(Q,S.deepClone(O),!0),Q}e.getExcludes=u;function w(M,Y){return M.excludePattern&&T.match(M.excludePattern,Y)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&T.match(M.includePattern,Y)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(x=>{const O=x.folder.fsPath;if(y.isEqualOrParent(Y,O)){const Q=v.relative(O,Y);return!x.includePattern||!!T.match(x.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var p;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(Y,x){super(Y);this.code=x}}e.SearchError=P;function A(M){const Y=M.message;if(C.isPromiseCanceledError(M))return new P(Y,p.canceled);try{const x=JSON.parse(Y);return new P(x.message,x.code)}catch(x){return new P(Y,p.other)}}e.deserializeSearchError=A;function a(M){const Y={message:M.message,code:M.code};return new Error(JSON.stringify(Y))}e.serializeSearchError=a;function R(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=R;function F(M){return M.type==="success"}e.isSerializedSearchSuccess=F;function U(M){return!!M.path}e.isSerializedFileMatch=U;function X(M,Y){const x=M.searchPath?M.searchPath:M.relativePath;return k.fuzzyContains(x,Y)}e.isFilePatternMatch=X;class oe{constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function j(M,Y){const x=Object.assign(Object.assign({},M||{}),Y||{});return Object.keys(x).filter(O=>{const Q=x[O];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=j;class W{constructor(Y,x){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},Y.excludePattern||{}),x.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let O=Y.includePattern;x.includePattern&&(O?O=Object.assign(Object.assign({},O),x.includePattern):O=x.includePattern),O&&(this._parsedIncludeExpression=T.parse(O))}includedInQuerySync(Y,x,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,x,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Y,x,O))}includedInQuery(Y,x,O){return Promise.resolve(this._parsedExcludeExpression(Y,x,O)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(Y,x,O)).then(le=>!!le):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=W;function K(M){for(const Y in M)if(typeof M[Y]!="boolean")return!0;return!1}}),define(Ee[31],ye([0,1,17,13,18,3,22,12,76,25,8,10,2,134,5,16,147,44,45,28,14,6,37,4]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c,f,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,F,U){return new C.ExtUri(X=>p(X,U)).isEqual(R,F)}function r(R,F,U){return s(R.uri,F.uri,U)?0:n.compare(R.uri.toString(),F.uri.toString())}function u(R,F,U){return R.index!==F.index?R.index<F.index?-1:1:s(R.uri,F.uri,U)?n.compare(R.name,F.name):n.compare(R.uri.toString(),F.uri.toString())}function w(R,F,U,X){const oe=R.slice(0).sort((W,K)=>U(W,K,X)),j=F.slice(0).sort((W,K)=>U(W,K,X));return m.delta(oe,j,(W,K)=>U(W,K,X))}function p(R,F){const U=F.getCapabilities(R.scheme);return!(U&&U&1024)}class P extends b.Workspace{constructor(F,U,X,oe,j,W){super(F,X.map(K=>new b.WorkspaceFolder(K)),oe,W);this._name=U,this._isUntitled=j,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(W),X.forEach(K=>{this._workspaceFolders.push(K),this._structure.set(K.uri,K)})}static toExtHostWorkspace(F,U,X,oe){if(!F)return{workspace:null,added:[],removed:[]};const{id:j,name:W,folders:K,configuration:M,isUntitled:Y}=F,x=[],O=U;U?K.forEach((be,Te)=>{const He=o.URI.revive(be.uri),Me=P._findFolder(X||U,He,oe);Me?(Me.name=be.name,Me.index=be.index,x.push(Me)):x.push({uri:He,name:be.name,index:Te})}):x.push(...K.map(({uri:be,name:Te,index:He})=>({uri:o.URI.revive(be),name:Te,index:He}))),x.sort((be,Te)=>be.index<Te.index?-1:1);const Q=new P(j,W,x,M?o.URI.revive(M):null,!!Y,be=>p(be,oe)),{added:V,removed:le}=w(O?O.workspaceFolders:[],Q.workspaceFolders,r,oe);return{workspace:Q,added:V,removed:le}}static _findFolder(F,U,X){for(let oe=0;oe<F.folders.length;oe++){const j=F.workspaceFolders[oe];if(s(j.uri,U,X))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,U){return U&&this._structure.get(F)&&(F=C.dirname(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let A=class{constructor(F,U,X,oe){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=oe,this._extHostFileSystemInfo=X,this._requestIdProvider=new v.Counter,this._barrier=new T.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const j=U.workspace;this._confirmedWorkspace=j?new P(j.id,j.name,[],j.configuration?o.URI.revive(j.configuration):null,!!j.isUntitled,W=>p(W,X)):void 0}$initializeWorkspace(F,U){this._trusted=U,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,U,X,...oe){const j=[];if(Array.isArray(oe)&&oe.forEach(x=>{o.URI.isUri(x.uri)&&!j.some(O=>s(O.uri,x.uri,this._extHostFileSystemInfo))&&j.push({uri:x.uri,name:x.name||C.basenameOrAuthority(x.uri)})}),this._unconfirmedWorkspace||[U,X].some(x=>typeof x!="number"||x<0)||X===0&&j.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+X>W.length)return!1;const K=W.slice(0);K.splice(U,X,...j.map(x=>({uri:x.uri,name:x.name||C.basenameOrAuthority(x.uri),index:void 0})));for(let x=0;x<K.length;x++){const O=K[x];if(K.some((Q,V)=>V!==x&&s(O.uri,Q.uri,this._extHostFileSystemInfo)))return!1}K.forEach((x,O)=>x.index=O);const{added:M,removed:Y}=w(W,K,u,this._extHostFileSystemInfo);if(M.length===0&&Y.length===0)return!1;if(this._proxy){const x=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(x,U,X,j).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,h.localize(0,null,x,O.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(F,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,U)}async getWorkspaceFolder2(F,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,U)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,U){let X,oe="";if(typeof F=="string"?(X=o.URI.file(F),oe=F):typeof F!="undefined"&&(X=F,oe=F.fsPath),!X)return oe;const j=this.getWorkspaceFolder(X,!0);if(!j)return oe;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let W=C.relativePath(j.uri,X);return U&&j.name&&(W=`${j.name}/${W}`),W}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:U,added:X,removed:oe}=P.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:X,removed:oe}))}findFiles(F,U,X,oe,j=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${oe.value}, entryPoint: findFiles`);let W;if(U===null?W=!1:U&&(typeof U=="string"?W=U:W=U.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:M}=a(F);return this._proxy.$startFileSearch(I.withUndefinedAsNull(K),I.withUndefinedAsNull(M),I.withUndefinedAsNull(W),I.withUndefinedAsNull(X),j).then(Y=>Array.isArray(Y)?Y.map(x=>o.URI.revive(x)):[])}async findTextInFiles(F,U,X,oe,j=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${oe.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),K=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:M,folder:Y}=a(U.include),x=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,O={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:K,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:M,excludePattern:x},Q=!1;if(this._activeSearchCallbacks[W]=V=>{if(Q)return;const le=o.URI.revive(V.resource);V.results.forEach(be=>{t.resultIsMatch(be)?X({uri:le,preview:{text:be.preview.text,matches:m.mapArrayOrNot(be.preview.matches,Te=>new g.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:m.mapArrayOrNot(be.ranges,Te=>new g.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):X({uri:le,text:be.text,lineNumber:be.lineNumber})})},j.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(F,I.withUndefinedAsNull(Y),O,W,j);return delete this._activeSearchCallbacks[W],V||{}}catch(V){throw delete this._activeSearchCallbacks[W],V}}$handleTextSearchResult(F,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};A=Ve([je(0,f.IExtHostRpcService),je(1,c.IExtHostInitDataService),je(2,E.IExtHostFileSystemInfo),je(3,l.ILogService)],A),e.ExtHostWorkspace=A,e.IExtHostWorkspace=d.createDecorator("IExtHostWorkspace");function a(R){let F,U;return R&&(typeof R=="string"?F=R:(F=R.pattern,U=R.baseFolder||o.URI.file(R.base))),{includePattern:F,folder:U}}}),define(Ee[32],ye([0,1,24,3,31,4,6,151,61,10,13,5,14,16,2]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(i,s){if(s){const r=s.split(".");let u=i;for(let w=0;u&&w<r.length;w++)u=u[r[w]];return u}}function _(i){return i instanceof d.URI}function b(i){return i&&i.uri instanceof d.URI&&i.languageId&&typeof i.languageId=="string"}function E(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof d.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function f(i){if(_(i))return{resource:i};if(b(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(E(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,r,u){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=u,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,r))}};g=Ve([je(0,o.IExtHostRpcService),je(1,S.IExtHostWorkspace),je(2,h.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,r,u,w){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=w,this._extHostWorkspace=r,this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,u))}getConfiguration(s,r,u){const w=f(r)||{},p=this._toReadonlyValue(s?l(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,w,u==null?void 0:u.identifier);function P(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const A={has(a){return typeof l(p,a)!="undefined"},get:(a,R)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,w,u==null?void 0:u.identifier);let F=l(p,a);if(typeof F=="undefined")F=R;else{let U;const X=(oe,j)=>{let W;const K=()=>{U=U||m.deepClone(p),W=W||l(U,j)};return C.isObject(oe)?new Proxy(oe,{get:(M,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return K(),()=>W;if(U)return W=W||l(U,j),W[Y];const x=M[Y];return typeof Y=="string"?X(x,`${j}.${Y}`):x},set:(M,Y,x)=>(K(),W&&(W[Y]=x),!0),deleteProperty:(M,Y)=>(K(),W&&delete W[Y],!0),defineProperty:(M,Y,x)=>(K(),W&&Object.defineProperty(W,Y,x),!0)}):oe};F=X(F,a)}return F},update:(a,R,F,U)=>{a=s?`${s}.${a}`:a;const X=P(F);return R!==void 0?this._proxy.$updateConfigurationOption(X,a,R,w,U):this._proxy.$removeConfigurationOption(X,a,w,U)},inspect:a=>{var R,F,U,X,oe,j,W,K;a=s?`${s}.${a}`:a;const M=m.deepClone(this._configuration.inspect(a,w,this._extHostWorkspace.workspace));if(M)return{key:a,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(F=M.user)===null||F===void 0?void 0:F.value,workspaceValue:(U=M.workspace)===null||U===void 0?void 0:U.value,workspaceFolderValue:(X=M.workspaceFolder)===null||X===void 0?void 0:X.value,defaultLanguageValue:(oe=M.default)===null||oe===void 0?void 0:oe.override,globalLanguageValue:(j=M.user)===null||j===void 0?void 0:j.override,workspaceLanguageValue:(W=M.workspace)===null||W===void 0?void 0:W.override,workspaceFolderLanguageValue:(K=M.workspaceFolder)===null||K===void 0?void 0:K.override,languageIds:M.overrideIdentifiers}}};return typeof p=="object"&&m.mixin(A,p,!1),Object.freeze(A)}_toReadonlyValue(s){const r=u=>C.isObject(u)?new Proxy(u,{get:(w,p)=>r(w[p]),set:(w,p,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(w,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(w,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return r(s)}_validateConfigurationAccess(s,r,u){const w=v.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=u?`[${u.value}] `:"";if(w===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const u=new D.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,p)=>u.affectsConfiguration(w,f(p))})}_toMap(s){return s.reduce((r,u)=>(r.set(u[0],u[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[104],ye([0,1,2,13,3,4,6,31,46,32,18,36,14,28,5,12,21,16,69,162,11]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(oe){function j(K){if(K!=null)return K}oe.from=j;function W(K){if(K!=null)return K}oe.to=W})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(oe){function j(K){if(K!=null)return K}oe.from=j;function W(K){if(K!=null)return K}oe.to=W})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(oe){function j(K){if(K!=null)return K}oe.from=j;function W(K){if(K!=null)return K}oe.to=W})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(oe){function j(M){if(M){const Y=M;return Y&&!!Y.process}else return!1}oe.is=j;function W(M){if(M==null)return;const Y={process:M.process,args:M.args};return M.options&&(Y.options=s.from(M.options)),Y}oe.from=W;function K(M){if(M!=null)return new k.ProcessExecution(M.process,M.args,M.options)}oe.to=K})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(oe){function j(K){if(K!=null)return K}oe.from=j;function W(K){if(K!=null)return K}oe.to=W})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(oe){function j(M){if(M){const Y=M;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}oe.is=j;function W(M){if(M==null)return;const Y={};return M.commandLine!==void 0?Y.commandLine=M.commandLine:(Y.command=M.command,Y.args=M.args),M.options&&(Y.options=u.from(M.options)),Y}oe.from=W;function K(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new k.ShellExecution(M.commandLine,M.options):new k.ShellExecution(M.command,M.args?M.args:[],M.options)}oe.to=K})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(oe){function j(M){if(M){let Y=M;return Y&&Y.customExecution==="customExecution"}else return!1}oe.is=j;function W(M){return{customExecution:"customExecution"}}oe.from=W;function K(M,Y){return Y.get(M)}oe.to=K})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(oe){function j(W,K){let M;return W.scope!==void 0&&typeof W.scope!="number"?M=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===k.TaskScope.Workspace&&K&&K.workspaceFile?M=K.workspaceFile:M=c.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:M}}oe.from=j})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var A;(function(oe){function j(M,Y){if(M==null)return[];const x=[];for(let O of M){const Q=W(O,Y);Q&&x.push(Q)}return x}oe.fromMany=j;function W(M,Y){if(M==null)return;let x;M.execution instanceof k.ProcessExecution?x=r.from(M.execution):M.execution instanceof k.ShellExecution?x=w.from(M.execution):M.execution&&M.execution instanceof k.CustomExecution&&(x=p.from(M.execution));const O=t.from(M.definition);let Q;if(M.scope?typeof M.scope=="number"?Q=M.scope:Q=M.scope.uri:Q=k.TaskScope.Workspace,!O||!Q)return;const V=M.group?M.group.id:void 0;return{_id:M._id,definition:O,name:M.name,source:{extensionId:Y.identifier.value,label:M.source,scope:Q},execution:x,isBackground:M.isBackground,group:V,presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}oe.from=W;async function K(M,Y,x){if(M==null)return;let O;r.is(M.execution)?O=r.to(M.execution):w.is(M.execution)?O=w.to(M.execution):p.is(M.execution)&&(O=p.to(M._id,x));const Q=t.to(M.definition);let V;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?V=M.source.scope:V=await Y.resolveWorkspaceFolder(m.URI.revive(M.source.scope)):V=k.TaskScope.Workspace),!Q||!V)return;const le=new k.Task(Q,V,M.name,M.source.label,O,M.problemMatchers);return M.isBackground!==void 0&&(le.isBackground=M.isBackground),M.group!==void 0&&(le.group=k.TaskGroup.from(M.group)),M.presentationOptions&&(le.presentationOptions=i.to(M.presentationOptions)),M._id&&(le._id=M._id),M.detail&&(le.detail=M.detail),le}oe.to=K})(A=e.TaskDTO||(e.TaskDTO={}));var a;(function(oe){function j(K){return K}oe.from=j;function W(K){if(!!K)return Object.assign(Object.create(null),K)}oe.to=W})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(j,W,K){this._id=W,this._task=K,g.set(this,void 0),rt(this,g,j,"f")}get task(){return this._task}terminate(){xe(this,g,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}g=new WeakMap;var F;(function(oe){function j(W){return{id:W._id,task:void 0}}oe.from=j})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let U=class{constructor(j,W,K,M,Y,x,O,Q){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=j.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=M,this._configurationService=Y,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,W,K){if(!K)return new k.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:W,provider:K,extension:j}),this._proxy.$registerTaskProvider(M,W),new k.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(j,W){this._proxy.$registerTaskSystem(j,W)}fetchTasks(j){return this._proxy.$fetchTasks(a.from(j)).then(async W=>{const K=[];for(let M of W){const Y=await A.to(M,this._workspaceProvider,this._providedCustomExecutions2);Y&&K.push(Y)}return K})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(W=>j.push(W)),j}terminateTask(j){if(!(j instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,W,K){const M=this._providedCustomExecutions2.get(j.id);if(M){if(this._activeCustomExecutions2.get(j.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(j.id,M),this._terminalService.attachPtyToTerminal(W,await M.callback(K))}this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const W=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const W=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:W,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const W=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:j.exitCode})}$provideTasks(j,W){const K=this._handlers.get(j);if(!K)return Promise.reject(new Error("no handler found"));const M=[],Y=T.asPromise(()=>K.provider.provideTasks(n.CancellationToken.None)).then(x=>this.provideTasksInternal(W,M,K,x));return new Promise(x=>{Y.then(O=>{Promise.all(M).then(()=>{x(O)})})})}async $resolveTask(j,W){const K=this._handlers.get(j);if(!K)return Promise.reject(new Error("no handler found"));if(W.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${K.type}].`);const M=await A.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const Y=await K.provider.resolveTask(M,n.CancellationToken.None);if(!Y)return;this.checkDeprecation(Y,K);const x=A.from(Y,K.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(x.execution)&&await this.addCustomExecution(x,Y,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,W,K){const M=await this._proxy.$createTaskId(j);!K&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,W.execution)}async getTaskExecution(j,W){if(typeof j=="string"){const Y=this._taskExecutionPromises.get(j);if(!Y)throw new Error("Unexpected: The specified task is missing an execution");return Y}let K=this._taskExecutionPromises.get(j.id);if(K)return K;const M=new Promise(async(Y,x)=>{const O=W||await A.to(j.task,this._workspaceProvider,this._providedCustomExecutions2);O?Y(new R(this,j.id,O)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(j.id,M),M.then(Y=>(this._taskExecutions.set(j.id,Y),Y),Y=>Promise.reject(Y))}checkDeprecation(j,W){j._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let K=this._notProvidedCustomExecutions.values(),M=K.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=K.next()}};U=Ve([je(0,o.IExtHostRpcService),je(1,h.IExtHostInitDataService),je(2,D.IExtHostWorkspace),je(3,v.IExtHostDocumentsAndEditors),je(4,C.IExtHostConfiguration),je(5,I.IExtHostTerminalService),je(6,b.ILogService),je(7,E.IExtHostApiDeprecationService)],U),e.ExtHostTaskBase=U;let X=class extends U{constructor(j,W,K,M,Y,x,O,Q){super(j,W,K,M,Y,x,O,Q);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(j,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const K=A.from(W,j);if(K===void 0)throw new Error("Task is not valid");if(p.is(K.execution))await this.addCustomExecution(K,W,!1);else throw new f.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),W);return this._proxy.$executeTask(K).catch(Y=>{throw new Error(Y)}),M}provideTasksInternal(j,W,K,M){const Y=[];if(M)for(let x of M){this.checkDeprecation(x,K),(!x.definition||!j[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const O=A.from(x,K.extension);O&&p.is(O.execution)?(Y.push(O),W.push(this.addCustomExecution(O,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:K.extension}}async resolveTaskInternal(j){if(p.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,W,K){}};X=Ve([je(0,o.IExtHostRpcService),je(1,h.IExtHostInitDataService),je(2,D.IExtHostWorkspace),je(3,v.IExtHostDocumentsAndEditors),je(4,C.IExtHostConfiguration),je(5,I.IExtHostTerminalService),je(6,b.ILogService),je(7,E.IExtHostApiDeprecationService)],X),e.WorkerExtHostTask=X,e.IExtHostTask=d.createDecorator("IExtHostTask")}),define(Ee[212],ye([0,1,17,75,27,80,22,12,15,25,8,10,2,116,136,90,44,165,211,37]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(P,A,a,R){this.configurationService=P,this.workspaceContextService=A,this.editorGroupsService=a,this.pathService=R}text(P,A,a={}){P=this.getContentPattern(P,a);const R=this.configurationService.getValue(),F=A&&A.some(X=>!this.configurationService.getValue({resource:X}).search.useRipgrep),U=this.commonQuery(A==null?void 0:A.map(_.toWorkspaceFolder),a);return Object.assign(Object.assign({},U),{type:2,contentPattern:P,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(P,A){const a=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},P),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(P,A)&&(R.isCaseSensitive=!0),this.isMultiline(P)&&(R.isMultiline=!0),R}file(P,A={}){const a=this.commonQuery(P,A);return Object.assign(Object.assign({},a),{type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey})}handleIncludeExclude(P,A){return P?(P=Array.isArray(P)?P.map(r):r(P),A?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],A={}){const a=this.handleIncludeExclude(A.includePattern,A.expandPatterns),R=this.handleIncludeExclude(A.excludePattern,A.expandPatterns),F=P.length>1,U=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,A,R)):P.map(j=>this.getFolderQueryForRoot(j,A,R,F))).filter(j=>!!j),X={_reason:A._reason,folderQueries:U,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:R.pattern,includePattern:a.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const W=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(Y=>Y.resource)))).filter(M=>c.pathIncludedInQuery(X,M.fsPath)),K=this.commonQueryFromFileList(W);return Object.assign(Object.assign({},X),K)}const oe=A.extraFileResources&&A.extraFileResources.filter(j=>c.pathIncludedInQuery(X,j.fsPath));return X.extraFileResources=oe&&oe.length?oe:void 0,X}commonQueryFromFileList(P){const A=[],a=new k.ResourceMap,R={};let F=!1;return P.forEach(U=>{var X,oe;if(U.scheme===D.Schemas.walkThrough)return;if(C.isAbsolutePath(U)){const W=(oe=(X=this.workspaceContextService.getWorkspaceFolder(U))===null||X===void 0?void 0:X.uri)!==null&&oe!==void 0?oe:U.with({path:v.dirname(U.fsPath)});let K=a.get(W);K||(F=!0,K={folder:W,includePattern:{}},A.push(K),a.set(W,K));const M=v.relative(W.fsPath,U.fsPath);I.assertIsDefined(K.includePattern)[M.replace(/\\/g,"/")]=!0}else U.fsPath&&(F=!0,R[U.fsPath]=!0)}),{folderQueries:A,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(P,A){if(A.isSmartCase){if(P.isRegExp){if(n.containsUppercaseCharacter(P.pattern,!0))return!0}else if(n.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&h.isMultilineRegexSource(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const A=K=>v.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),R=(Array.isArray(P)?P:i(P)).map(K=>{const M=this.pathService.resolvedUserHome;return M?y.untildify(K,M.scheme===D.Schemas.file?M.fsPath:M.path):K}),F=T.groupBy(R,K=>A(K)?"searchPaths":"exprSegments"),U=(F.exprSegments||[]).map(K=>n.rtrim(K,"/")).map(K=>n.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),s(K))),X={},oe=this.expandSearchPathPatterns(F.searchPaths||[]);oe&&oe.length&&(X.searchPaths=oe);const j=m.flatten(U),W=t(...j);return W&&(X.pattern=W),X}getExcludesForFolder(P,A){return A.disregardExcludeSettings?void 0:c.getExcludes(P,!A.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const A=m.flatten(P.map(R=>{let{pathPortion:F,globPortion:U}=g(R);U&&(U=u(U));const X=this.expandOneSearchPath(F);return m.flatten(X.map(oe=>this.resolveOneSearchPathPattern(oe,U)))})),a=new Map;return A.forEach(R=>{const F=R.searchPath.toString(),U=a.get(F);U?R.pattern&&(U.pattern=U.pattern||{},U.pattern[R.pattern]=!0):a.set(F,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(P){if(v.isAbsolute(P)){const A=this.workspaceContextService.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==D.Schemas.file?[{searchPath:A[0].uri.with({path:P})}]:[{searchPath:o.URI.file(v.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const A=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=r(P),P.startsWith("../")||P===".."){const R=v.posix.resolve(A.path,P);return[{searchPath:A.with({path:R})}]}const a=u(P);return[{searchPath:A,pattern:a}]}else{if(P==="./"||P===".\\")return[];{const A=P.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(F=>{const U=A.match(new RegExp(`^${n.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return U?{match:U,folder:F}:null}).filter(I.isDefined);if(R.length)return R.map(F=>{const U=F.match[1];return{searchPath:F.folder.uri,pattern:U&&u(U)}});{const F=P.match(/\.[\/\\](.+)[\/\\]?/),U=F?F[1]:P,X=d.localize(0,null,U);throw new Error(X)}}}}resolveOneSearchPathPattern(P,A){const a=P.pattern&&A?`${P.pattern}/${A}`:P.pattern||A,R=[{searchPath:P.searchPath,pattern:a}];return a&&!a.endsWith("**")&&R.push({searchPath:P.searchPath,pattern:a+"/**"}),R}getFolderQueryForSearchPath(P,A,a){const R=this.getFolderQueryForRoot(_.toWorkspaceFolder(P.searchPath),A,a,!1);return R?Object.assign(Object.assign({},R),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,A,a,R){let F;const U=o.URI.isUri(P)?P:P.uri;if(a.searchPaths){const K=a.searchPaths.filter(M=>C.isEqual(M.searchPath,U))[0];if(K&&!K.pattern)return null;K&&(F=K.pattern)}const X=this.configurationService.getValue({resource:U}),oe=this.getExcludesForFolder(X,A),j=Object.assign(Object.assign({},oe||{}),F||{}),W=o.URI.isUri(P)?C.basename(P):P.name;return{folder:U,folderName:R?W:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:X.files&&X.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!X.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!X.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!X.search.followSymlinks}}};f=Ve([je(0,l.IConfigurationService),je(1,_.IWorkspaceContextService),je(2,b.IEditorGroupsService),je(3,E.IPathService)],f),e.QueryBuilder=f;function g(p){const P=p.match(/[\*\{\}\(\)\[\]\?]/);if(P){const A=P.index,a=p.substr(0,A).match(/[/|\\][^/\\]*$/);if(a){let R=p.substr(0,a.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:p.substr((a.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((P,A)=>(P[A]=!0,P),Object.create(null)):void 0}function i(p){return S.splitGlobAware(p,",").map(P=>P.trim()).filter(P=>!!P.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function u(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(p,P){p=m.distinct(p,R=>R.toString());const A=[],a=P.getWorkspace();return p&&p.forEach(R=>{let F;if(P.getWorkbenchState()===2)F=C.relativePath(a.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const U=P.getWorkspaceFolder(R);if(U){const X=U.name;if(a.folders.filter(j=>j.name===X).length===1){const j=C.relativePath(U.uri,R);j===""?F=`./${U.name}`:F=`./${U.name}/${j}`}else F=R.fsPath}}F&&A.push(F)}),A}e.resolveResourcesForSearchIncludes=w}),define(Ee[213],ye([0,1,25,2,18,11,5,212,37,44]),function(Z,e,m,T,S,y,k,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(l,_){const b=_.activationEvents;if(!b)return Promise.resolve(void 0);const E=[],c=[];for(const r of b)if(/^workspaceContains:/.test(r)){const u=r.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||l.forceUsingSearch?c.push(u):E.push(u)}if(E.length===0&&c.length===0)return Promise.resolve(void 0);let f;const g=new Promise((r,u)=>{f=r}),t=r=>f({activationEvent:r}),i=Promise.all(E.map(r=>o(l,r,t))).then(()=>{}),s=h(l,_.identifier,c,t);return Promise.all([i,s]).then(()=>{f(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function o(l,_,b){for(const E of l.folders)if(await l.exists(m.joinPath(T.URI.revive(E),_))){b(`workspaceContains:${_}`);return}}async function h(l,_,b,E){if(b.length===0)return Promise.resolve(void 0);const c=new S.CancellationTokenSource,f=l.checkExists(l.folders,b,c.token),g=setTimeout(async()=>{c.cancel(),E(`workspaceContainsTimeout:${b.join(",")}`)},n);let t=!1;try{t=await f}catch(i){y.isPromiseCanceledError(i)||y.onUnexpectedError(i)}c.dispose(),clearTimeout(g),t&&E(`workspaceContains:${b.join(",")}`)}function d(l,_,b,E){const c=l.get(k.IInstantiationService),f=l.get(v.ISearchService),t=c.createInstance(D.QueryBuilder).file(_.map(i=>C.toWorkspaceFolder(T.URI.revive(i))),{_reason:"checkExists",includePattern:b,exists:!0});return f.fileSearch(t,E).then(i=>!!i.limitHit,i=>y.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=d});var rt=this&&this.__classPrivateFieldSet||function(Z,e,m,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!S:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(Z,m):S?S.value=m:e.set(Z,m),m},xe=this&&this.__classPrivateFieldGet||function(Z,e,m,T){if(m==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?T:m==="a"?T.call(Z):T?T.value:e.get(Z)};define(Ee[33],ye([0,1,129,15,74,25,13,7,22,2,16,4,32,176,72,31,29,174,11,26,23,153,6,91,5,28,73,14,60,64,36,3,213,68,155]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c,f,g,t,i,s,r,u,w,p,P,A,a,R,F,U){"use strict";var X,oe,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let W=class Bn extends D.Disposable{constructor(x,O,Q,V,le,be,Te,He,Me,qe){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=Q,this._initData=Te,this._extHostWorkspace=V,this._extHostConfiguration=le,this._logService=be,this._extHostTunnelService=Me,this._extHostTerminalService=qe,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=He,this._instaService=x.createChild(new p.ServiceCollection([d.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const nt=new Set;this._initData.hostExtensions.forEach(Je=>nt.add(c.ExtensionIdentifier.toKey(Je))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Je,Xe,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Je,E.transformErrorForSerialization(Xe),B)},actualActivateExtension:async(Je,Xe)=>{if(nt.has(c.ExtensionIdentifier.toKey(Je)))return await this._mainThreadExtensionsProxy.$activateExtension(Je,Xe),new h.HostExtension;const B=this._registry.getExtensionDescription(Je);return this._activateExtension(B,Xe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){E.onUnexpectedError(x)}}async deactivateAll(){let x=[];try{x=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(O){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,O){return this._activator.activateByEvent(x,O)}_activateById(x,O){return this._activator.activateById(x,O)}activateByIdWithErrors(x,O){return this._activateById(x,O).then(()=>{const Q=this._activator.getActivatedExtension(x);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=v.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(Q=>{if(!!this._getEntryPoint(Q))return this._hostUtils.realpath(Q.extensionLocation.fsPath).then(V=>x.set(C.URI.file(V).fsPath,Q))});this._extensionPathIndex=Promise.all(O).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return O;const Q=this._activator.getActivatedExtension(x);if(!Q)return O;try{typeof Q.module.deactivate=="function"&&(O=Promise.resolve(Q.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{D.dispose(Q.subscriptions)}catch(V){this._logService.error(V)}return O}async _activateExtension(x,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,O).then(Q=>{const V=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,O),this._logExtensionActivationTimes(x,O,"success",V),Q},Q=>{throw this._logExtensionActivationTimes(x,O,"failure"),Q})}_logExtensionActivationTimes(x,O,Q,V){const le=K(x,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},le),V||{}),{outcome:Q}))}_doActivateExtension(x,O){const Q=K(x,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const V=this._getEntryPoint(x);if(!V)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const le=new h.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(x.identifier,y.joinPath(x.extensionLocation,V),le),this._loadExtensionContext(x)]).then(be=>(S.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Bn._callActivate(this._logService,x.identifier,be[0],be[1],le))).then(be=>(S.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),be))}_loadExtensionContext(x){const O=new g.ExtensionGlobalMemento(x,this._storage),Q=new g.ExtensionMemento(x.identifier.value,!1,this._storage),V=new U.ExtensionSecrets(x,this._secretState),le=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,be=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([O.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let He;return Object.freeze({globalState:O,workspaceState:Q,secrets:V,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Me){return T.join(x.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Te._storagePath.workspaceValue(x))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(x).fsPath},get logPath(){return T.join(Te._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return C.URI.joinPath(Te._initData.logsLocation,x.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(x)},get globalStorageUri(){return Te._storagePath.globalValue(x)},get extensionMode(){return le},get extension(){return He===void 0&&(He=new M(Te,x.identifier,x,be)),He},get extensionRuntime(){return _.checkProposedApiEnabled(x),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,O,Q,V,le){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,O,Q,V,le).then(be=>new h.ActivatedExtension(!1,null,le.build(),Q,be,V.subscriptions))}static _callActivateOptional(x,O,Q,V,le){if(typeof Q.activate=="function")try{le.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${O.value}`);const be=typeof global=="object"?global:self,Te=Q.activate.apply(be,[V]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(Te).then(He=>(le.activateResolveStop(),He))}catch(be){return Promise.reject(be)}else return Promise.resolve(Q)}_activateOneStartupFinished(x,O){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:O}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const O of x.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(x,O)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions(O),V=Promise.all([x,Q]).then(()=>{});return Promise.race([V,k.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(x,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,O){if(this.isActivated(O.identifier))return;const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={folders:x.map(be=>be.uri),forceUsingSearch:Q,exists:be=>this._hostUtils.exists(be.fsPath),checkExists:(be,Te,He)=>this._mainThreadWorkspaceProxy.$checkExists(be,Te,He)},le=await R.checkActivateWorkspaceContainsExtension(V,O);if(!!le)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:le.activationEvent}).then(void 0,be=>this._logService.error(be))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:O}=this._initData.environment;if(!x||!O)throw new Error(m.localize(0,null));const Q=await this._loadCommonJSModule(null,O,new h.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(m.localize(1,null,O.toString()));return new Promise((V,le)=>{const be=(Me,qe)=>{Me?le(Me):V(typeof qe=="number"&&qe>0?1:0)},Te=y.originalFSPath(O),He=Q.run(Te,be);He&&He.then&&He.then(()=>{V(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,O){return this._resolvers[x]=O,D.toDisposable(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const O=x.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const Q=x.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this._resolvers[Q]}}async $resolveAuthority(x,O){const{authorityPrefix:Q,resolver:V}=await this._activateAndGetResolver(x);if(!V)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),S.mark(`code/extHost/willResolveAuthority/${Q}`);const le=await V.resolve(x,{resolveAttempt:O});S.mark(`code/extHost/didResolveAuthorityOK/${Q}`);const be={authority:x,host:le.host,port:le.port,connectionToken:le.connectionToken},Te={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:be,options:Te,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(S.mark(`code/extHost/didResolveAuthorityError/${Q}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(x,O){const{authorityPrefix:Q,resolver:V}=await this._activateAndGetResolver(x);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Q}`);const le=C.URI.revive(O);if(typeof V.getCanonicalURI=="undefined")return le;const be=await k.asPromise(()=>V.getCanonicalURI(le));return be||le}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,O){return O===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(x,!1))}async $activate(x,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,O),!0):!1}async $deltaExtensions(x,O){x.forEach(V=>V.extensionLocation=C.URI.revive(V.extensionLocation));const Q=await this.getExtensionPathIndex();return await Promise.all(O.map(async V=>{const le=this._registry.getExtensionDescription(V);if(!le)return;const be=await this._hostUtils.realpath(le.extensionLocation.fsPath);Q.delete(C.URI.file(be).fsPath)})),await Promise.all(x.map(async V=>{const le=await this._hostUtils.realpath(V.extensionLocation.fsPath);Q.set(C.URI.file(le).fsPath,V)})),this._registry.deltaExtensions(x,O),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let O=f.VSBuffer.alloc(x),Q=Math.random()%256;for(let V=0;V<x;V++)O.writeUInt8(Q,V);return O}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};W=Ve([je(0,s.IInstantiationService),je(1,e.IHostUtils),je(2,w.IExtHostRpcService),je(3,l.IExtHostWorkspace),je(4,o.IExtHostConfiguration),je(5,n.ILogService),je(6,r.IExtHostInitDataService),je(7,u.IExtensionStoragePaths),je(8,P.IExtHostTunnelService),je(9,A.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function K(Y,x){return{id:Y.identifier.value,name:Y.name,extensionVersion:Y.version,publisherDisplayName:Y.publisher,activationEvents:Y.activationEvents?Y.activationEvents.join(","):null,isBuiltin:Y.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class M{constructor(x,O,Q,V){X.set(this,void 0),oe.set(this,void 0),j.set(this,void 0),rt(this,X,x,"f"),rt(this,oe,O,"f"),rt(this,j,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=T.normalize(y.originalFSPath(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=V}get isActive(){return xe(this,X,"f").isActivated(xe(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,X,"f").getExtensionExports(xe(this,j,"f"))}activate(){return xe(this,X,"f").activateByIdWithErrors(xe(this,j,"f"),{startup:!1,extensionId:xe(this,oe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,X=new WeakMap,oe=new WeakMap,j=new WeakMap}),define(Ee[105],ye([0,1,15,2,3,13,4,6,160,31,33,46,164,32,161,14,5,10,40,63]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=_.createDecorator("IExtHostDebugService");let f=class{constructor(p,P,A,a,R,F){this._workspaceService=P,this._extensionService=A,this._editorsService=a,this._configurationService=R,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=p.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(X=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,P){const A=p;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let a=`debug:${encodeURIComponent(A.path||"")}`,R="?";return P&&(a+=`${R}session=${encodeURIComponent(P.id)}`,R="&"),a+=`${R}ref=${A.sourceReference}`,T.URI.parse(a)}else{if(A.path)return T.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const P=[];for(const A of p.getAllExtensionDescriptions())if(A.contributes){const a=A.contributes.debuggers;if(a&&a.length>0)for(const R of a)d.isDebuggerMainContribution(R)&&P.push(R.type)}this._debugServiceProxy.$registerDebugTypes(P)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(P=>p.push(P)),p}addBreakpoints(p){this.startBreakpoints();const P=p.filter(R=>{const F=R.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,R),!0)});this.fireBreakpointChanges(P,[],[]);const A=[],a=new Map;for(const R of P)if(R instanceof D.SourceBreakpoint){let F=a.get(R.location.uri.toString());F||(F={type:"sourceMulti",uri:R.location.uri,lines:[]},a.set(R.location.uri.toString(),F),A.push(F)),F.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof D.FunctionBreakpoint&&A.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(p){this.startBreakpoints();const P=p.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],P,[]);const A=P.filter(F=>F instanceof D.SourceBreakpoint).map(F=>F.id),a=P.filter(F=>F instanceof D.FunctionBreakpoint).map(F=>F.id),R=P.filter(F=>F instanceof D.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(A,a,R)}startDebugging(p,P,A){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,P,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,P,A){if(!P)return new D.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:a,provider:P}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,A,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,a),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==P),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(p,P,A){if(!A)return new D.Disposable(()=>{});if(!this.definesDebugType(p,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.getAdapterDescriptorFactoryByType(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:P,handle:a,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(P,a),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(p,P){if(!P)return new D.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:A,factory:P}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==P)})}async $runInTerminal(p,P){return Promise.resolve(void 0)}async $substituteVariables(p,P){if(!this._variableResolver){const[R,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,F)}let A;const a=await this.getFolder(p);return a&&(A={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,P)}createDebugAdapter(p,P){if(p.type==="implementation")return new r(p.implementation)}createSignService(){}async $startDASession(p,P){const A=this,a=await this.getSession(P);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const F=this.convertToDto(R),U=this.createDebugAdapter(F,a);if(!U)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const X=U;return this._debugAdapters.set(p,X),this.getDebugAdapterTrackers(a).then(oe=>(oe&&this._debugAdaptersTrackers.set(p,oe),X.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const W=j,K={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(W.arguments.value);K.body={signature:M},X.sendResponse(K)}else throw new Error("no signer")}catch(M){K.success=!1,K.message=M.message,X.sendResponse(K)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(j),j=d.convertToVSCPaths(j,!0),A._debugServiceProxy.$acceptDAMessage(p,j)}),X.onError(j=>{oe&&oe.onError&&oe.onError(j),this._debugServiceProxy.$acceptDAError(p,j.name,j.message,j.stack)}),X.onExit(j=>{oe&&oe.onExit&&oe.onExit(b.withNullAsUndefined(j),void 0),this._debugServiceProxy.$acceptDAExit(p,b.withNullAsUndefined(j),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),X.startSession()))})}$sendDAMessage(p,P){P=d.convertToDAPaths(P,!1);const A=this._debugAdaptersTrackers.get(p);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(P);const a=this._debugAdapters.get(p);a&&a.sendMessage(P)}$stopDASession(p){const P=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),P&&P.onWillStopSession&&P.onWillStopSession();const A=this._debugAdapters.get(p);return this._debugAdapters.delete(p),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const P=[],A=[],a=[];if(p.added)for(const R of p.added){const F=R.id;if(F&&!this._breakpoints.has(F)){let U;if(R.type==="function")U=new D.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")U=new D.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const X=T.URI.revive(R.uri);U=new D.SourceBreakpoint(new D.Location(X,new D.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}U._id=F,this._breakpoints.set(F,U),P.push(U)}}if(p.removed)for(const R of p.removed){const F=this._breakpoints.get(R);F&&(this._breakpoints.delete(R),A.push(F))}if(p.changed){for(const R of p.changed)if(R.id){const F=this._breakpoints.get(R.id);if(F){if(F instanceof D.FunctionBreakpoint&&R.type==="function"){const U=F;U.enabled=R.enabled,U.condition=R.condition,U.hitCondition=R.hitCondition,U.logMessage=R.logMessage,U.functionName=R.functionName}else if(F instanceof D.SourceBreakpoint&&R.type==="source"){const U=F;U.enabled=R.enabled,U.condition=R.condition,U.hitCondition=R.hitCondition,U.logMessage=R.logMessage,U.location=new D.Location(T.URI.revive(R.uri),new D.Position(R.line,R.character))}a.push(F)}}}this.fireBreakpointChanges(P,A,a)}$provideDebugConfigurations(p,P,A){return y.asPromise(async()=>{const a=this.getConfigProviderByHandle(p);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(P);return a.provideDebugConfigurations(R,A)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(p,P,A,a){return y.asPromise(async()=>{const R=this.getConfigProviderByHandle(p);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(P);return R.resolveDebugConfiguration(F,A,a)})}$resolveDebugConfigurationWithSubstitutedVariables(p,P,A,a){return y.asPromise(async()=>{const R=this.getConfigProviderByHandle(p);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(P);return R.resolveDebugConfigurationWithSubstitutedVariables(F,A,a)})}async $provideDebugAdapter(p,P){const A=this.getAdapterDescriptorFactoryByHandle(p);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(P);return this.getAdapterDescriptor(A,a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(p){const P=await this.getSession(p);this._onDidStartDebugSession.fire(P)}async $acceptDebugSessionTerminated(p){const P=await this.getSession(p);P&&(this._onDidTerminateDebugSession.fire(P),this._debugSessions.delete(P.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,P){const A=await this.getSession(p);A&&A._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(p,P){const a={session:await this.getSession(p),event:P.event,body:P.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(p){if(p instanceof D.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof D.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const P=this._adapterFactories.filter(A=>A.type===p);if(P.length>0)return P[0].factory}getAdapterDescriptorFactoryByHandle(p){const P=this._adapterFactories.filter(A=>A.handle===p);if(P.length>0)return P[0].factory}getConfigProviderByHandle(p){const P=this._configProviders.filter(A=>A.handle===p);if(P.length>0)return P[0].provider}definesDebugType(p,P){if(p.contributes){const A=p.contributes.debuggers;if(A&&A.length>0){for(const a of A)if(a.label&&a.type&&a.type===P)return!0}}return!1}getDebugAdapterTrackers(p){const A=p.configuration.type,a=this._trackerFactories.filter(R=>R.type===A||R.type==="*").map(R=>y.asPromise(()=>R.factory.createDebugAdapterTracker(p)).then(F=>F,F=>null));return Promise.race([Promise.all(a).then(R=>{const F=R.filter(U=>!!U);if(F.length>0)return new s(F)}),new Promise((R,F)=>{const U=setTimeout(()=>{clearTimeout(U),F(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(p,P){const A=P.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new D.DebugAdapterServer(A));if(p){const R=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>p.createDebugAdapterDescriptor(P,this.daExecutableFromPackage(P,R))).then(F=>{if(F)return F})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(P,a))}daExecutableFromPackage(p,P){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,P,A){(p.length>0||P.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:P,changed:A}))}async getSession(p){if(p)if(typeof p=="string"){const P=this._debugSessions.get(p);if(P)return P}else{let P=this._debugSessions.get(p.id);if(!P){const A=await this.getFolder(p.folderUri),a=p.parent?this._debugSessions.get(p.parent):void 0;P=new g(this._debugServiceProxy,p.id,p.type,p.name,A,p.configuration,a),this._debugSessions.set(P.id,P),this._debugServiceProxy.$sessionCached(P.id)}return P}throw new Error("cannot find session")}getFolder(p){if(p){const P=T.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}};f=Ve([je(0,l.IExtHostRpcService),je(1,C.IExtHostWorkspace),je(2,n.IExtHostExtensionService),je(3,I.IExtHostDocumentsAndEditors),je(4,h.IExtHostConfiguration),je(5,c.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class g{constructor(p,P,A,a,R,F,U){this._debugServiceProxy=p,this._id=P,this._type=A,this._name=a,this._workspaceFolder=R,this._configuration=F,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,P){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,P)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=g;class t{constructor(p){this.value=Object.freeze({append(P){p.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.ExtHostDebugConsole=t;class i extends o.AbstractVariableResolverService{constructor(p,P,A,a,R){function F(){if(P){const U=P.activeEditor();if(U)return U.document.uri;const X=a.tabs.filter(oe=>oe.isActive);if(X.length>0)return X[0].resource}}super({getFolderUri:U=>{const X=p.filter(oe=>oe.name===U);if(X&&X.length>0)return X[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(U,X)=>A.getConfiguration(void 0,U).get(X),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=F();if(U)return m.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const U=F();if(U){const X=R.getWorkspaceFolder(U);if(X)return m.normalize(X.uri.fsPath)}}},getSelectedText:()=>{if(P){const U=P.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(P){const U=P.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=i;class s{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(P=>P.onError?P.onError(p):void 0)}onExit(p,P){this.trackers.forEach(A=>A.onExit?A.onExit(p,P):void 0)}}class r extends v.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends f{constructor(p,P,A,a,R,F){super(p,P,A,a,R,F)}createVariableResolver(p,P,A){return new i(p,P,A,this._editorTabs)}};u=Ve([je(0,l.IExtHostRpcService),je(1,C.IExtHostWorkspace),je(2,n.IExtHostExtensionService),je(3,I.IExtHostDocumentsAndEditors),je(4,h.IExtHostConfiguration),je(5,c.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(Ee[214],ye([0,1,74,2,4,32,29,26,14,28,5,33,40,16]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(c,f,g,t,i,s,r){this._apiFactory=c,this._extensionRegistry=f,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,f,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,f,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let f of c.nodeModuleName)this._factories.set(f,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(f=>c.alternativeModuleName(f))}};d=Ve([je(2,n.IInstantiationService),je(3,y.IExtHostConfiguration),je(4,I.IExtHostExtensionService),je(5,C.IExtHostInitDataService),je(6,h.ILogService)],d),e.RequireInterceptor=d;class l{constructor(c,f,g,t,i){this._apiFactory=c,this._extensionPaths=f,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,f){const g=this._extensionPaths.findSubstr(f.fsPath);if(g){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(c,f){this.nodeModuleName="keytar";const{environment:g}=f,t=c.getProxy(S.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;o.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,r)=>t.$setPassword(i,s,r),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(c,f){return this._impl}alternativeModuleName(c){const f=c.length;if(f<=7||!this.alternativeNames)return;const g=f-7;if((c.charAt(g)==="/"||c.charAt(g)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};_=Ve([je(0,v.IExtHostRpcService),je(1,C.IExtHostInitDataService)],_);let b=class{constructor(c,f,g){this._extensionPaths=c,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(S.MainContext.MainThreadTelemetry);const t=g.getProxy(S.MainContext.MainThreadWindow);this._impl=(i,s)=>{const r=T.URI.parse(i);return s?this.callOriginal(i,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,s)}}load(c,f,g){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(c),this._impl}callOriginal(c,f){return this.sendNoForwardTelemetry(),this._original(c,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([je(2,v.IExtHostRpcService)],b)}),define(Ee[215],ye([0,1,13,11,74,7,2,4,208,16,57,60,28,146,14,65,33,36]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(f,g,t,i){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new v.RPCProtocol(f,null,i),g=E._transform(g,this._rpcProtocol);const s=new I.ServiceCollection(...n.getSingletonServiceDescriptors());s.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),s.set(l.IURITransformerService,new l.URITransformerService(i)),s.set(_.IHostUtils,t);const r=new h.InstantiationService(s,!0),u=r.invokeFunction(A=>A.get(b.IExtHostTerminalService));this._disposables.add(u),this._logService=r.invokeFunction(A=>A.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=r.invokeFunction(A=>A.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(A=>{Error.prepareStackTrace=(a,R)=>{let F="",U,X;for(const oe of R)F+=`
	at ${oe.toString()}`,X=oe.getFileName(),!U&&X&&(U=A.findSubstr(X));return w.set(a,U),`${a.name||"Error"}: ${a.message||""}${F}`}});const p=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),P=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(A=>{const a=T.transformErrorForSerialization(A),R=w.get(A);R?p.$onExtensionRuntimeError(R.identifier,a):P.$onUnexpectedError(a)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([m.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,g){f.extensions.forEach(i=>i.extensionLocation=k.URI.revive(g.transformIncomingURIs(i.extensionLocation))),f.environment.appRoot=k.URI.revive(g.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(i=>k.URI.revive(g.transformIncomingURIs(i)))),f.environment.extensionTestsLocationURI=k.URI.revive(g.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=k.URI.revive(g.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=k.URI.revive(g.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=k.URI.revive(g.transformIncomingURIs(f.logsLocation)),f.logFile=k.URI.revive(g.transformIncomingURIs(f.logFile)),f.workspace=g.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=E}),define(Ee[216],ye([0,1,15,18,56,27,25,52,37]),function(Z,e,m,T,S,y,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(o,h,d){this.config=o,this.provider=h,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&y.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&y.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const h=this.config.folderQueries||[];return new Promise((d,l)=>{const _=b=>{this.resultCount++,o(b)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const E=b.toString(),c=m.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,c)||this.matchFile(_,{base:b,basename:c})}),Promise.all(h.map(b=>this.searchInFolder(b,_))).then(b=>{d({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{l(new Error(S.toErrorMessage(b)))})})}async searchInFolder(o,h){const d=new T.CancellationTokenSource,l=this.getSearchOptionsForFolder(o),_=this.initDirectoryTree(),b=new v.QueryGlobTester(this.config,o),E=!b.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(d),c=D.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,d.token),g=c.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(i=>{const s=m.posix.relative(o.folder.path,i.path);if(E){const r=m.basename(i.path);this.matchFile(h,{base:o.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(_,o.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,b,h),{providerTime:g,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(o){const h=v.resolvePatternsForProvider(this.config.includePattern,o.includePattern),d=v.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:d,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},h,d,l){if(d===this.filePattern){const b=m.basename(this.filePattern);this.matchFile(l,{base:h,relativePath:this.filePattern,basename:b})}function _(b){const E=m.basename(b),c=m.dirname(b);let f=o[c];f||(f=o[c]=[],_(c)),f.push({base:h,relativePath:b,basename:E})}_(d)}matchDirectoryTree({rootEntries:o,pathToEntries:h},d,l){const _=this,b=this.filePattern;function E(c){const f=y.hasSiblingFn(()=>c.map(g=>g.basename));for(let g=0,t=c.length;g<t;g++){const i=c[g],{relativePath:s,basename:r}=i;if(!d.includedInQuerySync(s,r,b!==r?f:void 0))continue;const u=h[s];if(u)E(u);else{if(s===b)continue;_.matchFile(l,i)}if(_.isLimitHit)break}}E(o)}matchFile(o,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(h))}}class n{constructor(){this.sessions=new Map}fileSearch(o,h,d,l){const _=this.getSessionTokenSource(o.cacheKey),b=new C(o,h,_&&_.token);let E=0;const c=f=>{E+=f.length,d(f.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(b,n.BATCH_SIZE,c,l).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:f.stats}}))}clearCache(o){const h=this.getSessionTokenSource(o);h&&h.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:k.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,h,d,l){l.onCancellationRequested(()=>{o.cancel()});const _=E=>{E&&(b.push(E),h>0&&b.length>=h&&(d(b),b=[]))};let b=[];return o.search(_).then(E=>(b.length&&d(b),E),E=>(b.length&&d(b),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(Ee[217],ye([0,1,15,17,18,56,25,27,2,37,12,10]),function(Z,e,m,T,S,y,k,D,v,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(c,f,g){this.query=c,this.provider=f,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,f){const g=this.query.folderQueries||[],t=new S.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new d(c);let r=!1;const u=(w,p)=>{if(!r&&!this.isLimitHit){const P=this.resultSize(w);_(w)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const A=this.resultSize(w);this.resultCount+=A,(A>0||!_(w))&&this.collector.add(w,p)}};Promise.all(g.map((w,p)=>this.searchInFolder(w,P=>u(P,p),t.token))).then(w=>{t.dispose(),this.collector.flush();const p=w.some(P=>!!P&&!!P.limitHit);i({limitHit:this.isLimitHit||p,messages:T.flatten(w.map(P=>(P==null?void 0:P.message)?I.isArray(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},w=>{t.dispose();const p=y.toErrorMessage(w);s(new Error(p))})})}resultSize(c){return _(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,f){const g=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:g.slice(0,f),preview:{matches:t.slice(0,f),text:c.preview.text},uri:c.uri}}async searchInFolder(c,f,g){const t=new C.QueryGlobTester(this.query,c),i=[],s={report:w=>{if(!this.validateProviderResult(w))return;const p=c.folder.scheme===n.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(w.uri))):void 0,P=k.relativePath(c.folder,w.uri);P&&i.push(t.includedInQuery(P,m.basename(P),p).then(A=>{A&&f(w)}))}},r=this.getSearchOptionsForFolder(c),u=await this.provider.provideTextSearchResults(h(this.query.contentPattern),r,s,g);return await Promise.all(i),u}validateProviderResult(c){if(_(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const f=C.resolvePatternsForProvider(this.query.includePattern,c.includePattern),g=C.resolvePatternsForProvider(this.query.excludePattern,c.excludePattern),t={folder:v.URI.from(c.folder),excludes:g,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function h(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,f=>this.sendItems(f))}add(c,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!k.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(l(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function l(E){return _(E)?{preview:{matches:T.mapArrayOrNot(E.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:E.preview.text},ranges:T.mapArrayOrNot(E.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class b{constructor(c,f){this.maxBatchSize=c,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,f){!c||this.addItemToBatch(c,f)}addItems(c,f){!c||this.addItemsToBatch(c,f)}addItemToBatch(c,f){this.batch.push(c),this.batchSize+=f,this.onUpdate()}addItemsToBatch(c,f){this.batch=this.batch.concat(c),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(Ee[106],ye([0,1,7,4,5,216,14,65,16,2,217]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=S.createDecorator("IExtHostSearch");let I=class{constructor(l,_,b){this.extHostRpc=l,this._uriTransformer=_,this._logService=b,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,_){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const b=this._handlePool++;return this._textSearchProvider.set(b,_),this._proxy.$registerTextSearchProvider(b,this._transformScheme(l)),m.toDisposable(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(l,_){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const b=this._handlePool++;return this._fileSearchProvider.set(b,_),this._proxy.$registerFileSearchProvider(b,this._transformScheme(l)),m.toDisposable(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(l,_,b,E){const c=o(b),f=this._fileSearchProvider.get(l);if(f)return this._fileSearchManager.fileSearch(c,f,g=>{this._proxy.$handleFileMatch(l,_,g.map(t=>t.resource))},E);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,_,b,E){const c=this._textSearchProvider.get(l);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const f=o(b);return this.createTextSearchManager(f,c).search(t=>this._proxy.$handleTextMatch(l,_,t),E)}createTextSearchManager(l,_){return new n.TextSearchManager(l,_,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};I=Ve([je(0,k.IExtHostRpcService),je(1,D.IURITransformerService),je(2,v.ILogService)],I),e.ExtHostSearch=I;function o(d){return Object.assign(Object.assign({},d),{folderQueries:d.folderQueries&&d.folderQueries.map(h),extraFileResources:d.extraFileResources&&d.extraFileResources.map(l=>C.URI.revive(l))})}e.reviveQuery=o;function h(d){return Object.assign(Object.assign({},d),{folder:C.URI.revive(d.folder)})}}),define(Ee[218],ye([0,1,18,11,3,41,2,123,83,117,55,59,4,181,180,70,182,32,183,184,185,167,186,46,33,187,168,189,190,191,101,170,196,197,198,72,36,200,171,9,6,203,47,102,31,29,75,159,188,92,100,104,105,106,16,65,14,28,192,157,64,69,178,201,156,73,71,206,204,205,179,45,199,202,68,63,93,194,103,195,12,148,193,154]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c,f,g,t,i,s,r,u,w,p,P,A,a,R,F,U,X,oe,j,W,K,M,Y,x,O,Q,V,le,be,Te,He,Me,qe,nt,Je,Xe,B,G,ne,re,q,se,he,Re,Be,ve,Ke,H,ee,me,Fe,Oe,Qe,Ce,_e,Ie,ie,ue,de,ge,$,fe,we,Pe,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function $e(We){const Ye=We.get(ne.IExtHostInitDataService),tt=We.get(Qe.IExtHostFileSystemInfo),ut=We.get(H.IExtHostConsumerFileSystem),pe=We.get(s.IExtHostExtensionService),De=We.get(Q.IExtHostWorkspace),ae=We.get(ue.IExtHostTelemetry),z=We.get(b.IExtHostConfiguration),Ue=We.get(B.IURITransformerService),Se=We.get(G.IExtHostRpcService),ze=We.get(X.IExtHostStorage),Ze=We.get(Ke.IExtensionStoragePaths),et=We.get(Xe.ILogService),st=We.get(se.IExtHostTunnelService),pt=We.get(he.IExtHostApiDeprecationService),bt=We.get(O.IExtHostWindow),_t=We.get(Ie.IExtHostSecretState),vt=We.get(ie.IExtHostEditorTabs);Se.set(o.ExtHostContext.ExtHostFileSystemInfo,tt),Se.set(o.ExtHostContext.ExtHostLogService,et),Se.set(o.ExtHostContext.ExtHostWorkspace,De),Se.set(o.ExtHostContext.ExtHostConfiguration,z),Se.set(o.ExtHostContext.ExtHostExtensionService,pe),Se.set(o.ExtHostContext.ExtHostStorage,ze),Se.set(o.ExtHostContext.ExtHostTunnelService,st),Se.set(o.ExtHostContext.ExtHostWindow,bt),Se.set(o.ExtHostContext.ExtHostSecretState,_t),Se.set(o.ExtHostContext.ExtHostTelemetry,ae),Se.set(o.ExtHostContext.ExtHostEditorTabs,vt);const Bt=Se.set(o.ExtHostContext.ExtHostDecorations,We.get(Me.IExtHostDecorations)),Et=Se.set(o.ExtHostContext.ExtHostDocumentsAndEditors,We.get(i.IExtHostDocumentsAndEditors)),ht=Se.set(o.ExtHostContext.ExtHostCommands,We.get(l.IExtHostCommands)),ct=Se.set(o.ExtHostContext.ExtHostTerminalService,We.get(oe.IExtHostTerminalService)),ft=Se.set(o.ExtHostContext.ExtHostDebugService,We.get(nt.IExtHostDebugService)),Ht=Se.set(o.ExtHostContext.ExtHostSearch,We.get(Je.IExtHostSearch)),kt=Se.set(o.ExtHostContext.ExtHostTask,We.get(qe.IExtHostTask)),At=Se.set(o.ExtHostContext.ExtHostOutputService,We.get(A.IExtHostOutputService)),Kt=Se.set(o.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Se)),yt=Se.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Se,Et)),en=Se.set(o.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Se,Et,et)),tn=Se.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(et,yt,Se.getProxy(o.MainContext.MainThreadBulkEdits))),gt=Se.set(o.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Se,ht,Et,yt,Ze)),Qt=Se.set(o.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(et,gt)),zt=Se.set(o.ExtHostContext.ExtHostNotebookEditors,new Pe.ExtHostNotebookEditors(et,Se,gt)),nn=Se.set(o.ExtHostContext.ExtHostNotebookKernels,new de.ExtHostNotebookKernels(Se,Ye,gt,et)),_n=Se.set(o.ExtHostContext.ExtHostNotebookRenderers,new $.ExtHostNotebookRenderers(Se,gt)),Dt=Se.set(o.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(Se,Et)),Yt=Se.set(o.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(Se.getProxy(o.MainContext.MainThreadTreeViews),ht,et)),rn=Se.set(o.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(Se.getProxy(o.MainContext.MainThreadEditorInsets),Dt,Ye)),$t=Se.set(o.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Se,et)),dt=Se.set(o.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(Se,Ue,yt,ht,$t,et,pt)),sn=Se.set(o.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Se,dt)),Tt=Se.set(o.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Se,et,Et)),Vt=Se.set(o.ExtHostContext.ExtHostQuickOpen,R.createExtHostQuickOpen(Se,De,ht)),hn=Se.set(o.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Se,ht,et)),En=Se.set(o.ExtHostContext.ExtHostComments,new _.ExtHostComments(Se,ht,yt)),fn=Se.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(Se.getProxy(o.MainContext.MainThreadProgress))),yn=Se.set(o.ExtHostContext.ExtHosLabelService,new Te.ExtHostLabelService(Se)),Jt=Se.set(o.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Se)),Lt=Se.set(o.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Se)),Sn=Se.set(o.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(Se,ht)),on=Se.set(o.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Se,{remote:Ye.remote},De,et,pt)),an=Se.set(o.ExtHostContext.ExtHostWebviewPanels,new Fe.ExtHostWebviewPanels(Se,on,De)),Dn=Se.set(o.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Se,yt,Ze,on,an)),Xt=Se.set(o.ExtHostContext.ExtHostWebviewViews,new ee.ExtHostWebviewViews(Se,on)),jt=Se.set(o.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(Se,ht)),Cn=Se.set(o.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(Se)),ln=le.values(o.ExtHostContext);Se.assertRegistered(ln);const kn=new Oe.ExtHostBulkEdits(Se,Et),qt=new d.ExtHostClipboard(Se),Rt=new P.ExtHostMessageService(Se,et),mn=new c.ExtHostDialogs(Se),Pt=new U.ExtHostStatusBar(Se,ht.converter),Wt=new p.ExtHostLanguages(Se,yt);return h.ExtHostApiCommands.register(ht),function(Ne,un,gn){const mt=function(){let J=!Ne.isUnderDevelopment;function ce(Ae){J||(et.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ae(at){if(Array.isArray(at))at.forEach(Ae);else if(typeof at=="string")ce(at);else{const wt=at;typeof wt.scheme=="undefined"&&ce(at),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&V.throwProposedApiError(Ne)}return at}}(),In={getSession(J,ce,Ae){return Lt.getSession(Ne,J,ce,Ae)},get onDidChangeSessions(){return Lt.onDidChangeSessions},registerAuthenticationProvider(J,ce,Ae,at){return Lt.registerAuthenticationProvider(J,ce,Ae,at)},get onDidChangeAuthenticationProviders(){return V.checkProposedApiEnabled(Ne),Lt.onDidChangeAuthenticationProviders},get providers(){return V.checkProposedApiEnabled(Ne),Lt.providers},logout(J,ce){return V.checkProposedApiEnabled(Ne),Lt.removeSession(J,ce)}},Pn={registerCommand(J,ce,Ae){return ht.registerCommand(!0,J,ce,Ae)},registerTextEditorCommand(J,ce,Ae){return ht.registerCommand(!0,J,(...at)=>{const wt=Dt.getActiveTextEditor();if(!wt){et.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Ct=>{ce.apply(Ae,[wt,Ct,...at])}).then(Ct=>{Ct||et.warn("Edits from command "+J+" were not applied.")},Ct=>{et.warn("An error occurred while running command "+J,Ct)})})},registerDiffInformationCommand:(J,ce,Ae)=>(V.checkProposedApiEnabled(Ne),ht.registerCommand(!0,J,async(...at)=>{const wt=Et.activeEditor(!0);if(!wt){et.warn("Cannot execute "+J+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(wt.id);ce.apply(Ae,[Ct,...at])})),executeCommand(J,...ce){return ht.executeCommand(J,...ce)},getCommands(J=!1){return ht.getCommands(J)}},pn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){var J,ce;return(ce=(J=Ye.environment.appRoot)===null||J===void 0?void 0:J.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return qt.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return ae.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ae.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return bt.openUri(J,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Ye.environment.appUriScheme)return Kt.createAppUri(J);const ce=we.matchesScheme(J,fe.Schemas.http)||we.matchesScheme(J,fe.Schemas.https);ce||V.checkProposedApiEnabled(Ne);try{return await bt.asExternalUri(J,{allowTunneling:!!Ye.remote.authority})}catch(Ae){if(ce)return J;throw Ae}},get remoteName(){return He.getRemoteName(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(pn);const Zt=Ye.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,An={createTestController(J){return V.checkProposedApiEnabled(Ne),jt.createTestController(J)},createTestObserver(){return V.checkProposedApiEnabled(Ne),jt.createTestObserver()},runTests(J){return V.checkProposedApiEnabled(Ne),jt.runTests(J)},get onDidChangeTestResults(){return V.checkProposedApiEnabled(Ne),jt.onResultsChanged},get testResults(){return V.checkProposedApiEnabled(Ne),jt.results}},Tn={getExtension(J){const ce=un.getExtensionDescription(J);if(ce)return new s.Extension(pe,Ne.identifier,ce,Zt)},get all(){return un.getAllExtensionDescriptions().map(J=>new s.Extension(pe,Ne.identifier,J,Zt))},get onDidChange(){return un.onDidChange}},Rn={createDiagnosticCollection(J){return $t.createDiagnosticCollection(Ne.identifier,J)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:J=>$t.getDiagnostics(J),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(J,ce){return Wt.changeLanguage(J.uri,ce)},match(J,ce){return n.score(K.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,Ae){return dt.registerCodeActionProvider(Ne,mt(J),ce,Ae)},registerCodeLensProvider(J,ce){return dt.registerCodeLensProvider(Ne,mt(J),ce)},registerDefinitionProvider(J,ce){return dt.registerDefinitionProvider(Ne,mt(J),ce)},registerDeclarationProvider(J,ce){return dt.registerDeclarationProvider(Ne,mt(J),ce)},registerImplementationProvider(J,ce){return dt.registerImplementationProvider(Ne,mt(J),ce)},registerTypeDefinitionProvider(J,ce){return dt.registerTypeDefinitionProvider(Ne,mt(J),ce)},registerHoverProvider(J,ce){return dt.registerHoverProvider(Ne,mt(J),ce,Ne.identifier)},registerEvaluatableExpressionProvider(J,ce){return dt.registerEvaluatableExpressionProvider(Ne,mt(J),ce,Ne.identifier)},registerInlineValuesProvider(J,ce){return dt.registerInlineValuesProvider(Ne,mt(J),ce,Ne.identifier)},registerDocumentHighlightProvider(J,ce){return dt.registerDocumentHighlightProvider(Ne,mt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return dt.registerLinkedEditingRangeProvider(Ne,mt(J),ce)},registerReferenceProvider(J,ce){return dt.registerReferenceProvider(Ne,mt(J),ce)},registerRenameProvider(J,ce){return dt.registerRenameProvider(Ne,mt(J),ce)},registerDocumentSymbolProvider(J,ce,Ae){return dt.registerDocumentSymbolProvider(Ne,mt(J),ce,Ae)},registerWorkspaceSymbolProvider(J){return dt.registerWorkspaceSymbolProvider(Ne,J)},registerDocumentFormattingEditProvider(J,ce){return dt.registerDocumentFormattingEditProvider(Ne,mt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return dt.registerDocumentRangeFormattingEditProvider(Ne,mt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,Ae,...at){return dt.registerOnTypeFormattingEditProvider(Ne,mt(J),ce,[Ae].concat(at))},registerDocumentSemanticTokensProvider(J,ce,Ae){return dt.registerDocumentSemanticTokensProvider(Ne,mt(J),ce,Ae)},registerDocumentRangeSemanticTokensProvider(J,ce,Ae){return dt.registerDocumentRangeSemanticTokensProvider(Ne,mt(J),ce,Ae)},registerSignatureHelpProvider(J,ce,Ae,...at){return typeof Ae=="object"?dt.registerSignatureHelpProvider(Ne,mt(J),ce,Ae):dt.registerSignatureHelpProvider(Ne,mt(J),ce,typeof Ae=="undefined"?[]:[Ae,...at])},registerCompletionItemProvider(J,ce,...Ae){return dt.registerCompletionItemProvider(Ne,mt(J),ce,Ae)},registerInlineCompletionItemProvider(J,ce){return V.checkProposedApiEnabled(Ne),dt.registerInlineCompletionsProvider(Ne,mt(J),ce)},registerDocumentLinkProvider(J,ce){return dt.registerDocumentLinkProvider(Ne,mt(J),ce)},registerColorProvider(J,ce){return dt.registerColorProvider(Ne,mt(J),ce)},registerFoldingRangeProvider(J,ce){return dt.registerFoldingRangeProvider(Ne,mt(J),ce)},registerSelectionRangeProvider(J,ce){return dt.registerSelectionRangeProvider(Ne,J,ce)},registerCallHierarchyProvider(J,ce){return dt.registerCallHierarchyProvider(Ne,J,ce)},setLanguageConfiguration:(J,ce)=>dt.setLanguageConfiguration(Ne,J,ce),getTokenInformationAtPosition(J,ce){return V.checkProposedApiEnabled(Ne),Wt.tokenAtPosition(J,ce)},registerInlayHintsProvider(J,ce){return V.checkProposedApiEnabled(Ne),dt.registerInlayHintsProvider(Ne,J,ce)}},Fn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(J,ce,Ae){const at=await(k.URI.isUri(J)?Promise.resolve(vn.openTextDocument(J)):Promise.resolve(J));return Dt.showTextDocument(at,ce,Ae)},createTextEditorDecorationType(J){return Dt.createTextEditorDecorationType(Ne,J)},onDidChangeActiveTextEditor(J,ce,Ae){return Dt.onDidChangeActiveTextEditor(J,ce,Ae)},onDidChangeVisibleTextEditors(J,ce,Ae){return Dt.onDidChangeVisibleTextEditors(J,ce,Ae)},onDidChangeTextEditorSelection(J,ce,Ae){return Dt.onDidChangeTextEditorSelection(J,ce,Ae)},onDidChangeTextEditorOptions(J,ce,Ae){return Dt.onDidChangeTextEditorOptions(J,ce,Ae)},onDidChangeTextEditorVisibleRanges(J,ce,Ae){return Dt.onDidChangeTextEditorVisibleRanges(J,ce,Ae)},onDidChangeTextEditorViewColumn(J,ce,Ae){return Dt.onDidChangeTextEditorViewColumn(J,ce,Ae)},onDidCloseTerminal(J,ce,Ae){return ct.onDidCloseTerminal(J,ce,Ae)},onDidOpenTerminal(J,ce,Ae){return ct.onDidOpenTerminal(J,ce,Ae)},onDidChangeActiveTerminal(J,ce,Ae){return ct.onDidChangeActiveTerminal(J,ce,Ae)},onDidChangeTerminalDimensions(J,ce,Ae){return V.checkProposedApiEnabled(Ne),ct.onDidChangeTerminalDimensions(J,ce,Ae)},onDidWriteTerminalData(J,ce,Ae){return V.checkProposedApiEnabled(Ne),ct.onDidWriteTerminalData(J,ce,Ae)},get state(){return bt.state},onDidChangeWindowState(J,ce,Ae){return bt.onDidChangeWindowState(J,ce,Ae)},showInformationMessage(J,...ce){return Rt.showMessage(Ne,y.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return Rt.showMessage(Ne,y.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return Rt.showMessage(Ne,y.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,Ae){return Vt.showQuickPick(J,!!Ne.enableProposedApi,ce,Ae)},showWorkspaceFolderPick(J){return Vt.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Vt.showInput(J,ce)},showOpenDialog(J){return mn.showOpenDialog(J)},showSaveDialog(J){return mn.showSaveDialog(J)},createStatusBarItem(J,ce,Ae){let at,wt,Ct;return typeof J=="string"?(at=J,wt=ce,Ct=Ae):(wt=J,Ct=ce),Pt.createStatusBarEntry(Ne,at,wt,Ct)},setStatusBarMessage(J,ce){return Pt.setStatusBarMessage(J,ce)},withScmProgress(J){return pt.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:M.ProgressLocation.SourceControl},(ce,Ae)=>J({report(at){}}))},withProgress(J,ce){return fn.withProgress(Ne,J,ce)},createOutputChannel(J){return At.createOutputChannel(J)},createWebviewPanel(J,ce,Ae,at){return an.createWebviewPanel(Ne,J,ce,Ae,at)},createWebviewTextEditorInset(J,ce,Ae,at){return V.checkProposedApiEnabled(Ne),rn.createWebviewEditorInset(J,ce,Ae,at,Ne)},createTerminal(J,ce,Ae){return typeof J=="object"?"pty"in J?ct.createExtensionTerminal(J):ct.createTerminalFromOptions(J):ct.createTerminal(J,ce,Ae)},registerTerminalLinkProvider(J){return ct.registerLinkProvider(J)},registerTerminalProfileProvider(J,ce){return ct.registerProfileProvider(Ne,J,ce)},registerTreeDataProvider(J,ce){return Yt.registerTreeDataProvider(J,ce,Ne)},createTreeView(J,ce){return Yt.createTreeView(J,ce,Ne)},registerWebviewPanelSerializer:(J,ce)=>an.registerWebviewPanelSerializer(Ne,J,ce),registerCustomEditorProvider:(J,ce,Ae={})=>Dn.registerCustomEditorProvider(Ne,J,ce,Ae),registerFileDecorationProvider(J){return Bt.registerFileDecorationProvider(J,Ne.identifier)},registerUriHandler(J){return Kt.registerUriHandler(Ne.identifier,J)},createQuickPick(){return Vt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Vt.createInputBox(Ne.identifier)},get activeColorTheme(){return Jt.activeColorTheme},onDidChangeActiveColorTheme(J,ce,Ae){return Jt.onDidChangeActiveColorTheme(J,ce,Ae)},registerWebviewViewProvider(J,ce,Ae){return Xt.registerWebviewViewProvider(Ne,J,ce,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return V.checkProposedApiEnabled(Ne),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,Ae){return V.checkProposedApiEnabled(Ne),gt.onDidChangeActiveNotebookEditor(J,ce,Ae)},get visibleNotebookEditors(){return V.checkProposedApiEnabled(Ne),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return V.checkProposedApiEnabled(Ne),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,Ae){return V.checkProposedApiEnabled(Ne),zt.onDidChangeNotebookEditorSelection(J,ce,Ae)},onDidChangeNotebookEditorVisibleRanges(J,ce,Ae){return V.checkProposedApiEnabled(Ne),zt.onDidChangeNotebookEditorVisibleRanges(J,ce,Ae)},showNotebookDocument(J,ce){return V.checkProposedApiEnabled(Ne),gt.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,Ae){return V.checkProposedApiEnabled(Ne),Cn.registerExternalUriOpener(Ne.identifier,J,ce,Ae)},get openEditors(){return V.checkProposedApiEnabled(Ne),vt.tabs},get onDidChangeOpenEditors(){return V.checkProposedApiEnabled(Ne),vt.onDidChangeTabs},getInlineCompletionItemController(J){return V.checkProposedApiEnabled(Ne),w.InlineCompletionController.get(J)}},vn={get rootPath(){return pt.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),De.getPath()},set rootPath(J){throw T.readonly()},getWorkspaceFolder(J){return De.getWorkspaceFolder(J)},get workspaceFolders(){return De.getWorkspaceFolders()},get name(){return De.name},set name(J){throw T.readonly()},get workspaceFile(){return De.workspaceFile},set workspaceFile(J){throw T.readonly()},updateWorkspaceFolders:(J,ce,...Ae)=>De.updateWorkspaceFolders(Ne,J,ce||0,...Ae),onDidChangeWorkspaceFolders:function(J,ce,Ae){return De.onDidChangeWorkspace(J,ce,Ae)},asRelativePath:(J,ce)=>De.getRelativePath(J,ce),findFiles:(J,ce,Ae,at)=>De.findFiles(K.GlobPattern.from(J),K.GlobPattern.from(ce),Ae,Ne.identifier,at),findTextInFiles:(J,ce,Ae,at)=>{let wt,Ct;return typeof ce=="object"?(wt=ce,Ct=Ae):(wt={},Ct=ce,at=Ae),De.findTextInFiles(J,wt||{},Ct,Ne.identifier,at)},saveAll:J=>De.saveAll(J),applyEdit(J){return kn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,Ae,at)=>Tt.createFileSystemWatcher(K.GlobPattern.from(J),ce,Ae,at),get textDocuments(){return yt.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw T.readonly()},openTextDocument(J){let ce;const Ae=J;if(typeof J=="string")ce=Promise.resolve(k.URI.file(J));else if(k.URI.isUri(J))ce=Promise.resolve(J);else if(!Ae||typeof Ae=="object")ce=yt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(at=>yt.ensureDocumentData(at).then(wt=>wt.document))},onDidOpenTextDocument:(J,ce,Ae)=>yt.onDidAddDocument(J,ce,Ae),onDidCloseTextDocument:(J,ce,Ae)=>yt.onDidRemoveDocument(J,ce,Ae),onDidChangeTextDocument:(J,ce,Ae)=>yt.onDidChangeDocument(J,ce,Ae),onDidSaveTextDocument:(J,ce,Ae)=>yt.onDidSaveDocument(J,ce,Ae),onWillSaveTextDocument:(J,ce,Ae)=>tn.getOnWillSaveTextDocumentEvent(Ne)(J,ce,Ae),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ce){let Ae;if(k.URI.isUri(J))Ae=J,await gt.openNotebookDocument(J);else if(typeof J=="string")Ae=k.URI.revive(await gt.createNotebookDocument({viewType:J,content:ce}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ce,Ae,at){return gt.registerNotebookSerializer(Ne,J,ce,Ae,Ne.enableProposedApi?at:void 0)},registerNotebookContentProvider:(J,ce,Ae,at)=>(V.checkProposedApiEnabled(Ne),gt.registerNotebookContentProvider(Ne,J,ce,Ae,Ne.enableProposedApi?at:void 0)),onDidChangeConfiguration:(J,ce,Ae)=>gn.onDidChangeConfiguration(J,ce,Ae),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,gn.getConfiguration(J,ce,Ne)},registerTextDocumentContentProvider(J,ce){return en.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(pt.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Ne,J,ce)),registerFileSystemProvider(J,ce,Ae){return sn.registerFileSystemProvider(Ne.identifier,J,ce,Ae,Ne.enableProposedApi)},get fs(){return ut.value},registerFileSearchProvider:(J,ce)=>(V.checkProposedApiEnabled(Ne),Ht.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>(V.checkProposedApiEnabled(Ne),Ht.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>(V.checkProposedApiEnabled(Ne),pe.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>(V.checkProposedApiEnabled(Ne),yn.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,Ae)=>Tt.onDidCreateFile(J,ce,Ae),onDidDeleteFiles:(J,ce,Ae)=>Tt.onDidDeleteFile(J,ce,Ae),onDidRenameFiles:(J,ce,Ae)=>Tt.onDidRenameFile(J,ce,Ae),onWillCreateFiles:(J,ce,Ae)=>Tt.getOnWillCreateFileEvent(Ne)(J,ce,Ae),onWillDeleteFiles:(J,ce,Ae)=>Tt.getOnWillDeleteFileEvent(Ne)(J,ce,Ae),onWillRenameFiles:(J,ce,Ae)=>Tt.getOnWillRenameFileEvent(Ne)(J,ce,Ae),openTunnel:J=>(V.checkProposedApiEnabled(Ne),st.openTunnel(Ne,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return V.checkProposedApiEnabled(Ne),st.getTunnels()},onDidChangeTunnels:(J,ce,Ae)=>(V.checkProposedApiEnabled(Ne),st.onDidChangeTunnels(J,ce,Ae)),registerPortAttributesProvider:(J,ce)=>(V.checkProposedApiEnabled(Ne),st.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>(V.checkProposedApiEnabled(Ne),Sn.registerTimelineProvider(J,ce,Ne.identifier,ht.converter)),get isTrusted(){return De.trusted},requestWorkspaceTrust:J=>(V.checkProposedApiEnabled(Ne),De.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ce,Ae)=>De.onDidGrantWorkspaceTrust(J,ce,Ae)},Ln={get inputBox(){return pt.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),hn.getLastInputBox(Ne)},createSourceControl(J,ce,Ae){return hn.createSourceControl(Ne,J,ce,Ae)}},bn={createCommentController(J,ce){return En.createCommentController(Ne,J,ce)}},Mt={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(J,ce,Ae){return ft.onDidStartDebugSession(J,ce,Ae)},onDidTerminateDebugSession(J,ce,Ae){return ft.onDidTerminateDebugSession(J,ce,Ae)},onDidChangeActiveDebugSession(J,ce,Ae){return ft.onDidChangeActiveDebugSession(J,ce,Ae)},onDidReceiveDebugSessionCustomEvent(J,ce,Ae){return ft.onDidReceiveDebugSessionCustomEvent(J,ce,Ae)},onDidChangeBreakpoints(J,ce,Ae){return ft.onDidChangeBreakpoints(J,ce,Ae)},registerDebugConfigurationProvider(J,ce,Ae){return ft.registerDebugConfigurationProvider(J,ce,Ae||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return ft.registerDebugAdapterDescriptorFactory(Ne,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return ft.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ft.startDebugging(J,ce,{parentSession:Ae}):ft.startDebugging(J,ce,Ae||{})},stopDebugging(J){return ft.stopDebugging(J)},addBreakpoints(J){return ft.addBreakpoints(J)},removeBreakpoints(J){return ft.removeBreakpoints(J)},asDebugSourceUri(J,ce){return ft.asDebugSourceUri(J,ce)}},Ot={registerTaskProvider:(J,ce)=>kt.registerTaskProvider(Ne,J,ce),fetchTasks:J=>kt.fetchTasks(J),executeTask:J=>kt.executeTask(Ne,J),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(J,ce,Ae)=>kt.onDidStartTask(J,ce,Ae),onDidEndTask:(J,ce,Ae)=>kt.onDidEndTask(J,ce,Ae),onDidStartTaskProcess:(J,ce,Ae)=>kt.onDidStartTaskProcess(J,ce,Ae),onDidEndTaskProcess:(J,ce,Ae)=>kt.onDidEndTaskProcess(J,ce,Ae)},Mn={createNotebookController(J,ce,Ae,at,wt){return nn.createNotebookController(Ne,J,ce,Ae,at,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ce)=>gt.registerNotebookCellStatusBarItemProvider(Ne,J,ce),get onDidSaveNotebookDocument(){return V.checkProposedApiEnabled(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return V.checkProposedApiEnabled(Ne),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return V.checkProposedApiEnabled(Ne),_n.createRendererMessaging(J)},onDidChangeNotebookDocumentMetadata(J,ce,Ae){return V.checkProposedApiEnabled(Ne),Qt.onDidChangeNotebookDocumentMetadata(J,ce,Ae)},onDidChangeNotebookCells(J,ce,Ae){return V.checkProposedApiEnabled(Ne),gt.onDidChangeNotebookCells(J,ce,Ae)},onDidChangeNotebookCellExecutionState(J,ce,Ae){return V.checkProposedApiEnabled(Ne),gt.onDidChangeNotebookCellExecutionState(J,ce,Ae)},onDidChangeCellOutputs(J,ce,Ae){return V.checkProposedApiEnabled(Ne),gt.onDidChangeCellOutputs(J,ce,Ae)},onDidChangeCellMetadata(J,ce,Ae){return V.checkProposedApiEnabled(Ne),gt.onDidChangeCellMetadata(J,ce,Ae)},createConcatTextDocument(J,ce){return V.checkProposedApiEnabled(Ne),new ve.ExtHostNotebookConcatDocument(gt,yt,J,ce)}};return{version:Ye.version,authentication:In,commands:Pn,comments:bn,debug:Mt,env:pn,extensions:Tn,languages:Rn,notebooks:Mn,scm:Ln,tasks:Ot,test:An,window:Fn,workspace:vn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:C.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:v.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TextSearchCompleteMessageType:ge.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=$e}),define(Ee[219],ye([0,1,57,101,31,100,32,70,46,36,104,105,106,73,72,64,69,102,71,45,68,93,63]),function(Z,e,m,T,S,y,k,D,v,C,n,I,o,h,d,l,_,b,E,c,f,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),m.registerSingleton(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),m.registerSingleton(D.IExtHostCommands,D.ExtHostCommands),m.registerSingleton(k.IExtHostConfiguration,k.ExtHostConfiguration),m.registerSingleton(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),m.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),m.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),m.registerSingleton(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors),m.registerSingleton(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),m.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),m.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),m.registerSingleton(d.IExtHostStorage,d.ExtHostStorage),m.registerSingleton(n.IExtHostTask,n.WorkerExtHostTask),m.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),m.registerSingleton(l.IExtHostTunnelService,l.ExtHostTunnelService),m.registerSingleton(b.IExtHostWindow,b.ExtHostWindow),m.registerSingleton(S.IExtHostWorkspace,S.ExtHostWorkspace),m.registerSingleton(f.IExtHostSecretState,f.ExtHostSecretState),m.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),m.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(Ee[220],ye([0,1,218,33,214,6,13,4,12]),function(Z,e,m,T,S,y,k,D,v){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(l){var _;const b=(_=self.trustedTypes)===null||_===void 0?void 0:_.createPolicy("TrustedFunctionWorkaround",{createScript:(c,...f)=>{f.forEach(s=>{var r;if(!((r=self.trustedTypes)===null||r===void 0?void 0:r.isScript(s)))throw new Error("TrustedScripts only, please")});const g=f.slice(0,-1).join(","),t=f.pop().toString();return`(function anonymous(${g}) {
${t}
})`}});function E(...c){return b?self.eval(b.createScript("",...c)):new Function(...c)}l.create=E})(n||(n={}));class I extends S.RequireInterceptor{_installInterceptor(){}getModule(_,b){for(let E of this._alternatives){let c=E(_);if(c){_=c;break}}if(this._factories.has(_))return this._factories.get(_).load(_,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class o extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const _=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);d(_,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(I,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(_){return _.browser}async _loadCommonJSModule(_,b,E){var c,f,g,t,i,s,r,u;b=b.with({path:h(b.path,".js")}),_&&performance.mark(`code/extHost/willFetchExtensionCode/${_.value}`);const w=await fetch(v.FileAccess.asBrowserUri(b).toString(!0));if(_&&performance.mark(`code/extHost/didFetchExtensionCode/${_.value}`),w.status!==200)throw new Error(w.statusText);const p=await w.text(),P=`${b.toString(!0)}#vscode-extension`,A=`${p}
//# sourceURL=${P}`;let a;try{a=n.create((f=(c=o._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("module"))!==null&&f!==void 0?f:"module",(t=(g=o._ttpExtensionScripts)===null||g===void 0?void 0:g.createScript("exports"))!==null&&t!==void 0?t:"exports",(s=(i=o._ttpExtensionScripts)===null||i===void 0?void 0:i.createScript("require"))!==null&&s!==void 0?s:"require",(u=(r=o._ttpExtensionScripts)===null||r===void 0?void 0:r.createScript(A))!==null&&u!==void 0?u:A)}catch(X){throw console.error(_?`Loading code for extension ${_.value} failed: ${X.message}`:`Loading code failed: ${X.message}`),console.error(`${b.toString(!0)}${typeof X.line=="number"?` line ${X.line}`:""}${typeof X.column=="number"?` column ${X.column}`:""}`),console.error(X),X}const R={},F={exports:R},U=X=>{const oe=this._fakeModules.getModule(X,b);if(oe===void 0)throw new Error(`Cannot load module '${X}'`);return oe};try{return E.codeLoadingStart(),_&&performance.mark(`code/extHost/willLoadExtensionCode/${_.value}`),a(F,R,U),F.exports!==R?F.exports:R}finally{_&&performance.mark(`code/extHost/didLoadExtensionCode/${_.value}`),E.codeLoadingStop()}}async $setRemoteEnvironment(_){throw new Error("Not supported")}async _waitForDebuggerAttachment(_=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+_;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await k.timeout(10)}}e.ExtHostExtensionService=o,o._ttpExtensionScripts=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("ExtensionScripts",{createScript:l=>l});function h(l,_){return l.endsWith(_)?l:l+_}function d(l,_){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(f,g){const t=console[f];console[f]=function(){l.$logExtensionHostMessage({type:"__$console",severity:g,arguments:c(arguments)}),_&&t.apply(console,arguments)}}const E=1e5;function c(f){const g=[],t=[];if(f.length)for(let i=0;i<f.length;i++){if(typeof f[i]=="undefined")f[i]="undefined";else if(f[i]instanceof Error){const s=f[i];s.stack?f[i]=s.stack:f[i]=s.toString()}t.push(f[i])}try{const i=JSON.stringify(t,function(s,r){if(r&&typeof r=="object"){if(g.indexOf(r)!==-1)return"[Circular]";g.push(r)}return r});return i.length>E?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(Ee[221],ye([0,1,57,16,33,220,207]),function(Z,e,m,T,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.registerSingleton(S.IExtHostExtensionService,y.ExtHostExtensionService),m.registerSingleton(T.ILogService,k.ExtHostLogService)}),define(Ee[223],ye([0,1,23,3,175,215,209,15,74,12,2,219,221]),function(Z,e,m,T,S,y,k,D,v,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0});const o=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const E=(I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy("extensionHostWorker",{createScriptURL:f=>f}),c=self.Worker;Worker=function(f,g){/^file:/i.test(f.toString())&&(f=C.FileAccess.asBrowserUri(n.URI.parse(f.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${f}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;g=g||{},g.name=g.name||D.basename(f.toString());const i=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(i);return new c(E?E.createScriptURL(s):s,g)}}else self.Worker=class extends k.NestedWorker{constructor(E,c){super(h,E,Object.assign({name:D.basename(E.toString())},c))}};const d=new class{exit(E){o()}async exists(E){return!0}async realpath(E){return E}};class l{constructor(){const c=new MessageChannel,f=new T.Emitter;let g=!1;h(c.port2,[c.port2]),c.port1.onmessage=t=>{const{data:i}=t;if(!(i instanceof ArrayBuffer)){console.warn("UNKNOWN data received",i);return}const s=m.VSBuffer.wrap(new Uint8Array(i,0,i.byteLength));if(S.isMessageOfType(s,2)){g=!0,b("received terminate message from renderer");return}f.fire(s)},this.protocol={onMessage:f.event,send:t=>{if(!g){const i=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);c.port1.postMessage(i,[i])}}}}}function _(E){return new Promise(c=>{const f=E.onMessage(g=>{f.dispose();const t=JSON.parse(g.toString());E.send(S.createMessageOfType(0)),c({protocol:E,initData:t})});E.send(S.createMessageOfType(1))})}let b=E=>o();(function(){const c=new l;v.mark("code/extHost/willConnectToRenderer"),_(c.protocol).then(f=>{v.mark("code/extHost/didWaitForInitData");const g=new y.ExtensionHostMain(f.protocol,f.initData,d,null);b=t=>g.terminate(t)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3caebff71e514ece73b125468881d102e767ee4d/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
